package com.flurry.android;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.HandlerThread;
import android.os.Looper;
import android.os.SystemClock;
import java.io.ByteArrayOutputStream;
import java.io.Closeable;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.WeakHashMap;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ByteArrayEntity;
import org.apache.http.impl.client.DefaultHttpClient;
/* loaded from: classes.dex */
public class FlurryAgent implements LocationListener {
    private long A;
    private String B;
    private int C;
    private Location D;
    private Map E;
    private List F;
    private boolean G;
    private int H;
    private List I;
    private final Handler i;
    private long m;
    private String o;
    private String p;
    private String q;
    private List s;
    private LocationManager t;
    private String u;
    private boolean v;
    private long w;
    private long y;
    private long z;

    /* renamed from: a  reason: collision with root package name */
    private static volatile String f54a = null;
    private static volatile String kInsecureReportUrl = "http://data.flurry.com/aar.do";
    private static volatile String kSecureReportUrl = "https://data.flurry.com/aar.do";
    private static final FlurryAgent b = new FlurryAgent();
    private static long c = 10000;
    private static long d = 20000;
    private static boolean e = true;
    private static boolean f = false;
    private static boolean g = true;
    private static Criteria h = null;
    private File j = null;
    private boolean k = false;
    private boolean l = false;
    private Map n = new WeakHashMap();
    private boolean r = true;
    private List x = new ArrayList();

    /* JADX INFO: Access modifiers changed from: package-private */
    public final void a(Throwable th) {
        onError("uncaught", th.getMessage(), th.getClass().toString());
        this.n.clear();
        b((Context) null, true);
    }

    private FlurryAgent() {
        HandlerThread handlerThread = new HandlerThread("FlurryAgent");
        handlerThread.start();
        this.i = new Handler(handlerThread.getLooper());
    }

    public static void onStartSession(Context context, String str) {
        if (context == null) {
            throw new NullPointerException("Null context");
        }
        if (str == null || str.length() == 0) {
            throw new IllegalArgumentException("Api key not specified");
        }
        try {
            b.a(context, str);
        } catch (Throwable th) {
            Flog.b("FlurryAgent", "", th);
        }
    }

    public static void onEndSession(Context context) {
        if (context == null) {
            throw new NullPointerException("Null context");
        }
        try {
            b.b(context, false);
        } catch (Throwable th) {
            Flog.b("FlurryAgent", "", th);
        }
    }

    public static void onEvent(String str) {
        try {
            b.a(str, (Map) null);
        } catch (Throwable th) {
            Flog.b("FlurryAgent", "", th);
        }
    }

    public static void onEvent(String str, Map map) {
        try {
            b.a(str, map);
        } catch (Throwable th) {
            Flog.b("FlurryAgent", "", th);
        }
    }

    public static void onError(String str, String str2, String str3) {
        try {
            b.a(str, str2, str3);
        } catch (Throwable th) {
            Flog.b("FlurryAgent", "", th);
        }
    }

    public static void setReportUrl(String str) {
        f54a = str;
    }

    public static void setVersionName(String str) {
        synchronized (b) {
            b.q = str;
        }
    }

    public static void setReportLocation(boolean z) {
        synchronized (b) {
            b.r = false;
        }
    }

    public static void setLocationCriteria(Criteria criteria) {
        synchronized (b) {
            h = criteria;
        }
    }

    public static boolean getForbidPlaintextFallback() {
        return false;
    }

    public static void setLogEnabled(boolean z) {
        synchronized (b) {
            if (z) {
                Flog.enableLog();
            } else {
                Flog.disableLog();
            }
        }
    }

    public static void setContinueSessionMillis(long j) {
        synchronized (b) {
            c = j;
        }
    }

    public static void setLocationFixTimeoutMillis(long j) {
        synchronized (b) {
            d = j;
        }
    }

    public static void setLogEvents(boolean z) {
        synchronized (b) {
            e = z;
        }
    }

    public static void setUserId(String str) {
        synchronized (b) {
            b.B = a(str);
        }
    }

    public static void setCaptureUncaughtExceptions(boolean z) {
        synchronized (b) {
            if (b.k) {
                Flog.b("FlurryAgent", "Cannot setCaptureUncaughtExceptions after onSessionStart");
            } else {
                g = z;
            }
        }
    }

    /*  JADX ERROR: JadxRuntimeException in pass: BlockProcessor
        jadx.core.utils.exceptions.JadxRuntimeException: Found unreachable blocks
        	at jadx.core.dex.visitors.blocks.DominatorTree.sortBlocks(DominatorTree.java:35)
        	at jadx.core.dex.visitors.blocks.DominatorTree.compute(DominatorTree.java:25)
        	at jadx.core.dex.visitors.blocks.BlockProcessor.computeDominators(BlockProcessor.java:202)
        	at jadx.core.dex.visitors.blocks.BlockProcessor.processBlocksTree(BlockProcessor.java:45)
        	at jadx.core.dex.visitors.blocks.BlockProcessor.visit(BlockProcessor.java:39)
        */
    private synchronized void a(android.content.Context r10, java.lang.String r11) {
        /*
            Method dump skipped, instructions count: 492
            To view this dump add '--comments-level debug' option
        */
        throw new UnsupportedOperationException("Method not decompiled: com.flurry.android.FlurryAgent.a(android.content.Context, java.lang.String):void");
    }

    private synchronized void b(Context context, boolean z) {
        if (context != null) {
            if (((Context) this.n.remove(context)) == null) {
                Flog.c("FlurryAgent", "onEndSession called without context from corresponding onStartSession");
            }
        }
        if (this.k && this.n.isEmpty()) {
            Flog.a("FlurryAgent", "Ending session");
            a();
            Context applicationContext = context == null ? null : context.getApplicationContext();
            if (context != null) {
                String packageName = applicationContext.getPackageName();
                if (!this.p.equals(packageName)) {
                    Flog.b("FlurryAgent", "onEndSession called from different application package, expected: " + this.p + " actual: " + packageName);
                }
            }
            this.k = false;
            long elapsedRealtime = SystemClock.elapsedRealtime();
            this.m = elapsedRealtime;
            this.A = elapsedRealtime - this.z;
            c();
            f();
            if (!z) {
                this.i.postDelayed(new a(this, applicationContext), c);
            }
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public final void a(Context context) {
        boolean z;
        try {
            synchronized (this) {
                z = !this.k && SystemClock.elapsedRealtime() - this.m > c && this.x.size() > 0;
            }
            if (z) {
                e();
            }
        } catch (Throwable th) {
            Flog.b("FlurryAgent", "", th);
        }
    }

    private void c() {
        try {
            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            DataOutputStream dataOutputStream = new DataOutputStream(byteArrayOutputStream);
            dataOutputStream.writeUTF(this.q);
            dataOutputStream.writeLong(this.y);
            dataOutputStream.writeLong(this.A);
            dataOutputStream.writeUTF(this.B);
            if (this.D == null) {
                dataOutputStream.writeBoolean(false);
            } else {
                dataOutputStream.writeBoolean(true);
                dataOutputStream.writeDouble(this.D.getLatitude());
                dataOutputStream.writeDouble(this.D.getLongitude());
                dataOutputStream.writeFloat(this.D.getAccuracy());
            }
            dataOutputStream.writeInt(0);
            dataOutputStream.writeByte(-1);
            dataOutputStream.writeShort(this.E.size());
            for (Map.Entry entry : this.E.entrySet()) {
                dataOutputStream.writeUTF((String) entry.getKey());
                dataOutputStream.writeInt(((e) entry.getValue()).f59a);
            }
            dataOutputStream.writeShort(this.F.size());
            for (byte[] bArr : this.F) {
                dataOutputStream.write(bArr);
            }
            dataOutputStream.writeBoolean(this.G);
            dataOutputStream.writeInt(this.C);
            dataOutputStream.writeShort(this.I.size());
            for (f fVar : this.I) {
                dataOutputStream.writeLong(fVar.f60a);
                dataOutputStream.writeUTF(fVar.b);
                dataOutputStream.writeUTF(fVar.c);
                dataOutputStream.writeUTF(fVar.d);
            }
            dataOutputStream.writeShort(0);
            this.x.add(byteArrayOutputStream.toByteArray());
        } catch (IOException e2) {
            Flog.b("FlurryAgent", "", e2);
        }
    }

    private synchronized void a(String str, Map map) {
        if (this.F == null) {
            Flog.b("FlurryAgent", "onEvent called before onStartSession.  Event: " + str);
        } else {
            String a2 = a(str);
            if (a2.length() != 0) {
                e eVar = (e) this.E.get(a2);
                if (eVar == null) {
                    if (this.E.size() < 100) {
                        e eVar2 = new e();
                        eVar2.f59a = 1;
                        this.E.put(a2, eVar2);
                    } else if (Flog.a("FlurryAgent")) {
                        Flog.a("FlurryAgent", "MaxEventIds exceeded: " + a2);
                    }
                } else {
                    eVar.f59a++;
                }
                if (e && this.F.size() < 100 && this.H < 8000) {
                    Map emptyMap = map == null ? Collections.emptyMap() : map;
                    if (emptyMap.size() > 10) {
                        if (Flog.a("FlurryAgent")) {
                            Flog.a("FlurryAgent", "MaxEventParams exceeded: " + emptyMap.size());
                        }
                    } else {
                        byte[] b2 = b(a2, emptyMap);
                        if (b2.length + this.H <= 8000) {
                            this.F.add(b2);
                            this.H = b2.length + this.H;
                        } else {
                            this.H = 8000;
                            this.G = false;
                        }
                    }
                } else {
                    this.G = false;
                }
            }
        }
    }

    private static byte[] b(String str, Map map) {
        try {
            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            DataOutputStream dataOutputStream = new DataOutputStream(byteArrayOutputStream);
            dataOutputStream.writeUTF(str);
            dataOutputStream.writeShort(map.size());
            for (Map.Entry entry : map.entrySet()) {
                dataOutputStream.writeUTF(a((String) entry.getKey()));
                dataOutputStream.writeUTF(a((String) entry.getValue()));
            }
            dataOutputStream.close();
            return byteArrayOutputStream.toByteArray();
        } catch (IOException e2) {
            return new byte[0];
        }
    }

    private synchronized void a(String str, String str2, String str3) {
        if (this.I == null) {
            Flog.b("FlurryAgent", "onError called before onStartSession.  Error: " + str);
        } else {
            this.C++;
            if (this.I.size() < 10) {
                f fVar = new f();
                fVar.f60a = System.currentTimeMillis();
                fVar.b = a(str);
                fVar.c = a(str2);
                fVar.d = a(str3);
                this.I.add(fVar);
            }
        }
    }

    private static String a(String str) {
        if (str == null) {
            return "";
        }
        return str.length() <= 255 ? str : str.substring(0, 255);
    }

    private synchronized byte[] d() {
        byte[] bArr;
        try {
            ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
            DataOutputStream dataOutputStream = new DataOutputStream(byteArrayOutputStream);
            dataOutputStream.writeShort(8);
            dataOutputStream.writeShort(0);
            dataOutputStream.writeShort(3);
            dataOutputStream.writeShort(29);
            dataOutputStream.writeLong(System.currentTimeMillis());
            dataOutputStream.writeUTF(this.o);
            dataOutputStream.writeUTF(this.q);
            dataOutputStream.writeUTF(this.u);
            dataOutputStream.writeLong(this.w);
            dataOutputStream.writeLong(this.y);
            dataOutputStream.writeShort(4);
            dataOutputStream.writeUTF("device.model");
            dataOutputStream.writeUTF(Build.MODEL);
            dataOutputStream.writeUTF("build.brand");
            dataOutputStream.writeUTF(Build.BRAND);
            dataOutputStream.writeUTF("build.id");
            dataOutputStream.writeUTF(Build.ID);
            dataOutputStream.writeUTF("version.release");
            dataOutputStream.writeUTF(Build.VERSION.RELEASE);
            int size = this.x.size();
            dataOutputStream.writeShort(size);
            for (int i = 0; i < size; i++) {
                dataOutputStream.write((byte[]) this.x.get(i));
            }
            this.s = new ArrayList(this.x);
            dataOutputStream.close();
            bArr = byteArrayOutputStream.toByteArray();
        } catch (IOException e2) {
            Flog.b("FlurryAgent", "", e2);
            bArr = null;
        }
        return bArr;
    }

    private boolean a(byte[] bArr) {
        boolean z;
        String str = f54a != null ? f54a : kInsecureReportUrl;
        if (str == null) {
            return false;
        }
        try {
            z = a(bArr, str);
        } catch (Exception e2) {
            z = false;
        }
        if (z || f54a != null) {
        }
        return z;
    }

    private boolean a(byte[] bArr, String str) {
        Flog.a("FlurryAgent", "Sending report to: " + str);
        boolean z = false;
        ByteArrayEntity byteArrayEntity = new ByteArrayEntity(bArr);
        byteArrayEntity.setContentType("application/octet-stream");
        HttpPost httpPost = new HttpPost(str);
        httpPost.setEntity(byteArrayEntity);
        int statusCode = new DefaultHttpClient().execute(httpPost).getStatusLine().getStatusCode();
        synchronized (this) {
            if (statusCode == 200) {
                Flog.a("FlurryAgent", "Report successful");
                this.v = true;
                this.x.removeAll(this.s);
                z = true;
            } else {
                Flog.a("FlurryAgent", "Report failed");
            }
        }
        this.s = null;
        return z;
    }

    private void e() {
        try {
            byte[] d2 = d();
            if (d2 != null && a(d2)) {
                f();
            }
        } catch (IOException e2) {
            Flog.a("FlurryAgent", "", e2);
        } catch (Throwable th) {
            Flog.b("FlurryAgent", "", th);
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public final void a(Context context, boolean z) {
        boolean z2;
        Location location = null;
        if (z) {
            try {
                location = c(context);
            } catch (Throwable th) {
                Flog.b("FlurryAgent", "", th);
                return;
            }
        }
        synchronized (this) {
            this.D = location;
            z2 = !this.v || this.x.size() > 0;
        }
        if (z2) {
            e();
        }
    }

    private synchronized void a(DataInputStream dataInputStream) {
        int readUnsignedShort = dataInputStream.readUnsignedShort();
        if (readUnsignedShort > 2) {
            throw new IOException("Unknown agent file version: " + readUnsignedShort);
        }
        if (readUnsignedShort >= 2) {
            String readUTF = dataInputStream.readUTF();
            if (readUTF.equals(this.o)) {
                this.u = dataInputStream.readUTF();
                this.v = dataInputStream.readBoolean();
                this.w = dataInputStream.readLong();
                while (true) {
                    int readUnsignedShort2 = dataInputStream.readUnsignedShort();
                    if (readUnsignedShort2 == 0) {
                        break;
                    }
                    byte[] bArr = new byte[readUnsignedShort2];
                    dataInputStream.readFully(bArr);
                    this.x.add(0, bArr);
                }
                this.l = true;
            } else {
                Flog.a("FlurryAgent", "Api keys do not match, old: " + readUTF + ", new: " + this.o);
            }
        }
    }

    private synchronized void f() {
        DataOutputStream dataOutputStream;
        DataOutputStream dataOutputStream2 = null;
        dataOutputStream2 = null;
        int i = 0;
        synchronized (this) {
            try {
                File parentFile = this.j.getParentFile();
                if (!parentFile.mkdirs() && !parentFile.exists()) {
                    Flog.b("FlurryAgent", "Unable to create persistent dir: " + parentFile);
                    a((Closeable) null);
                } else {
                    dataOutputStream = new DataOutputStream(new FileOutputStream(this.j));
                    try {
                        dataOutputStream.writeShort(46586);
                        dataOutputStream.writeShort(2);
                        dataOutputStream.writeUTF(this.o);
                        dataOutputStream.writeUTF(this.u);
                        dataOutputStream.writeBoolean(this.v);
                        dataOutputStream.writeLong(this.w);
                        int size = this.x.size() - 1;
                        while (size >= 0) {
                            byte[] bArr = (byte[]) this.x.get(size);
                            int length = bArr.length;
                            i = length + 2 + dataOutputStream.size();
                            if (i > 50000) {
                                break;
                            }
                            dataOutputStream.writeShort(length);
                            dataOutputStream.write(bArr);
                            size--;
                            i = i;
                        }
                        dataOutputStream.writeShort(0);
                        a(dataOutputStream);
                        dataOutputStream2 = i;
                    } catch (Throwable th) {
                        th = th;
                        Flog.b("FlurryAgent", "", th);
                        a(dataOutputStream);
                    }
                }
            } catch (Throwable th2) {
                th = th2;
                dataOutputStream = dataOutputStream2;
            }
        }
    }

    private static void a(Closeable closeable) {
        if (closeable != null) {
            try {
                closeable.close();
            } catch (Throwable th) {
            }
        }
    }

    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:12:0x0027 -> B:5:0x0013). Please submit an issue!!! */
    private static String b(Context context) {
        PackageInfo packageInfo;
        try {
            packageInfo = context.getPackageManager().getPackageInfo(context.getPackageName(), 0);
        } catch (Throwable th) {
            Flog.b("FlurryAgent", "", th);
        }
        if (packageInfo.versionName != null) {
            return packageInfo.versionName;
        }
        if (packageInfo.versionCode != 0) {
            return Integer.toString(packageInfo.versionCode);
        }
        return "Unknown";
    }

    private Location c(Context context) {
        String bestProvider;
        if (context.checkCallingOrSelfPermission("android.permission.ACCESS_FINE_LOCATION") == 0 || context.checkCallingOrSelfPermission("android.permission.ACCESS_COARSE_LOCATION") == 0) {
            LocationManager locationManager = (LocationManager) context.getSystemService("location");
            synchronized (this) {
                if (this.t == null) {
                    this.t = locationManager;
                } else {
                    locationManager = this.t;
                }
                Criteria criteria = h;
                if (criteria == null) {
                    criteria = new Criteria();
                }
                bestProvider = locationManager.getBestProvider(criteria, true);
                if (bestProvider != null) {
                    locationManager.requestLocationUpdates(bestProvider, 0L, 0.0f, this, Looper.getMainLooper());
                    this.i.postDelayed(new b(this), d);
                }
            }
            if (bestProvider != null) {
                return locationManager.getLastKnownLocation(bestProvider);
            }
        }
        return null;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public final synchronized void a() {
        if (this.t != null) {
            this.t.removeUpdates(this);
        }
    }

    @Override // android.location.LocationListener
    public synchronized void onLocationChanged(Location location) {
        try {
            this.D = location;
            a();
        } catch (Throwable th) {
            Flog.b("FlurryAgent", "", th);
        }
    }

    @Override // android.location.LocationListener
    public void onProviderDisabled(String str) {
    }

    @Override // android.location.LocationListener
    public void onProviderEnabled(String str) {
    }

    @Override // android.location.LocationListener
    public void onStatusChanged(String str, int i, Bundle bundle) {
    }
}
