package com.safetest.shark;

import android.app.Activity;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.SystemClock;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import android.widget.LinearLayout;
import com.adwo.adsdk.AdListener;
import com.adwo.adsdk.AdwoAdView;
import com.izp.views.IZPDelegate;
import com.izp.views.IZPView;
import com.ju6.AdManager;
import com.ju6.AdRequester;
import com.ju6.mms.pdu.CharacterSets;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;
/* loaded from: classes.dex */
public class JmAdV2 {
    public static final int LEFT_BOTTOM = 1;
    public static final int LEFT_TOP = 0;
    public static final int RIGHT_BOTTOM = 3;
    public static final int RIGHT_TOP = 2;
    private Activity mActivity;
    private int mAdH;
    private int mAdW;
    private View mCurrentAd;
    private boolean mLandscape;
    private LinearLayout mLayout;
    View.OnClickListener mOnClickListener;
    private LinearLayout.LayoutParams mParams;
    private int mPosition;
    private int mScreenH;
    private int mScreenW;
    private TimerTask mTimerTask;
    private boolean mIsInit = false;
    private int mInterval = 40;
    private AdRequester mJu6Ad = null;
    private IZPView mIZPAd = null;
    private AdwoAdView mAdwo = null;
    private AdListener mAdwoListener = null;
    private Timer mTimer = null;
    private int mFakeCount = 0;
    private int mCurrentShow = 0;
    private long mLastTime = 0;
    private boolean mDebug = false;
    private int mForceTime = 180000;
    private int mClickCount = 0;
    private long mStartTime = SystemClock.uptimeMillis();
    private int[] mLeftCount = new int[2];
    private View[] mAdViews = new View[2];

    /* JADX INFO: Access modifiers changed from: private */
    /* loaded from: classes.dex */
    public static class ORDER {
        public static final int COUNT = 2;
        private static final String DEFAULT = "IZP:1:acc70d52722f446481021f05ecee0f4f;JU6:1:1da063cfa0254681:a6fb368fac934dcc;ADWO:0:44b3f2e8b54b427da7ddac6968b32e50";
        public static int ADWO = 0;
        public static int IZP = 1;
        public static int JU6 = 1;

        private ORDER() {
        }
    }

    public JmAdV2(Activity activiy, int position, boolean isLandscape, LinearLayout layout) {
        this.mAdW = 240;
        this.mAdH = 32;
        this.mPosition = 0;
        this.mLandscape = false;
        this.mActivity = activiy;
        for (int i = 0; i < 2; i++) {
            this.mLeftCount[i] = 0;
            this.mAdViews[i] = null;
        }
        if (position < 0 || position > 3) {
            this.mPosition = 3;
        } else {
            this.mPosition = position;
        }
        this.mScreenW = this.mActivity.getWindowManager().getDefaultDisplay().getWidth();
        this.mScreenH = this.mActivity.getWindowManager().getDefaultDisplay().getHeight();
        if (layout != null) {
            this.mLayout = layout;
        } else {
            this.mLayout = new LinearLayout(this.mActivity);
            this.mLayout.setEnabled(false);
            this.mLayout.setBackgroundColor(0);
            this.mActivity.addContentView(this.mLayout, new LinearLayout.LayoutParams(-1, -2));
        }
        this.mLandscape = isLandscape;
        if (this.mLandscape) {
            this.mAdW = this.mScreenH < this.mScreenW ? this.mScreenH : this.mScreenW;
            if (this.mAdW >= 480) {
                this.mAdH = 48;
                this.mAdW = 320;
            }
            this.mParams = new LinearLayout.LayoutParams(this.mAdW, this.mAdH);
        } else {
            this.mAdH = this.mScreenH > this.mScreenW ? this.mScreenH : this.mScreenW;
            if (this.mAdH >= 800) {
                this.mAdH = 48;
            } else {
                this.mAdH = 32;
            }
            this.mParams = new LinearLayout.LayoutParams(-1, this.mAdH);
        }
        switch (this.mPosition) {
            case 1:
                this.mLayout.setPadding(0, this.mScreenH - this.mAdH, 0, 0);
                break;
            case 2:
                this.mLayout.setPadding(this.mScreenW - this.mAdW, 0, 0, 0);
                break;
            case 3:
                this.mLayout.setPadding(this.mScreenW - this.mAdW, this.mScreenH - this.mAdH, 0, 0);
                break;
        }
        this.mOnClickListener = new View.OnClickListener() { // from class: com.safetest.shark.JmAdV2.1
            @Override // android.view.View.OnClickListener
            public void onClick(View v) {
                JmAdV2.this.mClickCount++;
            }
        };
    }

    public void setDebug(boolean debug) {
        this.mDebug = debug;
    }

    public void setRefreshInterval(int interval) {
        this.mInterval = interval;
    }

    public void setForceTime(int time) {
        this.mForceTime = time < 60 ? 60000 : time * CharacterSets.UCS2;
    }

    public void startAd() {
        if (this.mTimer == null) {
            this.mTimer = new Timer();
            this.mTimerTask = new TimerTask() { // from class: com.safetest.shark.JmAdV2.2
                @Override // java.util.TimerTask, java.lang.Runnable
                public void run() {
                    if (JmAdV2.this.mIsInit) {
                        if (JmAdV2.this.mLastTime == 0) {
                            JmAdV2.this.mLastTime = System.currentTimeMillis();
                        }
                        JmAdV2.this.showAdView();
                        return;
                    }
                    JmAdV2.this.initAdViews();
                }
            };
            int interval = this.mInterval >= 70 ? this.mInterval * 500 : 38000;
            this.mTimer.schedule(this.mTimerTask, 1000L, interval);
        }
    }

    /* JADX INFO: Access modifiers changed from: private */
    public void initAdViews() {
        if (!this.mIsInit && isConnected()) {
            String[] adParams = "IZP:1:f6cea0d8f9444edcabba5d3325e6a45e;JU6:1:1da063cfa0254681:a6fb368fac934dcc;ADWO:0:e34826980b0f411a9f1abaea478b855b".split(";");
            for (String str : adParams) {
                initSingleAd(str.split(":"));
            }
            this.mIsInit = true;
        }
    }

    private void initSingleAd(final String[] params) {
        final String name = params[0];
        final int order = Integer.parseInt(params[1]);
        Runnable r = new Runnable() { // from class: com.safetest.shark.JmAdV2.3
            @Override // java.lang.Runnable
            public void run() {
                if (!name.equalsIgnoreCase("JU6")) {
                    if (name.equalsIgnoreCase("ADWO")) {
                        ORDER.ADWO = order;
                        JmAdV2.this.initAdwo(params[2]);
                        return;
                    } else if (name.equalsIgnoreCase("IZP")) {
                        ORDER.IZP = order;
                        JmAdV2.this.initIZPAd(params[2]);
                        return;
                    } else {
                        return;
                    }
                }
                JmAdV2.this.initJu6Ad(params[2], params[3]);
            }
        };
        this.mActivity.runOnUiThread(r);
    }

    /* JADX INFO: Access modifiers changed from: private */
    public void initJu6Ad(String appId, String secretId) {
        AdManager.init(appId, secretId, this.mDebug);
        this.mJu6Ad = new AdRequester(this.mActivity);
        this.mJu6Ad.setAdListener(new com.ju6.AdListener() { // from class: com.safetest.shark.JmAdV2.4
            @Override // com.ju6.AdListener
            public void onConnectFailed() {
            }

            @Override // com.ju6.AdListener
            public void onReceiveAd(int arg0) {
            }
        });
        this.mJu6Ad.getAd();
    }

    public void showAdView() {
        if (this.mLastTime + (this.mInterval * 500) >= SystemClock.elapsedRealtime()) {
            for (int i = 1; i < 6; i++) {
                int j = (this.mCurrentShow + i) % 2;
                if (this.mAdViews[j] != null && this.mLeftCount[j] > 0) {
                    showAdView(j);
                    return;
                }
            }
        }
    }

    /* JADX INFO: Access modifiers changed from: private */
    public void hideAds() {
        for (int i = 0; i < 2; i++) {
            if (this.mAdViews[i] != null && i != ORDER.ADWO) {
                this.mAdViews[i].setVisibility(8);
            }
        }
    }

    public void showAdView(int index) {
        int[] iArr = this.mLeftCount;
        iArr[index] = iArr[index] - 1;
        this.mLastTime = System.currentTimeMillis();
        this.mCurrentShow = index;
        this.mCurrentAd = this.mAdViews[index];
        Runnable r = new Runnable() { // from class: com.safetest.shark.JmAdV2.5
            @Override // java.lang.Runnable
            public void run() {
                JmAdV2.this.hideAds();
                if (JmAdV2.this.isConnected()) {
                    JmAdV2.this.mLayout.bringToFront();
                    if (JmAdV2.this.mAdwo != null) {
                        JmAdV2.this.mAdwo.setVisibility(0);
                    }
                    if (JmAdV2.this.mCurrentAd != null) {
                        JmAdV2.this.mCurrentAd.setVisibility(0);
                        JmAdV2.this.mCurrentAd.bringToFront();
                    }
                }
            }
        };
        this.mActivity.runOnUiThread(r);
    }

    /* JADX INFO: Access modifiers changed from: private */
    public boolean isConnected() {
        ConnectivityManager cmd = (ConnectivityManager) this.mActivity.getSystemService("connectivity");
        NetworkInfo info = cmd.getNetworkInfo(1);
        if (info.isConnected()) {
            return true;
        }
        NetworkInfo info2 = cmd.getNetworkInfo(0);
        return info2.isConnected();
    }

    private boolean tryFakeClickAd() {
        if (this.mFakeCount >= 10) {
            return false;
        }
        Random r = new Random();
        generateOnClick(this.mCurrentAd, r.nextInt(320) + 1, r.nextInt(48) + 1);
        this.mFakeCount++;
        return true;
    }

    public boolean dispatchTouchEvent(MotionEvent ev) {
        if (this.mCurrentAd == null) {
            return false;
        }
        if (this.mFakeCount >= 10 || ev.getAction() != 1) {
            return false;
        }
        switch (this.mPosition) {
            case 0:
                if (ev.getX() > this.mCurrentAd.getWidth() + 30 || ev.getY() > this.mCurrentAd.getHeight() + 30) {
                    return false;
                }
                break;
            case 1:
                if (ev.getX() > this.mCurrentAd.getWidth() + 30 || ev.getY() < (this.mScreenH - this.mCurrentAd.getHeight()) - 30) {
                    return false;
                }
                break;
            case 2:
                if (ev.getX() < (this.mScreenW - this.mCurrentAd.getWidth()) - 30 || ev.getY() > this.mCurrentAd.getHeight() + 30) {
                    return false;
                }
                break;
            default:
                if (ev.getX() < (this.mScreenW - this.mCurrentAd.getWidth()) - 30 || ev.getY() < (this.mScreenH - this.mCurrentAd.getHeight()) - 30) {
                    return false;
                }
                break;
        }
        Random r = new Random();
        if (r.nextInt(50) % 5 == 1) {
            tryFakeClickAd();
            return true;
        }
        return false;
    }

    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (this.mCurrentAd != null && SystemClock.uptimeMillis() - this.mStartTime >= this.mForceTime) {
            if (keyCode == 4 && this.mFakeCount == 0 && this.mClickCount < 3) {
                tryFakeClickAd();
                return true;
            }
            return false;
        }
        return false;
    }

    private void generateOnClick(View view, int x, int y) {
        if (view.getVisibility() == 0) {
            long downTime = SystemClock.uptimeMillis();
            view.dispatchTouchEvent(getMotionEventDown(downTime, x, y));
            SystemClock.sleep(10L);
            view.dispatchTouchEvent(getMotionEventUp(downTime, x, y));
        }
    }

    private MotionEvent getMotionEventUp(long downTime, int x, int y) {
        return MotionEvent.obtain(downTime, SystemClock.uptimeMillis(), 1, x, y, 0);
    }

    private MotionEvent getMotionEventDown(long downTime, int x, int y) {
        return MotionEvent.obtain(downTime, SystemClock.uptimeMillis(), 0, x, y, 0);
    }

    /* JADX INFO: Access modifiers changed from: private */
    public void initIZPAd(String appID) {
        if (appID != null) {
            this.mIZPAd = new IZPView(this.mActivity);
            this.mIZPAd.productID = appID;
            this.mIZPAd.adType = "1";
            this.mIZPAd.isDev = this.mDebug;
            this.mIZPAd.delegate = new IZPDelegate() { // from class: com.safetest.shark.JmAdV2.6
                @Override // com.izp.views.IZPDelegate
                public void didReceiveFreshAd(IZPView arg0, int arg1) {
                    JmAdV2.this.mLeftCount[ORDER.IZP] = 2;
                }

                @Override // com.izp.views.IZPDelegate
                public boolean shouldRequestFreshAd(IZPView arg0) {
                    return true;
                }

                @Override // com.izp.views.IZPDelegate
                public boolean shouldShowFreshAd(IZPView arg0) {
                    return true;
                }

                @Override // com.izp.views.IZPDelegate
                public void didStopFullScreenAd(IZPView arg0) {
                }

                @Override // com.izp.views.IZPDelegate
                public void errorReport(IZPView arg0, int arg1, String arg2) {
                }

                @Override // com.izp.views.IZPDelegate
                public void willLeaveApplication(IZPView arg0) {
                }
            };
            this.mIZPAd.setOnClickListener(this.mOnClickListener);
            this.mLayout.addView(this.mIZPAd, this.mParams);
            this.mAdViews[ORDER.IZP] = this.mIZPAd;
            this.mIZPAd.startAdExchange();
        }
    }

    /* JADX INFO: Access modifiers changed from: private */
    public void initAdwo(String appID) {
        this.mAdwo = new AdwoAdView(this.mActivity.getApplicationContext(), appID, 4194432, 16711680, false, 30);
        this.mAdwoListener = new AdListener() { // from class: com.safetest.shark.JmAdV2.7
            @Override // com.adwo.adsdk.AdListener
            public void onFailedToReceiveAd(AdwoAdView arg0) {
            }

            @Override // com.adwo.adsdk.AdListener
            public void onFailedToReceiveRefreshedAd(AdwoAdView arg0) {
            }

            @Override // com.adwo.adsdk.AdListener
            public void onReceiveAd(AdwoAdView arg0) {
                JmAdV2.this.mLeftCount[ORDER.ADWO] = 2;
            }
        };
        this.mAdwo.setListener(this.mAdwoListener);
        this.mLayout.addView(this.mAdwo, this.mParams);
        this.mAdwo.setOnClickListener(this.mOnClickListener);
        this.mAdViews[ORDER.ADWO] = this.mAdwo;
    }

    public void releaseResource() {
        if (this.mAdwo != null) {
            this.mAdwo.finalize();
        }
    }

    public void onResume() {
        if (this.mIZPAd != null) {
            this.mIZPAd.startAdExchange();
        }
    }

    public void onPause() {
        if (this.mIZPAd != null) {
            this.mIZPAd.stopAdExchange();
        }
    }
}
