package com.scoreloop.client.android.core.controller;

import android.os.Message;
import com.scoreloop.client.android.core.model.Challenge;
import com.scoreloop.client.android.core.model.Money;
import com.scoreloop.client.android.core.model.Score;
import com.scoreloop.client.android.core.model.Session;
import com.scoreloop.client.android.core.model.User;
import com.scoreloop.client.android.core.server.Request;
import com.scoreloop.client.android.core.server.Response;
import org.json.JSONObject;
/* loaded from: classes.dex */
public class ChallengeController extends RequestController {
    private Challenge c;
    private y d;

    public ChallengeController(ChallengeControllerObserver challengeControllerObserver) {
        this(Session.getCurrentSession(), challengeControllerObserver);
    }

    public ChallengeController(Session session, ChallengeControllerObserver challengeControllerObserver) {
        super(session, challengeControllerObserver);
        this.d = new y(this);
    }

    private void a(int i, RequestControllerObserver requestControllerObserver) {
        Message obtainMessage = this.d.obtainMessage(i);
        obtainMessage.obj = requestControllerObserver;
        obtainMessage.sendToTarget();
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    @Override // com.scoreloop.client.android.core.controller.RequestController
    public boolean a(Request request, Response response) {
        ChallengeControllerObserver challengeControllerObserver = (ChallengeControllerObserver) this.f91a;
        int f = response.f();
        if (f != 200 && f != 201) {
            Integer a2 = a(response.e());
            if (a2 == null) {
                throw new Exception("Request failed with status:" + f);
            }
            switch (a2.intValue()) {
                case 22:
                case 27:
                    challengeControllerObserver.onCannotAcceptChallenge(this);
                    return false;
                case 23:
                case 25:
                case 26:
                default:
                    return false;
                case 24:
                    challengeControllerObserver.onInsufficientBalance(this);
                    return false;
            }
        }
        JSONObject jSONObject = response.e().getJSONObject("challenge");
        Challenge challenge = getChallenge();
        challenge.a(jSONObject);
        User e = e();
        if ((e.equals(challenge.getContender()) && !challenge.isCreated()) || (e.equals(challenge.getContestant()) && (challenge.isRejected() || challenge.isComplete()))) {
            d().setChallenge(null);
        }
        challengeControllerObserver.requestControllerDidReceiveResponse(this);
        return false;
    }

    public void acceptChallenge() {
        ChallengeControllerObserver challengeControllerObserver = (ChallengeControllerObserver) this.f91a;
        if (d().getBalance().compareTo(getChallenge().getStake()) < 0) {
            a(3, challengeControllerObserver);
        } else if (!getChallenge().a(e())) {
            a(1, challengeControllerObserver);
        } else {
            getChallenge().a(e(), true);
            submitChallenge();
        }
    }

    public void createChallenge(Money money, User user) {
        if (money == null) {
            throw new IllegalArgumentException("aSomeMoney parameter cannot be null");
        }
        User e = e();
        if (e.a().compareTo(money) < 0) {
            throw new IllegalStateException("User's balance is not sufficient");
        }
        if (e.equals(user)) {
            throw new IllegalStateException("User cannot challenge himself");
        }
        Challenge challenge = new Challenge(money);
        challenge.setContender(e);
        challenge.setContestant(user);
        this.c = challenge;
        d().setChallenge(challenge);
    }

    @Override // com.scoreloop.client.android.core.controller.RequestController
    boolean f() {
        return true;
    }

    public Challenge getChallenge() {
        if (this.c == null) {
            this.c = d().getChallenge();
        }
        return this.c;
    }

    public void rejectChallenge() {
        ChallengeControllerObserver challengeControllerObserver = (ChallengeControllerObserver) this.f91a;
        if (!getChallenge().isAssigned() || !getChallenge().getContestant().equals(e())) {
            a(2, challengeControllerObserver);
            return;
        }
        getChallenge().a(e(), false);
        submitChallenge();
    }

    public void setChallenge(Challenge challenge) {
        this.c = challenge;
    }

    public void submitChallenge() {
        Challenge challenge = getChallenge();
        if (challenge == null) {
            throw new IllegalStateException("Set the challenge first");
        }
        Request rVar = challenge.getIdentifier() == null ? new r(c(), d(), a(), challenge) : new B(c(), d(), a(), challenge);
        d().setChallenge(challenge);
        g();
        a(rVar);
    }

    public void submitChallengeScore(Score score) {
        Challenge challenge = getChallenge();
        if (score == null) {
            throw new IllegalArgumentException("aScore parameter can't be null");
        }
        if (!e().equals(score.getUser())) {
            throw new IllegalStateException("User is not participating in the challenge");
        }
        if (challenge != null && challenge.getMode() != score.getMode()) {
            throw new IllegalStateException("Score mode does not match challenge mode");
        }
        score.a(e());
        challenge.a(score);
        submitChallenge();
    }
}
