package com.scoreloop.client.android.core.controller;

import com.ju6.mms.pdu.PduPersister;
import com.scoreloop.client.android.core.model.Game;
import com.scoreloop.client.android.core.model.Session;
import com.scoreloop.client.android.core.model.User;
import com.scoreloop.client.android.core.server.Request;
import com.scoreloop.client.android.core.server.Response;
import com.scoreloop.client.android.core.utils.Logger;
import org.json.JSONObject;
/* loaded from: classes.dex */
public abstract class RequestController {
    static final /* synthetic */ boolean b;

    /* renamed from: a */
    RequestControllerObserver f91a;
    private final x c;
    private Request d;
    private final Session e;
    private M f;

    static {
        b = !RequestController.class.desiredAssertionStatus();
    }

    public RequestController(Session session, RequestControllerObserver requestControllerObserver) {
        if (requestControllerObserver == null) {
            throw new IllegalArgumentException("observer parameter cannot be null");
        }
        if (session == null) {
            this.e = Session.getCurrentSession();
        } else {
            this.e = session;
        }
        if (!b && this.e == null) {
            throw new AssertionError();
        }
        this.f91a = requestControllerObserver;
        this.c = new x(this);
    }

    public static Integer a(JSONObject jSONObject) {
        JSONObject jSONObject2;
        if (!jSONObject.has(PduPersister.ThreadsColumns.ERROR) || (jSONObject2 = jSONObject.getJSONObject(PduPersister.ThreadsColumns.ERROR)) == null) {
            return null;
        }
        return Integer.valueOf(jSONObject2.getInt("code"));
    }

    private void b(Request request) {
        this.d = request;
    }

    public void c(Exception exc) {
        Logger.a("onRequestCompleted", "failed with exception: ", exc);
        if (this.f91a == null) {
            throw new IllegalStateException("could not invoke ControllerDidFail() because of the lack of the observer in the RequestController's instance !");
        }
        this.f91a.requestControllerDidFail(this, exc);
    }

    private Request h() {
        return this.d;
    }

    public void i() {
        Logger.a("RequestController.invokeDidReceiveResponse", " observer = " + this.f91a.toString());
        if (this.f91a == null) {
            throw new IllegalStateException("could not invoke DidReceiveResponse() because of the lack of the observer in the RequestController's instance !");
        }
        this.f91a.requestControllerDidReceiveResponse(this);
    }

    public final Game a() {
        return d().getGame();
    }

    public void a(Request request) {
        Session.State b2;
        if (f() && (b2 = d().b()) != Session.State.AUTHENTICATED && b2 != Session.State.AUTHENTICATING) {
            if (this.f == null) {
                this.f = new M(d(), new t(this));
            }
            this.f.h();
        }
        b(request);
        this.e.a().a(request);
    }

    public void a(Exception exc) {
        Logger.a("RequestController.invokeDelayedDidReceiveResponse", " observer = " + this.f91a.toString());
        if (this.f91a == null) {
            throw new IllegalStateException("could not invoke DidReceiveResponse() because of the lack of the observer in the RequestController's instance !");
        }
        new p(this, this.f91a, true, exc).obtainMessage().sendToTarget();
    }

    public abstract boolean a(Request request, Response response);

    public RequestControllerObserver b() {
        return this.f91a;
    }

    public void b(Exception exc) {
        Request h = h();
        if (h != null) {
            h.a(exc);
            c(exc);
        }
    }

    public x c() {
        return this.c;
    }

    public final Session d() {
        return this.e;
    }

    public final User e() {
        return d().getUser();
    }

    abstract boolean f();

    public void g() {
        if (this.d != null) {
            if (!this.d.m()) {
                this.e.a().b(this.d);
            }
            this.d = null;
        }
    }
}
