package com.scoreloop.client.android.core.controller;

import com.ju6.mms.pdu.PduPart;
import com.ju6.mms.pdu.PduPersister;
import com.scoreloop.client.android.core.model.Session;
import com.scoreloop.client.android.core.model.User;
import com.scoreloop.client.android.core.server.Request;
import com.scoreloop.client.android.core.server.RequestMethod;
import com.scoreloop.client.android.core.server.Response;
import com.scoreloop.client.android.core.utils.JSONUtils;
import java.util.HashMap;
import java.util.regex.Pattern;
import org.json.JSONArray;
import org.json.JSONObject;
/* loaded from: classes.dex */
public class UserController extends RequestController {
    private static final Pattern c = Pattern.compile(".*taken.*", 2);
    private User d;

    public UserController(UserControllerObserver userControllerObserver) {
        this(Session.getCurrentSession(), userControllerObserver);
    }

    public UserController(Session session, UserControllerObserver userControllerObserver) {
        super(session, userControllerObserver);
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    @Override // com.scoreloop.client.android.core.controller.RequestController
    public boolean a(Request request, Response response) {
        int f = response.f();
        RequestMethod b = request.b();
        JSONObject e = response.e();
        switch (f) {
            case PduPart.P_CONTENT_TRANSFER_ENCODING /* 200 */:
            case 201:
                switch (C0030j.f101a[b.ordinal()]) {
                    case 1:
                    case 2:
                    case 3:
                        if (!e.has(PduPersister.Carriers.USER) && !e.has("context")) {
                            throw new Exception("Request failed");
                        }
                        break;
                    case 4:
                        if (!e.has("buddy_id")) {
                            throw new Exception("Request failed");
                        }
                        break;
                }
                if (b != RequestMethod.DELETE) {
                    User user = getUser();
                    if (e.has(PduPersister.Carriers.USER)) {
                        user.a(e.getJSONObject(PduPersister.Carriers.USER));
                    }
                    if (e.has("context")) {
                        user.setContext(JSONUtils.a(e.getJSONObject("context")));
                        user.c(e.getString("version"));
                    }
                }
                return true;
            case 409:
                User user2 = getUser();
                HashMap hashMap = new HashMap();
                hashMap.put("oldUserContext", new HashMap(user2.getContext()));
                user2.setContext(JSONUtils.a(e.getJSONObject("context")));
                user2.c(e.getString("version"));
                hashMap.put("newUserContext", new HashMap(user2.getContext()));
                throw new Exception("Request failed");
            case 422:
                if (b == RequestMethod.PUT || b == RequestMethod.POST) {
                    JSONObject jSONObject = e.getJSONObject(PduPersister.ThreadsColumns.ERROR);
                    JSONArray jSONArray = jSONObject.get("args") instanceof JSONArray ? jSONObject.getJSONArray("args") : null;
                    int length = jSONArray == null ? 0 : jSONArray.length();
                    boolean z = false;
                    boolean z2 = false;
                    for (int i = 0; i < length; i++) {
                        JSONArray jSONArray2 = jSONArray.getJSONArray(i);
                        String string = jSONArray2.getString(0);
                        String string2 = jSONArray2.getString(1);
                        if ("email".equalsIgnoreCase(string.trim())) {
                            if (c.matcher(string2).matches()) {
                                z = true;
                                z2 = true;
                            } else {
                                z = true;
                            }
                        }
                    }
                    if (!z) {
                        ((UserControllerObserver) b()).onUsernameAlreadyTaken(this);
                        return false;
                    } else if (z2) {
                        ((UserControllerObserver) b()).onEmailAlreadyTaken(this);
                        return false;
                    } else {
                        ((UserControllerObserver) b()).onEmailInvalidFormat(this);
                        return false;
                    }
                }
                throw new Exception("Request failed");
            default:
                throw new Exception("Request failed");
        }
    }

    public void addAsBuddy() {
        User user = getUser();
        User e = e();
        if (user.f()) {
            a(new Exception("User you're trying to add as buddy is a current session user"));
            return;
        }
        n nVar = new n(c(), user, e);
        g();
        a(nVar);
    }

    @Override // com.scoreloop.client.android.core.controller.RequestController
    boolean f() {
        return true;
    }

    public User getUser() {
        if (this.d == null) {
            this.d = super.e();
            if (this.d == null) {
                throw new IllegalStateException("No session user assigned");
            }
        }
        return this.d;
    }

    public void removeAsBuddy() {
        F f = new F(c(), getUser(), e());
        g();
        a(f);
    }

    public void requestBuddies() {
        u uVar = new u(c(), a(), getUser());
        g();
        a(uVar);
    }

    public void requestUser() {
        C c2 = new C(c(), a(), getUser());
        g();
        a(c2);
    }

    public void requestUserContext() {
        C0032l c0032l = new C0032l(c(), getUser(), a());
        g();
        a(c0032l);
    }

    public void requestUserDetail() {
        User user = getUser();
        User e = e();
        if (user.f()) {
            e = null;
        }
        E e2 = new E(c(), a(), user, e);
        g();
        a(e2);
    }

    public void requestUserWithIdentifier(String str) {
        if (str == null) {
            throw new IllegalArgumentException("anIdentifier parameter cannot be null");
        }
        this.d = new User();
        this.d.b(str);
        requestUser();
    }

    public void setUser(User user) {
        this.d = user;
    }

    public void updateUser() {
        C0021a c0021a = new C0021a(c(), a(), getUser());
        g();
        a(c0021a);
    }

    public void updateUserContext() {
        z zVar = new z(c(), getUser(), a());
        g();
        a(zVar);
    }
}
