package com.scoreloop.client.android.core.model;

import com.scoreloop.client.android.core.ClientObserver;
import com.scoreloop.client.android.core.SessionObserver;
import com.scoreloop.client.android.core.server.Server;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.BitSet;
/* loaded from: classes.dex */
public class Client implements SessionObserver {

    /* renamed from: a  reason: collision with root package name */
    private final BitSet f112a;
    private final ClientObserver b;
    private final Server c;
    private final Session d;

    public Client(String str, String str2, ClientObserver clientObserver) {
        this(str, str2, clientObserver, "https://api.scoreloop.com/bayeux");
    }

    Client(String str, String str2, ClientObserver clientObserver, String str3) {
        this.f112a = new BitSet();
        this.b = clientObserver;
        Game game = new Game(str, str2);
        game.setVersion("1.0");
        try {
            this.c = new Server(new URL(str3));
            this.c.a(game);
            this.d = new Session(this, this.c);
            this.d.a(game);
            Session.a(this.d);
        } catch (MalformedURLException e) {
            throw new IllegalStateException(e);
        }
    }

    private Game a() {
        return this.d.getGame();
    }

    public Range getGameLevels() {
        return !a().hasLevels() ? new Range(0, 1) : new Range(a().getMinLevel().intValue(), a().getLevelCount().intValue());
    }

    public Range getGameModes() {
        return !a().hasModes() ? new Range(0, 1) : new Range(a().getMinMode().intValue(), a().getModeCount().intValue());
    }

    public Session getSession() {
        return this.d;
    }

    public void setGameLevels(Range range) {
        a().setMinLevel(Integer.valueOf(range.a()));
        a().setMaxLevel(Integer.valueOf(range.b()));
    }

    public void setGameModes(Range range) {
        a().setMinMode(Integer.valueOf(range.a()));
        a().setMaxMode(Integer.valueOf(range.b()));
    }
}
