package com.scoreloop.client.android.core.server;

import com.scoreloop.client.android.core.model.Game;
import com.scoreloop.client.android.core.server.Request;
import com.scoreloop.client.android.core.utils.Base64;
import com.scoreloop.client.android.core.utils.Logger;
import java.net.URL;
import java.nio.channels.IllegalSelectorException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Iterator;
import java.util.LinkedList;
import org.json.JSONException;
import org.json.JSONObject;
/* loaded from: classes.dex */
public class Server {

    /* renamed from: a */
    static final /* synthetic */ boolean f139a;
    private final URL b;
    private c e;
    private Request f;
    private final LinkedList g = new LinkedList();
    private final j d = new j(this);
    private final e c = new e(this.d);

    static {
        f139a = !Server.class.desiredAssertionStatus();
    }

    public Server(URL url) {
        this.b = url;
        this.c.setPriority(1);
        try {
            MessageDigest messageDigest = MessageDigest.getInstance("SHA1");
            messageDigest.reset();
            messageDigest.update("https://api.scoreloop.com/bayeux/android/v2".getBytes());
            byte[] digest = messageDigest.digest();
            messageDigest.reset();
            messageDigest.update("https://www.scoreloop.com/android/updates".getBytes());
            byte[] digest2 = messageDigest.digest();
            byte[] bArr = new byte[16];
            for (int i = 0; i < bArr.length; i++) {
                bArr[i] = (byte) ((digest[(i + 6) % digest.length] ^ digest2[(i + 3) % digest2.length]) ^ 62);
            }
            this.e = new c(b(), this.c, bArr);
            for (int i2 = 0; i2 < digest.length; i2++) {
                digest[i2] = (byte) (digest[i2] ^ 26);
            }
            this.e.b(Base64.a(digest));
            for (int i3 = 0; i3 < digest2.length; i3++) {
                digest2[i3] = (byte) (digest2[i3] ^ 53);
            }
            this.e.a(Base64.a(digest2));
            this.c.a(this.e);
            this.c.start();
        } catch (NoSuchAlgorithmException e) {
            throw new IllegalStateException();
        }
    }

    private void c() {
        if (this.f != null) {
            Logger.a("Server", "doCancelCurrentRequest canceling request: " + this.f.toString());
            this.f.n();
            this.f.g().a(this.f);
            this.c.b();
        }
    }

    private void c(Request request) {
        Logger.a("Server", "startProcessingRequest: " + request.toString());
        if (!f139a && request == null) {
            throw new AssertionError();
        }
        if (!f139a && request.m()) {
            throw new AssertionError();
        }
        if (!f139a && this.f != null) {
            throw new AssertionError();
        }
        this.f = request;
        this.f.g().b(this.f);
        this.f.p();
        this.c.a(this.f);
    }

    public void d() {
        Logger.a("dumpQueue: ", "currentRequest: " + (this.f != null ? this.f.toString() : "null"));
        Iterator it = this.g.iterator();
        while (it.hasNext()) {
            Request request = (Request) it.next();
            Logger.a("dumpQueue: ", request.toString() + ", " + request.l().toString());
        }
    }

    public void e() {
        Request request;
        if (!f139a && this.f != null) {
            throw new AssertionError();
        }
        do {
            request = (Request) this.g.poll();
            if (request != null && !request.m()) {
                c(request);
                return;
            }
        } while (request != null);
    }

    public void a() {
        this.c.a();
    }

    public void a(Game game) {
        this.c.a(game);
    }

    public void a(Request request) {
        Logger.a("Server", "addRequest: " + request.toString());
        if (request.l() == Request.State.ENQUEUED || request.l() == Request.State.EXECUTING) {
            throw new IllegalStateException("Request already enqueued or executing");
        }
        if (request.c() == null) {
            throw new IllegalStateException("Request channel is not set");
        }
        if (request.b() == null) {
            throw new IllegalStateException("Request method is not set");
        }
        if (request.i() == null) {
            request.a(new JSONObject());
        }
        try {
            request.i().put("method", request.b().toString());
            if (this.f == null && this.g.isEmpty()) {
                c(request);
                return;
            }
            request.o();
            this.g.add(request);
        } catch (JSONException e) {
            throw new IllegalSelectorException();
        }
    }

    URL b() {
        return this.b;
    }

    public void b(Request request) {
        Logger.a("Server", "cancelRequest: " + request.toString());
        if (this.f == request) {
            c();
            return;
        }
        request.n();
        request.g().a(request);
    }

    protected void finalize() {
        a();
        super.finalize();
    }
}
