package com.scoreloop.client.android.core.ui;

import android.app.Activity;
import com.ju6.mms.pdu.PduPersister;
import com.scoreloop.client.android.core.SocialProviderCallbackDispatcher;
import com.scoreloop.client.android.core.controller.SocialProviderControllerObserver;
import com.scoreloop.client.android.core.utils.JSONUtils;
import com.scoreloop.client.android.core.utils.Logger;
import com.scoreloop.client.android.core.utils.OAuthUrlBuilder;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.json.JSONException;
import org.json.JSONObject;
/* loaded from: classes.dex */
public class MySpaceAuthViewController extends AuthViewController {

    /* renamed from: a  reason: collision with root package name */
    private Activity f150a;
    private String b;
    private String c;
    private String d;
    private MyspaceCredentialsDialog e;

    public MySpaceAuthViewController(SocialProviderControllerObserver socialProviderControllerObserver) {
        super(socialProviderControllerObserver);
    }

    private String a(HttpResponse httpResponse) {
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(httpResponse.getEntity().getContent()));
        String str = "";
        while (true) {
            String readLine = bufferedReader.readLine();
            if (readLine == null) {
                bufferedReader.close();
                return str;
            }
            str = str + readLine;
        }
    }

    private void a(Exception exc) {
        this.e.dismiss();
        a().didFail(exc);
    }

    private Activity b() {
        return this.f150a;
    }

    /* JADX INFO: Access modifiers changed from: private */
    public URL b(String str) {
        OAuthUrlBuilder oAuthUrlBuilder = new OAuthUrlBuilder();
        oAuthUrlBuilder.b("PUT");
        oAuthUrlBuilder.a(new URL(str));
        oAuthUrlBuilder.a("73c6e22c33e14b56a329e7a19b40914c");
        return oAuthUrlBuilder.a("814d340412384e27b0d480add625fb4391d5cefac08e431f9797c3c9fa94caaf", (String) null);
    }

    private HttpPut b(String str, String str2, URL url) {
        HttpPut httpPut = new HttpPut(url.toURI());
        httpPut.setHeader("Content-Type", "application/json");
        httpPut.setEntity(new StringEntity(a(str, str2).toString()));
        return httpPut;
    }

    private boolean b(JSONObject jSONObject) {
        return JSONUtils.a(jSONObject, "token") && JSONUtils.a(jSONObject, "tokenSecret") && JSONUtils.a(jSONObject, "userId");
    }

    private void c() {
        this.e.dismiss();
        a().didEnterInvalidCredentials();
    }

    private boolean c(JSONObject jSONObject) {
        if (JSONUtils.a(jSONObject, "captcha")) {
            JSONObject jSONObject2 = jSONObject.getJSONObject("captcha");
            return JSONUtils.a(jSONObject2, "captchaImageUri") && JSONUtils.a(jSONObject2, "captchaGuid");
        }
        return false;
    }

    private void d(JSONObject jSONObject) {
        Logger.a("myspace response parser", "MYSPACE: valid user credentials acquired");
        String string = jSONObject.getString("token");
        String string2 = jSONObject.getString("tokenSecret");
        String string3 = jSONObject.getString("userId");
        JSONObject jSONObject2 = new JSONObject();
        jSONObject2.put("uid", string3);
        jSONObject2.put("token", string);
        jSONObject2.put("token_secret", string2);
        a(jSONObject2);
        this.e.dismiss();
    }

    private void e(JSONObject jSONObject) {
        JSONObject jSONObject2 = jSONObject.getJSONObject("captcha");
        Logger.a("myspace response parser", "MYSPACE: captcha request aquired");
        String string = jSONObject2.getString("captchaImageUri");
        this.b = jSONObject2.getString("captchaGuid");
        MyspaceCaptchaDialog myspaceCaptchaDialog = new MyspaceCaptchaDialog(b(), new d(this), string);
        this.e.dismiss();
        myspaceCaptchaDialog.show();
    }

    JSONObject a(String str, String str2) {
        JSONObject jSONObject = new JSONObject();
        jSONObject.put("username", str);
        jSONObject.put(PduPersister.Carriers.PASSWORD, str2);
        return jSONObject;
    }

    @Override // com.scoreloop.client.android.core.ui.AuthViewController
    public void a(Activity activity) {
        this.f150a = activity;
        this.e = new MyspaceCredentialsDialog(b(), new c(this));
        this.e.show();
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void a(String str) {
        try {
            a(this.c, this.d, b("https://roa.myspace.com/roa/09/messaging/login/" + this.b + "/" + str));
        } catch (MalformedURLException e) {
            throw new IllegalStateException(e);
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public void a(String str, String str2, URL url) {
        try {
            this.c = str;
            this.d = str2;
            Logger.a("myspace url:", url.toString());
            JSONObject jSONObject = new JSONObject(a(new DefaultHttpClient().execute(b(str, str2, url))));
            Logger.a("myspace response parsed json:", jSONObject.toString(4));
            if (b(jSONObject)) {
                d(jSONObject);
            } else if (c(jSONObject)) {
                e(jSONObject);
            } else {
                c();
            }
        } catch (ClientProtocolException e) {
            a((Exception) e);
        } catch (UnsupportedEncodingException e2) {
            a(e2);
        } catch (IOException e3) {
            a(e3);
        } catch (URISyntaxException e4) {
            a(e4);
        } catch (JSONException e5) {
            a(e5);
        }
    }

    public void a(JSONObject jSONObject) {
        SocialProviderCallbackDispatcher.a(jSONObject);
    }
}
