package com.slg.j2me.game;

import android.graphics.Bitmap;
import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gfx.GfxUtils;
import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gfx.ImageSet;
import com.slg.j2me.lib.sys.FixedPoint;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.ImageLoader;
/* loaded from: classes.dex */
class Effects {
    public static final int cMaxEffects = 50;
    public static final int eBlendAdd = 1;
    public static final int eBlendNormal = 0;
    public static final int eEffectBloodCloudLarge = 3;
    public static final int eEffectBloodCloudSmall = 2;
    public static final int eEffectBloodSplatterLarge = 1;
    public static final int eEffectBloodSplatterSmall = 0;
    public static final int eEffectBubble = 7;
    public static final int eEffectCircle = 16;
    public static final int eEffectGibDiverHead = 17;
    public static final int eEffectGibDiverLeg = 18;
    public static final int eEffectGibHuman1 = 19;
    public static final int eEffectGibHuman2 = 20;
    public static final int eEffectGibLarge = 6;
    public static final int eEffectGibMedium = 5;
    public static final int eEffectGibSmall = 4;
    public static final int eEffectMineExplode = 8;
    public static final int eEffectPlankton1 = 9;
    public static final int eEffectPlankton2 = 10;
    public static final int eEffectPlankton3 = 11;
    public static final int eEffectPlankton4 = 12;
    public static final int eEffectSplashFroth = 15;
    public static final int eEffectSplashLarge = 14;
    public static final int eEffectSplashSmall = 13;
    public static final int eFlagDeleteAboveWaterSurface = 2;
    public static final int eFlagScaleAnimToFitLifeTime = 4;
    public static final int eFlagSharkMouthRelative = 1;
    public static final int eNumEffects = 21;
    public static final int eNumParams = 20;
    public static final int eNumPresets = 24;
    public static final int eParamAnimRate = 18;
    public static final int eParamBlendMode = 6;
    public static final int eParamColor0 = 7;
    public static final int eParamColor1 = 8;
    public static final int eParamColorBlendDelay = 9;
    public static final int eParamEffectMax = 1;
    public static final int eParamEffectMin = 0;
    public static final int eParamFlags = 19;
    public static final int eParamLifeMax = 17;
    public static final int eParamLifeMin = 16;
    public static final int eParamSize0Max = 3;
    public static final int eParamSize0Min = 2;
    public static final int eParamSize1Max = 5;
    public static final int eParamSize1Min = 4;
    public static final int eParamSpawnRadiusX = 10;
    public static final int eParamSpawnRadiusY = 11;
    public static final int eParamSpeedMax = 15;
    public static final int eParamSpeedMin = 14;
    public static final int eParamSpreadMax = 13;
    public static final int eParamSpreadMin = 12;
    public static final int ePresetAmbientBubble = 0;
    public static final int ePresetBloodJellyfish = 22;
    public static final int ePresetBloodLarge = 8;
    public static final int ePresetBloodMedium = 7;
    public static final int ePresetBloodSmall = 6;
    public static final int ePresetBloodXLarge = 9;
    public static final int ePresetCollectBonusWoosh = 21;
    public static final int ePresetExplosionBubble = 3;
    public static final int ePresetGibDiverHead = 13;
    public static final int ePresetGibDiverLeg = 14;
    public static final int ePresetGibHuman = 15;
    public static final int ePresetGibJellyfish = 23;
    public static final int ePresetGibLarge = 12;
    public static final int ePresetGibMedium = 11;
    public static final int ePresetGibSmall = 10;
    public static final int ePresetKillBubble = 1;
    public static final int ePresetMineExplosion = 5;
    public static final int ePresetPlankton = 4;
    public static final int ePresetSplashEnter = 17;
    public static final int ePresetSplashEnterSmall = 18;
    public static final int ePresetSplashExit = 19;
    public static final int ePresetSplashRandom = 16;
    public static final int ePresetSplashWake = 20;
    public static final int ePresetSubKillBubble = 2;
    private ImageSequence[] gfxEffects = new ImageSequence[21];
    private ImageSet isEffects;
    public static Effects instance = null;
    private static String[] effectNames = {"bloodsplatter-small", "bloodsplatter-large", "bloodcloud-small", "bloodcloud-large", "gib-small", "gib-medium", "gib-large", "bubble", "mine-explode", "plankton1", "plankton2", "plankton3", "plankton4", "splash-small", "splash-large", "splash-froth", "particle", "diver-head-gib", "diver-leg-gib", "human-gib1", "human-gib2"};
    private static int[][] presetTable = {new int[]{7, 7, 32768, FixedPoint.stringToFP("0.7"), 65536, 65536, 0, -1, 16777215, FixedPoint.stringToFP("0.95"), 0, 0, FixedPoint.stringToFP("0.7"), 65536, 131072, 262144, 196608, 262144, 16384, 2}, new int[]{7, 7, FixedPoint.stringToFP("0.7"), 65536, 65536, 65536, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, FixedPoint.stringToFP("0.3"), 65536, 131072, 262144, 65536, 65536, 16384, 2}, new int[]{7, 7, FixedPoint.stringToFP("0.7"), 65536, 65536, 65536, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 131072, 98304, FixedPoint.stringToFP("0.3"), 65536, 131072, 262144, 65536, 65536, 16384, 2}, new int[]{7, 7, 65536, 65536, 65536, 65536, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 65536, GameObj.cfpSharkWakePosYMin, 65536, 393216, 786432, 65536, 65536, 16384, 2}, new int[]{9, 12, GameLogic.cfpIntroFadeTime, 65536, 65536, 131072, FixedPoint.stringToFP("0.8"), 0, -1, 16777215, 0, 0, 32768, 65536, 196608, 393216, 131072, 131072, 65536, 2}, new int[]{8, 8, 131072, 131072, 131072, 131072, 0, -1, -1, 0, 0, 0, 0, 0, 0, 0, 65536, 65536, 65536, 4}, new int[]{0, 3, 32768, 32768, 98304, 131072, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, GameObj.cfpSharkWakePosYMin, 65536, 0, 65536, GameLogic.cfpIntroFadeTime, 65536, 65536, 0}, new int[]{0, 3, GameLogic.cfpIntroFadeTime, GameLogic.cfpIntroFadeTime, 98304, 131072, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, GameObj.cfpSharkWakePosYMin, 65536, 0, 65536, GameLogic.cfpIntroFadeTime, 65536, 65536, 0}, new int[]{0, 3, 65536, 65536, 98304, 131072, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, GameObj.cfpSharkWakePosYMin, 65536, 0, 65536, GameLogic.cfpIntroFadeTime, 65536, 65536, 0}, new int[]{0, 3, 65536, 65536, 98304, 131072, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 98304, GameLogic.cfpIntroFadeTime, GameObj.cfpSharkWakePosYMin, 65536, 65536, 131072, 65536, 98304, 65536, 0}, new int[]{4, 6, 32768, 32768, 98304, 131072, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, -49152, GameObj.cfpSharkWakePosYMin, 196608, 262144, GameLogic.cfpIntroFadeTime, 65536, 65536, 0}, new int[]{4, 6, GameLogic.cfpIntroFadeTime, GameLogic.cfpIntroFadeTime, 98304, 131072, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, -49152, GameObj.cfpSharkWakePosYMin, 196608, 262144, GameLogic.cfpIntroFadeTime, 65536, 65536, 0}, new int[]{4, 6, 65536, 65536, 98304, 131072, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, -49152, GameObj.cfpSharkWakePosYMin, 196608, 262144, GameLogic.cfpIntroFadeTime, 65536, 65536, 0}, new int[]{17, 17, 65536, 65536, 65536, 65536, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, -49152, GameObj.cfpSharkWakePosYMin, 196608, 262144, 98304, 131072, 65536, 0}, new int[]{18, 18, 65536, 65536, 65536, 65536, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, -49152, GameObj.cfpSharkWakePosYMin, 196608, 262144, 98304, 131072, 65536, 0}, new int[]{19, 20, 65536, 65536, 65536, 65536, 0, -1, 16777215, FixedPoint.stringToFP("0.8"), 65536, 32768, -49152, GameObj.cfpSharkWakePosYMin, 196608, 262144, 98304, 131072, 65536, 0}, new int[]{13, 15, 65536, 65536, 131072, 262144, 0, -1, -1, 0, 524288, 0, 0, 0, 0, 0, 32768, 98304, 65536, 4}, new int[]{14, 14, 98304, 131072, 65536, 131072, 0, -1, -1, 0, 262144, 0, 0, 0, 0, 0, 32768, 98304, 65536, 4}, new int[]{14, 14, GameLogic.cfpIntroFadeTime, 65536, 65536, 131072, 0, -1, -1, 0, 131072, 0, 0, 0, 0, 0, 32768, 98304, 65536, 4}, new int[]{13, 13, 98304, 131072, 65536, 131072, 0, -1, 16777215, FixedPoint.stringToFP("0.5"), 131072, 0, 0, 0, 0, 0, GameLogic.cfpIntroFadeTime, 65536, 65536, 4}, new int[]{15, 15, 32768, 65536, 65536, 98304, 0, -1, 16777215, FixedPoint.stringToFP("0.5"), 65536, 0, 0, 0, 0, 0, 32768, GameLogic.cfpIntroFadeTime, 65536, 4}, new int[]{16, 16, 32768, 32768, 98304, 131072, 1, -1, -16777216, 0, 32768, 32768, GameObj.cfpSharkWakePosYMin, 65536, 131072, 262144, 65536, 65536, 16384, 0}, new int[]{0, 3, GameLogic.cfpIntroFadeTime, GameLogic.cfpIntroFadeTime, 98304, 131072, 0, -16744193, 33023, FixedPoint.stringToFP("0.8"), 65536, 32768, GameObj.cfpSharkWakePosYMin, 65536, 0, 65536, GameLogic.cfpIntroFadeTime, 65536, 65536, 0}, new int[]{4, 6, GameLogic.cfpIntroFadeTime, GameLogic.cfpIntroFadeTime, 98304, 131072, 0, -16744193, 33023, FixedPoint.stringToFP("0.8"), 65536, 32768, -49152, GameObj.cfpSharkWakePosYMin, 196608, 262144, GameLogic.cfpIntroFadeTime, 65536, 65536, 0}};
    public static AnimSprite[] animSprite = new AnimSprite[50];
    public static boolean[] active = new boolean[50];
    public static int[] presetID = new int[50];
    public static int[] fpPosX = new int[50];
    public static int[] fpPosY = new int[50];
    public static int[] fpVelX = new int[50];
    public static int[] fpVelY = new int[50];
    public static int[] fpLifeTime = new int[50];
    public static int[] fpLifeTimeMax = new int[50];
    public static int[] fpColorBlendStartTime = new int[50];
    public static int[] fpSize0 = new int[50];
    public static int[] fpSize1 = new int[50];
    public static int[] flags = new int[50];

    public Effects() {
        ImageLoader.setImagePixelFormat("/effects_00.png", Bitmap.Config.ARGB_8888);
        instance = this;
        this.isEffects = new ImageSet("/effects.is", false);
        for (int i = 0; i < 21; i++) {
            this.gfxEffects[i] = this.isEffects.getImageSequence(effectNames[i]);
        }
        FrontEnd.gfxMenuEndGame = this.isEffects.getImageSequence("endgame");
        FrontEnd.gfxMenuResume = this.isEffects.getImageSequence("resume");
        FrontEnd.gfxMenuReplay = this.isEffects.getImageSequence("re-play");
        reset();
    }

    public void reset() {
        for (int i = 0; i < 50; i++) {
            if (animSprite[i] == null) {
                animSprite[i] = new AnimSprite();
            }
            active[i] = false;
        }
    }

    public void reload() {
        this.isEffects.reloadImages();
    }

    public void unload() {
        this.isEffects.unloadImages();
    }

    public void create(int preset, int numSpawn, int posX, int posY) {
        for (int i = 0; i < 50; i++) {
            if (!active[i]) {
                presetID[i] = preset;
                int[] table = presetTable[preset];
                int id = GameLogic.randRange(table[0], table[1]);
                fpSize0[i] = GameLogic.randRange(table[2], table[3]);
                fpSize1[i] = ((fpSize0[i] ^ GameLogic.randRange(table[4], table[5])) & 134217728) != 0 ? -((int) (((-fpSize0[i]) * GameLogic.randRange(table[4], table[5])) >> 16)) : (int) ((fpSize0[i] * GameLogic.randRange(table[4], table[5])) >> 16);
                fpLifeTime[i] = 0;
                fpLifeTimeMax[i] = GameLogic.randRange(table[16], table[17]);
                fpColorBlendStartTime[i] = ((fpLifeTimeMax[i] ^ table[9]) & 134217728) != 0 ? -((int) (((-fpLifeTimeMax[i]) * table[9]) >> 16)) : (int) ((fpLifeTimeMax[i] * table[9]) >> 16);
                int spawnRX = table[10];
                int spawnRY = table[11];
                fpPosX[i] = GameLogic.randRange(-spawnRY, spawnRX) + posX;
                fpPosY[i] = GameLogic.randRange(-spawnRY, spawnRY) + posY;
                int speed = GameLogic.randRange(table[14], table[15]);
                int spread = GameLogic.randRange(table[12], table[13]);
                int ang = spread << 6;
                if (GameLogic.randBoolean()) {
                    ang = GameObj.cfpDynamiteRotSpeedWater - ang;
                }
                int ang2 = ang & 16777215;
                fpVelX[i] = ((FixedPoint.sinLut(4194304 + ang2) ^ speed) & 134217728) != 0 ? -((int) (((-speed) * FixedPoint.sinLut(4194304 + ang2)) >> 16)) : (int) ((speed * FixedPoint.sinLut(4194304 + ang2)) >> 16);
                fpVelY[i] = (((-FixedPoint.sinLut(ang2)) ^ speed) & 134217728) != 0 ? -((int) (((-speed) * (-FixedPoint.sinLut(ang2))) >> 16)) : (int) ((speed * (-FixedPoint.sinLut(ang2))) >> 16);
                active[i] = true;
                flags[i] = table[19];
                int fpRateScale = table[18];
                boolean loop = fpLifeTimeMax[i] > 0;
                if ((flags[i] & 4) != 0) {
                    int defaultAnimTime = this.gfxEffects[id].numFrames * AnimSprite.cfpDefaultFrameDuration;
                    fpRateScale = fpLifeTimeMax[i] > 0 ? (int) ((defaultAnimTime << 16) / fpLifeTimeMax[i]) : 65536;
                    loop = false;
                }
                animSprite[i].startAnim(this.gfxEffects[id], id, loop, false, fpRateScale);
                animSprite[i].fpScale = fpSize0[i];
                animSprite[i].tintColor = table[7];
                animSprite[i].blendMode = table[6];
                numSpawn--;
                if (numSpawn == 0) {
                    return;
                }
            }
        }
    }

    public void process() {
        int dt = GameApp.fp_deltatime;
        for (int i = 0; i < 50; i++) {
            if (active[i]) {
                animSprite[i].animate(dt);
                boolean deleteUsingTimer = fpLifeTimeMax[i] > 0;
                if (!deleteUsingTimer && (animSprite[i].playFlags & 16) != 0) {
                    active[i] = false;
                } else {
                    int preset = presetID[i];
                    if (preset >= 0) {
                        int lifeTime = fpLifeTime[i];
                        int lifeTimeMax = fpLifeTimeMax[i];
                        int t = (int) ((lifeTime << 16) / lifeTimeMax);
                        int size0 = fpSize0[i];
                        int size1 = fpSize1[i];
                        if (size0 != size1) {
                            int size = FixedPoint.linearInterpolate(t, size0, size1);
                            animSprite[i].fpScale = size;
                        }
                        int[] table = presetTable[presetID[i]];
                        int col0 = table[7];
                        int col1 = table[8];
                        if (col0 != col1) {
                            int startTime = fpColorBlendStartTime[i];
                            if (startTime > 0) {
                                t = lifeTime <= startTime ? 0 : (int) (((lifeTime - startTime) << 16) / (lifeTimeMax - startTime));
                            }
                            animSprite[i].tintColor = GfxUtils.lerpColourWithAlpha(t, col0, col1);
                        }
                    }
                    if (deleteUsingTimer) {
                        int[] iArr = fpLifeTime;
                        iArr[i] = iArr[i] + dt;
                        if (fpLifeTime[i] >= fpLifeTimeMax[i]) {
                            active[i] = false;
                        }
                    }
                    int[] iArr2 = fpPosX;
                    iArr2[i] = iArr2[i] + (((fpVelX[i] ^ dt) & 134217728) != 0 ? -((int) (((-fpVelX[i]) * dt) >> 16)) : (int) ((fpVelX[i] * dt) >> 16));
                    int[] iArr3 = fpPosY;
                    iArr3[i] = iArr3[i] + (((fpVelY[i] ^ dt) & 134217728) != 0 ? -((int) (((-fpVelY[i]) * dt) >> 16)) : (int) ((fpVelY[i] * dt) >> 16));
                    if ((flags[i] & 2) != 0 && fpPosY[i] < Water.cfpWaterLevel) {
                        active[i] = false;
                    }
                }
            }
        }
    }

    public void paint(Graphics g) {
        for (int i = 0; i < 50; i++) {
            if (active[i]) {
                int wx = fpPosX[i];
                int wy = fpPosY[i];
                if ((flags[i] & 1) != 0) {
                    wx += GameObj.fpPlayerMouthPos[0];
                    wy += GameObj.fpPlayerMouthPos[1];
                }
                int sx = ((((wx - TiledLevel.fpGameCameraX) ^ 1048576) & 134217728) != 0 ? -((int) (((-(wx - TiledLevel.fpGameCameraX)) * 1048576) >> 16)) : (int) (((wx - TiledLevel.fpGameCameraX) * 1048576) >> 16)) < 0 ? -((-((((wx - TiledLevel.fpGameCameraX) ^ 1048576) & 134217728) != 0 ? -((int) (((-(wx - TiledLevel.fpGameCameraX)) * 1048576) >> 16)) : (int) (((wx - TiledLevel.fpGameCameraX) * 1048576) >> 16))) >> 16) : ((((wx - TiledLevel.fpGameCameraX) ^ 1048576) & 134217728) != 0 ? -((int) (((-(wx - TiledLevel.fpGameCameraX)) * 1048576) >> 16)) : (int) (((wx - TiledLevel.fpGameCameraX) * 1048576) >> 16)) >> 16;
                int sy = ((((wy - TiledLevel.fpGameCameraY) ^ 1048576) & 134217728) != 0 ? -((int) (((-(wy - TiledLevel.fpGameCameraY)) * 1048576) >> 16)) : (int) (((wy - TiledLevel.fpGameCameraY) * 1048576) >> 16)) < 0 ? -((-((((wy - TiledLevel.fpGameCameraY) ^ 1048576) & 134217728) != 0 ? -((int) (((-(wy - TiledLevel.fpGameCameraY)) * 1048576) >> 16)) : (int) (((wy - TiledLevel.fpGameCameraY) * 1048576) >> 16))) >> 16) : ((((wy - TiledLevel.fpGameCameraY) ^ 1048576) & 134217728) != 0 ? -((int) (((-(wy - TiledLevel.fpGameCameraY)) * 1048576) >> 16)) : (int) (((wy - TiledLevel.fpGameCameraY) * 1048576) >> 16)) >> 16;
                animSprite[i].paint(g, sx + (BaseScreen.displayWidth >> 1), sy + (BaseScreen.displayHeight >> 1));
            }
        }
    }
}
