package com.slg.j2me.game;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gfx.ImageSet;
import com.slg.j2me.lib.gui.BitmapFont;
import com.slg.j2me.lib.gui.control.GuiControl;
import com.slg.j2me.lib.gui.image.IconImage;
import com.slg.j2me.lib.gui.image.TextImage;
import com.slg.j2me.lib.gui.layout.CellLayout;
import com.slg.j2me.lib.gui.layout.MenuLayout;
import com.slg.j2me.lib.gui.layout.ScreenLayout;
import com.slg.j2me.lib.gui.layout.ScreenStack;
import com.slg.j2me.lib.gui.layout.TextLayout;
import com.slg.j2me.lib.gui.layout.TextScrollLayout;
import com.slg.j2me.lib.snd.SoundBank;
import com.slg.j2me.lib.sys.Application;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.j2meImage;
/* loaded from: classes.dex */
public class FrontEnd extends ScreenStack {
    private static GuiControl controlHelpTips = null;
    public static final int defaultMenuFlags = 1;
    private static final int eMainLayoutNumRows = 3;
    private static final int eMainRowBottomBar = 2;
    private static final int eMainRowContents = 1;
    private static final int eMainRowTitle = 1;
    public static BitmapFont font;
    public static BitmapFont fontSmall;
    public static ImageSequence gfxBackground;
    public static ImageSequence gfxMenuAbout;
    public static ImageSequence gfxMenuAchievements;
    public static ImageSequence gfxMenuBack;
    public static ImageSequence gfxMenuBuddies;
    public static ImageSequence gfxMenuCalibrate;
    public static ImageSequence gfxMenuCancel;
    public static ImageSequence gfxMenuControls;
    public static ImageSequence gfxMenuCredits;
    public static ImageSequence gfxMenuEndGame;
    public static ImageSequence gfxMenuEnterName;
    public static ImageSequence gfxMenuFindMe;
    public static ImageSequence gfxMenuFindTop;
    public static ImageSequence gfxMenuGlobal;
    public static ImageSequence gfxMenuHelp;
    public static ImageSequence gfxMenuHiscores;
    public static ImageSequence gfxMenuLocal;
    public static ImageSequence gfxMenuMenu;
    public static ImageSequence gfxMenuNo;
    public static ImageSequence gfxMenuOk;
    public static ImageSequence gfxMenuOptions;
    public static ImageSequence gfxMenuPlay;
    public static ImageSequence gfxMenuReplay;
    public static ImageSequence gfxMenuResume;
    public static ImageSequence gfxMenuSliderButton;
    public static ImageSequence gfxMenuSliderRail;
    public static ImageSequence gfxMenuSoundOff;
    public static ImageSequence gfxMenuSoundOn;
    public static ImageSequence gfxMenuTips;
    public static ImageSequence gfxMenuTitle;
    public static ImageSequence gfxMenuUpload;
    public static ImageSequence gfxMenuVibOff;
    public static ImageSequence gfxMenuVibOn;
    public static ImageSequence gfxMenuYes;
    public static ImageSequence gfxProgress;
    public static ImageSequence gfxSeaBackground;
    public static ImageSequence gfxTips;
    public static ImageSequence gfxTipsNext;
    public static ImageSequence gfxTipsPrev;
    public static ImageSequence gfxWavesBackground;
    private static IconImage iconBackButton;
    public static IconImage iconMenuTitle;
    public static ImageSet imageset;
    public static FrontEnd instance;
    public static ImageSet isBackground;
    public static ImageSet isControls;
    public static ImageSet isCredits;
    public static ImageSet isFishTank;
    public static ImageSet isTips;
    public static ScreenAchievements screenAchievements;
    public static HiscoreScreen screenHiscores;
    public static OptionsScreen screenOptions;
    private static TipScreen screenTips;
    public static boolean loaded = false;
    private static boolean firstTime = true;
    public static boolean firstPlaySinceBoot = true;
    public static j2meImage imgBackground = null;
    public static j2meImage imgBox = null;
    private static CellLayout mainLayout = new CellLayout(3);
    public static SplashScreen splashScreen = new SplashScreen();
    private static MenuLayout menuMain = new MenuLayout();
    private static GuiControl controlPlay = new GuiControl(true);
    private static GuiControl controlHiScores = new GuiControl(true);
    private static GuiControl controlOptions = new GuiControl(true);
    private static GuiControl controlHelp = new GuiControl(true);
    public static MenuLayout menuOptions = new MenuLayout();
    public static GuiControl controlOptionsTitle = new GuiControl(false);
    public static GuiControl controlOptionsSound = new GuiControl(true);
    public static GuiControl controlOptionsVibration = new GuiControl(true);
    public static GuiControl controlOptionsResetHiscores = new GuiControl(true);
    private static TextScrollLayout textControls = new TextScrollLayout();
    private static TextLayout textAbout = new TextLayout();
    private static TextLayout textCredits = new TextLayout();
    private static MenuLayout menuHelp = new MenuLayout();
    private static GuiControl controlHelpTitle = new GuiControl(false);
    private static GuiControl controlHelpControls = new GuiControl(textControls);
    private static GuiControl controlAbout = new GuiControl(textAbout);
    private static GuiControl controlCredits = new GuiControl(textCredits);
    private static TextLayout textGameLoading = new TextLayout();
    private static TextLayout textInitialGameLoading = new TextLayout();
    private static TextLayout textInitialCalibrate = new TextLayout();
    private static GuiControl controlCalibrate = new GuiControl(true);
    private static ConfirmScreen screenConfirm = null;
    public static boolean sound = true;
    public static boolean vibration = true;
    public static boolean shownFirstTip = false;
    public static boolean canUploadHiScore = false;
    public static int currentTip = 0;
    public static int cFadeDuration = 16384;
    public static int colFade = -16777153;
    public static int fade_time = 0;
    int fp_x = 0;
    int cSharkFrameDuration = 8192;
    int shark_time = 0;
    int shark_frame = 0;
    boolean havePausedLoops = false;

    public FrontEnd() {
        instance = this;
    }

    public void startup() {
        initFonts();
        initMenuGraphics();
        initScreens();
        initMenus();
        setupMenuText();
        initMainLayout();
    }

    public void initFonts() {
        ImageSet imagesetFont = new ImageSet("/mediumfont.is", true);
        font = new BitmapFont(imagesetFont, "mediumfont-in");
        font.iSpacing = -1;
        font.iOffsetTop = -2;
        font.iOffsetBottom = -2;
        ImageSet imagesetFont2 = new ImageSet("/smallfont.is", true);
        fontSmall = new BitmapFont(imagesetFont2, "smallfont-in");
        fontSmall.iSpacing = 0;
        fontSmall.iOffsetTop = -2;
        fontSmall.iOffsetBottom = -2;
        ImageSet imagesetLarge = new ImageSet("/largefont.is", true);
        GameScreen.fontGame = new BitmapFont(imagesetLarge, "largefont-in");
        GameScreen.fontGame.iSpaceWidth = 8;
        GameScreen.fontGame.iSpacing = -2;
        GameScreen.fontGame.iOffsetTop = -2;
        GameScreen.fontGame.iOffsetBottom = -2;
        ImageSet imagesetScore = new ImageSet("/scorefont.is", true);
        GameScreen.fontScore = new BitmapFont(imagesetScore, "scorefont-in");
        GameScreen.fontScore.iSpacing = 0;
        GameScreen.fontScore.iOffsetTop = 0;
        GameScreen.fontScore.iOffsetBottom = 0;
    }

    public void initMenuGraphics() {
        imageset = new ImageSet("/menu.is", true);
        isCredits = new ImageSet("/credits.is", false);
        isTips = new ImageSet("/tips.is", false);
        isControls = new ImageSet("/controls.is", false);
        gfxMenuTitle = imageset.getImageSequence("title");
        gfxMenuPlay = imageset.getImageSequence("play");
        gfxMenuHiscores = imageset.getImageSequence("hiscores");
        gfxMenuOptions = imageset.getImageSequence("options");
        gfxMenuHelp = imageset.getImageSequence("help");
        gfxMenuBack = imageset.getImageSequence("back");
        gfxMenuAbout = imageset.getImageSequence("about");
        gfxMenuControls = imageset.getImageSequence("controls");
        gfxMenuTips = imageset.getImageSequence("tips");
        gfxMenuCredits = imageset.getImageSequence("credits");
        gfxTipsPrev = imageset.getImageSequence("leftarrow");
        gfxTipsNext = imageset.getImageSequence("rightarrow");
        gfxMenuSliderRail = imageset.getImageSequence("slider-rail");
        gfxMenuSliderButton = imageset.getImageSequence("slider-button");
        gfxProgress = imageset.getImageSequence("Loading");
        gfxMenuLocal = imageset.getImageSequence("local");
        gfxMenuGlobal = imageset.getImageSequence("global");
        gfxMenuBuddies = imageset.getImageSequence("buddies");
        gfxMenuUpload = imageset.getImageSequence("upload");
        gfxMenuFindTop = imageset.getImageSequence("topscores");
        gfxMenuFindMe = imageset.getImageSequence("findme");
        gfxMenuAchievements = imageset.getImageSequence("achievements");
        gfxMenuYes = imageset.getImageSequence("yes");
        gfxMenuNo = imageset.getImageSequence("no");
        gfxMenuVibOn = imageset.getImageSequence("vibrate-on");
        gfxMenuVibOff = imageset.getImageSequence("vibrate-off");
        gfxMenuSoundOn = imageset.getImageSequence("sound-on");
        gfxMenuSoundOff = imageset.getImageSequence("sound-off");
        gfxMenuCalibrate = imageset.getImageSequence("calibrate");
        gfxMenuOk = imageset.getImageSequence("ok");
        gfxMenuEnterName = imageset.getImageSequence("entername");
        gfxMenuCancel = imageset.getImageSequence("cancel");
        gfxMenuMenu = imageset.getImageSequence("menubutton");
        gfxTips = isTips.getImageSequence("tip");
        iconMenuTitle = new IconImage(gfxMenuTitle, 0);
        isBackground = new ImageSet("/menubg.is", true);
        gfxBackground = isBackground.getImageSequence("bg");
        gfxSeaBackground = isBackground.getImageSequence("sea");
        gfxWavesBackground = isBackground.getImageSequence("waves");
        imgBox = ImageSet.loadImage("/highscorebg.png");
    }

    public void initScreens() {
        try {
            screenHiscores = new HiscoreScreen();
            screenHiscores.setupHiscoreScreen();
            screenAchievements = new ScreenAchievements();
            screenTips = new TipScreen();
            controlHelpTips = new GuiControl(screenTips);
            screenConfirm = new ConfirmScreen("SAVED GAME", "Continue?");
            screenConfirm.controlHandler = this;
            screenOptions = new OptionsScreen();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void initMenus() {
        menuMain.addControl(controlPlay);
        menuMain.addControl(controlHiScores);
        menuMain.addControl(controlOptions);
        menuMain.addControl(controlHelp);
        menuOptions.addControl(controlOptionsTitle);
        menuOptions.addControl(controlOptionsSound);
        menuOptions.addControl(controlOptionsVibration);
        menuHelp.addControl(controlHelpTitle);
        menuHelp.addControl(controlHelpControls);
        menuHelp.addControl(controlHelpTips);
        menuHelp.addControl(controlCredits);
    }

    public void initMainLayout() {
        mainLayout.controlHandler = this;
        mainLayout.setRow(0, 1, 2);
        mainLayout.setRow(1, 2, 8);
        mainLayout.setRow(2, 2, 1);
        mainLayout.setCell(1, 0, iconMenuTitle, 1, 0);
        mainLayout.setCell(2, 0, null, 1, 0);
        mainLayout.setCell(2, 1, ctrlRightSoftKey, -1, 3);
        controlAbout.initialise();
        mainLayout.addControl(controlAbout);
        mainLayout.layout();
    }

    public void setupMenuText() {
        BitmapFont theFont = font;
        iconBackButton = new MenuImage(gfxMenuBack, 0);
        ctrlRightSoftKey.controlImage = iconBackButton;
        controlPlay.controlImage = new MenuImage(gfxMenuPlay, 0);
        controlHiScores.controlImage = new MenuImage(gfxMenuHiscores, 0);
        controlOptions.controlImage = new MenuImage(gfxMenuOptions, 0);
        controlHelp.controlImage = new MenuImage(gfxMenuHelp, 0);
        controlAbout.controlImage = new MenuImage(gfxMenuAbout, 0);
        controlOptionsTitle.controlImage = new TextImage(GameScreen.fontGame, "OPTIONS");
        controlOptionsSound.controlImage = new MenuImage(sound ? gfxMenuSoundOn : gfxMenuSoundOff, 0);
        controlOptionsVibration.controlImage = new MenuImage(vibration ? gfxMenuVibOn : gfxMenuVibOff, 0);
        controlOptionsResetHiscores.controlImage = new TextImage(theFont, "Reset Hiscores");
        controlHelpTitle.controlImage = new TextImage(GameScreen.fontGame, "HELP");
        controlHelpControls.controlImage = new MenuImage(gfxMenuControls, 0);
        controlHelpTips.controlImage = new MenuImage(gfxMenuTips, 0);
        controlCredits.controlImage = new MenuImage(gfxMenuCredits, 0);
        controlCalibrate.controlImage = new MenuImage(gfxMenuCalibrate, 0);
    }

    public void setupHelpText() {
        textControls.textLayout.iLayoutFlags = 1;
        textControls.textLayout.clearText();
        textControls.textLayout.formatText(GameScreen.fontGame, "CONTROLS\n\n");
        textControls.textLayout.addImage(isControls.getImageSequence("tilt"), 0);
        textControls.textLayout.formatText(GameScreen.fontGame, "\n\nPress screen to Boost");
        textControls.textLayout.layout();
    }

    public void setupInitialLoadingText() {
        textInitialGameLoading.iLayoutFlags = 3;
        textInitialGameLoading.clearText();
        textInitialGameLoading.formatText(GameScreen.fontGame, "LOADING...\n\n\nCONTROLS\n");
        textInitialGameLoading.addImage(isControls.getImageSequence("tilt"), 0);
        textInitialGameLoading.formatText(GameScreen.fontGame, "\nPress screen to Boost");
        textInitialGameLoading.layout();
    }

    public void setupInitialCalibrateText() {
        textInitialCalibrate.iLayoutFlags = 3;
        textInitialCalibrate.clearText();
        textInitialCalibrate.formatText(font, "Press the button to calibrate the tilt sensor\n\n");
        textInitialCalibrate.addControl(controlCalibrate);
        textInitialCalibrate.layout();
    }

    public void setupAboutText() {
        textAbout.iLayoutFlags = 129;
        textAbout.clearText();
        textAbout.formatText(GameScreen.fontGame, "About\n\n");
        textAbout.formatText(font, "Hungry Shark v1.0.1\n\n");
        textAbout.formatText(fontSmall, "(c) 2010 Future Games of London\n\nDesigned, Developed and Published\nby Future Games of London\n\n");
        textAbout.formatText(fontSmall, "www.futuregamesoflondon.com");
        textAbout.layout();
    }

    public void setupNextTip() {
        String tipText;
        textGameLoading.iLayoutFlags = 3;
        textGameLoading.clearText();
        textGameLoading.formatText(GameScreen.fontGame, "LOADING...\n\n");
        textGameLoading.formatText(GameScreen.fontGame, "TIP:\n\n");
        currentTip = GameLogic.randRange(0, 8);
        textGameLoading.addImage(gfxTips, currentTip);
        switch (currentTip) {
            case 0:
                tipText = "\nThe shark's health slowly depletes, it must eat to stay alive.";
                break;
            case 1:
                tipText = "\nTouch anywhere on screen to use boost, this speeds up the shark and increases its attack power.";
                break;
            case 2:
                tipText = "\nAvoid mines and jellyfish - they don't taste too good!";
                break;
            case 3:
                tipText = "\nSome types of prey will fight back, so time your attacks carefully.";
                break;
            case 4:
                tipText = "\n10 sunken items are hidden in and around the sea bed, collect them for big points.";
                break;
            case 5:
                tipText = "\nThe more the shark eats, the bigger and more powerful it becomes.";
                break;
            case 6:
                tipText = "\nKnock the fishermen into the water by ramming their boats at speed, then it's payback time!";
                break;
            case 7:
                tipText = "\nGain point multipliers by eating many creatures in quick succession.";
                break;
            case 8:
                tipText = "\nExplore the ocean depths to discover weird and wonderful food.";
                break;
            default:
                tipText = "";
                break;
        }
        textGameLoading.formatText(fontSmall, tipText);
        textGameLoading.layout();
    }

    public void setupCreditsText() {
        BitmapFont fontGame = GameScreen.fontGame;
        textCredits.iLayoutFlags = 1;
        textCredits.clearText();
        textCredits.formatText(fontGame, "\n\n\n\n\n\n\n\n\n\n\n");
        textCredits.formatText(fontGame, "HUNGRY SHARK\n\n");
        textCredits.formatText(fontSmall, "Designed, Developed and Published\nby Future Games of London\n\n\n");
        textCredits.formatText(fontGame, "Design\n\n");
        textCredits.addImage(isCredits.getImageSequence("chrisd"), 0);
        textCredits.formatText(font, "Chris Dawson\n");
        textCredits.addImage(isCredits.getImageSequence("kriss"), 0);
        textCredits.formatText(font, "Kris 'K2' Skellorn\n\n\n");
        textCredits.formatText(fontGame, "Coding\n\n");
        textCredits.addImage(isCredits.getImageSequence("ianh"), 0);
        textCredits.formatText(font, "Ian Harper\n");
        textCredits.addImage(isCredits.getImageSequence("mattg"), 0);
        textCredits.formatText(font, "Matt Gosling\n\n\n");
        textCredits.formatText(fontGame, "Art\n\n");
        textCredits.addImage(isCredits.getImageSequence("chrisd"), 0);
        textCredits.formatText(font, "Chris Dawson\n");
        textCredits.addImage(isCredits.getImageSequence("paule"), 0);
        textCredits.formatText(font, "Paul Ellinor\n\n\n");
        textCredits.formatText(fontGame, "Quality Assurance\n\n");
        textCredits.addImage(isCredits.getImageSequence("paulw"), 0);
        textCredits.formatText(font, "Paul Welton\n");
        textCredits.addImage(isCredits.getImageSequence("andreeav"), 0);
        textCredits.formatText(font, "Andreea Vintila\n\n\n");
        textCredits.formatText(fontGame, "Special Thanks\n\n");
        textCredits.addImage(isCredits.getImageSequence("robb"), 0);
        textCredits.formatText(fontSmall, "\nDr Robertas Baronas of the Lithuanian Institute of Marine Biology\n\n");
        textCredits.addImage(isCredits.getImageSequence("leeb"), 0);
        textCredits.formatText(fontSmall, "\nLee 'The Surgeon' Baskerville\n\n\n\n\n");
        textCredits.addImage(isCredits.getImageSequence("fgol"), 0);
        textCredits.formatText(font, "\n\n\n\n");
        textCredits.addImage(isCredits.getImageSequence("fin"), 0);
        textCredits.formatText(font, "\nFin\n");
        textCredits.formatText(fontGame, "\n\n\n\n\n\n\n\n\n\n\n");
        textCredits.layout();
    }

    public static void setupSimpleTextLayout(TextLayout tl, int iLayoutFlags, BitmapFont font2, String text) {
        tl.iLayoutFlags = iLayoutFlags;
        tl.clearText();
        tl.formatText(font2, text);
        tl.layout();
    }

    public void loadTitleScreen() {
        GameApp.setAppLoading();
        pushScreen(splashScreen, false);
        Application.gc();
        loaded = true;
    }

    public void unload() {
        Application.printMemoryStatus();
        if (currentContainer != null) {
            currentContainer.close();
        }
        this.backgroundImage = null;
        isBackground.unloadImages();
        Application.printMemoryStatus();
    }

    public void reload() {
        Application.printMemoryStatus();
        isBackground.unloadImages();
        Application.printMemoryStatus();
        resetKeys();
        loaded = true;
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenStack
    public void open() {
        super.open(menuMain);
        setBackgroundColour(-16777216);
        if (firstTime) {
            GameApp.calibrateSensor();
            firstTime = false;
            if (GameApp.continueGameAvailable) {
                pushScreen(screenConfirm, true);
            }
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenStack
    public void onScreenOpen(ScreenLayout container) {
        if (container == GameApp.gameScreen) {
            container.clipRect.w = (short) BaseScreen.displayWidth;
            container.clipRect.h = (short) BaseScreen.displayHeight;
            imgBackground = null;
            container.layout();
        } else if (container == textGameLoading || container == textInitialGameLoading || container == textInitialCalibrate) {
            container.clipRect.w = (short) BaseScreen.displayWidth;
            container.clipRect.h = (short) BaseScreen.displayHeight;
            if (container == textInitialGameLoading) {
                isControls.reloadImages();
            } else {
                isControls.unloadImages();
            }
            if (container == textGameLoading) {
                isTips.reloadImages();
            } else {
                isTips.unloadImages();
            }
            if (container == textInitialCalibrate) {
                popPreviousScreen();
            }
            if (!Application.crapDevice && imgBackground == null) {
                imgBackground = ImageSet.loadImage("/tip" + GameLogic.randRange(1, 3) + ".png");
            }
            ctrlRightSoftKey.hidden = true;
        } else {
            mainLayout.clipRect.w = (short) BaseScreen.displayWidth;
            mainLayout.clipRect.h = (short) BaseScreen.displayHeight;
            mainLayout.setCell(1, 1, container, 1, 0);
            mainLayout.setRowFlags(0, 2);
            if (container == screenHiscores) {
                mainLayout.setCell(0, 0, screenHiscores.textHiscoreTitle, 1, 3);
                mainLayout.setCell(1, 0, screenHiscores.cellButtons, 1, 0);
                mainLayout.setCell(1, 1, container, 3, 0);
            } else if (container == screenAchievements) {
                mainLayout.setCell(0, 0, screenAchievements.textAchievementsTitle, 1, 3);
                mainLayout.setCell(1, 0, screenAchievements.cellButtons, 2, 0);
                mainLayout.setCell(1, 1, container, 3, 0);
            } else if (container == menuMain || container == menuOptions || container == menuHelp) {
                mainLayout.setCell(0, 0, null, 1, 0);
                mainLayout.setCell(1, 0, iconMenuTitle, 1, 0);
            } else if (container == textAbout) {
                mainLayout.setCell(0, 0, null, 1, 0);
                mainLayout.setCell(1, 0, null, 0, 0);
                mainLayout.setCell(1, 1, container, 1, 3);
            } else if (container == screenOptions) {
                mainLayout.setRowFlags(0, 0);
                mainLayout.setCell(0, 0, null, 0, 0);
                mainLayout.setCell(1, 0, null, 0, 0);
                mainLayout.setCell(1, 1, container, 1, 0);
            } else {
                mainLayout.setCell(0, 0, null, 1, 0);
                mainLayout.setCell(1, 0, null, 0, 0);
            }
            if (container == textControls) {
                setupHelpText();
                isControls.reloadImages();
            } else {
                isControls.unloadImages();
            }
            if (container == textCredits) {
                isCredits.reloadImages();
                setupCreditsText();
            } else {
                isCredits.unloadImages();
            }
            if (container == screenTips) {
                isTips.reloadImages();
            } else {
                isTips.unloadImages();
            }
            if (container instanceof MenuLayout) {
                MenuLayout menu = (MenuLayout) container;
                menu.iLayoutFlags = 1;
            }
            controlAbout.hidden = container != menuMain;
            controlAbout.clipRect.x0 = (short) 0;
            controlAbout.clipRect.y0 = (short) (BaseScreen.displayHeight - controlAbout.clipRect.h);
            ctrlRightSoftKey.hidden = container == menuMain || container == screenConfirm;
            mainLayout.layout();
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenStack, com.slg.j2me.lib.gui.control.ControlHandler
    public void controlExecuted(ScreenLayout container, GuiControl control) {
        if (screenState != 1) {
            FrontEnd frontEnd = instance;
            if (currentContainer instanceof MenuLayout) {
                return;
            }
        }
        SoundBank.sfxPlay(14, false, 100, 0);
        if (control == ctrlRightSoftKey) {
            popScreen(true);
        }
        if (control == controlAbout) {
            setupAboutText();
        }
        if (control == controlCalibrate) {
            pushScreen(GameApp.gameScreen, true);
        }
        if (container == menuMain) {
            if (control == controlPlay) {
                if (firstPlaySinceBoot) {
                    setupInitialLoadingText();
                    pushScreen(textInitialGameLoading, true);
                    firstPlaySinceBoot = false;
                } else {
                    setupNextTip();
                    pushScreen(textGameLoading, true);
                }
            } else if (control == controlHiScores) {
                pushScreen(screenHiscores, true);
            } else if (control == controlOptions) {
                pushScreen(screenOptions, true);
            } else if (control == controlHelp) {
                pushScreen(menuHelp, true);
            }
        }
        if (container == screenConfirm) {
            if (control == screenConfirm.ctrlYes) {
                firstPlaySinceBoot = false;
                setupNextTip();
                pushScreen(textGameLoading, true);
            } else if (control == screenConfirm.ctrlNo) {
                GameApp.continueGameAvailable = false;
                popScreen(true);
            }
        } else if (container == menuOptions) {
            if (control == controlOptionsSound) {
                sound = !sound;
                ((MenuImage) controlOptionsSound.controlImage).imgSeq = sound ? gfxMenuSoundOn : gfxMenuSoundOff;
                SoundBank.enableSound(sound);
                if (sound) {
                    SoundBank.sfxPlay(14, false, 100, 0);
                }
            } else if (control == controlOptionsVibration) {
                vibration = !vibration;
                ((MenuImage) controlOptionsVibration.controlImage).imgSeq = vibration ? gfxMenuVibOn : gfxMenuVibOff;
                if (vibration) {
                    Application.display.vibrate(100);
                }
            } else if (control == controlOptionsResetHiscores) {
                GameApp.resetHiscores();
                pushScreen(screenHiscores, true);
            }
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenStack, com.slg.j2me.lib.gfx.BaseScreen
    public void process() {
        processMusic();
        processFade();
        if (currentContainer == screenHiscores) {
            screenHiscores.processDialog();
        }
        if (currentDialog != null) {
            currentDialog.process();
        } else if (currentContainer == GameApp.gameScreen || currentContainer == textGameLoading || currentContainer == textInitialGameLoading || currentContainer == textInitialCalibrate) {
            currentContainer.process();
        } else {
            mainLayout.process();
        }
        super.process();
        if (currentContainer == textCredits) {
            TextLayout tl = (TextLayout) currentContainer;
            int fp_speed = ((2097152 ^ BaseScreen.fp_sy) & 134217728) != 0 ? -((int) (((-2097152) * BaseScreen.fp_sy) >> 16)) : (int) ((2097152 * BaseScreen.fp_sy) >> 16);
            int fp_diff = ((GameApp.fp_deltatime ^ fp_speed) & 134217728) != 0 ? -((int) (((-GameApp.fp_deltatime) * fp_speed) >> 16)) : (int) ((GameApp.fp_deltatime * fp_speed) >> 16);
            if (!tl.scroll(-fp_diff)) {
                popScreen(true);
            }
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenStack
    public int setScreenState(int newState) {
        super.setScreenState(newState);
        if (newState == 1) {
            fade_time = cFadeDuration;
            if (currentContainer == textGameLoading) {
                pushScreen(GameApp.gameScreen, true);
            }
            if (currentContainer == textInitialGameLoading) {
                GameApp.gameScreen.newGame();
                GameApp.gameScreen.reload();
                setupInitialCalibrateText();
                pushScreen(textInitialCalibrate, true);
            }
        }
        if (newState == 0) {
            return 500;
        }
        return (newState == 2 || newState == 3) ? 500 : 0;
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenStack
    public void handleEvent(int event) {
        super.handleEvent(event);
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenStack, com.slg.j2me.lib.gfx.BaseScreen
    public void paintInternal(Graphics g) {
        if (currentContainer == GameApp.gameScreen) {
            currentContainer.paint(g);
        } else if (currentContainer == splashScreen) {
            drawBackground(g);
            currentContainer.paint(g);
        } else if (currentContainer == textGameLoading || currentContainer == textInitialGameLoading || currentContainer == textInitialCalibrate) {
            drawEmptyBackground(g);
            currentContainer.paint(g);
        } else {
            drawBackground(g);
            int h = gfxBackground.getRectHeight(0);
            gfxBackground.drawImageStretched(g, 0, 0, displayHeight - h, 0, displayWidth, h);
            if ((currentContainer == textAbout || currentContainer == screenConfirm) && imgBox != null) {
                g.drawRegionStretched(imgBox, 0, 0, imgBox.getWidth(), imgBox.getHeight(), 0, currentContainer.clipRect.x0 - 16, currentContainer.clipRect.y0 - 16, currentContainer.clipRect.w + 32, currentContainer.clipRect.h + 16, 13);
            }
            if (currentContainer == menuMain || currentContainer == menuOptions || currentContainer == menuHelp) {
                drawShark(g);
            }
            mainLayout.paint(g);
        }
        if (currentDialog != null) {
            if (imgBox != null) {
                g.drawRegionStretched(imgBox, 0, 0, imgBox.getWidth(), imgBox.getHeight(), 0, currentDialog.clipRect.x0 - 16, currentDialog.clipRect.y0 - 16, currentDialog.clipRect.w + 32, currentDialog.clipRect.h + 32, 13);
                g.drawRegionStretched(imgBox, 0, 0, imgBox.getWidth(), imgBox.getHeight(), 0, currentDialog.clipRect.x0 - 16, currentDialog.clipRect.y0 - 16, currentDialog.clipRect.w + 32, currentDialog.clipRect.h + 32, 13);
            }
            currentDialog.paint(g);
        }
        drawForeground(g);
    }

    private void drawBackground(Graphics g) {
        g.setColor(this.colBackground);
        g.fillRect(0, 0, BaseScreen.displayWidth, BaseScreen.displayHeight);
        int dw = BaseScreen.displayWidth;
        int w = gfxSeaBackground.getRectWidth(0);
        this.fp_x += GameApp.fp_deltatime * 20;
        while (this.fp_x < 0) {
            this.fp_x += ((w < 0 ? -((-w) << 16) : w << 16) - 0) + 1;
        }
        while (true) {
            if (this.fp_x <= (w < 0 ? -((-w) << 16) : w << 16)) {
                break;
            }
            this.fp_x -= ((w < 0 ? -((-w) << 16) : w << 16) - 0) + 1;
        }
        int x = this.fp_x < 0 ? -((-this.fp_x) >> 16) : this.fp_x >> 16;
        int y = BaseScreen.displayHeight - gfxSeaBackground.getRectHeight(0);
        gfxSeaBackground.drawImage(g, 0, -x, y);
        gfxSeaBackground.drawImage(g, 0, w - x, y);
        gfxSeaBackground.drawImage(g, 0, (w * 2) - x, y);
        gfxWavesBackground.drawImageStretched(g, 0, 0, 0, 0, dw, gfxWavesBackground.getRectHeight(0));
    }

    private void drawEmptyBackground(Graphics g) {
        if (imgBackground != null) {
            g.drawRegionStretched(imgBackground, 0, 0, imgBackground.getWidth(), imgBackground.getHeight(), 0, 0, 0, BaseScreen.displayWidth, BaseScreen.displayHeight, 13);
            return;
        }
        g.setColor(colFade);
        g.fillRect(0, 0, BaseScreen.displayWidth, BaseScreen.displayHeight);
    }

    public void drawShark(Graphics g) {
        this.shark_time += GameApp.fp_deltatime;
        if (this.shark_time > this.cSharkFrameDuration) {
            this.shark_time -= this.cSharkFrameDuration;
            this.shark_frame++;
            while (this.shark_frame < 0) {
                this.shark_frame += ((GameScreen.gfxShark.numFrames - 1) - 0) + 1;
            }
            while (this.shark_frame > GameScreen.gfxShark.numFrames - 1) {
                this.shark_frame -= ((GameScreen.gfxShark.numFrames - 1) - 0) + 1;
            }
        }
        GameScreen.gfxShark.drawImageTrans(g, this.shark_frame, 10, 132, 1);
    }

    public void processFade() {
        int i;
        if (screenState == 0) {
            fade_time += GameApp.fp_deltatime;
        } else if (screenState == 2 || screenState == 3) {
            fade_time -= GameApp.fp_deltatime;
        }
        if (fade_time < 0) {
            i = 0;
        } else {
            i = fade_time > cFadeDuration ? cFadeDuration : fade_time;
        }
        fade_time = i;
    }

    public void drawForeground(Graphics g) {
        int i;
        int fade = (int) ((fade_time << 16) / cFadeDuration);
        if (fade < 0) {
            i = 0;
        } else {
            i = fade > 65536 ? 65536 : fade;
        }
        int fade2 = 65536 - i;
        if (fade2 != 0) {
            int alpha = (fade2 * 255 < 0 ? -((-(fade2 * 255)) >> 16) : (fade2 * 255) >> 16) & 255;
            g.setColor((colFade & 16777215) | (alpha << 24));
            g.fillRect(0, 0, BaseScreen.displayWidth, BaseScreen.displayHeight);
        }
    }

    public void saveOptions(DataOutputStream dataStream) {
        try {
            dataStream.writeInt(5);
            dataStream.writeBoolean(sound);
            dataStream.writeBoolean(vibration);
            dataStream.writeBoolean(shownFirstTip);
            dataStream.writeBoolean(canUploadHiScore);
            dataStream.writeUTF(GameScreen.strPlayerName);
            for (int i = 0; i < 10; i++) {
                dataStream.writeInt(GameLogic.achievements[i]);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void loadOptions(DataInputStream inputStream) throws IOException {
        try {
            int version = inputStream.readInt();
            if (version == 5) {
                sound = inputStream.readBoolean();
                vibration = inputStream.readBoolean();
                shownFirstTip = inputStream.readBoolean();
                canUploadHiScore = inputStream.readBoolean();
                GameScreen.strPlayerName = inputStream.readUTF();
                for (int i = 0; i < 10; i++) {
                    GameLogic.achievements[i] = inputStream.readInt();
                }
            } else {
                defaultOptions();
            }
            SoundBank.enableSound(sound);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void defaultOptions() {
        sound = true;
        vibration = true;
        shownFirstTip = false;
        canUploadHiScore = false;
        GameScreen.strPlayerName = "PLAYER";
        for (int i = 0; i < 10; i++) {
            GameLogic.achievements[i] = 0;
        }
    }

    private void processMusic() {
        if (sound) {
            if (currentContainer == GameApp.gameScreen) {
                if (Application.crapDevice) {
                    if (SoundBank.musicGetCurrent() != -1) {
                        SoundBank.musicStop();
                    }
                    GameScreen gameScreen = GameApp.gameScreen;
                    if (GameScreen.currentDialog == null) {
                        if (this.havePausedLoops) {
                            this.havePausedLoops = false;
                            SoundBank.sfxRestoreLoops();
                            return;
                        }
                        return;
                    } else if (!this.havePausedLoops) {
                        this.havePausedLoops = true;
                        SoundBank.sfxSaveLoops();
                        SoundBank.sfxStopAll();
                        return;
                    } else {
                        return;
                    }
                }
                GameScreen gameScreen2 = GameApp.gameScreen;
                if (GameScreen.currentDialog == null) {
                    int current = SoundBank.musicGetCurrent();
                    if (current != 1) {
                        SoundBank.musicPlay(1, true, 100);
                        if (current == -1) {
                            SoundBank.sfxRestoreLoops();
                        }
                    }
                } else if (SoundBank.musicGetCurrent() != -1) {
                    SoundBank.musicStop();
                    SoundBank.sfxSaveLoops();
                    SoundBank.sfxStopAll();
                }
            } else if (SoundBank.musicGetCurrent() != 0) {
                SoundBank.musicPlay(0, true, 100);
            }
        }
    }

    public static void vibrate(int millis) {
        if (vibration) {
            Application.display.vibrate(millis);
        }
    }
}
