package com.slg.j2me.game;

import com.ju6.mms.pdu.CharacterSets;
import com.safetest.shark.R;
import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.snd.SoundBank;
import com.slg.j2me.lib.sys.Application;
import com.slg.j2me.lib.sys.FixedPoint;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
/* loaded from: classes.dex */
public class GameApp extends Application {
    private static final String GAME_ID = "ca2c829d-b6f3-41a4-9b72-68c62262dd66";
    private static final String GAME_SECRET = "X8epv8O4qBlvIVnKdhoCU9cMI3iFC/TCMIYALJ8NdzUmfNLmF6fPdQ==";
    public static final int cHiscoreNumTables = 3;
    public static final int cHiscoreNumVisibleTables = 3;
    public static final int sfxAllItems = 41;
    public static final int sfxBlobDeath = 0;
    public static final int sfxBonecrunch = 37;
    public static final int sfxButton = 14;
    public static final int sfxChew = 8;
    public static final int sfxChop = 9;
    public static final int sfxCritical = 38;
    public static final int sfxDeath = 42;
    public static final int sfxExplosion = 1;
    public static final int sfxLevelUp = 17;
    public static final int sfxManScream = 2;
    public static final int sfxManScream2 = 3;
    public static final int sfxMetal = 18;
    public static final int sfxMetal2 = 19;
    public static final int sfxMoonOnAStick = 40;
    public static final int sfxMultiplierBingeBonus = 20;
    public static final int sfxMultiplierBonus = 21;
    public static final int sfxMultiplierBonusOut = 22;
    public static final int sfxMultiplierChopFest = 23;
    public static final int sfxMultiplierMegaMunch = 24;
    public static final int sfxNibble = 4;
    public static final int sfxNibble2 = 5;
    public static final int sfxObjectFall = 44;
    public static final int sfxPelicanEatten_1 = 25;
    public static final int sfxPelicanEatten_2 = 26;
    public static final int sfxPenguinEatten1 = 27;
    public static final int sfxPufferAttack = 43;
    public static final int sfxSailfishAttack = 43;
    public static final int sfxScubaDeath = 29;
    public static final int sfxScubaDiver = 28;
    public static final int sfxScubaKnifeAttack = 30;
    public static final int sfxSpecialHiddenItem = 31;
    public static final int sfxSquelch3 = 10;
    public static final int sfxSquelsh = 6;
    public static final int sfxSquelsh2 = 7;
    public static final int sfxStarving = 39;
    public static final int sfxSubLoop = 33;
    public static final int sfxSubSmash = 34;
    public static final int sfxSwimmer = 35;
    public static final int sfxTorpido = 36;
    public static final int sfxWaterRush = 32;
    public static final int sfxWaterSplish = 15;
    public static final int sfxWaterSplish2 = 16;
    public static final int sfxWhy = 11;
    public static final int sfxWomanScream = 12;
    public static final int sfxWomanScream2 = 13;
    public static final int tuneGame = 1;
    public static final int tuneMenu = 0;
    public static GameScreen gameScreen = null;
    public static FrontEnd frontEnd = null;
    public static HiscoreTable hiscoreTable = null;
    public static Water water = null;
    public static Effects effects = null;
    private static final int[][] defaultScores = {new int[]{25000, 20000, 15000, 10000, 7500, 5000, 2500, CharacterSets.UCS2}, new int[]{0, 0, 0, 0, 0, 0, 0, 0}, new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    private static final int[][] defaultTimes = {new int[]{1200, 900, 720, 600, 480, 240, 120, 60}, new int[]{0, 0, 0, 0, 0, 0, 0, 0}, new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}};
    private static final String[] defaultNames = {"IAN", "CHRIS", "MATT", "PAUL", "KRIS", "ROB", "LINDSAY", "FONZ"};
    public static boolean continueGameAvailable = false;
    public static boolean finishedLoading = false;
    public static final int[] midifiles = {R.raw.menu_music, R.raw.underwater};
    public static final int[] sfxfiles = {R.raw.blob_death, R.raw.explosion, R.raw.man_scream, R.raw.man_scream2, R.raw.nibble, R.raw.nibble2, R.raw.squelsh, R.raw.squelsh2, R.raw.chew_3, R.raw.chop_1, R.raw.squelch3, R.raw.why, R.raw.woman_scream, R.raw.woman_scream2, R.raw.button, R.raw.water_splish, R.raw.water_splish2, R.raw.level_up, R.raw.metal, R.raw.metal2, R.raw.multiplier_binge_bonus, R.raw.multiplier_bonus, R.raw.multiplier_bonus_out, R.raw.multiplier_chop_fest, R.raw.multiplier_mega_munch, R.raw.pelican_eatten_1, R.raw.pelican_eatten_2, R.raw.penguin_eatten1, R.raw.scuba_diver, R.raw.scuba_death, R.raw.scuba_knife_attack, R.raw.special_hidden_item, R.raw.water_rush, R.raw.sub_loop, R.raw.sub_smash, R.raw.swimmer, R.raw.torpidolauch, R.raw.bonecrunch_1, R.raw.critical, R.raw.starving, R.raw.moon_on_a_stick, R.raw.all_items, R.raw.death, R.raw.puffa_attack, R.raw.object_fall};

    @Override // javax.microedition.midlet.MIDlet
    public void init() {
        FixedPoint.startup();
        BaseScreen.setDefaultRes(480, 320);
        frontEnd = new FrontEnd();
        water = new Water();
        effects = new Effects();
        frontEnd.setBackgroundColour(-1);
        BaseScreen.setCurrent(frontEnd);
        backgroundLoad();
    }

    @Override // com.slg.j2me.lib.sys.Application
    public void load() {
        loadOptions();
        try {
            hiscoreTable = new HiscoreTable(3);
            resetHiscores();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        try {
            SoundBank.musicSetFiles(midifiles);
            SoundBank.sfxSetFiles(sfxfiles);
            Application.printMemoryStatus();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            frontEnd.startup();
        } catch (Exception e2) {
            e2.printStackTrace();
        }
        Application.printMemoryStatus();
        frontEnd.loadTitleScreen();
        try {
            gameScreen = new GameScreen();
        } catch (Exception e3) {
            e3.printStackTrace();
        }
        autoLoad();
        continueGameAvailable = loadGame(true);
        finishedLoading = true;
    }

    public static void resetHiscores() {
        hiscoreTable.makeDefaultTable(3, defaultNames, defaultScores, defaultTimes);
    }

    @Override // com.slg.j2me.lib.sys.Application
    public void process() {
        if (Application.loaded) {
            frontEnd.process();
        }
    }

    @Override // com.slg.j2me.lib.sys.Application, javax.microedition.midlet.MIDlet
    public void startApp() {
        if (Application.loaded) {
            autoLoad();
        }
        if (applicationPaused) {
            unPause();
        }
    }

    @Override // com.slg.j2me.lib.sys.Application, javax.microedition.midlet.MIDlet
    public void pauseApp() {
        hasFocus = false;
        if (!finishedLoading) {
            System.exit(0);
        }
        if (!applicationPaused) {
            SoundBank.musicStop();
            SoundBank.sfxSaveLoops();
            SoundBank.sfxStopAll();
            SoundBank.enableSound(false);
        }
        autoSave();
        applicationPaused = true;
    }

    public void unPause() {
        if (applicationPaused) {
            applicationPaused = false;
            SoundBank.enableSound(FrontEnd.sound);
            SoundBank.sfxRestoreLoops();
            FrontEnd frontEnd2 = FrontEnd.instance;
            if (FrontEnd.currentContainer == gameScreen && !GameScreen.isPaused()) {
                GameScreen.ctrlMenu.execute();
            }
        }
    }

    @Override // javax.microedition.midlet.MIDlet
    public void destroyApp(boolean unconditional) {
        try {
            if (Application.loaded) {
                SoundBank.shutdown();
                autoSave();
            }
            super.destroyApp(unconditional);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void loadOptions() {
        try {
            FileInputStream instream = instance.openFileInput("options.bin");
            DataInputStream dis = new DataInputStream(instream);
            frontEnd.loadOptions(dis);
            instream.close();
        } catch (Exception e) {
        }
    }

    public static void autoLoad() {
        loadOptions();
        try {
            FileInputStream instream = instance.openFileInput("hiscores.bin");
            DataInputStream dis = new DataInputStream(instream);
            hiscoreTable.loadHiscores(dis);
            instream.close();
        } catch (Exception e) {
            resetHiscores();
        }
    }

    public static void autoSave() {
        HiscoreTable hiscoreTable2 = hiscoreTable;
        if (HiscoreTable.modified) {
            try {
                FileOutputStream outstream = instance.openFileOutput("hiscores.bin", 0);
                DataOutputStream dos = new DataOutputStream(outstream);
                hiscoreTable.saveHiscores(dos);
                outstream.close();
            } catch (Exception e) {
            }
        }
        try {
            FileOutputStream outstream2 = instance.openFileOutput("options.bin", 0);
            DataOutputStream dos2 = new DataOutputStream(outstream2);
            frontEnd.saveOptions(dos2);
            outstream2.close();
        } catch (Exception e2) {
        }
        saveGame();
    }

    @Override // javax.microedition.midlet.MIDlet
    public void initScoreloopManager() {
        ScoreloopManager.init(this, GAME_ID, GAME_SECRET);
    }

    public static void outputStreamWriteIntArray(DataOutputStream outputStream, int[] data) {
        try {
            outputStream.writeInt(data.length);
            for (int i : data) {
                outputStream.writeInt(i);
            }
        } catch (Exception e) {
        }
    }

    public static void inputStreamReadIntArray(DataInputStream inputStream, int[] out) {
        try {
            int len = inputStream.readInt();
            for (int i = 0; i < len; i++) {
                out[i] = inputStream.readInt();
            }
        } catch (Exception e) {
        }
    }

    public static void saveGame() {
        if (!continueGameAvailable) {
            try {
                FileOutputStream outstream = instance.openFileOutput("savegame.bin", 0);
                DataOutputStream dos = new DataOutputStream(outstream);
                GameScreen gameScreen2 = gameScreen;
                boolean continueGame = GameScreen.game.gameState == 2;
                dos.writeInt(1);
                dos.writeInt(continueGame ? 1 : 0);
                if (continueGame) {
                    GameScreen gameScreen3 = gameScreen;
                    GameScreen.game.saveState(dos);
                }
                outstream.close();
            } catch (Exception e) {
            }
        }
    }

    public static boolean loadGame(boolean onlyCheckExists) {
        try {
            FileInputStream instream = instance.openFileInput("savegame.bin");
            DataInputStream dis = new DataInputStream(instream);
            int version = dis.readInt();
            if (version != 1) {
                instream.close();
                return false;
            }
            boolean continueGame = dis.readInt() != 0;
            if (continueGame && !onlyCheckExists) {
                GameScreen gameScreen2 = gameScreen;
                GameScreen.game.loadState(dis);
            }
            instream.close();
            return continueGame;
        } catch (Exception e) {
            return false;
        }
    }
}
