package com.slg.j2me.game;

import com.ju6.mms.pdu.CharacterSets;
import com.ju6.mms.pdu.PduHeaders;
import com.ju6.mms.pdu.PduPart;
import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gfx.GfxUtils;
import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.snd.SoundBank;
import com.slg.j2me.lib.sys.FixedPoint;
import com.slg.j2me.lib.sys.VecMath;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.lang.reflect.Array;
import javax.microedition.lcdui.Graphics;
/* JADX INFO: Access modifiers changed from: package-private */
/* loaded from: classes.dex */
public class GameObj {
    public static int[][] bloodTable = null;
    public static int[] bonusItemScoreTable = null;
    public static final int cMaxTempCollIgnoreFrames = 3;
    public static final int cNumSharkLevels = 10;
    public static final int cPenguinNumFlapCycles = 2;
    public static final int cPenguinNumGlideCycles = 5;
    public static final int cPointsForFlyingPelican = 60;
    public static final int cSwimmerRandomSplashPerc = 25;
    public static final int cfpBeachCorrectionOffsetY = 131072;
    public static final int cfpBeachCorrectionSpeed = 1638400;
    public static final int cfpBirdSeeSharkRangeX;
    public static final int cfpBirdSeeSharkRangeY;
    public static final int cfpBiteRateScale = 131072;
    public static final int cfpBlowfishSeeSharkRangeX;
    public static final int cfpBlowfishSeeSharkRangeY;
    public static final int cfpBoatBigJoltSpeed;
    public static final int cfpBoatBobbingRangeRot;
    public static final int cfpBoatBobbingRangeY;
    public static final int cfpBoatBobbingRate;
    public static final int cfpBoatCollOffsetX;
    public static final int cfpBoatCollOffsetY;
    public static final int cfpBoatJoltMinYDir;
    public static final int cfpBoatJoltTime;
    public static final int cfpBoatMaxJoltRange;
    public static final int cfpBuoyBobbingRangeRot;
    public static final int cfpBuoyBobbingRangeY;
    public static final int cfpBuoyBobbingRate;
    public static final int cfpCollReactBlendRate = 65536;
    public static final int cfpCollReactBlendTime = 65536;
    public static final int cfpDeathFadeRate;
    public static final int cfpDeathFadeTime;
    public static final int cfpDefaultDeathTime;
    public static final int cfpDefaultEvadeSharkRange;
    public static final int cfpDefaultMinChaseDist2;
    public static final int cfpDefaultPostDeathTime;
    public static final int cfpDefaultSeeSharkRangeX;
    public static final int cfpDefaultSeeSharkRangeY;
    public static final int cfpDiverSeeSharkRangeX;
    public static final int cfpDiverSeeSharkRangeY;
    public static final int cfpDynamiteFallSpeedWater = 262144;
    public static final int cfpDynamiteGravity = 1310720;
    public static final int cfpDynamiteLaunchOffsetX = 65536;
    public static final int cfpDynamiteLaunchOffsetY = 131072;
    public static final int cfpDynamiteLaunchSpeedXMax = 524288;
    public static final int cfpDynamiteLaunchSpeedXMin = 458752;
    public static final int cfpDynamiteLaunchSpeedYMax = 524288;
    public static final int cfpDynamiteLaunchSpeedYMin = 458752;
    public static final int cfpDynamiteRotSpeedAir = 33554432;
    public static final int cfpDynamiteRotSpeedWater = 8388608;
    public static final int cfpFishermanFallSpeedX;
    public static final int cfpFishermanTreadWaterOffsetY;
    public static final int cfpGibSinkSpeed;
    public static final int cfpHunterFireDelay = 131072;
    public static final int cfpLungeEndSpeed = 262144;
    public static final int cfpLungeSpeed = 2097152;
    public static final int cfpMineBobbingRangeY;
    public static final int cfpMineBobbingRate;
    public static final int cfpMineCollOffsetX;
    public static final int cfpMineCollOffsetY;
    public static final int cfpMouthDeathLimitX;
    public static final int cfpMouthDeathLimitY;
    public static final int cfpMouthDeathSuckInRate;
    public static final int cfpPelicanBigCollBoxHeight;
    public static final int cfpPelicanBigScoreHeight;
    public static final int cfpPelicanBobbingRangeY;
    public static final int cfpPelicanBobbingRate;
    public static final int cfpPelicanFlySpeedXMax;
    public static final int cfpPelicanFlySpeedXMin;
    public static final int cfpPelicanFlySpeedYMax;
    public static final int cfpPelicanFlySpeedYMin;
    public static final int cfpPersonCloseToSurfaceRange = 131072;
    public static final int cfpPlayerBigSplashSpeed = 655360;
    public static final int cfpPostDeathFadeRate;
    public static final int cfpPostDeathFadeTime;
    public static final int cfpSharkDrownSpeed;
    public static final int cfpSharkShakeSpeedLarge = 131072;
    public static final int cfpSharkShakeSpeedSmall = 65536;
    public static final int cfpSharkWakePosYMax = 32768;
    public static final int cfpSharkWakePosYMin = -65536;
    public static final int cfpSharkWakeSpeedXMin = 655360;
    public static final int cfpSubChaseToggleTime = 196608;
    public static final int cfpSubCollOffsetX;
    public static final int cfpSubCollOffsetY;
    public static final int cfpSubDebrisFallSpeedX = 65536;
    public static final int cfpSubDebrisFallSpeedY1 = 131072;
    public static final int cfpSubDebrisFallSpeedY2 = 196608;
    public static final int cfpSubDebrisSeparationOffsetX = 458752;
    public static final int cfpSubFireDelay = 131072;
    public static final int cfpSubInitFireDelay = 131072;
    public static final int cfpSubPostDeathTime;
    public static final int cfpSubSeeSharkRangeX;
    public static final int cfpSubSeeSharkRangeY;
    public static final int cfpSwallowMaxRange;
    public static final int cfpSwallowRate;
    public static final int cfpSwallowStartTime;
    public static final int cfpSwarmEvadeSharkRange;
    public static final int cfpSwarmSeeSharkRangeX;
    public static final int cfpSwarmSeeSharkRangeY;
    public static final int cfpSwimmerSplashOffsetX = 131072;
    public static final int cfpTorpedoLaunchSpeed = 1048576;
    public static final int eAIStateChase = 3;
    public static final int eAIStateDie = 5;
    public static final int eAIStateEvade = 4;
    public static final int eAIStateFallOutOfBoat = 6;
    public static final int eAIStateFlyAway = 8;
    public static final int eAIStateIdle = 1;
    public static final int eAIStateLunge = 9;
    public static final int eAIStateNone = 0;
    public static final int eAIStateProjectileFly = 11;
    public static final int eAIStatePuff = 7;
    public static final int eAIStateSimpleAttack = 10;
    public static final int eAIStateWander = 2;
    public static final int eAnimStateBite = 4;
    public static final int eAnimStateCharge = 5;
    public static final int eAnimStateDamage = 6;
    public static final int eAnimStateDie = 7;
    public static final int eAnimStateFall = 8;
    public static final int eAnimStateFly = 11;
    public static final int eAnimStateIdle = 1;
    public static final int eAnimStateLunge = 13;
    public static final int eAnimStateNone = 0;
    public static final int eAnimStatePanic = 12;
    public static final int eAnimStatePostDeath = 17;
    public static final int eAnimStatePuff = 10;
    public static final int eAnimStateShake = 9;
    public static final int eAnimStateShootAttack = 15;
    public static final int eAnimStateSimpleAttack = 14;
    public static final int eAnimStateSwim = 2;
    public static final int eAnimStateThrowAttack = 16;
    public static final int eAnimStateTurn = 3;
    public static final int eBloodFXGib = 1;
    public static final int eBloodFXSplat = 0;
    public static final int eBloodJellyfish = 5;
    public static final int eBloodLarge = 3;
    public static final int eBloodMedium = 2;
    public static final int eBloodNone = 0;
    public static final int eBloodNumAttributes = 3;
    public static final int eBloodRandomSpawnPerc = 2;
    public static final int eBloodSmall = 1;
    public static final int eBloodXLarge = 4;
    public static final int eBonusAmphora = 0;
    public static final int eBonusBoot = 8;
    public static final int eBonusCarTyre = 1;
    public static final int eBonusCrystalSkull = 9;
    public static final int eBonusMoonOnAStick = 2;
    public static final int eBonusNumberPlate = 3;
    public static final int eBonusRoadCone = 4;
    public static final int eBonusShoppingTrolley = 5;
    public static final int eBonusSpaceHelmet = 6;
    public static final int eBonusTrike = 7;
    public static final int eCompoundChild = 2;
    public static final int eCompoundNone = 0;
    public static final int eCompoundParent = 1;
    public static final int eDataBloodType = 8;
    public static final int eDataDamage = 17;
    public static final int eDataDieType = 7;
    public static final int eDataEvadeSpeed = 3;
    public static final int eDataFlags = 9;
    public static final int eDataHealthGain = 16;
    public static final int eDataMaxRot = 6;
    public static final int eDataMultiKillType = 18;
    public static final int eDataPoints = 15;
    public static final int eDataScaleMax = 11;
    public static final int eDataScaleMin = 10;
    public static final int eDataShakeMax = 13;
    public static final int eDataShakeMin = 12;
    public static final int eDataShakeSpeedScale = 14;
    public static final int eDataSoundDieMax = 20;
    public static final int eDataSoundDieMin = 19;
    public static final int eDataSpeedMax = 2;
    public static final int eDataSpeedMin = 1;
    public static final int eDataType = 0;
    public static final int eDataWanderRangeX = 4;
    public static final int eDataWanderRangeY = 5;
    public static final int eDieDrown = 2;
    public static final int eDieInMouth = 3;
    public static final int eDieStationary = 1;
    public static final int eDieSub = 4;
    public static final int eDieVanish = 0;
    public static final int eFlagAtSurface = 1;
    public static final int eFlagBigCollision = 64;
    public static final int eFlagBlendRot = 32;
    public static final int eFlagCanGoAboveWater = 8;
    public static final int eFlagHasTurnAnim = 4;
    public static final int eFlagHorizontal = 2;
    public static final int eFlagSwimLoopRegular = 16;
    public static final int eNumBonusItems = 10;
    public static final int eSharkBitePower = 2;
    public static final int eSharkHealthDrainRate = 6;
    public static final int eSharkHitPoints = 4;
    public static final int eSharkMaxDepth = 3;
    public static final int eSharkNumAttributes = 8;
    public static final int eSharkPoints = 0;
    public static final int eSharkSize = 1;
    public static final int eSharkSizeCM = 7;
    public static final int eSharkSpeed = 5;
    public static final int eSplashEnterWater = 2;
    public static final int eSplashEnterWaterSmall = 3;
    public static final int eSplashExitWater = 0;
    public static final int eSplashExitWaterSmall = 1;
    public static final int eSplashNone = -1;
    public static final int eSplashSharkWake = 6;
    public static final int eSplashSwimmerGrabbed = 4;
    public static final int eSplashSwimmerSwim = 5;
    public static final int eTypeBird = 6;
    public static final int eTypeBoat = 4;
    public static final int eTypeBonus = 9;
    public static final int eTypeBuoy = 10;
    public static final int eTypeFish = 2;
    public static final int eTypeInvalid = 0;
    public static final int eTypeMine = 7;
    public static final int eTypePerson = 3;
    public static final int eTypePlayer = 1;
    public static final int eTypeProjectile = 8;
    public static final int eTypeSub = 5;
    public static int fpBeachedTextLockTimer;
    static int[] fpCastDir;
    static int[][] fpCheckPoints;
    private static int[] fpDir;
    public static int fpPlayerChargeFactor;
    public static int fpPlayerChargeLevel;
    public static int fpPlayerChargeScale;
    public static int fpPlayerChargeTime;
    public static int fpPlayerDamageTintTimeRemaining;
    public static int fpPlayerDeathFallSpeed;
    public static int[] fpPlayerLastGoodPos;
    public static int[] fpPlayerMouthPos;
    public static int fpPlayerNoBreachTimer;
    public static int fpPlayerPoisonTimeRemaining;
    public static int[] fpPlayerRotCalcVel;
    public static int fpPlayerShakeSpeedScale;
    public static int fpSharkLevelFrac;
    static final int[][] fpSolidNormal;
    public static GameLogic game;
    public static boolean playerBeached;
    public static boolean playerChargeLock;
    public static int playerNumBonusItemsCollected;
    public static int playerNumShakesRequired;
    public static int playerShakeCount;
    public static int playerTotalEaten;
    public static int playerWhichBonusItemsCollected;
    private static int[] reverse;
    public static int sharkLevel;
    public static int[][] sharkTable;
    public static int[] tempPos;
    public static int[] tempPos2;
    public static int[] tempRect;
    public static int[] tempRect2;
    public static int[][] typeData;
    public int aiMiscData;
    public int aiState;
    public GameObj aiTargetObj;
    public int allocIndex;
    public int animSet;
    public AnimSprite animSprite;
    public int animState;
    public int bonusFrame;
    public int compoundObjType;
    public GameObj detachedChild;
    public GameObj detachedParent;
    public boolean facingLeft;
    public int fpAIMaxChaseRange;
    public int fpAIMiscTimer;
    public int fpAIWanderPhaseX;
    public int fpAIWanderPhaseY;
    public int fpAIWanderRangeX;
    public int fpAIWanderRangeY;
    public int fpAnimScaleRate;
    public int fpAnimStateTime;
    public int fpCollReactBlend;
    public int fpEvadeDisableTimer;
    public int fpEvadeSpeed;
    public int fpEvadeTimer;
    public int fpFadeAlpha;
    public int fpFireDelay;
    public int fpHealth;
    public int fpInitSpeed;
    public int fpJoltPhase;
    public int fpJoltScale;
    public int fpMoveSpeed;
    public int fpPuffTimer;
    public int fpRot;
    public int fpScale;
    public int fpShoalRadiusPhase;
    public int fpShoalRotPhase;
    boolean hidden;
    public boolean joltLock;
    public int loopCounter;
    public int loopCounterType;
    public int numGibsSpawned;
    public int objType;
    public int shoal;
    public int spawner;
    public int specialSwimAnim;
    public int tempCollIgnoreFrames;
    public int tintColor;
    public static final int cfpChargeDrainRate = FixedPoint.stringToFP("0.3");
    public static final int cfpChargeRestoreRate = FixedPoint.stringToFP("0.1");
    public static final int cfpPlayerChargeMinStart = FixedPoint.stringToFP("0.05");
    public static final int cfpSmallSharkChargeScale = FixedPoint.stringToFP("0.5");
    public static final int cfpWaterHeight = FixedPoint.stringToFP("2.0");
    public static final int cfpSafeWaterHeight = cfpWaterHeight + 131072;
    public static final int cfpHealthWarningLevelLow = FixedPoint.stringToFP("40");
    public static final int cfpHealthWarningLevelCritical = FixedPoint.stringToFP("20");
    public static final int cfpJellyfishPoisonAmount = FixedPoint.stringToFP("20");
    public static final int cfpPlayerPoisonTime = FixedPoint.stringToFP("2.5");
    public static final int cfpPlayerPoisonRate = (int) ((cfpJellyfishPoisonAmount << 16) / cfpPlayerPoisonTime);
    public static final int cfpPlayerDamageTintTime = FixedPoint.stringToFP("1");
    public static final int cfpSharkMouthOffsetX = FixedPoint.stringToFP("3");
    public static final int cfpSharkMouthOffsetY = FixedPoint.stringToFP("1");
    public static final int cfpSharkBiteRange = FixedPoint.stringToFP("4");
    public static final int cfpSharkBitePredictTime = FixedPoint.stringToFP("0.2");
    public static final int cfpDefaultMinChaseDist = FixedPoint.stringToFP("8");
    public int[] fpPos = new int[2];
    public int[] fpVel = new int[2];
    public int[] fpExtents = new int[4];
    public int[] fpBasicExtents = new int[4];
    public int[] fpAIHomePos = new int[2];
    int[] fpNormal = new int[2];
    public boolean allocated = false;
    public boolean deleted = false;

    static {
        cfpDefaultMinChaseDist2 = ((cfpDefaultMinChaseDist ^ cfpDefaultMinChaseDist) & 134217728) != 0 ? -((int) (((-cfpDefaultMinChaseDist) * cfpDefaultMinChaseDist) >> 16)) : (int) ((cfpDefaultMinChaseDist * cfpDefaultMinChaseDist) >> 16);
        cfpDefaultSeeSharkRangeX = FixedPoint.stringToFP("12.5");
        cfpDefaultSeeSharkRangeY = FixedPoint.stringToFP("8.0");
        cfpDefaultEvadeSharkRange = FixedPoint.stringToFP("25");
        cfpSwarmSeeSharkRangeX = FixedPoint.stringToFP("6");
        cfpSwarmSeeSharkRangeY = FixedPoint.stringToFP("6");
        cfpSwarmEvadeSharkRange = FixedPoint.stringToFP("12");
        cfpBlowfishSeeSharkRangeX = FixedPoint.stringToFP("10");
        cfpBlowfishSeeSharkRangeY = FixedPoint.stringToFP("4");
        cfpDiverSeeSharkRangeX = FixedPoint.stringToFP("4");
        cfpDiverSeeSharkRangeY = FixedPoint.stringToFP("4");
        cfpBirdSeeSharkRangeX = FixedPoint.stringToFP("15");
        cfpBirdSeeSharkRangeY = FixedPoint.stringToFP("3");
        cfpSubSeeSharkRangeX = FixedPoint.stringToFP("15");
        cfpSubSeeSharkRangeY = FixedPoint.stringToFP("3");
        cfpMouthDeathLimitX = FixedPoint.stringToFP("1");
        cfpMouthDeathLimitY = FixedPoint.stringToFP("0");
        cfpMouthDeathSuckInRate = FixedPoint.stringToFP("8");
        cfpSwallowStartTime = FixedPoint.stringToFP("0.25");
        cfpSwallowRate = FixedPoint.stringToFP("6");
        cfpSwallowMaxRange = FixedPoint.stringToFP("4");
        cfpDefaultDeathTime = FixedPoint.stringToFP("1");
        cfpGibSinkSpeed = FixedPoint.stringToFP("4");
        cfpDefaultPostDeathTime = FixedPoint.stringToFP("3");
        cfpSubPostDeathTime = FixedPoint.stringToFP("5");
        cfpSharkDrownSpeed = FixedPoint.stringToFP("2");
        cfpDeathFadeTime = FixedPoint.stringToFP("0.5");
        cfpPostDeathFadeTime = FixedPoint.stringToFP("1");
        cfpDeathFadeRate = (int) (4294967296L / cfpDeathFadeTime);
        cfpPostDeathFadeRate = (int) (4294967296L / cfpPostDeathFadeTime);
        cfpBoatBobbingRangeY = FixedPoint.stringToFP("0.25");
        cfpBoatBobbingRangeRot = FixedPoint.stringToFP("2.0");
        cfpBoatBobbingRate = FixedPoint.stringToFP("100");
        cfpBuoyBobbingRangeY = FixedPoint.stringToFP("0.5");
        cfpBuoyBobbingRangeRot = FixedPoint.stringToFP("4.0");
        cfpBuoyBobbingRate = FixedPoint.stringToFP("100");
        cfpBoatMaxJoltRange = FixedPoint.stringToFP("1.0");
        cfpBoatJoltMinYDir = FixedPoint.stringToFP("-0.7");
        cfpBoatBigJoltSpeed = FixedPoint.stringToFP("20");
        cfpBoatJoltTime = FixedPoint.stringToFP("1.0");
        cfpFishermanFallSpeedX = FixedPoint.stringToFP("6.0");
        cfpFishermanTreadWaterOffsetY = FixedPoint.stringToFP("1");
        cfpBoatCollOffsetX = FixedPoint.stringToFP("6");
        cfpBoatCollOffsetY = FixedPoint.stringToFP("2");
        cfpSubCollOffsetX = FixedPoint.stringToFP("4");
        cfpSubCollOffsetY = FixedPoint.stringToFP("2");
        cfpMineBobbingRangeY = FixedPoint.stringToFP("0.5");
        cfpMineBobbingRate = FixedPoint.stringToFP("100");
        cfpMineCollOffsetX = FixedPoint.stringToFP("3");
        cfpMineCollOffsetY = FixedPoint.stringToFP("2");
        cfpPelicanBobbingRangeY = FixedPoint.stringToFP("0.2");
        cfpPelicanBobbingRate = FixedPoint.stringToFP("100");
        cfpPelicanFlySpeedXMin = FixedPoint.stringToFP("5");
        cfpPelicanFlySpeedXMax = FixedPoint.stringToFP("6");
        cfpPelicanFlySpeedYMin = FixedPoint.stringToFP("4");
        cfpPelicanFlySpeedYMax = FixedPoint.stringToFP("5");
        cfpPelicanBigCollBoxHeight = FixedPoint.stringToFP("2");
        cfpPelicanBigScoreHeight = FixedPoint.stringToFP("3.5");
        game = null;
        typeData = new int[][]{new int[]{1, 0, 0, 0, 0, 0, cfpLungeSpeed, 2, 3, 68, 65536, 65536, 0, 0, 65536, 0, 0, 0, -1, -1, -1}, new int[]{3, 131072, 262144, 786432, cfpBeachCorrectionSpeed, 0, 0, 3, 4, 21, FixedPoint.stringToFP("1.15"), FixedPoint.stringToFP("1.15"), 6, 1, FixedPoint.stringToFP("0.15"), 100, 50, 0, -1, 2, 3}, new int[]{2, 786432, 1048576, 1048576, cfpBeachCorrectionSpeed, 0, 1048576, 3, 3, 36, GameLogic.cfpIntroFadeTime, 81920, 4, 1, FixedPoint.stringToFP("0.6"), 50, 30, 0, -1, 4, 9}, new int[]{2, 131072, 262144, 1048576, cfpBeachCorrectionSpeed, 786432, 1048576, 3, 2, 36, GameLogic.cfpIntroFadeTime, 65536, 3, 1, FixedPoint.stringToFP("0.8"), 20, 25, 0, 0, 4, 9}, new int[]{2, cfpLungeSpeed, cfpLungeSpeed, 524288, cfpBeachCorrectionSpeed, 0, 4194304, 0, 1, 0, GameLogic.cfpIntroFadeTime, 65536, 0, 0, 65536, 5, 5, 0, -1, 4, 9}, new int[]{2, cfpBeachCorrectionSpeed, 1966080, 1966080, FixedPoint.stringToFP("150"), 1048576, 1048576, 3, 3, 36, 65536, 81920, 8, 1, FixedPoint.stringToFP("0.5"), PduPart.P_CONTENT_TRANSFER_ENCODING, 50, 20, -1, 4, 9}, new int[]{2, 131072, 262144, 393216, cfpBeachCorrectionSpeed, 0, 0, 3, 5, 18, 32768, 65536, 2, 1, FixedPoint.stringToFP("0.5"), 0, 0, 35, -1, 10, -1}, new int[]{2, 131072, 262144, 524288, cfpBeachCorrectionSpeed, 786432, 1048576, 3, 2, 4, GameLogic.cfpIntroFadeTime, 65536, 4, 1, FixedPoint.stringToFP("0.7"), 80, 30, 25, 1, 4, 9}, new int[]{2, 131072, 262144, 786432, 524288, 262144, cfpLungeSpeed, 3, 1, 0, GameLogic.cfpIntroFadeTime, 65536, 1, 0, FixedPoint.stringToFP("0.85"), 10, 12, 0, 5, 4, 9}, new int[]{2, 131072, 262144, 524288, cfpBeachCorrectionSpeed, 786432, 1048576, 3, 2, 36, GameLogic.cfpIntroFadeTime, 65536, 4, 1, FixedPoint.stringToFP("0.5"), 250, 40, 30, 2, 4, 9}, new int[]{6, 131072, 262144, 786432, cfpBeachCorrectionSpeed, 0, 0, 3, 3, 8, 65536, 65536, 3, 1, FixedPoint.stringToFP("0.8"), 30, 20, 0, 4, 25, 26}, new int[]{7, 0, 0, 0, 0, 0, 0, 0, 0, 8, 65536, 65536, 0, 0, 65536, 0, 0, 40, -1, -1, -1}, new int[]{3, 131072, 262144, 786432, cfpBeachCorrectionSpeed, 0, 0, 3, 4, 21, FixedPoint.stringToFP("1.15"), FixedPoint.stringToFP("1.15"), 6, 1, FixedPoint.stringToFP("0.15"), 100, 50, 0, -1, 12, 13}, new int[]{3, 131072, 262144, 524288, cfpBeachCorrectionSpeed, 786432, 1048576, 3, 4, 36, 65536, 65536, 8, 1, FixedPoint.stringToFP("0.15"), 300, 75, 30, -1, 29, -1}, new int[]{2, 655360, 983040, 1310720, cfpBeachCorrectionSpeed, 786432, 1048576, 3, 2, 52, FixedPoint.stringToFP("0.9"), 65536, 6, 1, FixedPoint.stringToFP("0.8"), 125, 40, 0, -1, 27, -1}, new int[]{4, 0, 0, 0, 0, 0, 0, 0, 0, 8, 65536, 65536, 0, 0, 65536, 0, 0, 0, -1, -1, -1}, new int[]{3, 0, 0, 0, 0, 0, 0, 3, 4, 8, 65536, 65536, 8, 1, FixedPoint.stringToFP("0.15"), PduPart.P_CONTENT_TRANSFER_ENCODING, 50, 0, -1, 2, 3}, new int[]{2, 131072, 262144, 786432, cfpBeachCorrectionSpeed, 786432, 524288, 3, 2, 4, FixedPoint.stringToFP("0.9"), 65536, 3, 1, FixedPoint.stringToFP("0.6"), 500, PduPart.P_CONTENT_TRANSFER_ENCODING, 0, 3, 0, -1}, new int[]{5, 327680, 327680, 327680, cfpBeachCorrectionSpeed, 786432, 524288, 4, 0, 68, 98304, 98304, 8, 2, FixedPoint.stringToFP("0.3"), 1500, 0, 25, -1, -1, -1}, new int[]{8, 0, 0, 0, 0, 0, 4194304, 0, 0, 8, 65536, 65536, 0, 0, 65536, 0, 0, 60, -1, -1, -1}, new int[]{8, 0, 0, 0, 0, 0, 4194304, 0, 0, 0, 65536, 65536, 0, 0, 65536, 0, 0, 60, -1, -1, -1}, new int[]{3, 0, 0, 0, 0, 0, 0, 3, 4, 8, 65536, 65536, 8, 1, FixedPoint.stringToFP("0.15"), 400, 75, 0, -1, 2, 3}, new int[]{4, 0, 0, 0, 0, 0, 0, 0, 0, 8, 65536, 65536, 0, 0, 65536, 0, 0, 0, -1, -1, -1}, new int[]{9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 65536, 65536, 0, 0, 65536, 0, 0, 0, -1, 31, -1}, new int[]{10, 0, 0, 0, 0, 0, 0, 0, 0, 8, FixedPoint.stringToFP("0.8"), FixedPoint.stringToFP("0.8"), 0, 0, 65536, 0, 0, 0, -1, -1, -1}};
        bloodTable = new int[][]{new int[0], new int[]{6, 10, cfpBeachCorrectionSpeed}, new int[]{7, 11, 2621440}, new int[]{8, 12, 3932160}, new int[]{9, 12, 3932160}, new int[]{22, 23, 2621440}};
        sharkTable = new int[][]{new int[]{0, FixedPoint.stringToFP("0.5"), FixedPoint.stringToFP("0.4"), FixedPoint.stringToFP("0.3"), 100, 917504, FixedPoint.stringToFP("2.25"), 150}, new int[]{500, FixedPoint.stringToFP("0.6"), FixedPoint.stringToFP("0.5"), FixedPoint.stringToFP("0.4"), 110, 983040, FixedPoint.stringToFP("2.75"), PduPart.P_CONTENT_TRANSFER_ENCODING}, new int[]{1500, FixedPoint.stringToFP("0.7"), FixedPoint.stringToFP("0.6"), FixedPoint.stringToFP("0.5"), 120, 1048576, FixedPoint.stringToFP("3"), 250}, new int[]{3000, FixedPoint.stringToFP("0.8"), FixedPoint.stringToFP("0.7"), FixedPoint.stringToFP("0.6"), 130, 1114112, FixedPoint.stringToFP("3.5"), 280}, new int[]{6000, FixedPoint.stringToFP("0.9"), FixedPoint.stringToFP("0.8"), FixedPoint.stringToFP("0.7"), 140, 1179648, FixedPoint.stringToFP("4"), 315}, new int[]{10000, FixedPoint.stringToFP("1.0"), FixedPoint.stringToFP("0.9"), FixedPoint.stringToFP("0.8"), 150, 1179648, FixedPoint.stringToFP("4.75"), 350}, new int[]{18000, FixedPoint.stringToFP("1.1"), FixedPoint.stringToFP("1.0"), FixedPoint.stringToFP("0.9"), PduHeaders.PREVIOUSLY_SENT_BY, 1245184, FixedPoint.stringToFP("6"), 385}, new int[]{26000, FixedPoint.stringToFP("1.2"), FixedPoint.stringToFP("1.1"), FixedPoint.stringToFP("1.0"), PduHeaders.MBOX_TOTALS, 1310720, FixedPoint.stringToFP("7"), Spawner.cMaxSpawners}, new int[]{40000, FixedPoint.stringToFP("1.3"), FixedPoint.stringToFP("1.2"), FixedPoint.stringToFP("1.0"), PduHeaders.RECOMMENDED_RETRIEVAL_MODE, 1376256, FixedPoint.stringToFP("8.25"), 525}, new int[]{60000, FixedPoint.stringToFP("1.4"), FixedPoint.stringToFP("1.3"), FixedPoint.stringToFP("1.0"), PduPart.P_CONTENT_TRANSFER_ENCODING, 1441792, FixedPoint.stringToFP("10.5"), 600}};
        bonusItemScoreTable = new int[]{250, 500, CharacterSets.UCS2, 2250, 3500, 4500, 6000, 8000, 12500, 25000};
        fpPlayerMouthPos = new int[2];
        fpPlayerLastGoodPos = new int[2];
        fpPlayerRotCalcVel = new int[2];
        tempPos = new int[2];
        tempPos2 = new int[2];
        tempRect = new int[4];
        tempRect2 = new int[4];
        fpSolidNormal = new int[][]{new int[]{65536, 0}, new int[]{cfpSharkWakePosYMin, 0}, new int[]{0, cfpSharkWakePosYMin}, new int[]{0, 65536}};
        fpCheckPoints = (int[][]) Array.newInstance(Integer.TYPE, 4, 2);
        fpCastDir = new int[2];
        reverse = new int[2];
        fpDir = new int[2];
    }

    public GameObj() {
        this.animSprite = null;
        this.animSprite = new AnimSprite();
        reset();
    }

    public void reset() {
        this.objType = 0;
        this.hidden = false;
        this.animSet = 0;
        this.animState = 0;
        this.spawner = -1;
        this.shoal = -1;
        this.compoundObjType = 0;
        this.bonusFrame = -1;
        this.fpAnimStateTime = 0;
        this.fpPos[0] = 0;
        this.fpPos[1] = 0;
        this.fpVel[0] = 0;
        this.fpVel[1] = 0;
        for (int i = 0; i < 4; i++) {
            this.fpExtents[i] = 0;
            this.fpBasicExtents[i] = 0;
        }
        this.facingLeft = true;
        this.fpRot = 0;
        this.fpScale = 65536;
        this.fpFadeAlpha = 65536;
        this.tintColor = 16777215;
        this.fpMoveSpeed = 0;
        this.fpEvadeSpeed = 0;
        this.fpInitSpeed = 0;
        this.fpEvadeDisableTimer = 0;
        this.fpEvadeTimer = 0;
        this.fpCollReactBlend = 0;
        this.tempCollIgnoreFrames = 3;
        this.fpAnimScaleRate = 65536;
        this.specialSwimAnim = -1;
        this.fpPuffTimer = 0;
        this.fpHealth = 6553600;
        this.loopCounter = 0;
        this.loopCounterType = 0;
        this.numGibsSpawned = 0;
        this.aiState = 0;
        this.fpAIHomePos[0] = 0;
        this.fpAIHomePos[1] = 0;
        this.fpAIWanderRangeX = 0;
        this.fpAIWanderRangeY = 0;
        this.fpAIWanderPhaseX = 0;
        this.fpAIWanderPhaseY = 0;
        this.aiTargetObj = null;
        this.fpAIMaxChaseRange = 0;
        this.fpFireDelay = 0;
        this.detachedChild = null;
        this.detachedParent = null;
        this.fpJoltPhase = 0;
        this.joltLock = false;
        this.animSprite.reset();
    }

    public void resetPlayer() {
        fpPlayerMouthPos[0] = 0;
        fpPlayerMouthPos[1] = 0;
        fpPlayerLastGoodPos[0] = 0;
        fpPlayerLastGoodPos[1] = 0;
        fpPlayerRotCalcVel[0] = 0;
        fpPlayerRotCalcVel[1] = 0;
        playerShakeCount = 0;
        playerNumShakesRequired = 0;
        sharkLevel = 0;
        fpSharkLevelFrac = 0;
        fpPlayerChargeTime = 0;
        fpPlayerChargeLevel = 65536;
        fpPlayerChargeFactor = 0;
        fpPlayerChargeScale = 0;
        playerChargeLock = false;
        fpPlayerNoBreachTimer = 0;
        fpPlayerShakeSpeedScale = 65536;
        playerNumBonusItemsCollected = 0;
        playerWhichBonusItemsCollected = 0;
        fpPlayerPoisonTimeRemaining = 0;
        fpPlayerDamageTintTimeRemaining = 0;
        fpBeachedTextLockTimer = 0;
        playerBeached = false;
        playerTotalEaten = 0;
    }

    public void requestDelete() {
        if (this.spawner != -1) {
            GameLogic gameLogic = game;
            GameLogic.spawner.notifyObjectDeleted(this.spawner);
        } else if (this.animSet == 10) {
            GameLogic gameLogic2 = game;
            GameLogic.spawner.notifyBirdDeleted();
        }
        if (this.animSet >= 0) {
            int[] iArr = game.npcNumActive;
            int i = this.animSet;
            iArr[i] = iArr[i] - 1;
            checkStopAmbientLoop();
        }
        this.deleted = true;
    }

    public void process() {
        if (!this.deleted) {
            updateAIState();
            updateAnimState();
            updateAnimation();
            updateMovement();
            updateCulling();
        }
    }

    public void paint(Graphics g) {
        int i;
        if (!this.deleted && !this.hidden && collTestRect(game.rectVisible)) {
            TiledLevel.worldToScreenPos(tempPos, this.fpPos);
            this.animSprite.flipped = !this.facingLeft;
            if (this.animSet == 14) {
                this.animSprite.flipped = !this.animSprite.flipped;
            }
            this.animSprite.fpRot = this.fpRot;
            this.animSprite.fpScale = this.fpScale;
            AnimSprite animSprite = this.animSprite;
            int i2 = this.tintColor;
            if (this.fpFadeAlpha >= 65536) {
                i = -16777216;
            } else {
                i = (this.fpFadeAlpha * 255 < 0 ? -((-(this.fpFadeAlpha * 255)) >> 16) : (this.fpFadeAlpha * 255) >> 16) << 24;
            }
            animSprite.tintColor = i2 | i;
            this.animSprite.blendMode = this.animSet == 6 ? 1 : 0;
            this.animSprite.paint(g, tempPos[0], tempPos[1]);
        }
    }

    public void paintFakeShark(Graphics g, int x, int y) {
        this.animSprite.flipped = !this.facingLeft;
        this.animSprite.fpRot = this.fpRot;
        this.animSprite.fpScale = this.fpScale;
        this.animSprite.tintColor = -1;
        this.animSprite.blendMode = 0;
        this.animSprite.paint(g, x, y);
    }

    public void updateAnimation() {
        if (!this.hidden) {
            int dt = GameApp.fp_deltatime;
            if (this.fpAnimScaleRate != 65536) {
                dt = ((this.fpAnimScaleRate ^ dt) & 134217728) != 0 ? -((int) (((-dt) * this.fpAnimScaleRate) >> 16)) : (int) ((dt * this.fpAnimScaleRate) >> 16);
            }
            if (this.objType == 1 && fpPlayerChargeFactor > 0) {
                dt <<= 1;
            }
            this.animSprite.animate(dt);
        }
    }

    private void updateMovement() {
        int i;
        int dt = GameApp.fp_deltatime;
        if (dt >= 6553) {
            dt = 6553;
        }
        tempPos[0] = this.fpPos[0];
        tempPos[1] = this.fpPos[1];
        int[] iArr = this.fpPos;
        iArr[0] = iArr[0] + (((this.fpVel[0] ^ dt) & 134217728) != 0 ? -((int) (((-this.fpVel[0]) * dt) >> 16)) : (int) ((this.fpVel[0] * dt) >> 16));
        int[] iArr2 = this.fpPos;
        iArr2[1] = iArr2[1] + (((this.fpVel[1] ^ dt) & 134217728) != 0 ? -((int) (((-this.fpVel[1]) * dt) >> 16)) : (int) ((this.fpVel[1] * dt) >> 16));
        if (this.fpCollReactBlend - (((65536 ^ dt) & 134217728) != 0 ? -((int) (((-dt) * 65536) >> 16)) : (int) ((dt * 65536) >> 16)) < 0) {
            i = 0;
        } else {
            i = this.fpCollReactBlend - (((65536 ^ dt) & 134217728) != 0 ? -((int) (((-dt) * 65536) >> 16)) : (int) ((dt * 65536) >> 16));
        }
        this.fpCollReactBlend = i;
        boolean flagCanGoAboveWater = (typeData[this.animSet][9] & 8) != 0;
        boolean canGoAboveWater = flagCanGoAboveWater;
        if (this.objType != 1 && this.animState == 7) {
            canGoAboveWater = true;
        }
        if (this.objType == 1) {
            if (this.fpCollReactBlend > 49152) {
                fpPlayerNoBreachTimer = 0;
            }
            if (fpPlayerNoBreachTimer > 0) {
                fpPlayerNoBreachTimer -= dt;
                fpPlayerNoBreachTimer = fpPlayerNoBreachTimer > 0 ? fpPlayerNoBreachTimer : 0;
            } else if (tempPos[1] < cfpWaterHeight) {
                canGoAboveWater = true;
                if (this.fpPos[1] >= cfpWaterHeight) {
                    fpPlayerNoBreachTimer = 32768;
                    if (this.fpVel[1] > 655360) {
                        doSplashFX(2, this.fpPos[0]);
                    } else {
                        doSplashFX(3, this.fpPos[0]);
                    }
                }
            } else {
                canGoAboveWater = true;
                if (this.fpPos[1] < cfpWaterHeight) {
                    if (this.fpVel[1] < -655360) {
                        doSplashFX(0, this.fpPos[0]);
                    } else {
                        doSplashFX(1, this.fpPos[0]);
                    }
                }
            }
        }
        boolean bounceOffSurface = false;
        if (this.fpPos[1] < cfpWaterHeight && !canGoAboveWater) {
            this.fpPos[1] = cfpWaterHeight;
            this.fpVel[1] = 0;
            if (this.objType == 1) {
                if (fpPlayerChargeFactor == 0) {
                    fpPlayerNoBreachTimer = 16384;
                }
            } else if (tempPos[1] > cfpWaterHeight) {
                bounceOffSurface = true;
            }
        }
        if (this.compoundObjType == 2) {
            int fpRotOffset = ((FixedPoint.sinLut(this.aiTargetObj.fpRot) ^ this.fpAIHomePos[0]) & 134217728) != 0 ? -((int) (((-FixedPoint.sinLut(this.aiTargetObj.fpRot)) * this.fpAIHomePos[0]) >> 16)) : (int) ((FixedPoint.sinLut(this.aiTargetObj.fpRot) * this.fpAIHomePos[0]) >> 16);
            this.fpPos[0] = this.fpAIHomePos[0] + this.aiTargetObj.fpPos[0];
            this.fpPos[1] = this.fpAIHomePos[1] + this.aiTargetObj.fpPos[1] + fpRotOffset;
        }
        boolean canCollide = true;
        canCollide = (flagCanGoAboveWater || this.compoundObjType != 0) ? false : false;
        if (this.objType == 8) {
            canCollide = true;
        }
        if (this.objType == 1 && this.animState == 7) {
            canCollide = false;
        }
        if (this.objType == 1 && playerBeached) {
            canCollide = false;
        }
        boolean collided = false;
        boolean bigCollision = (typeData[this.animSet][9] & 64) != 0;
        if (canCollide) {
            GameScreen gameScreen = GameApp.gameScreen;
            TiledLevel tiledLevel = GameScreen.tiledLevel;
            if (bigCollision) {
                if (!tiledLevel.canMoveTo(tempPos, this.fpPos, this.fpBasicExtents[2] >> 2, this.fpBasicExtents[3] >> 2)) {
                    collided = true;
                    boolean beached = tempPos[1] < cfpWaterHeight && this.objType == 1;
                    if (beached) {
                        if (fpBeachedTextLockTimer == 0) {
                            GameApp.gameScreen.addEatTextMessageFixed("BEACHED!", -49088);
                            fpBeachedTextLockTimer = 65536;
                        }
                        collReactBeached(tempPos);
                    } else {
                        collReact(TiledLevel.collResultNormal, tempPos);
                    }
                }
            } else if (!tiledLevel.canMoveTo(tempPos, this.fpPos)) {
                collided = true;
                collReact(TiledLevel.collResultNormal, tempPos);
            }
        }
        if (bounceOffSurface) {
            collReact(fpSolidNormal[2], tempPos);
        }
        if (!collided && this.tempCollIgnoreFrames > 0) {
            this.tempCollIgnoreFrames--;
        }
        getExtents(this.fpExtents);
        updateBasicExtents();
        if (this.objType == 4) {
            checkBoatCollisionVsShark();
        } else if (this.objType == 7) {
            checkMineCollisionVsShark();
        } else if (this.objType == 5) {
            checkSubCollisionVsShark();
        } else if (this.objType == 8) {
            if (collided) {
                GameScreen.effects.create(5, 1, this.fpPos[0], this.fpPos[1]);
                requestDelete();
                return;
            }
            checkProjectileCollisionVsShark();
        } else if (this.animSet == 5) {
            checkSailfishCollisionVsShark();
        }
        if (this.objType == 1) {
            refreshMouthPos();
        }
    }

    private void updateCulling() {
        if (this.objType != 1 && this.compoundObjType != 1 && this.detachedChild == null) {
            boolean cull = false;
            if (this.spawner == -1) {
                if (!collTestPointVsRect(this.fpPos[0], this.fpPos[1], game.rectCullSpawner)) {
                    cull = true;
                }
            } else {
                GameLogic gameLogic = game;
                if (GameLogic.spawner.getSpawnerState(this.spawner) != 1 && !collTestRect(game.rectCullSpawner)) {
                    cull = true;
                }
            }
            if (cull) {
                if (this.spawner != -1 && this.animState != 17) {
                    GameLogic gameLogic2 = game;
                    GameLogic.spawner.notifyObjectCulled(this.spawner);
                }
                if (this.compoundObjType == 2) {
                    this.aiTargetObj.requestDelete();
                } else if (this.detachedParent != null) {
                    this.detachedParent.detachedChild = null;
                    this.detachedParent.requestDelete();
                }
                requestDelete();
            }
        }
    }

    public void initPlayer() {
        this.objType = 1;
        resetPlayer();
        setSharkLevel(0, false, false);
        this.animSet = 0;
        this.animState = 0;
    }

    public void initFakePlayer() {
        this.objType = 1;
        this.animSet = 0;
        this.animState = 0;
    }

    public void initNewObj(int _animSet, int posX, int posY, int _spawner, int _shoal) {
        this.animSet = _animSet;
        int[] table = typeData[this.animSet];
        int[] iArr = game.npcNumActive;
        int i = this.animSet;
        iArr[i] = iArr[i] + 1;
        checkStartAmbientLoop();
        this.objType = table[0];
        int speedMin = table[1];
        int speedMax = table[2];
        int evadeSpeed = table[3];
        int wanderRangeX = table[4];
        int wanderRangeY = table[5];
        int typeFlags = table[9];
        if (posY - wanderRangeY < cfpSafeWaterHeight && (typeFlags & 9) == 0) {
            wanderRangeY = posY < cfpSafeWaterHeight ? 0 : posY - cfpSafeWaterHeight;
        }
        this.animState = 0;
        this.spawner = _spawner;
        this.shoal = _shoal;
        this.fpPos[0] = posX;
        this.fpPos[1] = posY;
        if ((typeFlags & 1) != 0) {
            this.fpPos[1] = cfpWaterHeight;
        }
        this.fpScale = GameLogic.randRange(table[10], table[11]);
        this.fpHealth = 6553600;
        if (this.animSet == 8) {
            int special = GameLogic.randRange(0, 2);
            if (special == 0) {
                this.specialSwimAnim = 2;
            } else if (special == 1) {
                this.specialSwimAnim = 16;
            } else {
                this.specialSwimAnim = 17;
            }
        }
        switch (this.animSet) {
            case 10:
            case 11:
            case 15:
            case 16:
            case 21:
            case 22:
            case 23:
            case 24:
                nextAnimState(1);
                aiGotoStateIdle();
                break;
            case 12:
            case 13:
            case 14:
            case 17:
            case 18:
            default:
                int speed = GameLogic.randRange(speedMin, speedMax);
                this.fpMoveSpeed = speed;
                this.fpInitSpeed = speed;
                this.fpEvadeSpeed = evadeSpeed;
                nextAnimState(2);
                this.fpAIWanderPhaseX = GameLogic.randAngle();
                this.fpAIWanderPhaseY = GameLogic.randAngle();
                aiInitStateWander(posX, posY, wanderRangeX, wanderRangeY);
                if (this.animSet == 18) {
                    this.fpFireDelay = 131072;
                    break;
                }
                break;
            case 19:
            case 20:
                nextAnimState(1);
                break;
        }
        getExtents(this.fpExtents);
        initBasicExtents();
    }

    public void initDynamite(GameObj parent) {
        this.fpPos[0] = parent.facingLeft ? parent.fpPos[0] - 65536 : parent.fpPos[0] + 65536;
        this.fpPos[1] = parent.fpPos[1] - 131072;
        this.fpVel[0] = GameLogic.randRange(458752, 524288);
        this.fpVel[1] = GameLogic.randRange(-458752, -524288);
        if (parent.facingLeft) {
            this.fpVel[0] = -this.fpVel[0];
        }
        this.fpRot = 0;
        aiGotoStateProjectileFly();
    }

    public void initTorpedo(GameObj parent) {
        int[] iArr = tempPos;
        GameLogic gameLogic = game;
        iArr[0] = GameLogic.player.fpPos[0] - this.fpPos[0];
        int[] iArr2 = tempPos;
        GameLogic gameLogic2 = game;
        iArr2[1] = GameLogic.player.fpPos[1] - this.fpPos[1];
        VecMath.norm2d(tempPos, tempPos);
        this.fpVel[0] = ((tempPos[0] ^ 1048576) & 134217728) != 0 ? -((int) (((-tempPos[0]) * 1048576) >> 16)) : (int) ((tempPos[0] * 1048576) >> 16);
        this.fpVel[1] = ((tempPos[1] ^ 1048576) & 134217728) != 0 ? -((int) (((-tempPos[1]) * 1048576) >> 16)) : (int) ((tempPos[1] * 1048576) >> 16);
        pointInDirection(this.fpVel[0], this.fpVel[1], 4194304, false, false);
        aiGotoStateProjectileFly();
    }

    public void initBonusItem(int id) {
        this.bonusFrame = id;
        this.animSprite.pause(true);
        this.animSprite.setFrame(id);
    }

    public static void setSharkLevel(int n, boolean displayMessage, boolean updateHealthBarSize) {
        int numSharkLevels = sharkTable.length;
        sharkLevel = n;
        fpSharkLevelFrac = (n < 0 ? -((-n) << 16) : n << 16) / (numSharkLevels - 1);
        GameLogic gameLogic = game;
        GameLogic.player.fpHealth = sharkTable[n][4] < 0 ? -((-sharkTable[n][4]) << 16) : sharkTable[n][4] << 16;
        GameLogic gameLogic2 = game;
        GameLogic.player.fpScale = sharkTable[sharkLevel][1];
        if (displayMessage) {
            GameApp.gameScreen.addEatTextMessageFixed(n == numSharkLevels - 1 ? "MAX LEVEL!" : "LEVEL UP!", -1);
            SoundBank.sfxPlay(17, false, 100, 0);
            GameLogic gameLogic3 = game;
            GameLogic.player.initBasicExtents();
        }
        if (updateHealthBarSize) {
            refreshHealthBarSize();
        }
    }

    public static void refreshHealthBarSize() {
        GameApp.gameScreen.setHealthBarSizePerc(sharkTable[sharkLevel][4] >> 1);
    }

    public void attachToParent(GameObj parent) {
        this.aiTargetObj = parent;
        this.compoundObjType = 2;
        parent.aiTargetObj = this;
        parent.compoundObjType = 1;
        this.fpAIHomePos[0] = this.fpPos[0] - parent.fpPos[0];
        this.fpAIHomePos[1] = this.fpPos[1] - parent.fpPos[1];
    }

    public void detachParentAndChild() {
        GameObj child;
        GameObj parent;
        if (this.compoundObjType == 2) {
            child = this;
            parent = this.aiTargetObj;
        } else {
            child = this.aiTargetObj;
            parent = this;
        }
        child.fpPos[0] = parent.fpPos[0] + child.fpAIHomePos[0];
        child.fpPos[1] = parent.fpPos[1] + child.fpAIHomePos[1];
        child.aiTargetObj = null;
        parent.aiTargetObj = null;
        child.compoundObjType = 0;
        parent.compoundObjType = 0;
        child.detachedParent = parent;
        parent.detachedChild = child;
        if (child.spawner != -1) {
            GameLogic gameLogic = game;
            int[] spawnerState = GameLogic.spawner.spawners[child.spawner];
            spawnerState[9] = 1;
        }
    }

    public void playAnim(int id, boolean loop, boolean pingPong) {
        int idx = AnimData.findAnim(this.animSet, id);
        if (idx != -1) {
            this.animSprite.startAnim(AnimData.animSets[this.animSet][idx], idx, loop, pingPong, 65536);
        }
    }

    public boolean checkAnimFinished() {
        return (this.animSprite.playFlags & 16) != 0;
    }

    public boolean checkAnimLooped() {
        return (this.animSprite.playFlags & 8) != 0;
    }

    public void nextAnimState(int newState) {
        if (newState != this.animState) {
            this.animState = newState;
            this.fpAnimStateTime = 0;
            switch (newState) {
                case 1:
                    playAnim(1, true, true);
                    return;
                case 2:
                    if (this.animSet == 6) {
                        this.fpAnimScaleRate = GameLogic.randRange(16384, 21845);
                    }
                    if (this.animSet == 14) {
                        this.loopCounter = 2;
                        this.loopCounterType = 0;
                    }
                    int typeFlags = typeData[this.animSet][9];
                    boolean pingPong = (typeFlags & 16) == 0;
                    int animID = this.specialSwimAnim == -1 ? 2 : this.specialSwimAnim;
                    if (this.fpPuffTimer > 0) {
                        animID = 18;
                    }
                    playAnim(animID, true, pingPong);
                    return;
                case 3:
                    switch (this.animSet) {
                        case 2:
                        case 3:
                        case 5:
                            this.fpAnimScaleRate = 131072;
                            break;
                    }
                    int animID2 = 3;
                    if (this.fpPuffTimer > 0) {
                        animID2 = 19;
                        this.fpAnimScaleRate = 131072;
                    }
                    playAnim(animID2, false, false);
                    return;
                case 4:
                    if (this.objType == 1) {
                        this.fpAnimScaleRate = 131072;
                    }
                    playAnim(4, false, false);
                    return;
                case 5:
                    playAnim(5, true, true);
                    return;
                case 6:
                    playAnim(6, false, false);
                    return;
                case 7:
                    boolean loop = this.objType == 3;
                    playAnim(7, loop, false);
                    if (this.objType == 1) {
                        fpPlayerDeathFallSpeed = cfpSharkDrownSpeed;
                        FrontEnd.vibrate(PduPart.P_CONTENT_TRANSFER_ENCODING);
                        SoundBank.sfxPlay(42, false, 100, 0);
                        return;
                    }
                    return;
                case 8:
                    playAnim(10, false, false);
                    return;
                case 9:
                    playerShakeCount = 0;
                    playAnim(11, true, true);
                    this.fpAnimScaleRate = FixedPoint.linearInterpolate(fpSharkLevelFrac, 65536, 131072);
                    return;
                case 10:
                    this.fpAnimScaleRate = 65536;
                    playAnim(9, false, false);
                    return;
                case 11:
                    this.fpAnimScaleRate = GameLogic.randRange(131072, 196608);
                    playAnim(8, true, false);
                    return;
                case 12:
                    playAnim(12, true, false);
                    return;
                case 13:
                    this.fpAnimScaleRate = 98304;
                    playAnim(9, false, false);
                    return;
                case 14:
                case 15:
                    this.fpAnimScaleRate = 65536;
                    playAnim(9, false, false);
                    return;
                case 16:
                    this.fpAnimScaleRate = 65536;
                    playAnim(9, false, false);
                    this.aiMiscData = 1;
                    return;
                case 17:
                    int anim = 14;
                    if (this.objType == 5 && this.spawner == -1) {
                        anim = 15;
                    }
                    playAnim(anim, true, false);
                    return;
                default:
                    return;
            }
        }
    }

    /* JADX WARN: Can't fix incorrect switch cases order, some code will duplicate */
    public void updateAnimState() {
        this.fpAnimStateTime += GameApp.fp_deltatime;
        switch (this.animState) {
            case 2:
                if (this.animSet == 14 && checkAnimLooped()) {
                    this.loopCounter--;
                    if (this.loopCounter <= 0) {
                        if (this.loopCounterType == 0) {
                            playAnim(13, true, false);
                            this.loopCounterType = 1;
                            this.loopCounter = 5;
                        } else {
                            playAnim(2, true, false);
                            this.loopCounterType = 0;
                            this.loopCounter = 2;
                        }
                    }
                }
                if (this.objType == 3) {
                    if ((this.fpPos[1] - cfpWaterHeight < 0 ? -(this.fpPos[1] - cfpWaterHeight) : this.fpPos[1] - cfpWaterHeight) < 131072 && GameLogic.randRange(0, 100) < 25) {
                        int offset = GameLogic.randBoolean() ? 131072 : -131072;
                        doSplashFX(5, this.fpPos[0] + offset);
                        return;
                    }
                    return;
                }
                return;
            case 3:
                if (checkAnimFinished()) {
                    this.facingLeft = !this.facingLeft;
                    this.fpAnimScaleRate = 65536;
                    if (this.objType == 3 && this.aiState == 4) {
                        nextAnimState(12);
                        return;
                    } else {
                        nextAnimState(2);
                        return;
                    }
                }
                return;
            case 4:
                if (checkAnimFinished()) {
                    if (playerNumShakesRequired > 0) {
                        this.fpAnimScaleRate = 65536;
                        int temp = playerShakeCount;
                        biteKill();
                        nextAnimState(9);
                        playerShakeCount = temp;
                        return;
                    }
                    biteKill();
                    return;
                }
                return;
            case 5:
            case 11:
            default:
                return;
            case 6:
                if (checkAnimFinished()) {
                    nextAnimState(2);
                    return;
                }
                return;
            case 7:
                if (this.objType == 1) {
                    if (game.gameState == 2 && checkAnimFinished()) {
                        game.nextGameState(3);
                        return;
                    }
                    return;
                }
                int dieType = typeData[this.animSet][7];
                if (dieType == 3) {
                    int relX = this.fpAIHomePos[0];
                    int relY = this.fpAIHomePos[1];
                    int fpSuckRate = ((cfpMouthDeathSuckInRate ^ GameApp.fp_deltatime) & 134217728) != 0 ? -((int) (((-cfpMouthDeathSuckInRate) * GameApp.fp_deltatime) >> 16)) : (int) ((cfpMouthDeathSuckInRate * GameApp.fp_deltatime) >> 16);
                    GameLogic gameLogic = game;
                    int fpSharkScale = GameLogic.player.fpScale;
                    int limitX = ((cfpMouthDeathLimitX ^ fpSharkScale) & 134217728) != 0 ? -((int) (((-cfpMouthDeathLimitX) * fpSharkScale) >> 16)) : (int) ((cfpMouthDeathLimitX * fpSharkScale) >> 16);
                    int limitY = ((cfpMouthDeathLimitY ^ fpSharkScale) & 134217728) != 0 ? -((int) (((-cfpMouthDeathLimitY) * fpSharkScale) >> 16)) : (int) ((cfpMouthDeathLimitY * fpSharkScale) >> 16);
                    if (relX < (-limitX)) {
                        this.fpAIHomePos[0] = GameLogic.moveValue(relX, -limitX, fpSuckRate);
                    } else if (relX > limitX) {
                        this.fpAIHomePos[0] = GameLogic.moveValue(relX, limitX, fpSuckRate);
                    }
                    if (relY < (-limitY)) {
                        this.fpAIHomePos[1] = GameLogic.moveValue(relY, -limitY, fpSuckRate);
                    } else if (relY > limitY) {
                        this.fpAIHomePos[1] = GameLogic.moveValue(relY, limitY, fpSuckRate);
                    }
                    if (this.fpAnimStateTime > cfpSwallowStartTime) {
                        int fpSwallowRate = ((cfpSwallowRate ^ fpSharkScale) & 134217728) != 0 ? -((int) (((-cfpSwallowRate) * fpSharkScale) >> 16)) : (int) ((cfpSwallowRate * fpSharkScale) >> 16);
                        if (((cfpSwallowMaxRange ^ fpSharkScale) & 134217728) != 0) {
                            int i = -((int) (((-cfpSwallowMaxRange) * fpSharkScale) >> 16));
                        } else {
                            int i2 = (int) ((cfpSwallowMaxRange * fpSharkScale) >> 16);
                        }
                        GameLogic gameLogic2 = game;
                        int fpDownThroatRate = GameLogic.player.fpVel[0] < 0 ? fpSwallowRate : -fpSwallowRate;
                        int[] iArr = this.fpAIHomePos;
                        iArr[0] = iArr[0] + (((GameApp.fp_deltatime ^ fpDownThroatRate) & 134217728) != 0 ? -((int) (((-fpDownThroatRate) * GameApp.fp_deltatime) >> 16)) : (int) ((fpDownThroatRate * GameApp.fp_deltatime) >> 16));
                    }
                    this.fpPos[0] = fpPlayerMouthPos[0] + this.fpAIHomePos[0];
                    this.fpPos[1] = fpPlayerMouthPos[1] + this.fpAIHomePos[1];
                    GameLogic gameLogic3 = game;
                    if (GameLogic.player.animState == 3) {
                        this.hidden = true;
                    }
                }
                if (dieType == 4) {
                    if (checkAnimFinished()) {
                        nextAnimState(17);
                        this.fpVel[0] = this.facingLeft ? 65536 : cfpSharkWakePosYMin;
                        this.fpVel[1] = 131072;
                        int offsetX = this.facingLeft ? 458752 : -458752;
                        int[] iArr2 = this.fpPos;
                        iArr2[0] = iArr2[0] + offsetX;
                        GameObj obj = game.allocateGameObj();
                        obj.initNewObj(18, this.fpPos[0] - offsetX, this.fpPos[1], -1, -1);
                        obj.aiGotoStateDie();
                        obj.nextAnimState(17);
                        obj.fpVel[0] = -this.fpVel[0];
                        obj.fpVel[1] = 196608;
                        obj.facingLeft = this.facingLeft;
                        return;
                    }
                    return;
                }
                spawnRandomBlood();
                GameLogic gameLogic4 = game;
                int playerState = GameLogic.player.animState;
                boolean abort = (playerState == 4 || playerState == 9) ? false : true;
                if (playerNumShakesRequired <= playerShakeCount || abort) {
                    if (this.animSet == 13) {
                        nextAnimState(17);
                        this.fpVel[0] = 0;
                        this.fpVel[1] = -262144;
                        GameScreen.effects.create(13, 1, this.fpPos[0], this.fpPos[1]);
                        GameScreen.effects.create(14, 2, this.fpPos[0], this.fpPos[1]);
                        return;
                    }
                    requestDelete();
                    return;
                } else if (playerNumShakesRequired - playerShakeCount == 1) {
                    GameLogic gameLogic5 = game;
                    if (GameLogic.player.animState == 9 && dieType == 3 && this.animSet != 13) {
                        this.fpFadeAlpha -= ((cfpDeathFadeRate ^ GameApp.fp_deltatime) & 134217728) != 0 ? -((int) (((-cfpDeathFadeRate) * GameApp.fp_deltatime) >> 16)) : (int) ((cfpDeathFadeRate * GameApp.fp_deltatime) >> 16);
                        this.fpFadeAlpha = this.fpFadeAlpha > 0 ? this.fpFadeAlpha : 0;
                        return;
                    }
                    return;
                } else {
                    return;
                }
            case 8:
                break;
            case 9:
                if (checkAnimLooped()) {
                    playerShakeCount++;
                    if (playerShakeCount % 3 == 2 && playerNumShakesRequired > playerShakeCount + 1) {
                        playerNumShakesRequired--;
                        nextAnimState(4);
                    }
                    if (playerShakeCount >= playerNumShakesRequired) {
                        playerNumShakesRequired = 0;
                        this.fpAnimScaleRate = 65536;
                        nextAnimState(2);
                        return;
                    }
                    return;
                }
                return;
            case 10:
                if (checkAnimFinished()) {
                    this.fpPuffTimer = 196608;
                    nextAnimState(2);
                    return;
                }
                return;
            case 12:
                if (this.objType == 3) {
                    if ((this.fpPos[1] - cfpWaterHeight < 0 ? -(this.fpPos[1] - cfpWaterHeight) : this.fpPos[1] - cfpWaterHeight) < 131072 && GameLogic.randRange(0, 100) < 25) {
                        int offset2 = GameLogic.randBoolean() ? 131072 : -131072;
                        doSplashFX(5, this.fpPos[0] + offset2);
                        return;
                    }
                    return;
                }
                return;
            case 13:
                if (checkAnimFinished()) {
                    checkAttackCollisionVsShark();
                    VecMath.norm2d(this.fpVel, this.fpVel);
                    this.fpVel[0] = ((this.fpVel[0] ^ 262144) & 134217728) != 0 ? -((int) (((-this.fpVel[0]) * 262144) >> 16)) : (int) ((this.fpVel[0] * 262144) >> 16);
                    this.fpVel[1] = ((this.fpVel[1] ^ 262144) & 134217728) != 0 ? -((int) (((-this.fpVel[1]) * 262144) >> 16)) : (int) ((this.fpVel[1] * 262144) >> 16);
                    nextAnimState(2);
                    return;
                }
                return;
            case 14:
                if (checkAnimFinished()) {
                    checkAttackCollisionVsShark();
                    nextAnimState(2);
                    return;
                }
                return;
            case 15:
                if (checkAnimFinished()) {
                    nextAnimState(2);
                    return;
                }
                return;
            case 16:
                if (this.aiMiscData == 1 && this.fpAnimStateTime > 49152) {
                    this.aiMiscData = 0;
                    GameLogic gameLogic6 = game;
                    GameLogic.spawner.spawnProjectile(this);
                }
                if (checkAnimFinished()) {
                    nextAnimState(1);
                    return;
                }
                return;
            case 17:
                if (this.objType == 5) {
                    if (GameLogic.randBoolean()) {
                        GameScreen.effects.create(2, 1, this.fpPos[0], this.fpPos[1]);
                    }
                    if (this.fpAnimStateTime > cfpSubPostDeathTime) {
                        requestDelete();
                        break;
                    } else {
                        int fpTimeLeft = cfpSubPostDeathTime - this.fpAnimStateTime;
                        if (fpTimeLeft < cfpPostDeathFadeTime) {
                            this.fpFadeAlpha = (int) ((fpTimeLeft << 16) / cfpPostDeathFadeTime);
                            break;
                        }
                    }
                } else {
                    if (GameLogic.randBoolean()) {
                        GameScreen.effects.create(1, 1, this.fpPos[0], this.fpPos[1]);
                    }
                    if (this.fpAnimStateTime > cfpDefaultPostDeathTime) {
                        requestDelete();
                        break;
                    } else {
                        int fpTimeLeft2 = cfpDefaultPostDeathTime - this.fpAnimStateTime;
                        if (fpTimeLeft2 < cfpPostDeathFadeTime) {
                            this.fpFadeAlpha = (int) ((fpTimeLeft2 << 16) / cfpPostDeathFadeTime);
                            break;
                        }
                    }
                }
                break;
        }
        if (checkAnimFinished()) {
            this.fpPos[1] = cfpWaterHeight + cfpFishermanTreadWaterOffsetY;
            this.fpVel[0] = 0;
            this.fpVel[1] = 0;
            nextAnimState(2);
            doSplashFX(2, this.fpPos[0]);
        }
    }

    public void spawnRandomBlood() {
        int bloodType = typeData[this.animSet][8];
        if (bloodType != 0) {
            int[] table = bloodTable[bloodType];
            GameLogic gameLogic = game;
            if (GameLogic.randRange(0, 100) < table[2]) {
                GameScreen.effects.create(GameLogic.randBoolean() ? table[0] : table[1], 1, this.fpPos[0], this.fpPos[1]);
                if (this.objType == 3 && this.numGibsSpawned < 2) {
                    GameLogic gameLogic2 = game;
                    if (GameLogic.randRange(0, 100) >= 90) {
                        this.numGibsSpawned++;
                        GameScreen.effects.create(15, 1, this.fpPos[0], this.fpPos[1]);
                    }
                }
                GameLogic gameLogic3 = game;
                if (GameLogic.randBoolean()) {
                    GameScreen.effects.create(1, 1, this.fpPos[0], this.fpPos[1]);
                }
                if (this.animSet == 13 && this.animState == 7 && this.fpAnimStateTime < 65536) {
                    GameScreen.effects.create(1, 4, this.fpPos[0], this.fpPos[1]);
                }
            }
        }
    }

    public void aiGotoStateNone() {
        this.aiState = 0;
    }

    public void aiGotoStateIdle() {
        this.aiState = 1;
        switch (this.animSet) {
            case 10:
            case 11:
            case 15:
            case 22:
            case 24:
                this.fpAIHomePos[0] = this.fpPos[0];
                this.fpAIHomePos[1] = this.fpPos[1];
                this.fpAIWanderPhaseY = GameLogic.randAngle();
                if (this.animSet == 10) {
                    this.facingLeft = GameLogic.randBoolean();
                }
                if (this.animSet == 22) {
                    this.fpAIHomePos[1] = cfpWaterHeight - 163840;
                    return;
                } else if (this.animSet == 15) {
                    this.fpAIHomePos[1] = cfpWaterHeight - 131072;
                    return;
                } else {
                    return;
                }
            default:
                return;
        }
    }

    public void aiInitStateWander(int fpHomeX, int fpHomeY, int fpRangeX, int fpRangeY) {
        this.aiState = 2;
        this.fpAIHomePos[0] = fpHomeX;
        this.fpAIHomePos[1] = fpHomeY;
        this.fpAIWanderRangeX = fpRangeX;
        this.fpAIWanderRangeY = fpRangeY;
        this.fpMoveSpeed = this.fpInitSpeed;
        this.fpAnimScaleRate = 65536;
    }

    public void aiGotoStateWander() {
        this.aiState = 2;
        this.fpMoveSpeed = this.fpInitSpeed;
        this.fpAnimScaleRate = 65536;
    }

    public void aiGotoStateChase(GameObj target) {
        this.aiState = 3;
        this.aiTargetObj = target;
        if (this.objType == 5) {
            this.fpAIMiscTimer = 196608;
            this.aiMiscData = 0;
        }
    }

    public void aiGotoStateEvade(GameObj target, int fpRange) {
        int nextAnim;
        this.aiState = 4;
        this.aiTargetObj = target;
        this.fpAIMaxChaseRange = fpRange;
        this.fpMoveSpeed = this.fpEvadeSpeed;
        if (this.objType == 3) {
            this.fpAnimScaleRate = 65536;
            nextAnim = 12;
        } else {
            this.fpAnimScaleRate = 131072;
            nextAnim = 2;
        }
        this.fpEvadeTimer = 65536;
        if (this.animState != nextAnim) {
            nextAnimState(nextAnim);
        }
    }

    public void aiGotoStateDie() {
        if (this.aiState != 5) {
            playerTotalEaten++;
            int[] table = typeData[this.animSet];
            int points = getPointsForKill();
            if (points > 0) {
                GameLogic gameLogic = game;
                GameLogic.player.awardPointsAndHealth(points, table[16]);
                game.updateKillChain();
            }
            if (this.objType == 3) {
                if ((this.fpPos[1] - cfpWaterHeight < 0 ? -(this.fpPos[1] - cfpWaterHeight) : this.fpPos[1] - cfpWaterHeight) < 131072) {
                    doSplashFX(4, this.fpPos[0]);
                }
            }
            if (this.detachedParent != null) {
                this.detachedParent.detachedChild = null;
                this.detachedParent = null;
            }
            int dieType = table[7];
            if (dieType == 0) {
                if (table[8] != 0) {
                    GameScreen.effects.create(6, 1, this.fpPos[0], this.fpPos[1]);
                }
                if (this.objType == 9) {
                    collectBonus();
                }
                requestDelete();
                return;
            }
            this.fpAnimScaleRate = 65536;
            this.aiState = 5;
            nextAnimState(7);
            if (dieType == 2) {
                this.fpVel[0] = 0;
                this.fpVel[1] = 131072;
            } else if (dieType == 3) {
                this.fpAIHomePos[0] = this.fpPos[0] - fpPlayerMouthPos[0];
                this.fpAIHomePos[1] = this.fpPos[1] - fpPlayerMouthPos[1];
                this.fpVel[0] = 0;
                this.fpVel[1] = 0;
            } else if (dieType == 4) {
                this.fpVel[0] = 0;
                this.fpVel[1] = 131072;
                GameScreen.effects.create(5, 1, this.fpPos[0], this.fpPos[1]);
            }
        }
    }

    public void aiGotoStateFallOutOfBoat() {
        this.aiState = 6;
        nextAnimState(8);
        this.fpVel[0] = -cfpFishermanFallSpeedX;
    }

    public void aiGotoStatePuff() {
        this.aiState = 7;
        nextAnimState(10);
        this.fpMoveSpeed = this.fpInitSpeed >> 1;
    }

    public void aiGotoStateLunge() {
        this.aiState = 9;
        nextAnimState(13);
        this.fpMoveSpeed = cfpLungeSpeed;
        VecMath.norm2d(this.fpVel, this.fpVel);
        this.fpVel[0] = ((this.fpVel[0] ^ (this.fpMoveSpeed >> 1)) & 134217728) != 0 ? -((int) (((-this.fpVel[0]) * (this.fpMoveSpeed >> 1)) >> 16)) : (int) ((this.fpVel[0] * (this.fpMoveSpeed >> 1)) >> 16);
        this.fpVel[1] = ((this.fpVel[1] ^ (this.fpMoveSpeed >> 1)) & 134217728) != 0 ? -((int) (((-this.fpVel[1]) * (this.fpMoveSpeed >> 1)) >> 16)) : (int) ((this.fpVel[1] * (this.fpMoveSpeed >> 1)) >> 16);
    }

    public void aiGotoStateSimpleAttack() {
        this.aiState = 10;
        nextAnimState(14);
    }

    public void aiGotoStateFlyAway() {
        this.aiState = 8;
        nextAnimState(11);
        int speedX = GameLogic.randRange(cfpPelicanFlySpeedXMin, cfpPelicanFlySpeedXMax);
        int speedY = GameLogic.randRange(cfpPelicanFlySpeedYMin, cfpPelicanFlySpeedYMax);
        this.fpVel[0] = this.facingLeft ? speedX : -speedX;
        this.fpVel[1] = -speedY;
    }

    public void aiGotoStateProjectileFly() {
        this.aiState = 11;
    }

    private void updateAIState() {
        int i;
        if (this.objType == 1) {
            updatePlayer();
            return;
        }
        if (this.fpFireDelay > 0) {
            this.fpFireDelay = this.fpFireDelay - GameApp.fp_deltatime > 0 ? this.fpFireDelay - GameApp.fp_deltatime : 0;
        }
        switch (this.aiState) {
            case 0:
            case 5:
            case 8:
            default:
                return;
            case 1:
                switch (this.animSet) {
                    case 10:
                        int fpSin = FixedPoint.sinLut(this.fpAIWanderPhaseY);
                        int offsetY = ((cfpPelicanBobbingRangeY ^ fpSin) & 134217728) != 0 ? -((int) (((-fpSin) * cfpPelicanBobbingRangeY) >> 16)) : (int) ((fpSin * cfpPelicanBobbingRangeY) >> 16);
                        this.fpPos[1] = this.fpAIHomePos[1] + offsetY;
                        this.fpAIWanderPhaseY += ((cfpPelicanBobbingRate ^ GameApp.fp_deltatime) & 134217728) != 0 ? -((int) (((-cfpPelicanBobbingRate) * GameApp.fp_deltatime) >> 16)) : (int) ((cfpPelicanBobbingRate * GameApp.fp_deltatime) >> 16);
                        this.fpAIWanderPhaseY &= 16777215;
                        int fpSeeSharkRangeX = cfpBirdSeeSharkRangeX;
                        int fpSeeSharkRangeY = cfpBirdSeeSharkRangeY;
                        int i2 = this.fpPos[0];
                        GameLogic gameLogic = game;
                        int dx = i2 - GameLogic.player.fpPos[0];
                        int i3 = this.fpPos[1];
                        GameLogic gameLogic2 = game;
                        int dy = i3 - GameLogic.player.fpPos[1];
                        if ((dx < 0 ? -dx : dx) < fpSeeSharkRangeX) {
                            if ((dy < 0 ? -dy : dy) < fpSeeSharkRangeY) {
                                aiGotoStateFlyAway();
                                return;
                            }
                            return;
                        }
                        return;
                    case 11:
                        int fpSin2 = FixedPoint.sinLut(this.fpAIWanderPhaseY);
                        int offsetY2 = ((cfpMineBobbingRangeY ^ fpSin2) & 134217728) != 0 ? -((int) (((-fpSin2) * cfpMineBobbingRangeY) >> 16)) : (int) ((fpSin2 * cfpMineBobbingRangeY) >> 16);
                        this.fpPos[1] = this.fpAIHomePos[1] + offsetY2;
                        this.fpAIWanderPhaseY += ((cfpMineBobbingRate ^ GameApp.fp_deltatime) & 134217728) != 0 ? -((int) (((-cfpMineBobbingRate) * GameApp.fp_deltatime) >> 16)) : (int) ((cfpMineBobbingRate * GameApp.fp_deltatime) >> 16);
                        this.fpAIWanderPhaseY &= 16777215;
                        return;
                    case 15:
                    case 22:
                        int fpSin3 = FixedPoint.sinLut(this.fpAIWanderPhaseY);
                        int offsetY3 = ((cfpBoatBobbingRangeY ^ fpSin3) & 134217728) != 0 ? -((int) (((-fpSin3) * cfpBoatBobbingRangeY) >> 16)) : (int) ((fpSin3 * cfpBoatBobbingRangeY) >> 16);
                        this.fpPos[1] = this.fpAIHomePos[1] + offsetY3;
                        int fpSin4 = FixedPoint.sinLut((this.fpAIWanderPhaseY + 4194304) & 16777215);
                        this.fpRot = -(((cfpBoatBobbingRangeRot ^ fpSin4) & 134217728) != 0 ? -((int) (((-fpSin4) * cfpBoatBobbingRangeRot) >> 16)) : (int) ((fpSin4 * cfpBoatBobbingRangeRot) >> 16));
                        this.fpRot &= 16777215;
                        this.fpAIWanderPhaseY += ((cfpBoatBobbingRate ^ GameApp.fp_deltatime) & 134217728) != 0 ? -((int) (((-cfpBoatBobbingRate) * GameApp.fp_deltatime) >> 16)) : (int) ((cfpBoatBobbingRate * GameApp.fp_deltatime) >> 16);
                        this.fpAIWanderPhaseY &= 16777215;
                        if (this.fpJoltPhase > 0) {
                            int jolt = FixedPoint.sinLut((65536 - this.fpJoltPhase) << 7);
                            int[] iArr = this.fpPos;
                            int i4 = iArr[1];
                            if ((((((cfpBoatMaxJoltRange ^ this.fpJoltScale) & 134217728) != 0 ? -((int) (((-cfpBoatMaxJoltRange) * this.fpJoltScale) >> 16)) : (int) ((cfpBoatMaxJoltRange * this.fpJoltScale) >> 16)) ^ jolt) & 134217728) != 0) {
                                i = -((int) (((-jolt) * (((cfpBoatMaxJoltRange ^ this.fpJoltScale) & 134217728) != 0 ? -((int) (((-cfpBoatMaxJoltRange) * this.fpJoltScale) >> 16)) : (int) ((cfpBoatMaxJoltRange * this.fpJoltScale) >> 16))) >> 16));
                            } else {
                                i = (int) ((jolt * (((cfpBoatMaxJoltRange ^ this.fpJoltScale) & 134217728) != 0 ? -((int) (((-cfpBoatMaxJoltRange) * this.fpJoltScale) >> 16)) : (int) ((cfpBoatMaxJoltRange * this.fpJoltScale) >> 16))) >> 16);
                            }
                            iArr[1] = i4 - i;
                            this.fpJoltPhase -= ((cfpBoatJoltTime ^ GameApp.fp_deltatime) & 134217728) != 0 ? -((int) (((-cfpBoatJoltTime) * GameApp.fp_deltatime) >> 16)) : (int) ((cfpBoatJoltTime * GameApp.fp_deltatime) >> 16);
                            this.fpJoltPhase = this.fpJoltPhase > 0 ? this.fpJoltPhase : 0;
                            return;
                        }
                        return;
                    case 21:
                        if (this.compoundObjType == 2) {
                            if (this.fpFireDelay == 0) {
                                this.fpFireDelay = 131072;
                                nextAnimState(16);
                                return;
                            } else if (this.animState == 1) {
                                GameLogic gameLogic3 = game;
                                this.facingLeft = GameLogic.player.fpPos[0] < this.fpPos[0];
                                return;
                            } else {
                                return;
                            }
                        }
                        return;
                    case 24:
                        int fpSin5 = FixedPoint.sinLut(this.fpAIWanderPhaseY);
                        int offsetY4 = ((cfpBuoyBobbingRangeY ^ fpSin5) & 134217728) != 0 ? -((int) (((-fpSin5) * cfpBuoyBobbingRangeY) >> 16)) : (int) ((fpSin5 * cfpBuoyBobbingRangeY) >> 16);
                        this.fpPos[1] = this.fpAIHomePos[1] + offsetY4;
                        int fpSin6 = FixedPoint.sinLut((this.fpAIWanderPhaseY + 4194304) & 16777215);
                        this.fpRot = -(((cfpBuoyBobbingRangeRot ^ fpSin6) & 134217728) != 0 ? -((int) (((-fpSin6) * cfpBuoyBobbingRangeRot) >> 16)) : (int) ((fpSin6 * cfpBuoyBobbingRangeRot) >> 16));
                        this.fpRot &= 16777215;
                        this.fpAIWanderPhaseY += ((cfpBuoyBobbingRate ^ GameApp.fp_deltatime) & 134217728) != 0 ? -((int) (((-cfpBuoyBobbingRate) * GameApp.fp_deltatime) >> 16)) : (int) ((cfpBuoyBobbingRate * GameApp.fp_deltatime) >> 16);
                        this.fpAIWanderPhaseY &= 16777215;
                        return;
                    default:
                        return;
                }
            case 2:
                if (this.shoal != -1) {
                    updateShoalMovement();
                } else {
                    updateSimpleMovement();
                }
                checkEvade();
                return;
            case 3:
                if (this.objType == 5) {
                    this.fpAIMiscTimer -= GameApp.fp_deltatime;
                    if (this.fpAIMiscTimer <= 0) {
                        this.fpAIMiscTimer = 196608;
                        this.aiMiscData = 1 - this.aiMiscData;
                    }
                    int fpDistToTarget2 = ((int) (((this.fpPos[0] - this.aiTargetObj.fpPos[0]) * (this.fpPos[0] - this.aiTargetObj.fpPos[0])) >> 16)) + ((int) (((this.fpPos[1] - this.aiTargetObj.fpPos[1]) * (this.fpPos[1] - this.aiTargetObj.fpPos[1])) >> 16));
                    if (fpDistToTarget2 > cfpDefaultMinChaseDist2 && this.aiMiscData == 0) {
                        goTowardsPoint(this.aiTargetObj.fpPos[0], this.aiTargetObj.fpPos[1]);
                    }
                    if (this.fpFireDelay == 0) {
                        GameLogic gameLogic4 = game;
                        GameLogic.spawner.spawnProjectile(this);
                        SoundBank.sfxPlay(36, false, 100, 0);
                        this.fpFireDelay = 131072;
                        nextAnimState(15);
                    }
                    if (this.animState == 3) {
                        this.fpFireDelay = 131072;
                        return;
                    }
                    return;
                }
                return;
            case 4:
                int dx2 = this.fpPos[0] - this.aiTargetObj.fpPos[0];
                int dy2 = this.fpPos[1] - this.aiTargetObj.fpPos[1];
                int fpDesiredX = this.fpPos[0] + dx2;
                int fpDesiredY = this.fpPos[1] + dy2;
                if (fpDesiredY < cfpSafeWaterHeight) {
                    int typeFlags = typeData[this.animSet][9];
                    if ((typeFlags & 9) == 0) {
                        fpDesiredY = cfpSafeWaterHeight;
                    }
                }
                goTowardsPoint(fpDesiredX, fpDesiredY);
                if ((dx2 < 0 ? -dx2 : dx2) <= this.fpAIMaxChaseRange) {
                    if ((dy2 < 0 ? -dy2 : dy2) <= this.fpAIMaxChaseRange) {
                        this.fpEvadeTimer -= GameApp.fp_deltatime;
                        if (this.fpEvadeTimer <= 0) {
                            this.fpEvadeTimer = 0;
                            this.fpEvadeDisableTimer = 131072;
                            aiGotoStateWander();
                            return;
                        }
                        return;
                    }
                }
                aiGotoStateWander();
                return;
            case 6:
                if (this.animState != 8) {
                    this.fpVel[0] = 0;
                    return;
                }
                return;
            case 7:
                updateSimpleMovement();
                if (this.fpPuffTimer > 0) {
                    this.fpPuffTimer -= GameApp.fp_deltatime;
                    if (this.fpPuffTimer <= 0) {
                        this.fpPuffTimer = 0;
                        this.fpAnimScaleRate = 65536;
                        GameLogic gameLogic5 = game;
                        aiGotoStateEvade(GameLogic.player, cfpDefaultEvadeSharkRange);
                        return;
                    }
                    return;
                }
                return;
            case 9:
                if (this.animState != 13) {
                    this.fpEvadeDisableTimer = 65536;
                    this.fpEvadeTimer = 0;
                    aiGotoStateWander();
                    return;
                }
                GameLogic gameLogic6 = game;
                int[] ppos = GameLogic.player.fpPos;
                goTowardsPoint(ppos[0], ppos[1]);
                return;
            case 10:
                if (this.animState != 14) {
                    this.fpEvadeDisableTimer = 65536;
                    this.fpEvadeTimer = 0;
                    aiGotoStateWander();
                    return;
                }
                return;
            case 11:
                switch (this.animSet) {
                    case 19:
                        int dt = GameApp.fp_deltatime;
                        if (this.fpPos[1] <= cfpWaterHeight) {
                            int[] iArr2 = this.fpVel;
                            iArr2[1] = iArr2[1] + (((1310720 ^ dt) & 134217728) != 0 ? -((int) (((-1310720) * dt) >> 16)) : (int) ((1310720 * dt) >> 16));
                            this.fpRot -= ((33554432 ^ dt) & 134217728) != 0 ? -((int) (((-33554432) * dt) >> 16)) : (int) ((33554432 * dt) >> 16);
                            this.fpRot &= 16777215;
                            return;
                        }
                        int fpStep = ((1048576 ^ dt) & 134217728) != 0 ? -((int) (((-1048576) * dt) >> 16)) : (int) ((1048576 * dt) >> 16);
                        this.fpVel[0] = GameLogic.moveValue(this.fpVel[0], 0, fpStep);
                        this.fpVel[1] = GameLogic.moveValue(this.fpVel[1], 262144, fpStep);
                        this.fpRot -= ((8388608 ^ dt) & 134217728) != 0 ? -((int) (((-8388608) * dt) >> 16)) : (int) ((8388608 * dt) >> 16);
                        this.fpRot &= 16777215;
                        if (GameLogic.randBoolean()) {
                            GameScreen.effects.create(1, 1, this.fpPos[0], this.fpPos[1]);
                            return;
                        }
                        return;
                    case 20:
                        if (GameLogic.randBoolean()) {
                            GameScreen.effects.create(1, 1, this.fpPos[0], this.fpPos[1]);
                            return;
                        }
                        return;
                    default:
                        return;
                }
        }
    }

    private void updatePlayer() {
        int dt = GameApp.fp_deltatime;
        if (game.gameState != 2) {
            GameApp.gameScreen.setHealthBarPerc((this.fpHealth >> 1) < 0 ? -((-(this.fpHealth >> 1)) >> 16) : (this.fpHealth >> 1) >> 16);
            return;
        }
        if (this.fpPos[1] >= cfpWaterHeight) {
            if (playerBeached) {
                playerBeached = false;
                this.fpPos[0] = fpPlayerLastGoodPos[0];
                this.fpPos[1] = fpPlayerLastGoodPos[1];
            } else {
                fpPlayerLastGoodPos[0] = this.fpPos[0];
                fpPlayerLastGoodPos[1] = this.fpPos[1];
            }
        }
        checkPlayerBite();
        int fpWaterDiff = cfpWaterHeight - this.fpPos[1];
        if (fpWaterDiff < 32768 && fpWaterDiff > -65536) {
            int fpSpeedX = this.fpVel[0] < 0 ? -this.fpVel[0] : this.fpVel[0];
            if (fpSpeedX > 655360) {
                doSplashFX(6, this.fpPos[0]);
            }
        }
        boolean chargePress = false;
        if (BaseScreen.keysDown(2048)) {
            if (!playerChargeLock) {
                if (fpPlayerChargeTime == 0) {
                    startCharge();
                }
                fpPlayerChargeTime = AnimSprite.cfpDefaultFrameDuration;
                chargePress = true;
            }
        } else {
            playerChargeLock = false;
        }
        if (fpPlayerChargeTime > 0) {
            if (GameLogic.randBoolean()) {
                GameScreen.effects.create(1, 1, this.fpPos[0], this.fpPos[1]);
            }
            fpPlayerChargeFactor = fpPlayerChargeLevel;
            fpPlayerChargeFactor = FixedPoint.linearInterpolate(fpSharkLevelFrac, cfpSmallSharkChargeScale, 65536);
            fpPlayerChargeScale = fpPlayerChargeFactor > 49152 ? 65536 : fpPlayerChargeFactor + 16384;
            fpPlayerChargeLevel -= ((cfpChargeDrainRate ^ dt) & 134217728) != 0 ? -((int) (((-cfpChargeDrainRate) * dt) >> 16)) : (int) ((cfpChargeDrainRate * dt) >> 16);
            if (fpPlayerChargeLevel <= 0) {
                fpPlayerChargeLevel = 0;
                playerChargeLock = true;
                fpPlayerChargeTime = 0;
            }
            if (!chargePress) {
                fpPlayerChargeTime -= dt;
                if (fpPlayerChargeTime < 0) {
                    stopCharge();
                }
            }
        } else {
            fpPlayerChargeFactor = 0;
            fpPlayerChargeScale = 0;
            if (fpPlayerChargeLevel < 65536 && !playerChargeLock) {
                fpPlayerChargeLevel += ((cfpChargeRestoreRate ^ dt) & 134217728) != 0 ? -((int) (((-cfpChargeRestoreRate) * dt) >> 16)) : (int) ((cfpChargeRestoreRate * dt) >> 16);
                if (fpPlayerChargeLevel > 65536) {
                    fpPlayerChargeLevel = 65536;
                }
            }
        }
        int healthDrainRate = sharkTable[sharkLevel][6];
        if (fpPlayerPoisonTimeRemaining > 0) {
            healthDrainRate += cfpPlayerPoisonRate;
            fpPlayerPoisonTimeRemaining = fpPlayerPoisonTimeRemaining - dt < 0 ? 0 : fpPlayerPoisonTimeRemaining - dt;
        }
        int hp = ((healthDrainRate ^ dt) & 134217728) != 0 ? -((int) (((-healthDrainRate) * dt) >> 16)) : (int) ((healthDrainRate * dt) >> 16);
        this.fpHealth -= hp;
        if (this.fpHealth <= 0) {
            this.fpHealth = 0;
            if (this.animState != 7) {
                nextAnimState(7);
            }
        }
        GameApp.gameScreen.setHealthBarPerc((this.fpHealth >> 1) < 0 ? -((-(this.fpHealth >> 1)) >> 16) : (this.fpHealth >> 1) >> 16);
        if (fpPlayerPoisonTimeRemaining > 0) {
            int fpBlend = ((int) ((fpPlayerPoisonTimeRemaining << 16) / cfpPlayerPoisonTime)) << 2;
            this.tintColor = GfxUtils.lerpColour(FixedPoint.sinLut((fpBlend << 8) & 16777215) < 0 ? -FixedPoint.sinLut((fpBlend << 8) & 16777215) : FixedPoint.sinLut((fpBlend << 8) & 16777215), 16777215, 8454016);
        } else if (fpPlayerDamageTintTimeRemaining > 0) {
            this.tintColor = GfxUtils.lerpColour((int) ((fpPlayerDamageTintTimeRemaining << 16) / cfpPlayerDamageTintTime), 16777215, GameScreen.cColMultiplier);
            fpPlayerDamageTintTimeRemaining = fpPlayerDamageTintTimeRemaining - dt < 0 ? 0 : fpPlayerDamageTintTimeRemaining - dt;
        } else {
            this.tintColor = 16777215;
        }
        if (playerNumShakesRequired > 0 && this.animState != 4 && this.animState != 9) {
            playerNumShakesRequired = 0;
        }
        GameApp.gameScreen.setScoreText(game.playerScore);
        GameApp.gameScreen.setBoostBarPerc(fpPlayerChargeLevel * 100 < 0 ? -((-(fpPlayerChargeLevel * 100)) >> 16) : (fpPlayerChargeLevel * 100) >> 16);
        game.fpPlayerKillChainTimer -= dt;
        if (game.fpPlayerKillChainTimer <= 0) {
            game.resetKillChain();
        }
        fpBeachedTextLockTimer = fpBeachedTextLockTimer - dt < 0 ? 0 : fpBeachedTextLockTimer - dt;
        updatePlayerHeartbeatSound();
    }

    public void startCharge() {
        fpPlayerChargeTime = AnimSprite.cfpDefaultFrameDuration;
        fpPlayerChargeFactor = fpPlayerChargeLevel;
        SoundBank.sfxPlay(32, false, 100, 0);
        FrontEnd.vibrate(50);
    }

    public void stopCharge() {
        fpPlayerChargeTime = 0;
        fpPlayerChargeFactor = 0;
        playerChargeLock = true;
    }

    private void checkPlayerBite() {
        int fpBiteRange;
        if (this.animState == 2 || this.animState == 3) {
            if (this.fpScale == 65536) {
                fpBiteRange = cfpSharkBiteRange;
            } else {
                fpBiteRange = ((cfpSharkBiteRange ^ this.fpScale) & 134217728) != 0 ? -((int) (((-cfpSharkBiteRange) * this.fpScale) >> 16)) : (int) ((cfpSharkBiteRange * this.fpScale) >> 16);
            }
            tempRect[0] = (fpPlayerMouthPos[0] + (((cfpSharkBitePredictTime ^ this.fpVel[0]) & 134217728) != 0 ? -((int) (((-cfpSharkBitePredictTime) * this.fpVel[0]) >> 16)) : (int) ((cfpSharkBitePredictTime * this.fpVel[0]) >> 16))) - (fpBiteRange >> 1);
            tempRect[1] = (fpPlayerMouthPos[1] + (((cfpSharkBitePredictTime ^ this.fpVel[1]) & 134217728) != 0 ? -((int) (((-cfpSharkBitePredictTime) * this.fpVel[1]) >> 16)) : (int) ((cfpSharkBitePredictTime * this.fpVel[1]) >> 16))) - (fpBiteRange >> 1);
            tempRect[2] = fpBiteRange;
            tempRect[3] = fpBiteRange;
            boolean canBite = false;
            int i = 0;
            while (true) {
                if (i >= game.numGameObj) {
                    break;
                }
                GameObj obj = game.gameObjList[i];
                if (!obj.deleted && obj.canBeBitten()) {
                    tempRect2[0] = obj.fpExtents[0] + (((cfpSharkBitePredictTime ^ obj.fpVel[0]) & 134217728) != 0 ? -((int) (((-cfpSharkBitePredictTime) * obj.fpVel[0]) >> 16)) : (int) ((cfpSharkBitePredictTime * obj.fpVel[0]) >> 16));
                    tempRect2[1] = obj.fpExtents[1] + (((cfpSharkBitePredictTime ^ obj.fpVel[1]) & 134217728) != 0 ? -((int) (((-cfpSharkBitePredictTime) * obj.fpVel[1]) >> 16)) : (int) ((cfpSharkBitePredictTime * obj.fpVel[1]) >> 16));
                    tempRect2[2] = obj.fpExtents[2];
                    tempRect2[3] = obj.fpExtents[3];
                    if (collTestRectVsRect(tempRect, tempRect2)) {
                        canBite = true;
                        break;
                    }
                }
                i++;
            }
            if (canBite) {
                if (this.animState == 3) {
                    this.facingLeft = !this.facingLeft;
                    this.fpAnimScaleRate = 65536;
                }
                nextAnimState(4);
            }
        }
    }

    private void checkEvade() {
        int fpSeeSharkRangeX;
        int fpSeeSharkRangeY;
        int fpEvadeSharkRange;
        if (this.fpEvadeDisableTimer > 0) {
            this.fpEvadeDisableTimer = this.fpEvadeDisableTimer - GameApp.fp_deltatime < 0 ? 0 : this.fpEvadeDisableTimer - GameApp.fp_deltatime;
        } else if (this.animSet != 4 && this.animSet != 6) {
            switch (this.objType) {
                case 2:
                case 3:
                case 5:
                    switch (this.animSet) {
                        case 1:
                        case 2:
                        case 4:
                        case 12:
                            fpSeeSharkRangeX = cfpSwarmSeeSharkRangeX;
                            fpSeeSharkRangeY = cfpSwarmSeeSharkRangeY;
                            fpEvadeSharkRange = cfpSwarmEvadeSharkRange;
                            break;
                        case 3:
                        case 6:
                        case 8:
                        case 9:
                        case 10:
                        case 11:
                        case 14:
                        case 15:
                        case 16:
                        case 17:
                        default:
                            fpSeeSharkRangeX = cfpDefaultSeeSharkRangeX;
                            fpSeeSharkRangeY = cfpDefaultSeeSharkRangeY;
                            fpEvadeSharkRange = cfpDefaultEvadeSharkRange;
                            break;
                        case 5:
                            return;
                        case 7:
                            fpSeeSharkRangeX = cfpBlowfishSeeSharkRangeY;
                            fpSeeSharkRangeY = cfpBlowfishSeeSharkRangeY;
                            fpEvadeSharkRange = cfpDefaultEvadeSharkRange;
                            break;
                        case 13:
                            fpSeeSharkRangeX = cfpDiverSeeSharkRangeX;
                            fpSeeSharkRangeY = cfpDiverSeeSharkRangeY;
                            fpEvadeSharkRange = cfpDefaultEvadeSharkRange;
                            break;
                        case 18:
                            fpSeeSharkRangeX = 983040;
                            fpSeeSharkRangeY = 983040;
                            fpEvadeSharkRange = cfpDefaultEvadeSharkRange;
                            break;
                    }
                    int i = this.fpPos[0];
                    GameLogic gameLogic = game;
                    int dx = i - GameLogic.player.fpPos[0];
                    if ((dx < 0 ? -dx : dx) <= fpSeeSharkRangeX) {
                        int i2 = this.fpPos[1];
                        GameLogic gameLogic2 = game;
                        int dy = i2 - GameLogic.player.fpPos[1];
                        if ((dy < 0 ? -dy : dy) <= fpSeeSharkRangeY) {
                            if (this.animSet == 7) {
                                if ((dx > 0) == this.facingLeft) {
                                    aiGotoStatePuff();
                                    return;
                                }
                                return;
                            } else if (this.animSet == 9) {
                                GameLogic gameLogic3 = game;
                                if (dotFacingPoint(GameLogic.player.fpPos) > 49152) {
                                    aiGotoStateLunge();
                                    return;
                                }
                                return;
                            } else if (this.animSet == 13) {
                                GameLogic gameLogic4 = game;
                                if (dotFacingPoint(GameLogic.player.fpPos) > 49152) {
                                    aiGotoStateSimpleAttack();
                                    return;
                                }
                                return;
                            } else if (this.animSet == 18) {
                                if (this.aiState == 2) {
                                    GameLogic gameLogic5 = game;
                                    aiGotoStateChase(GameLogic.player);
                                    return;
                                }
                                return;
                            } else {
                                GameLogic gameLogic6 = game;
                                aiGotoStateEvade(GameLogic.player, fpEvadeSharkRange);
                                return;
                            }
                        }
                        return;
                    }
                    return;
                case 4:
                default:
                    return;
            }
        }
    }

    public void inflictDamage(int points) {
        game.resetKillChain();
        this.fpHealth -= points < 0 ? -((-points) << 16) : points << 16;
        this.fpAnimScaleRate = 65536;
        if (this.fpHealth <= 0) {
            this.fpHealth = 0;
            stopCharge();
            nextAnimState(7);
            return;
        }
        nextAnimState(6);
        if (fpPlayerPoisonTimeRemaining == 0) {
            fpPlayerDamageTintTimeRemaining = cfpPlayerDamageTintTime;
        }
        if (points >= 30) {
            FrontEnd.vibrate(PduPart.P_CONTENT_TRANSFER_ENCODING);
        } else {
            FrontEnd.vibrate(100);
        }
    }

    public void awardPointsAndHealth(int points, int health) {
        int maxHealth = sharkTable[sharkLevel][4] < 0 ? -((-sharkTable[sharkLevel][4]) << 16) : sharkTable[sharkLevel][4] << 16;
        this.fpHealth += health < 0 ? -((-health) << 16) : health << 16;
        this.fpHealth = this.fpHealth < maxHealth ? this.fpHealth : maxHealth;
        game.playerScore += points;
        if (sharkLevel < 9 && game.playerScore >= sharkTable[sharkLevel + 1][0]) {
            setSharkLevel(sharkLevel + 1, true, true);
        }
    }

    public void collectBonus() {
        GameScreen.effects.create(21, 10, this.fpPos[0], this.fpPos[1]);
        int points = bonusItemScoreTable[playerNumBonusItemsCollected];
        awardPointsAndHealth(points, 0);
        playerNumBonusItemsCollected++;
        GameApp.gameScreen.addEatTextMessageFixed(strBonusItemName(this.bonusFrame) + " " + playerNumBonusItemsCollected + "/10", -16711681);
        if (this.bonusFrame == 2) {
            SoundBank.sfxPlay(40, false, 100, 0);
        }
        if (playerNumBonusItemsCollected == 10) {
            GameApp.gameScreen.addEatTextMessageFixed("ALL ITEMS FOUND!", -1);
            SoundBank.sfxPlay(41, false, 100, 0);
        }
        playerWhichBonusItemsCollected |= 1 << this.bonusFrame;
    }

    public int dotFacingPoint(int[] in) {
        tempPos[0] = in[0] - this.fpPos[0];
        tempPos[1] = in[1] - this.fpPos[1];
        VecMath.norm2d(tempPos, tempPos);
        VecMath.norm2d(tempPos2, this.fpVel);
        return (((tempPos[0] ^ tempPos2[0]) & 134217728) != 0 ? -((int) (((-tempPos[0]) * tempPos2[0]) >> 16)) : (int) ((tempPos[0] * tempPos2[0]) >> 16)) + (((tempPos[1] ^ tempPos2[1]) & 134217728) != 0 ? -((int) (((-tempPos[1]) * tempPos2[1]) >> 16)) : (int) ((tempPos[1] * tempPos2[1]) >> 16));
    }

    public void getExtents(int[] out) {
        int w = this.animSprite.gfx.getClipRectWidth(this.animSprite.frame) * 4096;
        int h = this.animSprite.gfx.getClipRectHeight(this.animSprite.frame) * 4096;
        int scale = this.fpScale;
        if (this.animSet == 4) {
            scale <<= 1;
            if (this.shoal != -1) {
                GameLogic gameLogic = game;
                int[] spawnerState = GameLogic.spawner.spawners[this.spawner];
                if (spawnerState[4] == 1 && spawnerState[5] == 0) {
                    scale <<= 1;
                }
            }
        } else if (this.animSet == 8) {
            scale <<= 1;
        } else if (this.animSet == 10 && this.animState == 11 && cfpWaterHeight - this.fpPos[1] > cfpPelicanBigCollBoxHeight) {
            scale <<= 1;
        }
        if (scale != 65536) {
            w = ((w ^ scale) & 134217728) != 0 ? -((int) (((-w) * scale) >> 16)) : (int) ((w * scale) >> 16);
            h = ((h ^ scale) & 134217728) != 0 ? -((int) (((-h) * scale) >> 16)) : (int) ((h * scale) >> 16);
        }
        out[0] = this.fpPos[0] - (w >> 1);
        out[1] = this.fpPos[1] - (h >> 1);
        out[2] = w;
        out[3] = h;
    }

    public void initBasicExtents() {
        ImageSequence gfx = AnimData.animSets[this.animSet][0];
        int w = gfx.getClipRectWidth(0) * 4096;
        int h = gfx.getClipRectHeight(0) * 4096;
        if (this.fpScale != 65536) {
            w = ((this.fpScale ^ w) & 134217728) != 0 ? -((int) (((-w) * this.fpScale) >> 16)) : (int) ((w * this.fpScale) >> 16);
            h = ((this.fpScale ^ h) & 134217728) != 0 ? -((int) (((-h) * this.fpScale) >> 16)) : (int) ((h * this.fpScale) >> 16);
        }
        this.fpBasicExtents[0] = this.fpPos[0] - (w >> 1);
        this.fpBasicExtents[1] = this.fpPos[1] - (h >> 1);
        this.fpBasicExtents[2] = w;
        this.fpBasicExtents[3] = h;
    }

    public void updateBasicExtents() {
        int w = this.fpBasicExtents[2];
        int h = this.fpBasicExtents[3];
        this.fpBasicExtents[0] = this.fpPos[0] - (w >> 1);
        this.fpBasicExtents[1] = this.fpPos[1] - (h >> 1);
    }

    public boolean collTestPoint(int px, int py) {
        return px >= this.fpExtents[0] && py >= this.fpExtents[1] && px <= this.fpExtents[0] + this.fpExtents[2] && py <= this.fpExtents[1] + this.fpExtents[3];
    }

    public boolean collTestRect(int[] in) {
        return in[0] < this.fpExtents[0] + this.fpExtents[2] && in[1] < this.fpExtents[1] + this.fpExtents[3] && in[0] + in[2] > this.fpExtents[0] && in[1] + in[3] > this.fpExtents[1];
    }

    public boolean collTestObj(GameObj obj) {
        return collTestRect(obj.fpExtents);
    }

    public static boolean collTestPointVsRect(int px, int py, int[] rect) {
        return px >= rect[0] && py >= rect[1] && px <= rect[0] + rect[2] && py <= rect[1] + rect[3];
    }

    public static boolean collTestRectVsRect(int[] r0, int[] r1) {
        return r0[0] < r1[0] + r1[2] && r0[1] < r1[1] + r1[3] && r0[0] + r0[2] > r1[0] && r0[1] + r0[3] > r1[1];
    }

    public void refreshMouthPos() {
        int offsetX;
        int offsetY;
        int offsetY2;
        if (this.fpScale == 65536) {
            offsetX = cfpSharkMouthOffsetX;
        } else {
            offsetX = ((cfpSharkMouthOffsetX ^ this.fpScale) & 134217728) != 0 ? -((int) (((-cfpSharkMouthOffsetX) * this.fpScale) >> 16)) : (int) ((cfpSharkMouthOffsetX * this.fpScale) >> 16);
        }
        if (this.fpScale == 65536) {
            offsetY = cfpSharkMouthOffsetY;
        } else {
            offsetY = ((cfpSharkMouthOffsetY ^ this.fpScale) & 134217728) != 0 ? -((int) (((-cfpSharkMouthOffsetY) * this.fpScale) >> 16)) : (int) ((cfpSharkMouthOffsetY * this.fpScale) >> 16);
        }
        if (this.animState == 3) {
            offsetX = 0;
            offsetY2 = 0;
        } else if (this.facingLeft) {
            offsetY2 = offsetY - (((FixedPoint.sinLut(this.fpRot) ^ offsetX) & 134217728) != 0 ? -((int) (((-offsetX) * FixedPoint.sinLut(this.fpRot)) >> 16)) : (int) ((offsetX * FixedPoint.sinLut(this.fpRot)) >> 16));
            offsetX = -offsetX;
        } else {
            offsetY2 = offsetY + (((FixedPoint.sinLut(this.fpRot) ^ offsetX) & 134217728) != 0 ? -((int) (((-offsetX) * FixedPoint.sinLut(this.fpRot)) >> 16)) : (int) ((offsetX * FixedPoint.sinLut(this.fpRot)) >> 16));
        }
        fpPlayerMouthPos[0] = this.fpPos[0] + offsetX;
        fpPlayerMouthPos[1] = this.fpPos[1] + offsetY2;
    }

    public boolean canBeBitten() {
        switch (this.objType) {
            case 1:
            case 4:
            case 5:
            case 7:
            case 8:
                return false;
            case 2:
            case 3:
            case 6:
            default:
                switch (this.animState) {
                    case 2:
                    case 3:
                    case 10:
                    case 12:
                        return true;
                    case 1:
                    case 11:
                        if (this.objType == 6 || this.objType == 9) {
                            return true;
                        }
                        break;
                }
                return false;
        }
    }

    private void biteKill() {
        int fpBiteRange;
        if (this.fpScale == 65536) {
            fpBiteRange = cfpSharkBiteRange;
        } else {
            fpBiteRange = ((cfpSharkBiteRange ^ this.fpScale) & 134217728) != 0 ? -((int) (((-cfpSharkBiteRange) * this.fpScale) >> 16)) : (int) ((cfpSharkBiteRange * this.fpScale) >> 16);
        }
        tempRect[0] = fpPlayerMouthPos[0] - (fpBiteRange >> 1);
        tempRect[1] = fpPlayerMouthPos[1] - (fpBiteRange >> 1);
        tempRect[2] = fpBiteRange;
        tempRect[3] = fpBiteRange;
        int numShakes = 0;
        if (playerNumShakesRequired <= 0) {
            fpPlayerShakeSpeedScale = 65536;
        }
        boolean damaged = false;
        boolean jellyfishDamage = false;
        GameObj damageObj = null;
        int numKills = 0;
        int killedType = -1;
        int score = game.playerScore;
        boolean shoalBonus = false;
        int multiKillType = -1;
        boolean swimmerAbove = false;
        boolean airPelican = false;
        for (int i = 0; i < game.numGameObj; i++) {
            GameObj obj = game.gameObjList[i];
            if (!obj.deleted && obj.canBeBitten() && obj.collTestRect(tempRect)) {
                if ((obj.animState == 10 || obj.fpPuffTimer > 0) && sharkLevel < 5 && fpPlayerChargeFactor == 0) {
                    damaged = true;
                    damageObj = obj;
                    GameApp.gameScreen.addEatTextMessage("PRICKLY!", -32768);
                    SoundBank.sfxPlay(43, false, 100, 0);
                } else {
                    if (obj.shoal != -1 && obj.animSet != 6) {
                        GameLogic gameLogic = game;
                        int[] spawnerState = GameLogic.spawner.spawners[obj.spawner];
                        if (spawnerState[4] == 1 && spawnerState[5] == 0 && spawnerState[8] > 1) {
                            shoalBonus = true;
                            awardPointsAndHealth(spawnerState[8] * typeData[obj.animSet][15] * game.scoreMultiplier, 0);
                        }
                    }
                    obj.aiGotoStateDie();
                    int[] iArr = game.npcNumKilled;
                    int i2 = obj.animSet;
                    iArr[i2] = iArr[i2] + 1;
                    int[] objData = typeData[obj.animSet];
                    int shakeMin = objData[12];
                    int shakeMax = objData[13];
                    int shakeScaled = FixedPoint.linearInterpolate(fpSharkLevelFrac, shakeMin, shakeMax);
                    if (fpPlayerChargeTime > 0) {
                        shakeScaled >>= 1;
                    }
                    if (numShakes < shakeScaled) {
                        numShakes = shakeScaled;
                    }
                    if (numShakes >= 1 && objData[14] < fpPlayerShakeSpeedScale) {
                        fpPlayerShakeSpeedScale = objData[14];
                    }
                    if (obj.animSet == 6) {
                        fpPlayerPoisonTimeRemaining = cfpPlayerPoisonTime;
                        fpPlayerDamageTintTimeRemaining = 0;
                        jellyfishDamage = true;
                        game.resetKillChain();
                    }
                    if (obj.animSet == 10 && cfpWaterHeight - obj.fpPos[1] > cfpPelicanBigScoreHeight) {
                        airPelican = true;
                    }
                    if ((obj.animSet == 1 || obj.animSet == 12) && this.fpVel[1] > 655360) {
                        swimmerAbove = true;
                    }
                    numKills++;
                    if (killedType == -1) {
                        killedType = obj.animSet;
                    } else if (killedType != obj.animSet) {
                        killedType = -2;
                    }
                    int mkType = objData[18];
                    if (mkType != -1 && game.updateMultiKill(mkType)) {
                        multiKillType = mkType;
                    }
                }
            }
        }
        if (damaged) {
            inflictDamage(typeData[damageObj.animSet][17]);
            tempPos[0] = this.fpPos[0] - damageObj.fpPos[0];
            tempPos[1] = this.fpPos[1] - damageObj.fpPos[1];
            VecMath.norm2d(tempPos, tempPos);
            this.fpVel[0] = ((tempPos[0] ^ 262144) & 134217728) != 0 ? -((int) (((-tempPos[0]) * 262144) >> 16)) : (int) ((tempPos[0] * 262144) >> 16);
            this.fpVel[1] = ((tempPos[1] ^ 262144) & 134217728) != 0 ? -((int) (((-tempPos[1]) * 262144) >> 16)) : (int) ((tempPos[1] * 262144) >> 16);
            this.fpCollReactBlend = 65536;
        } else if (numShakes > 0) {
            this.fpAnimScaleRate = 65536;
            playerNumShakesRequired = playerNumShakesRequired > numShakes ? playerNumShakesRequired : numShakes;
            nextAnimState(9);
        } else {
            this.fpAnimScaleRate = 65536;
            nextAnimState(2);
        }
        if (numKills > 0) {
            int score2 = game.playerScore - score;
            if (killedType < 0) {
                SoundBank.sfxPlay(5, false, 100, 0);
                GameApp.gameScreen.addEatText(score2, "" + score2);
            } else {
                GameApp.gameScreen.addEatText(score2, "" + score2);
                int snd = typeData[killedType][19];
                if (snd != -1) {
                    int sndMax = typeData[killedType][20];
                    if (sndMax != -1) {
                        snd = GameLogic.randRange(snd, sndMax);
                    }
                    SoundBank.sfxPlay(snd, false, 100, 0);
                }
                if (killedType == 1 || killedType == 12) {
                    SoundBank.sfxPlay(37, false, 100, 0);
                }
            }
            if (multiKillType != -1) {
                GameApp.gameScreen.addEatTextMessage(strMultiKill(multiKillType), -256);
                if (multiKillType == 3) {
                    SoundBank.sfxPlay(11, false, 100, 0);
                }
            } else if (shoalBonus && score2 > 0) {
                GameApp.gameScreen.addEatTextMessage(strShoalBonus(killedType), -256);
            } else {
                switch (killedType) {
                    case 1:
                    case 12:
                        GameApp.gameScreen.addEatTextMessage(strSingleKill(killedType, swimmerAbove, false), -256);
                        break;
                    case 6:
                    case 13:
                    case 16:
                    case 18:
                    case 21:
                        GameApp.gameScreen.addEatTextMessage(strSingleKill(killedType, false, false), -256);
                        break;
                    case 10:
                        if (airPelican) {
                            GameApp.gameScreen.addEatTextMessage(strSingleKill(killedType, false, true), -256);
                            break;
                        }
                        break;
                }
            }
        }
        if (numKills > 0 && !damaged) {
            FrontEnd.vibrate(jellyfishDamage ? PduPart.P_CONTENT_TRANSFER_ENCODING : 50);
        }
    }

    public int getPointsForKill() {
        if (this.objType == 1) {
            return 0;
        }
        if (this.objType == 5 && this.spawner == -1) {
            return 0;
        }
        int[] table = typeData[this.animSet];
        int points = table[15];
        if (this.animSet == 10 && cfpWaterHeight - this.fpPos[1] > cfpPelicanBigScoreHeight) {
            points = 60;
        }
        if (this.objType != 9) {
            points *= game.scoreMultiplier;
        }
        return points;
    }

    public void destroySub() {
        aiGotoStateDie();
        int[] iArr = game.npcNumKilled;
        int i = this.animSet;
        iArr[i] = iArr[i] + 1;
        int score = typeData[this.animSet][15] * game.scoreMultiplier;
        GameApp.gameScreen.addEatText(score, "" + score);
        SoundBank.sfxPlay(34, false, 100, 0);
    }

    public static final void reflect2d(int[] out, int[] normal, int[] indir) {
        reverse[0] = -indir[0];
        reverse[1] = -indir[1];
        int d = (((normal[0] ^ reverse[0]) & 134217728) != 0 ? -((int) (((-normal[0]) * reverse[0]) >> 16)) : (int) ((normal[0] * reverse[0]) >> 16)) + (((normal[1] ^ reverse[1]) & 134217728) != 0 ? -((int) (((-normal[1]) * reverse[1]) >> 16)) : (int) ((normal[1] * reverse[1]) >> 16));
        int d2 = ((131072 ^ d) & 134217728) != 0 ? -((int) (((-d) * 131072) >> 16)) : (int) ((d * 131072) >> 16);
        out[0] = ((normal[0] ^ d2) & 134217728) != 0 ? -((int) (((-normal[0]) * d2) >> 16)) : (int) ((normal[0] * d2) >> 16);
        out[1] = ((normal[1] ^ d2) & 134217728) != 0 ? -((int) (((-normal[1]) * d2) >> 16)) : (int) ((normal[1] * d2) >> 16);
        out[0] = out[0] + indir[0];
        out[1] = out[1] + indir[1];
    }

    private void collReact(int[] normal, int[] oldPos) {
        if (this.tempCollIgnoreFrames > 0) {
            this.tempCollIgnoreFrames = 3;
            return;
        }
        this.fpPos[0] = oldPos[0];
        this.fpPos[1] = oldPos[1];
        int vx = this.fpVel[0];
        int vy = this.fpVel[1];
        int fpSpeed = FixedPoint.sqrt_bits((((vx ^ vx) & 134217728) != 0 ? -((int) (((-vx) * vx) >> 16)) : (int) ((vx * vx) >> 16)) + (((vy ^ vy) & 134217728) != 0 ? -((int) (((-vy) * vy) >> 16)) : (int) ((vy * vy) >> 16)));
        VecMath.norm2d(fpDir, this.fpVel);
        int dot = (((normal[0] ^ fpDir[0]) & 134217728) != 0 ? -((int) (((-normal[0]) * fpDir[0]) >> 16)) : (int) ((normal[0] * fpDir[0]) >> 16)) + (((normal[1] ^ fpDir[1]) & 134217728) != 0 ? -((int) (((-normal[1]) * fpDir[1]) >> 16)) : (int) ((normal[1] * fpDir[1]) >> 16));
        if (fpSpeed > 131072) {
            fpSpeed >>= 1;
        }
        if (dot < 0) {
            reflect2d(this.fpVel, normal, fpDir);
            this.fpVel[0] = ((this.fpVel[0] ^ fpSpeed) & 134217728) != 0 ? -((int) (((-this.fpVel[0]) * fpSpeed) >> 16)) : (int) ((this.fpVel[0] * fpSpeed) >> 16);
            this.fpVel[1] = ((this.fpVel[1] ^ fpSpeed) & 134217728) != 0 ? -((int) (((-this.fpVel[1]) * fpSpeed) >> 16)) : (int) ((this.fpVel[1] * fpSpeed) >> 16);
            if (this.objType == 1 && this.fpCollReactBlend < 32768) {
                FrontEnd.vibrate(50);
            }
            this.fpCollReactBlend = 65536;
        } else {
            if (this.objType == 1) {
            }
            this.fpVel[0] = ((normal[0] ^ fpSpeed) & 134217728) != 0 ? -((int) (((-normal[0]) * fpSpeed) >> 16)) : (int) ((normal[0] * fpSpeed) >> 16);
            this.fpVel[1] = ((normal[1] ^ fpSpeed) & 134217728) != 0 ? -((int) (((-normal[1]) * fpSpeed) >> 16)) : (int) ((normal[1] * fpSpeed) >> 16);
            this.fpPos[0] = this.fpPos[0] + (((normal[0] ^ 4096) & 134217728) != 0 ? -((int) (((-normal[0]) * 4096) >> 16)) : (int) ((normal[0] * 4096) >> 16));
            this.fpPos[1] = this.fpPos[1] + (((normal[1] ^ 4096) & 134217728) != 0 ? -((int) (((-normal[1]) * 4096) >> 16)) : (int) ((normal[1] * 4096) >> 16));
            this.fpCollReactBlend = 65536;
        }
        this.fpEvadeTimer = 0;
    }

    private void collReactBeached(int[] oldPos) {
        this.fpPos[0] = oldPos[0];
        this.fpPos[1] = oldPos[1];
        int dx = fpPlayerLastGoodPos[0] - oldPos[0];
        if (dx < 0) {
            this.fpVel[0] = -1638400;
        } else {
            this.fpVel[0] = 1638400;
        }
        int fpTime = (int) ((dx << 16) / this.fpVel[0]);
        if (fpTime > 0) {
            int dy = fpPlayerLastGoodPos[1] - oldPos[1];
            this.fpVel[1] = ((int) ((dy << 16) / fpTime)) - ((((4587520 ^ fpTime) & 134217728) != 0 ? -((int) (((-4587520) * fpTime) >> 16)) : (int) ((4587520 * fpTime) >> 16)) >> 1);
            this.fpCollReactBlend = 65536;
            playerBeached = true;
        }
    }

    private void checkBoatCollisionVsShark() {
        GameLogic gameLogic = game;
        GameObj player = GameLogic.player;
        if (this.fpJoltPhase <= 0) {
            int fpTempXOffset = ((cfpBoatCollOffsetX ^ player.fpScale) & 134217728) != 0 ? -((int) (((-cfpBoatCollOffsetX) * player.fpScale) >> 16)) : (int) ((cfpBoatCollOffsetX * player.fpScale) >> 16);
            int fpTempYOffset = ((cfpBoatCollOffsetY ^ player.fpScale) & 134217728) != 0 ? -((int) (((-cfpBoatCollOffsetY) * player.fpScale) >> 16)) : (int) ((cfpBoatCollOffsetY * player.fpScale) >> 16);
            tempRect[0] = this.fpExtents[0] + (fpTempXOffset >> 1);
            tempRect[1] = this.fpExtents[1];
            tempRect[2] = this.fpExtents[2] - fpTempXOffset;
            tempRect[3] = this.fpExtents[3] - fpTempYOffset;
            if (!collTestRectVsRect(tempRect, player.fpExtents)) {
                this.joltLock = false;
            } else if (!this.joltLock) {
                this.joltLock = true;
                VecMath.norm2d(fpDir, player.fpVel);
                int fpSpeed = VecMath.len2d(player.fpVel);
                if (fpDir[1] <= cfpBoatJoltMinYDir) {
                    this.fpJoltPhase = 65536;
                    if (fpSpeed >= cfpBoatBigJoltSpeed && fpPlayerChargeFactor > 0) {
                        this.fpJoltScale = 65536;
                        GameObj bloke = this.aiTargetObj;
                        if (bloke != null) {
                            detachParentAndChild();
                            bloke.aiGotoStateFallOutOfBoat();
                        }
                        SoundBank.sfxPlay(18, false, 100, 0);
                        return;
                    }
                    this.fpJoltScale = (int) ((fpSpeed << 16) / cfpBoatBigJoltSpeed);
                    SoundBank.sfxPlay(19, false, 100, 0);
                }
            }
        }
    }

    private void checkSubCollisionVsShark() {
        GameLogic gameLogic = game;
        GameObj player = GameLogic.player;
        if (this.animState == 2 || this.animState == 3) {
            int fpTempXOffset = ((cfpSubCollOffsetX ^ player.fpScale) & 134217728) != 0 ? -((int) (((-cfpSubCollOffsetX) * player.fpScale) >> 16)) : (int) ((cfpSubCollOffsetX * player.fpScale) >> 16);
            int fpTempYOffset = ((cfpSubCollOffsetY ^ player.fpScale) & 134217728) != 0 ? -((int) (((-cfpSubCollOffsetY) * player.fpScale) >> 16)) : (int) ((cfpSubCollOffsetY * player.fpScale) >> 16);
            tempRect[0] = this.fpExtents[0] + (fpTempXOffset >> 1);
            tempRect[1] = this.fpExtents[1] + (fpTempYOffset >> 1);
            tempRect[2] = this.fpExtents[2] - fpTempXOffset;
            tempRect[3] = this.fpExtents[3] - fpTempYOffset;
            if (collTestRectVsRect(tempRect, player.fpExtents)) {
                this.fpNormal[0] = player.fpPos[0] - this.fpPos[0];
                this.fpNormal[1] = player.fpPos[1] - this.fpPos[1];
                VecMath.norm2d(this.fpNormal, this.fpNormal);
                VecMath.norm2d(fpDir, player.fpVel);
                int fpSpeed = VecMath.len2d(player.fpVel);
                int dot = (((this.fpNormal[0] ^ fpDir[0]) & 134217728) != 0 ? -((int) (((-this.fpNormal[0]) * fpDir[0]) >> 16)) : (int) ((this.fpNormal[0] * fpDir[0]) >> 16)) + (((this.fpNormal[1] ^ fpDir[1]) & 134217728) != 0 ? -((int) (((-this.fpNormal[1]) * fpDir[1]) >> 16)) : (int) ((this.fpNormal[1] * fpDir[1]) >> 16));
                int i = player.fpVel[1];
                if (dot < 0) {
                    reflect2d(player.fpVel, this.fpNormal, fpDir);
                    player.fpVel[0] = ((player.fpVel[0] ^ fpSpeed) & 134217728) != 0 ? -((int) (((-player.fpVel[0]) * fpSpeed) >> 16)) : (int) ((player.fpVel[0] * fpSpeed) >> 16);
                    player.fpVel[1] = ((player.fpVel[1] ^ fpSpeed) & 134217728) != 0 ? -((int) (((-player.fpVel[1]) * fpSpeed) >> 16)) : (int) ((player.fpVel[1] * fpSpeed) >> 16);
                    player.updateMovement();
                }
                if (fpPlayerChargeFactor > 0) {
                    int fpCockpitX = this.facingLeft ? this.fpExtents[0] + 131072 : (this.fpExtents[0] + this.fpExtents[2]) - 131072;
                    int fpCockpitY = this.fpPos[1] - (((FixedPoint.sinLut(this.fpRot) ^ (this.fpPos[0] - fpCockpitX)) & 134217728) != 0 ? -((int) (((-FixedPoint.sinLut(this.fpRot)) * (this.fpPos[0] - fpCockpitX)) >> 16)) : (int) ((FixedPoint.sinLut(this.fpRot) * (this.fpPos[0] - fpCockpitX)) >> 16));
                    if (player.collTestPoint(fpCockpitX, fpCockpitY)) {
                        destroySub();
                    }
                }
            }
        }
    }

    private void checkMineCollisionVsShark() {
        GameLogic gameLogic = game;
        GameObj player = GameLogic.player;
        int fpTempXOffset = ((cfpMineCollOffsetX ^ player.fpScale) & 134217728) != 0 ? -((int) (((-cfpMineCollOffsetX) * player.fpScale) >> 16)) : (int) ((cfpMineCollOffsetX * player.fpScale) >> 16);
        int fpTempYOffset = ((cfpMineCollOffsetY ^ player.fpScale) & 134217728) != 0 ? -((int) (((-cfpMineCollOffsetY) * player.fpScale) >> 16)) : (int) ((cfpMineCollOffsetY * player.fpScale) >> 16);
        int[] rectPlayer = player.fpExtents;
        tempRect[0] = rectPlayer[0] + (fpTempXOffset >> 1);
        tempRect[1] = rectPlayer[1] + (fpTempYOffset >> 1);
        tempRect[2] = rectPlayer[2] - fpTempXOffset;
        tempRect[3] = rectPlayer[3] - fpTempYOffset;
        if (collTestRect(tempRect)) {
            SoundBank.sfxPlay(1, false, 100, 0);
            GameScreen.effects.create(5, 1, this.fpPos[0], this.fpPos[1]);
            GameScreen.effects.create(3, 10, this.fpPos[0], this.fpPos[1]);
            player.inflictDamage(typeData[this.animSet][17]);
            tempPos[0] = player.fpPos[0] - this.fpPos[0];
            tempPos[1] = player.fpPos[1] - this.fpPos[1];
            VecMath.norm2d(tempPos, tempPos);
            player.fpVel[0] = ((tempPos[0] ^ 1048576) & 134217728) != 0 ? -((int) (((-tempPos[0]) * 1048576) >> 16)) : (int) ((tempPos[0] * 1048576) >> 16);
            player.fpVel[1] = ((tempPos[1] ^ 1048576) & 134217728) != 0 ? -((int) (((-tempPos[1]) * 1048576) >> 16)) : (int) ((tempPos[1] * 1048576) >> 16);
            GameApp.gameScreen.addEatTextMessage("BOOM!", -32768);
            requestDelete();
        }
    }

    private void checkSailfishCollisionVsShark() {
        int px;
        GameLogic gameLogic = game;
        GameObj player = GameLogic.player;
        if (this.animState == 2) {
            if (player.animState == 2 || player.animState == 4) {
                int py = this.fpPos[1];
                if (this.facingLeft) {
                    px = this.fpExtents[0];
                } else {
                    px = this.fpExtents[0] + this.fpExtents[2];
                }
                int py2 = py + (((FixedPoint.sinLut(this.fpRot) ^ (px - this.fpPos[0])) & 134217728) != 0 ? -((int) (((-FixedPoint.sinLut(this.fpRot)) * (px - this.fpPos[0])) >> 16)) : (int) ((FixedPoint.sinLut(this.fpRot) * (px - this.fpPos[0])) >> 16));
                int dy = py2 - player.fpPos[1] < 0 ? -(py2 - player.fpPos[1]) : py2 - player.fpPos[1];
                if (dy < (this.fpExtents[3] >> 1)) {
                    int dx = px - player.fpPos[0] < 0 ? -(px - player.fpPos[0]) : px - player.fpPos[0];
                    if (dx < (this.fpExtents[2] >> 1)) {
                        player.inflictDamage(typeData[this.animSet][17]);
                        GameApp.gameScreen.addEatTextMessage("OUCH!", -32768);
                        SoundBank.sfxPlay(43, false, 100, 0);
                    }
                }
            }
        }
    }

    private void checkAttackCollisionVsShark() {
        GameLogic gameLogic = game;
        GameObj player = GameLogic.player;
        if ((player.animState == 2 || player.animState == 4) && collTestRect(player.fpExtents)) {
            player.inflictDamage(typeData[this.animSet][17]);
            GameScreen.effects.create(GameLogic.randBoolean() ? 8 : 12, 1, this.fpPos[0], this.fpPos[1]);
            GameScreen.effects.create(1, 1, this.fpPos[0], this.fpPos[1]);
            if (this.animSet == 13) {
                SoundBank.sfxPlay(30, false, 100, 0);
                GameApp.gameScreen.addEatTextMessage("STAB!", -32768);
            } else if (this.animSet == 9) {
                SoundBank.sfxPlay(GameLogic.randRange(4, 9), false, 100, 0);
                GameApp.gameScreen.addEatTextMessage("NIPPED!", -32768);
            }
        }
    }

    private void checkProjectileCollisionVsShark() {
        GameLogic gameLogic = game;
        GameObj player = GameLogic.player;
        if (collTestRect(player.fpExtents)) {
            player.inflictDamage(typeData[this.animSet][17]);
            GameScreen.effects.create(5, 1, this.fpPos[0], this.fpPos[1]);
            SoundBank.sfxPlay(1, false, 100, 0);
            requestDelete();
        }
    }

    private void updateShoalMovement() {
        int rx;
        int ry;
        int dt = GameApp.fp_deltatime;
        GameLogic gameLogic = game;
        int[] s = GameLogic.spawner.shoals[this.shoal];
        GameLogic gameLogic2 = game;
        Spawner spawner = GameLogic.spawner;
        int[] def = Spawner.shoalTypeTable[s[1]];
        int fpDesiredX = s[2];
        int fpDesiredY = s[3];
        int fpRadius = FixedPoint.sinLut(this.fpShoalRadiusPhase);
        int fpShoalScale = s[5];
        if ((((((fpRadius ^ fpShoalScale) & 134217728) != 0 ? -((int) (((-fpRadius) * fpShoalScale) >> 16)) : (int) ((fpRadius * fpShoalScale) >> 16)) ^ def[2]) & 134217728) != 0) {
            rx = -((int) (((-(((fpRadius ^ fpShoalScale) & 134217728) != 0 ? -((int) (((-fpRadius) * fpShoalScale) >> 16)) : (int) ((fpRadius * fpShoalScale) >> 16))) * def[2]) >> 16));
        } else {
            rx = (int) (((((fpRadius ^ fpShoalScale) & 134217728) != 0 ? -((int) (((-fpRadius) * fpShoalScale) >> 16)) : (int) ((fpRadius * fpShoalScale) >> 16)) * def[2]) >> 16);
        }
        if ((((((fpRadius ^ fpShoalScale) & 134217728) != 0 ? -((int) (((-fpRadius) * fpShoalScale) >> 16)) : (int) ((fpRadius * fpShoalScale) >> 16)) ^ def[3]) & 134217728) != 0) {
            ry = -((int) (((-(((fpRadius ^ fpShoalScale) & 134217728) != 0 ? -((int) (((-fpRadius) * fpShoalScale) >> 16)) : (int) ((fpRadius * fpShoalScale) >> 16))) * def[3]) >> 16));
        } else {
            ry = (int) (((((fpRadius ^ fpShoalScale) & 134217728) != 0 ? -((int) (((-fpRadius) * fpShoalScale) >> 16)) : (int) ((fpRadius * fpShoalScale) >> 16)) * def[3]) >> 16);
        }
        int fpDesiredX2 = fpDesiredX + (((FixedPoint.sinLut(this.fpShoalRotPhase + 4194304) ^ rx) & 134217728) != 0 ? -((int) (((-rx) * FixedPoint.sinLut(this.fpShoalRotPhase + 4194304)) >> 16)) : (int) ((rx * FixedPoint.sinLut(this.fpShoalRotPhase + 4194304)) >> 16));
        int fpDesiredY2 = fpDesiredY + (((FixedPoint.sinLut(this.fpShoalRotPhase) ^ ry) & 134217728) != 0 ? -((int) (((-ry) * FixedPoint.sinLut(this.fpShoalRotPhase)) >> 16)) : (int) ((ry * FixedPoint.sinLut(this.fpShoalRotPhase)) >> 16));
        int fpRotRate = def[6];
        int fpRadiusRate = def[7];
        this.fpShoalRotPhase = (this.fpShoalRotPhase + (((fpRotRate ^ dt) & 134217728) != 0 ? -((int) (((-fpRotRate) * dt) >> 16)) : (int) ((fpRotRate * dt) >> 16))) & 16777215;
        this.fpShoalRadiusPhase = (this.fpShoalRadiusPhase + (((fpRadiusRate ^ dt) & 134217728) != 0 ? -((int) (((-fpRadiusRate) * dt) >> 16)) : (int) ((fpRadiusRate * dt) >> 16))) & 16777215;
        goTowardsPoint(fpDesiredX2, fpDesiredY2);
    }

    private void updateSimpleMovement() {
        int dt = GameApp.fp_deltatime;
        int fpDesiredX = this.fpAIHomePos[0] + (((this.fpAIWanderRangeX ^ FixedPoint.sinLut(this.fpAIWanderPhaseX)) & 134217728) != 0 ? -((int) (((-this.fpAIWanderRangeX) * FixedPoint.sinLut(this.fpAIWanderPhaseX)) >> 16)) : (int) ((this.fpAIWanderRangeX * FixedPoint.sinLut(this.fpAIWanderPhaseX)) >> 16));
        int fpDesiredY = this.fpAIHomePos[1] + (((this.fpAIWanderRangeY ^ FixedPoint.sinLut(this.fpAIWanderPhaseY)) & 134217728) != 0 ? -((int) (((-this.fpAIWanderRangeY) * FixedPoint.sinLut(this.fpAIWanderPhaseY)) >> 16)) : (int) ((this.fpAIWanderRangeY * FixedPoint.sinLut(this.fpAIWanderPhaseY)) >> 16));
        if (this.fpAIWanderRangeX > 0) {
            int fpRate = (int) (((this.fpMoveSpeed << 7) << 16) / this.fpAIWanderRangeX);
            this.fpAIWanderPhaseX += ((fpRate ^ dt) & 134217728) != 0 ? -((int) (((-fpRate) * dt) >> 16)) : (int) ((fpRate * dt) >> 16);
            this.fpAIWanderPhaseX &= 16777215;
        }
        if (this.fpAIWanderRangeY > 0) {
            int fpRate2 = (int) (((this.fpMoveSpeed << 7) << 16) / this.fpAIWanderRangeY);
            this.fpAIWanderPhaseY += ((fpRate2 ^ dt) & 134217728) != 0 ? -((int) (((-fpRate2) * dt) >> 16)) : (int) ((fpRate2 * dt) >> 16);
            this.fpAIWanderPhaseY &= 16777215;
        }
        goTowardsPoint(fpDesiredX, fpDesiredY);
    }

    public void goTowardsPoint(int fpDesiredX, int fpDesiredY) {
        int dt = GameApp.fp_deltatime;
        int fpDesiredSpeed = this.fpMoveSpeed;
        int dx = fpDesiredX - this.fpPos[0];
        int dy = fpDesiredY - this.fpPos[1];
        int len2 = (((dx ^ dx) & 134217728) != 0 ? -((int) (((-dx) * dx) >> 16)) : (int) ((dx * dx) >> 16)) + (((dy ^ dy) & 134217728) != 0 ? -((int) (((-dy) * dy) >> 16)) : (int) ((dy * dy) >> 16));
        int len = FixedPoint.sqrt_bits(len2);
        int fpDesiredVelX = 0;
        int fpDesiredVelY = 0;
        if (len > 0) {
            int fpDesiredVelX2 = (int) ((dx << 16) / len);
            int fpDesiredVelY2 = (int) ((dy << 16) / len);
            fpDesiredVelX = ((fpDesiredVelX2 ^ fpDesiredSpeed) & 134217728) != 0 ? -((int) (((-fpDesiredVelX2) * fpDesiredSpeed) >> 16)) : (int) ((fpDesiredVelX2 * fpDesiredSpeed) >> 16);
            fpDesiredVelY = ((fpDesiredVelY2 ^ fpDesiredSpeed) & 134217728) != 0 ? -((int) (((-fpDesiredVelY2) * fpDesiredSpeed) >> 16)) : (int) ((fpDesiredVelY2 * fpDesiredSpeed) >> 16);
        }
        int typeFlags = typeData[this.animSet][9];
        if ((typeFlags & 3) != 0) {
            fpDesiredVelY = 0;
        }
        int collReactBlend = this.fpCollReactBlend;
        if (collReactBlend > 0) {
            int collReactBlend2 = 65536 < (collReactBlend << 1) ? 65536 : collReactBlend << 1;
            fpDesiredVelX = FixedPoint.linearInterpolate(collReactBlend2, fpDesiredVelX, this.fpVel[0]);
            fpDesiredVelY = FixedPoint.linearInterpolate(collReactBlend2, fpDesiredVelY, this.fpVel[1]);
        }
        int fpAcc = fpDesiredSpeed << 1;
        int fpVelStep = ((fpAcc ^ dt) & 134217728) != 0 ? -((int) (((-fpAcc) * dt) >> 16)) : (int) ((fpAcc * dt) >> 16);
        this.fpVel[0] = GameLogic.moveValue(this.fpVel[0], fpDesiredVelX, fpVelStep);
        this.fpVel[1] = GameLogic.moveValue(this.fpVel[1], fpDesiredVelY, fpVelStep);
        boolean hasTurnAnim = (typeFlags & 4) != 0;
        boolean blendRot = (typeFlags & 32) != 0;
        int fpMaxRot = typeData[this.animSet][6];
        if (fpMaxRot > 0) {
            pointInDirection(this.fpVel[0], this.fpVel[1], fpMaxRot, hasTurnAnim, blendRot);
        } else if (hasTurnAnim) {
            if (this.animState == 2 || this.animState == 12) {
                if ((this.fpVel[0] < 0) != this.facingLeft) {
                    nextAnimState(3);
                }
            }
        } else {
            this.facingLeft = this.fpVel[0] <= 0;
        }
    }

    public void pointInDirection(int dx, int dy, int fpMaxRot, boolean hasTurnAnim, boolean blendRot) {
        int i;
        int fpOldRot = this.fpRot;
        int fpLen = FixedPoint.sqrt_bits((((dx ^ dx) & 134217728) != 0 ? -((int) (((-dx) * dx) >> 16)) : (int) ((dx * dx) >> 16)) + (((dy ^ dy) & 134217728) != 0 ? -((int) (((-dy) * dy) >> 16)) : (int) ((dy * dy) >> 16)));
        int fpDirX = 65536;
        if (fpLen > 0) {
            fpDirX = (int) ((dx << 16) / fpLen);
        }
        this.fpRot = 4194304 - FixedPoint.asinLut(fpDirX);
        if (dx < 0) {
            this.fpRot = cfpDynamiteRotSpeedWater - this.fpRot;
        }
        if (dy > 0) {
            this.fpRot = -this.fpRot;
        }
        if (hasTurnAnim) {
            if (this.animState == 2 || this.animState == 12) {
                if ((dx < 0) != this.facingLeft) {
                    nextAnimState(3);
                }
            }
        } else {
            this.facingLeft = dx < 0;
        }
        if (!this.facingLeft) {
            this.fpRot = -this.fpRot;
        }
        if (fpMaxRot < 4194304) {
            if (this.fpRot < (-fpMaxRot)) {
                i = -fpMaxRot;
            } else {
                i = this.fpRot > fpMaxRot ? fpMaxRot : this.fpRot;
            }
            this.fpRot = i;
        }
        this.fpRot &= 16777215;
        if (this.animState == 3) {
            this.fpRot = 0;
        }
        if (blendRot) {
            this.fpRot = GameLogic.moveAngle(fpOldRot, this.fpRot, ((4194304 ^ GameApp.fp_deltatime) & 134217728) != 0 ? -((int) (((-4194304) * GameApp.fp_deltatime) >> 16)) : (int) ((4194304 * GameApp.fp_deltatime) >> 16));
        }
    }

    public void doSplashFX(int id, int posX) {
        boolean bigger = this.objType == 1 && sharkLevel >= 6;
        switch (id) {
            case 0:
                if (bigger) {
                    GameScreen.effects.create(17, 4, posX - 131072, cfpWaterHeight - 131072);
                    GameScreen.effects.create(17, 4, posX + 131072, cfpWaterHeight - 131072);
                } else {
                    GameScreen.effects.create(17, 4, posX, cfpWaterHeight - 131072);
                }
                SoundBank.sfxPlay(15, false, 100, 0);
                FrontEnd.vibrate(50);
                return;
            case 1:
                if (bigger) {
                    GameScreen.effects.create(18, 4, posX - 131072, cfpWaterHeight - 65536);
                    GameScreen.effects.create(18, 4, posX + 131072, cfpWaterHeight - 65536);
                    return;
                }
                GameScreen.effects.create(18, 4, posX, cfpWaterHeight - 65536);
                return;
            case 2:
                if (bigger) {
                    GameScreen.effects.create(17, 4, posX - 131072, cfpWaterHeight - 131072);
                    GameScreen.effects.create(17, 4, posX + 131072, cfpWaterHeight - 131072);
                } else {
                    GameScreen.effects.create(17, 4, posX, cfpWaterHeight - 131072);
                }
                SoundBank.sfxPlay(16, false, 100, 0);
                FrontEnd.vibrate(50);
                return;
            case 3:
                if (bigger) {
                    GameScreen.effects.create(18, 4, posX - 131072, cfpWaterHeight - 131072);
                    GameScreen.effects.create(18, 4, posX + 131072, cfpWaterHeight - 131072);
                    return;
                }
                GameScreen.effects.create(18, 4, posX, cfpWaterHeight - 131072);
                return;
            case 4:
                GameScreen.effects.create(17, 10, posX, cfpWaterHeight - 131072);
                SoundBank.sfxPlay(16, false, 100, 0);
                return;
            case 5:
                GameScreen.effects.create(20, 1, posX, cfpWaterHeight);
                return;
            case 6:
                GameScreen.effects.create(20, 1, posX, cfpWaterHeight);
                return;
            default:
                return;
        }
    }

    public void checkStartAmbientLoop() {
        switch (this.animSet) {
            case 1:
            case 12:
                if (game.npcNumActive[1] + game.npcNumActive[12] == 1) {
                    SoundBank.sfxPlay(35, true, 100, 65536);
                    return;
                }
                return;
            case 13:
                if (game.npcNumActive[13] == 1) {
                    SoundBank.sfxPlay(28, true, 100, 65536);
                    return;
                }
                return;
            case 18:
                if (game.npcNumActive[18] == 1) {
                    SoundBank.sfxPlay(33, true, 100, 65536);
                    return;
                }
                return;
            default:
                return;
        }
    }

    public void checkStopAmbientLoop() {
        switch (this.animSet) {
            case 1:
            case 12:
                if (game.npcNumActive[1] + game.npcNumActive[12] == 0) {
                    SoundBank.sfxStop(35, 65536);
                    return;
                }
                return;
            case 13:
                if (game.npcNumActive[13] == 0) {
                    SoundBank.sfxStop(28, 65536);
                    return;
                }
                return;
            case 18:
                if (game.npcNumActive[18] == 0) {
                    SoundBank.sfxStop(33, 65536);
                    return;
                }
                return;
            default:
                return;
        }
    }

    public void updatePlayerHeartbeatSound() {
        boolean playingLow = SoundBank.sfxIsLooping(39);
        boolean playingCritical = SoundBank.sfxIsLooping(38);
        boolean shouldPlayLow = false;
        boolean shouldPlayCritical = false;
        if (this.fpHealth > 0) {
            if (this.fpHealth < cfpHealthWarningLevelCritical) {
                shouldPlayCritical = true;
            } else if (this.fpHealth < cfpHealthWarningLevelLow) {
                shouldPlayLow = true;
            }
        }
        if (playingLow && !shouldPlayLow) {
            SoundBank.sfxStop(39, 0);
        }
        if (playingCritical && !shouldPlayCritical) {
            SoundBank.sfxStop(38, 0);
        }
        if (shouldPlayLow && !playingLow) {
            SoundBank.sfxPlay(39, true, 100, 0);
        }
        if (shouldPlayCritical && !playingCritical) {
            SoundBank.sfxPlay(38, true, 100, 0);
        }
    }

    public static String strObjectName(int n) {
        switch (n) {
            case 0:
                return "SHARK";
            case 1:
                return "SWIMMER";
            case 2:
                return "TUNA";
            case 3:
                return "BARRACUDA";
            case 4:
                return "SARDINE";
            case 5:
                return "SAILFISH";
            case 6:
                return "JELLYFISH";
            case 7:
                return "BLOWFISH";
            case 8:
                return "TROPICAL FISH";
            case 9:
                return "ANGLER FISH";
            case 10:
                return "PELICAN";
            case 11:
                return "MINE";
            case 12:
                return "SWIMMER";
            case 13:
                return "DIVER";
            case 14:
                return "PENGUIN";
            case 15:
                return "BOAT";
            case 16:
                return "FISHERMAN";
            case 17:
                return "BLOBFISH";
            case 18:
                return "SUBMARINE";
            case 19:
                return "DYNAMITE";
            case 20:
                return "TORPEDO";
            case 21:
                return "SHARK HUNTER";
            case 22:
                return "BOAT";
            default:
                return "";
        }
    }

    public static String strBonusItemName(int n) {
        switch (n) {
            case 0:
                return "ANCIENT VASE";
            case 1:
                return "CAR TIRE";
            case 2:
                return "MOON ON A STICK";
            case 3:
                return "LICENSE PLATE";
            case 4:
                return "TRAFFIC CONE";
            case 5:
                return "SHOPPING CART";
            case 6:
                return "SPACE HELMET";
            case 7:
                return "TRIKE";
            case 8:
                return "BOOT";
            case 9:
                return "CRYSTAL SKULL";
            default:
                return "";
        }
    }

    /* JADX WARN: Removed duplicated region for block: B:19:0x0035 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:23:0x0041 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:24:0x0044 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:25:0x0047 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:26:0x004a  */
    /* JADX WARN: Removed duplicated region for block: B:27:0x004e  */
    /* JADX WARN: Removed duplicated region for block: B:28:0x0052 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:29:0x0055 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:30:0x0058 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:31:0x005b A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:32:0x005e A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:33:0x0061 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:34:0x0064 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:35:0x0067 A[RETURN, SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:36:0x006a A[RETURN, SYNTHETIC] */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static String strMultiKill(int n) {
        switch (n) {
            case 0:
                switch (GameLogic.randRange(0, 2)) {
                    case 0:
                        return "OOO BARRACUDA";
                    case 1:
                        return "BARRACUDA BISQUE";
                    case 2:
                        return "BARBECUDA";
                }
                switch (GameLogic.randRange(0, 2)) {
                    case 0:
                        return "BLOW OUT";
                    case 1:
                        return "PUFF PASTRY";
                    case 2:
                        return "BURST THE BUBBLE";
                }
                switch (GameLogic.randRange(0, 2)) {
                    case 0:
                        return "ANGLER MANGLER";
                    case 1:
                        return "ANGLER MANGLER";
                    case 2:
                        return "TERROR OF THE DEEP";
                }
                switch (GameLogic.randRange(0, 2)) {
                    case 0:
                        return "CHUBBY CHASER";
                    case 1:
                        return "BLOBBY HOBBY";
                    case 2:
                        return "BLOB BOBBING";
                }
                switch (GameLogic.randRange(0, 2)) {
                    case 0:
                        return "PELICAN PICNIC";
                    case 1:
                        return "PELICAN PORK OUT";
                    case 2:
                        return "BELLYCAN";
                }
                switch (GameLogic.randRange(0, 2)) {
                    case 0:
                        return "REEF RAIDER";
                    case 1:
                        return "CORAL THIEF";
                    case 2:
                        return "SUSHI ROLL";
                }
                return "";
            case 1:
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                return "";
            case 2:
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                return "";
            case 3:
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                return "";
            case 4:
                switch (GameLogic.randRange(0, 2)) {
                }
                switch (GameLogic.randRange(0, 2)) {
                }
                return "";
            case 5:
                switch (GameLogic.randRange(0, 2)) {
                }
                return "";
            default:
                return "";
        }
    }

    /*  JADX ERROR: JadxRuntimeException in pass: RegionMakerVisitor
        jadx.core.utils.exceptions.JadxRuntimeException: Failed to find switch 'out' block
        	at jadx.core.dex.visitors.regions.RegionMaker.processSwitch(RegionMaker.java:817)
        	at jadx.core.dex.visitors.regions.RegionMaker.traverse(RegionMaker.java:160)
        	at jadx.core.dex.visitors.regions.RegionMaker.makeRegion(RegionMaker.java:94)
        	at jadx.core.dex.visitors.regions.RegionMaker.processSwitch(RegionMaker.java:856)
        	at jadx.core.dex.visitors.regions.RegionMaker.traverse(RegionMaker.java:160)
        	at jadx.core.dex.visitors.regions.RegionMaker.makeRegion(RegionMaker.java:94)
        	at jadx.core.dex.visitors.regions.RegionMakerVisitor.visit(RegionMakerVisitor.java:52)
        */
    public static java.lang.String strShoalBonus(int r3) {
        /*
            r2 = 3
            r1 = 0
            switch(r3) {
                case 2: goto Lf;
                case 4: goto L8;
                case 5: goto L17;
                case 14: goto L1e;
                default: goto L5;
            }
        L5:
            java.lang.String r0 = "SHOAL BONUS!"
        L7:
            return r0
        L8:
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r2)
            switch(r0) {
                case 0: goto L2a;
                case 1: goto L2d;
                case 2: goto L30;
                case 3: goto L33;
                default: goto Lf;
            }
        Lf:
            r0 = 5
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r0)
            switch(r0) {
                case 0: goto L36;
                case 1: goto L39;
                case 2: goto L3c;
                case 3: goto L3f;
                case 4: goto L42;
                case 5: goto L45;
                default: goto L17;
            }
        L17:
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r2)
            switch(r0) {
                case 0: goto L48;
                case 1: goto L4b;
                case 2: goto L4e;
                case 3: goto L51;
                default: goto L1e;
            }
        L1e:
            r0 = 2
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r0)
            switch(r0) {
                case 0: goto L27;
                case 1: goto L54;
                case 2: goto L57;
                default: goto L26;
            }
        L26:
            goto L5
        L27:
            java.lang.String r0 = "PENGUIN PICK UP"
            goto L7
        L2a:
            java.lang.String r0 = "SCHOOL'S OUT"
            goto L7
        L2d:
            java.lang.String r0 = "WIPED OUT"
            goto L7
        L30:
            java.lang.String r0 = "EVERY LAST ONE"
            goto L7
        L33:
            java.lang.String r0 = "SWALLOW THE LEADER"
            goto L7
        L36:
            java.lang.String r0 = "DOLPHIN FRIENDLY"
            goto L7
        L39:
            java.lang.String r0 = "TUNA CHUNKS"
            goto L7
        L3c:
            java.lang.String r0 = "SKIPJACK SURPRISE"
            goto L7
        L3f:
            java.lang.String r0 = "NO MAYO"
            goto L7
        L42:
            java.lang.String r0 = "LOONEY TUNAS"
            goto L7
        L45:
            java.lang.String r0 = "A TUNA MATATA"
            goto L7
        L48:
            java.lang.String r0 = "SAIL SNACKER"
            goto L7
        L4b:
            java.lang.String r0 = "PLAIN SAILING"
            goto L7
        L4e:
            java.lang.String r0 = "SAIL AWAY"
            goto L7
        L51:
            java.lang.String r0 = "FINTASTIC"
            goto L7
        L54:
            java.lang.String r0 = "ICEBURGER"
            goto L7
        L57:
            java.lang.String r0 = "FROZEN FOOD"
            goto L7
        */
        throw new UnsupportedOperationException("Method not decompiled: com.slg.j2me.game.GameObj.strShoalBonus(int):java.lang.String");
    }

    /*  JADX ERROR: JadxRuntimeException in pass: RegionMakerVisitor
        jadx.core.utils.exceptions.JadxRuntimeException: Failed to find switch 'out' block
        	at jadx.core.dex.visitors.regions.RegionMaker.processSwitch(RegionMaker.java:817)
        	at jadx.core.dex.visitors.regions.RegionMaker.traverse(RegionMaker.java:160)
        	at jadx.core.dex.visitors.regions.RegionMaker.makeRegion(RegionMaker.java:94)
        	at jadx.core.dex.visitors.regions.RegionMaker.processSwitch(RegionMaker.java:856)
        	at jadx.core.dex.visitors.regions.RegionMaker.traverse(RegionMaker.java:160)
        	at jadx.core.dex.visitors.regions.RegionMaker.makeRegion(RegionMaker.java:94)
        	at jadx.core.dex.visitors.regions.RegionMakerVisitor.visit(RegionMakerVisitor.java:52)
        */
    public static java.lang.String strSingleKill(int r4, boolean r5, boolean r6) {
        /*
            r3 = 2
            r2 = 3
            r1 = 0
            if (r5 == 0) goto Lc
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r3)
            switch(r0) {
                case 0: goto L1b;
                case 1: goto L1e;
                case 2: goto L21;
                default: goto Lc;
            }
        Lc:
            if (r6 == 0) goto L15
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r3)
            switch(r0) {
                case 0: goto L24;
                case 1: goto L27;
                case 2: goto L2a;
                default: goto L15;
            }
        L15:
            switch(r4) {
                case 1: goto L34;
                case 6: goto L2d;
                case 12: goto L3b;
                case 13: goto L42;
                case 16: goto L49;
                case 18: goto L57;
                case 21: goto L50;
                default: goto L18;
            }
        L18:
            java.lang.String r0 = ""
        L1a:
            return r0
        L1b:
            java.lang.String r0 = "DEATH FROM ABOVE"
            goto L1a
        L1e:
            java.lang.String r0 = "AERIAL ATTACK"
            goto L1a
        L21:
            java.lang.String r0 = "INCOMING!"
            goto L1a
        L24:
            java.lang.String r0 = "AIR TO AIR"
            goto L1a
        L27:
            java.lang.String r0 = "IN FLIGHT MEAL"
            goto L1a
        L2a:
            java.lang.String r0 = "SLAM DUNK"
            goto L1a
        L2d:
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r3)
            switch(r0) {
                case 0: goto L62;
                case 1: goto L65;
                case 2: goto L68;
                default: goto L34;
            }
        L34:
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r2)
            switch(r0) {
                case 0: goto L6b;
                case 1: goto L6e;
                case 2: goto L71;
                case 3: goto L74;
                default: goto L3b;
            }
        L3b:
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r2)
            switch(r0) {
                case 0: goto L77;
                case 1: goto L7a;
                case 2: goto L7d;
                case 3: goto L80;
                default: goto L42;
            }
        L42:
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r2)
            switch(r0) {
                case 0: goto L83;
                case 1: goto L86;
                case 2: goto L89;
                case 3: goto L8c;
                default: goto L49;
            }
        L49:
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r2)
            switch(r0) {
                case 0: goto L8f;
                case 1: goto L92;
                case 2: goto L95;
                case 3: goto L98;
                default: goto L50;
            }
        L50:
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r3)
            switch(r0) {
                case 0: goto L9b;
                case 1: goto L9f;
                case 2: goto La3;
                default: goto L57;
            }
        L57:
            int r0 = com.slg.j2me.game.GameLogic.randRange(r1, r2)
            switch(r0) {
                case 0: goto L5f;
                case 1: goto La7;
                case 2: goto Lab;
                case 3: goto Laf;
                default: goto L5e;
            }
        L5e:
            goto L18
        L5f:
            java.lang.String r0 = "TOASTED SUB"
            goto L1a
        L62:
            java.lang.String r0 = "JELLY BELLY"
            goto L1a
        L65:
            java.lang.String r0 = "YUK!"
            goto L1a
        L68:
            java.lang.String r0 = "STING!"
            goto L1a
        L6b:
            java.lang.String r0 = "ERGH!"
            goto L1a
        L6e:
            java.lang.String r0 = "TASTES LIKE CHICKEN"
            goto L1a
        L71:
            java.lang.String r0 = "MAN EATER"
            goto L1a
        L74:
            java.lang.String r0 = "HUNK CHUNKS"
            goto L1a
        L77:
            java.lang.String r0 = "ARRRGH!"
            goto L1a
        L7a:
            java.lang.String r0 = "TAKEAWAY"
            goto L1a
        L7d:
            java.lang.String r0 = "BIKINI BAIT"
            goto L1a
        L80:
            java.lang.String r0 = "DINNER DATE"
            goto L1a
        L83:
            java.lang.String r0 = "BURP!"
            goto L1a
        L86:
            java.lang.String r0 = "SCUBA SCOFFING"
            goto L1a
        L89:
            java.lang.String r0 = "SCUBA SNACK"
            goto L1a
        L8c:
            java.lang.String r0 = "AQUALUNCH"
            goto L1a
        L8f:
            java.lang.String r0 = "ROCK THE BOAT"
            goto L1a
        L92:
            java.lang.String r0 = "NEEDS A BIGGER BOAT"
            goto L1a
        L95:
            java.lang.String r0 = "FISHERMAN'S FIEND"
            goto L1a
        L98:
            java.lang.String r0 = "CATCH OF THE DAY"
            goto L1a
        L9b:
            java.lang.String r0 = "MAN BURGER"
            goto L1a
        L9f:
            java.lang.String r0 = "SMASH AND GRAB"
            goto L1a
        La3:
            java.lang.String r0 = "DOWN IN ONE"
            goto L1a
        La7:
            java.lang.String r0 = "FOOT LONG"
            goto L1a
        Lab:
            java.lang.String r0 = "CAN OPENER"
            goto L1a
        Laf:
            java.lang.String r0 = "DAS KAPUT"
            goto L1a
        */
        throw new UnsupportedOperationException("Method not decompiled: com.slg.j2me.game.GameObj.strSingleKill(int, boolean, boolean):java.lang.String");
    }

    public void saveState(DataOutputStream outputStream) {
        try {
            outputStream.writeInt(this.objType);
            outputStream.writeInt(this.hidden ? 1 : 0);
            outputStream.writeInt(this.animSet);
            outputStream.writeInt(this.animState);
            outputStream.writeInt(this.fpAnimStateTime);
            this.animSprite.saveState(outputStream);
            outputStream.writeInt(this.spawner);
            outputStream.writeInt(this.shoal);
            outputStream.writeInt(this.compoundObjType);
            outputStream.writeInt(this.bonusFrame);
            outputStream.writeInt(this.fpPos[0]);
            outputStream.writeInt(this.fpPos[1]);
            outputStream.writeInt(this.fpVel[0]);
            outputStream.writeInt(this.fpVel[1]);
            GameApp.outputStreamWriteIntArray(outputStream, this.fpExtents);
            GameApp.outputStreamWriteIntArray(outputStream, this.fpBasicExtents);
            outputStream.writeInt(this.facingLeft ? 1 : 0);
            outputStream.writeInt(this.fpRot);
            outputStream.writeInt(this.fpScale);
            outputStream.writeInt(this.fpFadeAlpha);
            outputStream.writeInt(this.tintColor);
            outputStream.writeInt(this.fpInitSpeed);
            outputStream.writeInt(this.fpEvadeSpeed);
            outputStream.writeInt(this.fpMoveSpeed);
            outputStream.writeInt(this.fpEvadeTimer);
            outputStream.writeInt(this.fpEvadeDisableTimer);
            outputStream.writeInt(this.fpCollReactBlend);
            outputStream.writeInt(this.tempCollIgnoreFrames);
            outputStream.writeInt(this.fpAnimScaleRate);
            outputStream.writeInt(this.specialSwimAnim);
            outputStream.writeInt(this.fpPuffTimer);
            outputStream.writeInt(this.fpHealth);
            outputStream.writeInt(this.loopCounter);
            outputStream.writeInt(this.loopCounterType);
            outputStream.writeInt(this.numGibsSpawned);
            outputStream.writeInt(this.aiState);
            outputStream.writeInt(this.fpAIHomePos[0]);
            outputStream.writeInt(this.fpAIHomePos[1]);
            outputStream.writeInt(this.fpAIWanderRangeX);
            outputStream.writeInt(this.fpAIWanderRangeY);
            outputStream.writeInt(this.fpAIWanderPhaseX);
            outputStream.writeInt(this.fpAIWanderPhaseY);
            outputStream.writeInt(game.getGameObjSaveID(this.aiTargetObj));
            outputStream.writeInt(this.fpAIMaxChaseRange);
            outputStream.writeInt(this.fpFireDelay);
            outputStream.writeInt(this.fpAIMiscTimer);
            outputStream.writeInt(this.aiMiscData);
            outputStream.writeInt(game.getGameObjSaveID(this.detachedChild));
            outputStream.writeInt(game.getGameObjSaveID(this.detachedParent));
            outputStream.writeInt(this.fpShoalRadiusPhase);
            outputStream.writeInt(this.fpShoalRotPhase);
            outputStream.writeInt(this.fpJoltPhase);
            outputStream.writeInt(this.fpJoltScale);
            outputStream.writeInt(this.joltLock ? 1 : 0);
        } catch (Exception e) {
        }
    }

    public static void saveStaticVars(DataOutputStream outputStream) {
        try {
            outputStream.writeInt(fpPlayerMouthPos[0]);
            outputStream.writeInt(fpPlayerMouthPos[1]);
            outputStream.writeInt(fpPlayerLastGoodPos[0]);
            outputStream.writeInt(fpPlayerLastGoodPos[1]);
            outputStream.writeInt(fpPlayerRotCalcVel[0]);
            outputStream.writeInt(fpPlayerRotCalcVel[1]);
            outputStream.writeInt(playerShakeCount);
            outputStream.writeInt(playerNumShakesRequired);
            outputStream.writeInt(sharkLevel);
            outputStream.writeInt(fpSharkLevelFrac);
            outputStream.writeInt(fpPlayerChargeTime);
            outputStream.writeInt(fpPlayerChargeLevel);
            outputStream.writeInt(fpPlayerChargeFactor);
            outputStream.writeInt(fpPlayerChargeScale);
            outputStream.writeInt(playerChargeLock ? 1 : 0);
            outputStream.writeInt(fpPlayerNoBreachTimer);
            outputStream.writeInt(fpPlayerShakeSpeedScale);
            outputStream.writeInt(fpPlayerDeathFallSpeed);
            outputStream.writeInt(playerNumBonusItemsCollected);
            outputStream.writeInt(playerWhichBonusItemsCollected);
            outputStream.writeInt(fpPlayerPoisonTimeRemaining);
            outputStream.writeInt(fpPlayerDamageTintTimeRemaining);
            outputStream.writeInt(fpBeachedTextLockTimer);
            outputStream.writeInt(playerBeached ? 1 : 0);
            outputStream.writeInt(playerTotalEaten);
        } catch (Exception e) {
        }
    }

    public void loadState(DataInputStream inputStream) {
        try {
            this.objType = inputStream.readInt();
            this.hidden = inputStream.readInt() != 0;
            this.animSet = inputStream.readInt();
            this.animState = inputStream.readInt();
            this.fpAnimStateTime = inputStream.readInt();
            this.animSprite.loadState(inputStream, AnimData.animSets[this.animSet]);
            this.spawner = inputStream.readInt();
            this.shoal = inputStream.readInt();
            this.compoundObjType = inputStream.readInt();
            this.bonusFrame = inputStream.readInt();
            this.fpPos[0] = inputStream.readInt();
            this.fpPos[1] = inputStream.readInt();
            this.fpVel[0] = inputStream.readInt();
            this.fpVel[1] = inputStream.readInt();
            GameApp.inputStreamReadIntArray(inputStream, this.fpExtents);
            GameApp.inputStreamReadIntArray(inputStream, this.fpBasicExtents);
            this.facingLeft = inputStream.readInt() != 0;
            this.fpRot = inputStream.readInt();
            this.fpScale = inputStream.readInt();
            this.fpFadeAlpha = inputStream.readInt();
            this.tintColor = inputStream.readInt();
            this.fpInitSpeed = inputStream.readInt();
            this.fpEvadeSpeed = inputStream.readInt();
            this.fpMoveSpeed = inputStream.readInt();
            this.fpEvadeTimer = inputStream.readInt();
            this.fpEvadeDisableTimer = inputStream.readInt();
            this.fpCollReactBlend = inputStream.readInt();
            this.tempCollIgnoreFrames = inputStream.readInt();
            this.fpAnimScaleRate = inputStream.readInt();
            this.specialSwimAnim = inputStream.readInt();
            this.fpPuffTimer = inputStream.readInt();
            this.fpHealth = inputStream.readInt();
            this.loopCounter = inputStream.readInt();
            this.loopCounterType = inputStream.readInt();
            this.numGibsSpawned = inputStream.readInt();
            this.aiState = inputStream.readInt();
            this.fpAIHomePos[0] = inputStream.readInt();
            this.fpAIHomePos[1] = inputStream.readInt();
            this.fpAIWanderRangeX = inputStream.readInt();
            this.fpAIWanderRangeY = inputStream.readInt();
            this.fpAIWanderPhaseX = inputStream.readInt();
            this.fpAIWanderPhaseY = inputStream.readInt();
            this.aiTargetObj = game.getGameObjFromSaveID(inputStream.readInt());
            this.fpAIMaxChaseRange = inputStream.readInt();
            this.fpFireDelay = inputStream.readInt();
            this.fpAIMiscTimer = inputStream.readInt();
            this.aiMiscData = inputStream.readInt();
            this.detachedChild = game.getGameObjFromSaveID(inputStream.readInt());
            this.detachedParent = game.getGameObjFromSaveID(inputStream.readInt());
            this.fpShoalRadiusPhase = inputStream.readInt();
            this.fpShoalRotPhase = inputStream.readInt();
            this.fpJoltPhase = inputStream.readInt();
            this.fpJoltScale = inputStream.readInt();
            this.joltLock = inputStream.readInt() != 0;
        } catch (Exception e) {
        }
    }

    public static void loadStaticVars(DataInputStream inputStream) {
        try {
            fpPlayerMouthPos[0] = inputStream.readInt();
            fpPlayerMouthPos[1] = inputStream.readInt();
            fpPlayerLastGoodPos[0] = inputStream.readInt();
            fpPlayerLastGoodPos[1] = inputStream.readInt();
            fpPlayerRotCalcVel[0] = inputStream.readInt();
            fpPlayerRotCalcVel[1] = inputStream.readInt();
            playerShakeCount = inputStream.readInt();
            playerNumShakesRequired = inputStream.readInt();
            sharkLevel = inputStream.readInt();
            fpSharkLevelFrac = inputStream.readInt();
            fpPlayerChargeTime = inputStream.readInt();
            fpPlayerChargeLevel = inputStream.readInt();
            fpPlayerChargeFactor = inputStream.readInt();
            fpPlayerChargeScale = inputStream.readInt();
            playerChargeLock = inputStream.readInt() != 0;
            fpPlayerNoBreachTimer = inputStream.readInt();
            fpPlayerShakeSpeedScale = inputStream.readInt();
            fpPlayerDeathFallSpeed = inputStream.readInt();
            playerNumBonusItemsCollected = inputStream.readInt();
            playerWhichBonusItemsCollected = inputStream.readInt();
            fpPlayerPoisonTimeRemaining = inputStream.readInt();
            fpPlayerDamageTintTimeRemaining = inputStream.readInt();
            fpBeachedTextLockTimer = inputStream.readInt();
            playerBeached = inputStream.readInt() != 0;
            playerTotalEaten = inputStream.readInt();
        } catch (Exception e) {
        }
    }
}
