package com.slg.j2me.game;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gfx.ClipRect;
import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gfx.ImageSet;
import com.slg.j2me.lib.gui.Transition;
import com.slg.j2me.lib.gui.control.ControlHandler;
import com.slg.j2me.lib.gui.control.GuiControl;
import com.slg.j2me.lib.gui.image.AnimImage;
import com.slg.j2me.lib.gui.image.IconImage;
import com.slg.j2me.lib.gui.layout.CellLayout;
import com.slg.j2me.lib.gui.layout.ScreenLayout;
import com.slg.j2me.lib.gui.layout.TextLayout;
import com.slg.j2me.lib.snd.SoundBank;
import java.util.Vector;
import javax.microedition.lcdui.Graphics;
/* JADX INFO: Access modifiers changed from: package-private */
/* loaded from: classes.dex */
public class GameOverScreen extends CellLayout implements ControlHandler {
    public static AnimImage animShark;
    public static ImageSequence gfxShark;
    public static HiscoreEntry hiscoreEntry;
    public static ImageSet isShark;
    public static Transition transShark;
    int time;
    Vector vecBonus;
    public static GuiControl ctrlGameOverReplay = new GuiControl(true);
    public static GuiControl ctrlGameOverReturnToMenu = new GuiControl(true);
    public static TextLayout textEaten = new TextLayout();
    public static int[] fishList = {8, 3, 10, 7, 4, 2, 5, 17, 1, 12, 13, 14, 9, 18, 16, 21};
    public static String[] strFishName = {"Tropical", "Barracuda", "Pelican", "Blowfish", "Sardine", "Tuna", "Sailfish", "Blobfish", "Hunk", "Babe", "Scuba", "Penguin", "Anglerfish", "Sub", "Fisherman", "Hunter"};

    public GameOverScreen() {
        super(2);
        this.time = 0;
        this.vecBonus = new Vector();
        this.controlHandler = this;
        ctrlGameOverReplay.controlImage = new MenuImage(FrontEnd.gfxMenuReplay, 0);
        ctrlGameOverReturnToMenu.controlImage = new MenuImage(FrontEnd.gfxMenuMenu, 0);
        isShark = new ImageSet("/sharkgameover.is", false);
        gfxShark = isShark.getImageSequence("shark-swing");
        animShark = new AnimImage(gfxShark, 6);
        animShark.pingpong = true;
        setRow(0, 1, 2);
        setRow(1, 2, 1);
        textEaten.iLayoutFlags = 1;
        setCell(1, 0, ctrlGameOverReplay, 1, 3);
        setCell(1, 1, ctrlGameOverReturnToMenu, 1, 3);
        layout();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void open() {
        super.open();
        isShark.reloadImages();
        this.controlList.removeAllElements();
        this.vecBonus.removeAllElements();
        int bonus_count = 0;
        for (int i = 0; i < 10; i++) {
            if ((GameObj.playerWhichBonusItemsCollected & (1 << i)) != 0) {
                IconImage bonus = new IconImage(AnimData.animSets[23][0], i);
                bonus.clipRect.y0 = (short) (this.clipRect.h / 2);
                bonus_count++;
                this.vecBonus.addElement(bonus);
            }
        }
        if (bonus_count > 0) {
            animShark.clipRect.y0 = (short) 0;
            addControl(animShark);
            FrontEnd.doTransition(animShark, 20, 2000, 400);
        }
        this.time = 0;
        if (GameLogic.achievements[1] < GameScreen.game.playerScore) {
            SoundBank.sfxPlay(41, true, 100, 0);
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void close() {
        super.close();
        isShark.unloadImages();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void process() {
        super.process();
        this.time += GameApp.fp_deltatime;
        if (this.time > 196608) {
            int bonuses = (this.time - 131072) / 131072;
            if (bonuses >= this.vecBonus.size()) {
                bonuses = this.vecBonus.size();
            }
            for (int b = 0; b < bonuses; b++) {
                IconImage bonus = (IconImage) this.vecBonus.elementAt(b);
                int t = (this.time - 131072) - (b * 131072);
                if (bonus.clipRect.y0 + bonus.clipRect.h < BaseScreen.displayHeight) {
                    int v = (((t ^ t) & 134217728) != 0 ? -((int) (((-t) * t) >> 16)) : (int) ((t * t) >> 16)) * 2;
                    int v2 = v < 0 ? -((-v) >> 16) : v >> 16;
                    ClipRect clipRect = bonus.clipRect;
                    clipRect.y0 = (short) (clipRect.y0 + v2);
                    if (bonus.clipRect.y0 + bonus.clipRect.h >= BaseScreen.displayHeight) {
                        SoundBank.sfxPlay(44, false, 100, 0);
                    }
                } else {
                    bonus.clipRect.y0 = (short) (BaseScreen.displayHeight - bonus.clipRect.h);
                    ClipRect clipRect2 = bonus.clipRect;
                    clipRect2.x0 = (short) (clipRect2.x0 + 1);
                }
            }
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        if (this.time > 196608) {
            int bonuses = (this.time - 131072) / 131072;
            if (bonuses >= this.vecBonus.size()) {
                bonuses = this.vecBonus.size();
            }
            for (int b = 0; b < bonuses; b++) {
                IconImage bonus = (IconImage) this.vecBonus.elementAt(b);
                bonus.paint(g);
            }
        }
        super.paint(g);
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void layout() {
        this.clipRect.w = (short) (BaseScreen.displayWidth / 2);
        this.clipRect.h = (short) ((BaseScreen.displayHeight * 2) / 3);
        this.clipRect.x0 = (short) ((BaseScreen.displayWidth - this.clipRect.w) / 2);
        this.clipRect.y0 = (short) ((BaseScreen.displayHeight - this.clipRect.h) / 2);
        super.layout();
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void pushScreen(ScreenLayout container, boolean transition) {
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void controlExecuted(ScreenLayout container, GuiControl control) {
        SoundBank.sfxPlay(14, false, 100, 0);
        GameScreen gameScreen = GameApp.gameScreen;
        GameLogic game = GameScreen.game;
        if (control == ctrlGameOverReturnToMenu) {
            if (GameScreen.hiscoreplace != -1) {
                hiscoreEntry = new HiscoreEntry("HISCORE #" + (GameScreen.hiscoreplace + 1), false);
                hiscoreEntry.controlHandler = this;
                GameScreen.currentDialog = hiscoreEntry;
            } else {
                game.updateAchsGameOver();
                FrontEnd.instance.popScreen(true);
                GameScreen.currentDialog = null;
                SoundBank.sfxClearSavedLoops();
            }
        }
        if (control == ctrlGameOverReplay) {
            if (GameScreen.hiscoreplace != -1) {
                hiscoreEntry = new HiscoreEntry("HISCORE #" + (GameScreen.hiscoreplace + 1), true);
                hiscoreEntry.controlHandler = this;
                GameScreen.currentDialog = hiscoreEntry;
            } else {
                game.updateAchsGameOver();
                GameScreen.currentDialog = null;
                GameApp.gameScreen.newGame();
            }
        }
        if (hiscoreEntry != null) {
            if (control == hiscoreEntry.ctrlOk) {
                GameApp.hiscoreTable.addHiscore(0, GameScreen.last_score, GameScreen.last_time, GameScreen.strPlayerName);
                game.updateAchsGameOver();
                if (hiscoreEntry.replayOnExit) {
                    GameScreen.currentDialog = null;
                    GameApp.gameScreen.newGame();
                } else {
                    FrontEnd.instance.popScreen(true);
                    GameScreen.currentDialog = null;
                    SoundBank.sfxClearSavedLoops();
                }
            }
            if (control == hiscoreEntry.ctrlEnterName) {
                hiscoreEntry.showKeyboard();
            }
            if (control == hiscoreEntry.keyboard.ctrlOk) {
                hiscoreEntry.hideKeyboard();
            }
        }
    }
}
