package com.slg.j2me.game;

import com.ju6.mms.pdu.CharacterSets;
import com.ju6.mms.pdu.PduPart;
import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gfx.ClipRect;
import com.slg.j2me.lib.gfx.GfxUtils;
import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gfx.ImageSet;
import com.slg.j2me.lib.gui.BitmapFont;
import com.slg.j2me.lib.gui.control.ControlHandler;
import com.slg.j2me.lib.gui.control.GuiControl;
import com.slg.j2me.lib.gui.image.IconImage;
import com.slg.j2me.lib.gui.image.TextImage;
import com.slg.j2me.lib.gui.layout.CellLayout;
import com.slg.j2me.lib.gui.layout.MenuLayout;
import com.slg.j2me.lib.gui.layout.ScreenLayout;
import com.slg.j2me.lib.gui.layout.ScreenStack;
import com.slg.j2me.lib.snd.SoundBank;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.util.Vector;
import javax.microedition.lcdui.Graphics;
/* loaded from: classes.dex */
public class GameScreen extends CellLayout implements ControlHandler {
    public static final int cColMultiplier = 16736352;
    public static final int cGameOverFadeCol = 0;
    public static final int cMultiplierFadeRate = 196608;
    public static final int cPauseFadeDuration = 16384;
    public static GameOverScreen cellGameOver;
    public static ScreenLayout currentDialog;
    public static int displayHeight;
    public static int displayWidth;
    public static BitmapFont fontGame;
    public static BitmapFont fontScore;
    public static int fpMultiplierFade;
    public static GameLogic game;
    public static ImageSequence gfxGuiBoost;
    public static ImageSequence gfxGuiHealth;
    public static ImageSequence gfxGuiMenu;
    public static ImageSequence gfxGuiScore;
    public static ImageSequence gfxGuiTime;
    public static ImageSequence gfxShark;
    public static PowerBarImage iconBoost;
    public static PowerBarImage iconHealth;
    public static ImageSet isGame;
    public static int lastMultiplierDrawn;
    public static TextImage textIntroCount;
    public static TextImage textIntroInfo;
    public static TextImage textIntroMessage;
    public static TextImage textScore;
    public static TextImage textTime;
    int fp_pausefade;
    boolean pauseFadeIn;
    boolean pauseFadeOut;
    ConfirmScreen screenConfirm;
    boolean showIntroCount;
    public static TiledLevel tiledLevel = new TiledLevel();
    public static Water water = null;
    public static Effects effects = null;
    public static boolean loaded = false;
    public static boolean skipDrawFirstFrame = false;
    public static ImageSet[] isAnims = null;
    public static int[] animImageSets = {0, 1, 2, 3, 4, 5};
    public static MenuLayout menuPause = new MenuLayout();
    public static GuiControl ctrlPauseTitle = new GuiControl(false);
    public static GuiControl ctrlPauseResume = new GuiControl(true);
    public static GuiControl ctrlPauseCalibrate = new GuiControl(true);
    public static GuiControl ctrlPauseVibrate = new GuiControl(true);
    public static GuiControl ctrlPauseOptions = new GuiControl(true);
    public static GuiControl ctrlPauseSound = new GuiControl(true);
    public static GuiControl ctrlPauseEndGame = new GuiControl(true);
    public static GuiControl ctrlMenu = new GuiControl(true);
    public static TextImage[] textMultiplier = new TextImage[3];
    public static TextImage[] textHealthLow = new TextImage[5];
    public static int randDeathMsg = 0;
    public static String strPlayerName = "PLAYER";
    public static int fpFullScreenFade = 0;
    public static final int cFullScreenFadeCol = FrontEnd.colFade & 16777215;
    public static int fpGameFade = 0;
    public static final int cPauseFadeCol = cFullScreenFadeCol;
    public static int fpFlashTimer = 0;
    public static boolean fastFlash = false;
    public static int fpFastFlashTimer = 0;
    public static int eatTextOffset = 0;
    public static int numFixedEatText = 0;
    public static int hiscoreplace = -1;
    public static int last_time = -1;
    public static int last_score = -1;
    static Vector vecEatText = new Vector();
    static int[] tempRect = new int[4];
    static int[] tempPos = new int[2];

    public GameScreen() {
        super(2);
        this.fp_pausefade = 0;
        this.pauseFadeIn = false;
        this.pauseFadeOut = false;
        this.screenConfirm = new ConfirmScreen("End Game", "Are you sure?");
        setRow(0, 4, -1);
        setRow(1, 1, 1);
        this.controlHandler = this;
        displayWidth = BaseScreen.displayWidth;
        displayHeight = BaseScreen.displayHeight;
        game = new GameLogic();
        water = Water.instance;
        effects = Effects.instance;
        isGame = new ImageSet("/game.is", false);
        gfxGuiHealth = isGame.getImageSequence("health");
        gfxGuiTime = isGame.getImageSequence("time");
        gfxGuiScore = isGame.getImageSequence("score");
        gfxGuiMenu = isGame.getImageSequence("menu");
        gfxGuiBoost = isGame.getImageSequence("boost");
        ctrlMenu.controlImage = new IconImage(gfxGuiMenu, 0);
        textTime = new TextImage(fontScore, "0:00");
        textScore = new TextImage(fontScore, "00000");
        iconHealth = new PowerBarImage(gfxGuiHealth);
        iconBoost = new PowerBarImage(gfxGuiBoost);
        textIntroMessage = new TextImage(fontGame, "");
        textIntroCount = new TextImage(fontGame, "");
        textIntroInfo = new TextImage(FrontEnd.font, "");
        textMultiplier[0] = new TextImage(fontGame, "X2");
        textMultiplier[1] = new TextImage(fontGame, "X4");
        textMultiplier[2] = new TextImage(fontGame, "X8");
        textHealthLow[0] = new TextImage(fontGame, "STARVING!");
        textHealthLow[1] = new TextImage(fontGame, "CRITICAL!");
        textHealthLow[2] = new TextImage(fontGame, "SHARK FIN SOUP!");
        textHealthLow[3] = new TextImage(fontGame, "SLEEP WITH THE FISHES!");
        textHealthLow[4] = new TextImage(fontGame, "BOTTOM OF THE FOOD CHAIN!");
        for (int i = 0; i < 5; i++) {
            ClipRect cr = textHealthLow[i].clipRect;
            cr.x0 = (short) ((displayWidth - cr.w) >> 1);
            cr.y0 = (short) (displayHeight / 3);
        }
        setCell(0, 0, ctrlMenu, -1, 3);
        setCell(0, 1, textTime, 1, 3);
        setCell(0, 2, textScore, 1, 3);
        setCell(0, 3, iconHealth, 1, 3);
        addControl(iconBoost);
        layout();
        int numAnimImageSets = animImageSets.length;
        isAnims = new ImageSet[numAnimImageSets];
        for (int i2 = 0; i2 < numAnimImageSets; i2++) {
            isAnims[i2] = new ImageSet(AnimData.imageSetNames[animImageSets[i2]], false);
        }
        gfxShark = isAnims[0].getImageSequence("shark-swim");
        isAnims[0].reloadImages();
        for (int i3 = 0; i3 < animImageSets.length; i3++) {
            AnimData.initAnimImageSet(animImageSets[i3], isAnims[i3]);
        }
        ctrlPauseTitle.controlImage = new TextImage(fontGame, "PAUSE");
        ctrlPauseResume.controlImage = new MenuImage(FrontEnd.gfxMenuResume, 0);
        ctrlPauseOptions.controlImage = new MenuImage(FrontEnd.gfxMenuOptions, 0);
        ctrlPauseEndGame.controlImage = new MenuImage(FrontEnd.gfxMenuEndGame, 0);
        menuPause.addControl(ctrlPauseTitle);
        menuPause.addControl(ctrlPauseResume);
        menuPause.addControl(ctrlPauseOptions);
        menuPause.addControl(ctrlPauseEndGame);
        updateMenuHeight(menuPause);
        menuPause.layout();
        menuPause.open();
        cellGameOver = new GameOverScreen();
        loaded = true;
    }

    public static boolean isPaused() {
        return currentDialog != null;
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void layout() {
        super.layout();
        displayWidth = BaseScreen.displayWidth;
        displayHeight = BaseScreen.displayHeight;
        iconBoost.clipRect.x0 = (short) ((iconHealth.clipRect.x0 + ((iconHealth.clipRect.w - iconBoost.clipRect.w) / 2)) - 2);
        iconBoost.clipRect.y0 = (short) (iconHealth.clipRect.y0 + iconHealth.clipRect.h + 2);
        for (int i = 0; i < 3; i++) {
            ClipRect cr = textMultiplier[i].clipRect;
            cr.x0 = (short) ((displayWidth - cr.w) - 5);
            cr.y0 = (short) ((displayHeight - cr.h) - 5);
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void open() {
        if (game.gameState != 2) {
            FrontEnd.instance.popPreviousScreen();
            newGame();
        }
        super.open();
        reload();
        if (GameApp.continueGameAvailable) {
            FrontEnd.instance.popPreviousScreen();
            GameApp.continueGameAvailable = false;
            GameApp.loadGame(false);
            GameApp.calibrateSensor();
            GameLogic.firstTimeCalibrate = false;
            skipDrawFirstFrame = true;
        }
        currentDialog = null;
        this.fp_pausefade = 16384;
        this.pauseFadeOut = false;
        this.pauseFadeIn = false;
        fpGameFade = 0;
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void close() {
        super.close();
        if (ScreenStack.nextScreen != FrontEnd.screenOptions) {
            unload();
        }
    }

    public void reload() {
        tiledLevel.reload();
        isGame.reloadImages();
        for (int i = 1; i < isAnims.length; i++) {
            isAnims[i].reloadImages();
        }
        effects.reload();
    }

    public void unload() {
        try {
            isGame.unloadImages();
            for (int i = 1; i < isAnims.length; i++) {
                isAnims[i].unloadImages();
            }
            effects.unload();
            tiledLevel.unload();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void updateMenuHeight(MenuLayout menu) {
        menu.clipRect.h = (short) 32;
        menu.clipRect.w = (short) 0;
        for (int i = 0; i < menu.controlList.size(); i++) {
            GuiControl control = (GuiControl) menu.controlList.elementAt(i);
            if (!control.hidden) {
                ClipRect clipRect = menu.clipRect;
                clipRect.h = (short) (clipRect.h + ((control.clipRect.h * 3) / 2));
                if (control.clipRect.w > menu.clipRect.w) {
                    menu.clipRect.w = (short) (control.clipRect.w * 2);
                }
            }
        }
        menu.clipRect.x0 = (short) ((displayWidth - menu.clipRect.w) / 2);
        menu.clipRect.y0 = (short) ((displayHeight - menu.clipRect.h) / 2);
        menu.layout();
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void pushScreen(ScreenLayout container, boolean transition) {
        currentDialog = container;
        if (currentDialog.controlHandler == null) {
            currentDialog.controlHandler = this;
        }
        if (currentDialog instanceof MenuLayout) {
            updateMenuHeight((MenuLayout) currentDialog);
        } else {
            currentDialog.clipRect.w = (short) BaseScreen.displayWidth;
            currentDialog.clipRect.h = (short) BaseScreen.displayHeight;
        }
        currentDialog.open();
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void controlExecuted(ScreenLayout container, GuiControl control) {
        SoundBank.sfxPlay(14, false, 100, 0);
        if (control == ctrlMenu && game.gameState == 2) {
            if (currentDialog == null) {
                pushScreen(menuPause, true);
                this.fp_pausefade = 0;
                this.pauseFadeIn = true;
            } else {
                this.fp_pausefade = 0;
                this.pauseFadeOut = true;
            }
        }
        if (control == ctrlPauseEndGame) {
            pushScreen(this.screenConfirm, true);
        }
        if (control == ctrlPauseOptions) {
            FrontEnd.instance.pushScreen(FrontEnd.screenOptions, true);
        }
        if (control == this.screenConfirm.ctrlYes) {
            game.gameState = 3;
            setIntroText("", 0, false);
            FrontEnd.instance.popScreen(true);
            this.fp_pausefade = 0;
            this.pauseFadeOut = true;
            SoundBank.sfxClearSavedLoops();
        }
        if (control == this.screenConfirm.ctrlNo || control == ctrlPauseResume) {
            this.fp_pausefade = 0;
            this.pauseFadeOut = true;
        }
    }

    public void newGame() {
        hiscoreplace = -1;
        tiledLevel.loadLevel("/level1.bin");
        fpMultiplierFade = 0;
        lastMultiplierDrawn = -1;
        eatTextOffset = 0;
        numFixedEatText = 0;
        textScore.setText(GameApp.formatNumber(0, 5, '0'));
        game.newGame();
        GameObj.refreshHealthBarSize();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void process() {
        if (!GameApp.isLoading) {
            super.process();
            if (currentDialog != null) {
                currentDialog.process();
            }
            if (!isPaused()) {
                game.process();
                effects.process();
                water.process();
                tiledLevel.process();
                setTimeText(game.gameTime / CharacterSets.UCS2);
                updateFlashing();
            }
        }
    }

    public void updateFlashing() {
        int dt = GameApp.fp_deltatime;
        fpFastFlashTimer += dt;
        if (fpFastFlashTimer > 16384) {
            fpFastFlashTimer = 0;
            fastFlash = !fastFlash;
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        if (skipDrawFirstFrame) {
            skipDrawFirstFrame = false;
            g.setColor(FrontEnd.colFade);
            g.fillRect(0, 0, displayWidth, displayHeight);
            return;
        }
        water.paint(g);
        drawGameObjects(g);
        tiledLevel.drawTiles(g, 0);
        effects.paint(g);
        AnimSprite.resetTintColor(g);
        water.paintWaterDepth(g);
        water.paintOverlays(g);
        drawEatText(g);
        drawDebugStuff(g);
        drawGameFade(g);
        if (game.gameState != 3) {
            super.paint(g);
            drawMultiplier(g);
        }
        if (game.gameState != 3 || game.gameSubState == 0) {
            drawHealthWarning(g);
        }
        drawDialog(g);
        drawFullScreenFade(g);
        drawIntroText(g);
    }

    public void drawGameObjects(Graphics g) {
        for (int i = 0; i < 6; i++) {
            GameObj[] drawList = game.gameObjDrawList[i];
            int numDraw = game.numDrawObj[i];
            for (int j = 0; j < numDraw; j++) {
                drawList[j].paint(g);
            }
        }
        AnimSprite.resetTintColor(g);
    }

    public void drawFullScreenFade(Graphics g) {
        if (fpFullScreenFade != 0) {
            int alpha = fpFullScreenFade * 255 < 0 ? -((-(fpFullScreenFade * 255)) >> 16) : (fpFullScreenFade * 255) >> 16;
            if (FrontEnd.imgBackground != null) {
                g.setBlendColor((alpha << 24) | 16777215);
                g.drawRegionStretched(FrontEnd.imgBackground, 0, 0, FrontEnd.imgBackground.getWidth(), FrontEnd.imgBackground.getHeight(), 0, 0, 0, BaseScreen.displayWidth, BaseScreen.displayHeight, 13);
                g.setBlendColor(-1);
                return;
            }
            g.setColor(cFullScreenFadeCol | (alpha << 24));
            g.fillRect(0, 0, displayWidth, displayHeight);
        }
    }

    public void drawGameFade(Graphics g) {
        int fadeCol;
        if (fpGameFade != 0) {
            int fadeCol2 = (fpGameFade * 255 < 0 ? -((-(fpGameFade * 255)) >> 16) : (fpGameFade * 255) >> 16) << 24;
            if (game.gameState == 3) {
                fadeCol = fadeCol2 | 0;
            } else {
                fadeCol = fadeCol2 | cPauseFadeCol;
            }
            g.setColor(fadeCol);
            g.fillRect(0, 0, displayWidth, displayHeight);
        }
    }

    public void drawDialog(Graphics g) {
        if (currentDialog != null) {
            if (this.fp_pausefade < 16384) {
                this.fp_pausefade += GameApp.fp_deltatime;
            } else {
                if (this.pauseFadeOut) {
                    currentDialog = null;
                    this.pauseFadeOut = false;
                }
                if (this.pauseFadeIn) {
                    this.pauseFadeIn = false;
                }
            }
            int t = (int) ((this.fp_pausefade << 16) / 16384);
            if (t < 0) {
                t = 0;
            } else if (t > 65536) {
                t = 65536;
            }
            if (this.pauseFadeIn) {
                int alpha = t * 255 < 0 ? -((-(t * 255)) >> 16) : (t * 255) >> 16;
                fpGameFade = t >> 1;
                g.setBlendColor((alpha << 24) | 16777215);
            }
            if (this.pauseFadeOut) {
                int alpha2 = (65536 - t) * 255 < 0 ? -((-((65536 - t) * 255)) >> 16) : ((65536 - t) * 255) >> 16;
                fpGameFade = (65536 - t) >> 1;
                g.setBlendColor((alpha2 << 24) | 16777215);
            }
            if (currentDialog != null) {
                if (FrontEnd.imgBox != null && !(currentDialog instanceof VirtualKeyboard)) {
                    g.drawRegionStretched(FrontEnd.imgBox, 0, 0, FrontEnd.imgBox.getWidth(), FrontEnd.imgBox.getHeight(), 0, currentDialog.clipRect.x0, currentDialog.clipRect.y0, currentDialog.clipRect.w, currentDialog.clipRect.h, 13);
                }
                currentDialog.paint(g);
            }
            g.setBlendColor(-1);
        }
    }

    public void drawMultiplier(Graphics g) {
        int idx;
        switch (game.scoreMultiplier) {
            case 1:
                idx = -1;
                break;
            case 2:
                idx = 0;
                break;
            case 3:
            case 5:
            case 6:
            case 7:
            default:
                idx = -1;
                break;
            case 4:
                idx = 1;
                break;
            case 8:
                idx = 2;
                break;
        }
        if (idx >= 0 && fpMultiplierFade < 65536) {
            fpMultiplierFade += ((GameApp.fp_deltatime ^ 196608) & 134217728) != 0 ? -((int) (((-196608) * GameApp.fp_deltatime) >> 16)) : (int) ((196608 * GameApp.fp_deltatime) >> 16);
            fpMultiplierFade = 65536 < fpMultiplierFade ? 65536 : fpMultiplierFade;
        } else if (idx == -1 && fpMultiplierFade > 0) {
            fpMultiplierFade -= ((GameApp.fp_deltatime ^ 196608) & 134217728) != 0 ? -((int) (((-196608) * GameApp.fp_deltatime) >> 16)) : (int) ((196608 * GameApp.fp_deltatime) >> 16);
            if (fpMultiplierFade <= 0) {
                fpMultiplierFade = 0;
            } else {
                idx = lastMultiplierDrawn;
            }
        }
        if (idx != -1) {
            int col = ((fpMultiplierFade * 255 < 0 ? -((-(fpMultiplierFade * 255)) >> 16) : (fpMultiplierFade * 255) >> 16) << 24) | cColMultiplier;
            g.setBlendColor(col);
            textMultiplier[idx].paint(g);
            lastMultiplierDrawn = idx;
            g.setBlendColor(-1);
        }
    }

    public void drawHealthWarning(Graphics g) {
        int drawIdx;
        GameLogic gameLogic = game;
        if (GameLogic.player.fpHealth <= 0) {
            drawIdx = randDeathMsg + 2;
        } else {
            GameLogic gameLogic2 = game;
            if (GameLogic.player.fpHealth < GameObj.cfpHealthWarningLevelCritical) {
                drawIdx = 1;
            } else {
                GameLogic gameLogic3 = game;
                if (GameLogic.player.fpHealth < GameObj.cfpHealthWarningLevelLow) {
                    drawIdx = 0;
                } else {
                    return;
                }
            }
        }
        if (drawIdx >= 2 || fastFlash) {
            if (game.gameState == 3) {
                GameLogic gameLogic4 = game;
                g.setBlendColor(GameLogic.player.animSprite.tintColor);
            }
            textHealthLow[drawIdx].paint(g);
            g.setBlendColor(-1);
        }
    }

    public void setHealthBarPerc(int n) {
        iconHealth.setValue(n);
    }

    public void setHealthBarSizePerc(int n) {
        iconHealth.max_value = n + 1;
    }

    public void setBoostBarPerc(int n) {
        iconBoost.setValue(n);
    }

    public void setScoreText(int n) {
        if (last_score != n) {
            last_score = n;
            int newplace = GameApp.hiscoreTable.getHiscorePlace(0, n);
            if (newplace != hiscoreplace) {
                addEatTextMessage("Hiscore #" + (newplace + 1) + "!\nScore: " + n, -256);
                hiscoreplace = newplace;
            }
            textScore.setText(GameApp.formatNumber(n, 5, '0'));
        }
    }

    public void setTimeText(int seconds) {
        if (last_time != seconds) {
            last_time = seconds;
            int secs = seconds % 60;
            int mins = seconds / 60;
            textTime.setText("" + mins + ":" + (secs < 10 ? "0" + secs : Integer.valueOf(secs)));
        }
    }

    public void addEatText(int points, String pointsText) {
        int t;
        if (points != 0) {
            int[] iArr = tempPos;
            GameLogic gameLogic = game;
            GameObj gameObj = GameLogic.player;
            TiledLevel.worldToScreenPos(iArr, GameObj.fpPlayerMouthPos);
            if ((65536 * points) / PduPart.P_CONTENT_TRANSFER_ENCODING < 0) {
                t = 0;
            } else {
                t = (65536 * points) / PduPart.P_CONTENT_TRANSFER_ENCODING > 131072 ? 131072 : (65536 * points) / PduPart.P_CONTENT_TRANSFER_ENCODING;
            }
            EatText eat = new EatText(fontGame, pointsText, t < 65536 ? GfxUtils.lerpColour(t, -16732161, -16711936) : GfxUtils.lerpColour(t - 65536, -16711936, -20736), GameLogic.randRange(-16, 16) + (tempPos[0] - tiledLevel.m_x), GameLogic.randRange(-16, 16) + ((tempPos[1] + eatTextOffset) - tiledLevel.m_y), false);
            vecEatText.addElement(eat);
            eatTextOffset += 32;
        }
    }

    public void addEatTextMessage(String message, int col) {
        EatText eat = new EatText(fontGame, message, col, (displayWidth / 2) - tiledLevel.m_x, ((displayHeight / 2) + eatTextOffset) - tiledLevel.m_y, false);
        vecEatText.addElement(eat);
        eatTextOffset += 32;
    }

    public void addEatTextMessageFixed(String message, int col) {
        EatText eat = new EatText(fontGame, message, col, displayWidth / 2, (displayHeight / 4) + (numFixedEatText * 32), true);
        vecEatText.addElement(eat);
        numFixedEatText++;
    }

    public void drawEatText(Graphics g) {
        int i = 0;
        while (i < vecEatText.size()) {
            EatText eat = (EatText) vecEatText.elementAt(i);
            eat.paint(g);
            if (eat.time > eat.cFadeEnd) {
                if (eat.fixedPos) {
                    numFixedEatText--;
                }
                vecEatText.removeElementAt(i);
                i--;
            }
            i++;
        }
        eatTextOffset = 0;
    }

    public void drawDebugStuff(Graphics g) {
    }

    public void drawIntroText(Graphics g) {
        if (game.gameState != 2) {
            if (currentDialog == null || currentDialog == cellGameOver) {
                textIntroMessage.paint(g);
                if (this.showIntroCount) {
                    if (game.gameState == 3) {
                        fpFlashTimer += GameApp.fp_deltatime;
                        if (fpFlashTimer > 65536) {
                            fpFlashTimer = 0;
                        }
                        if (fpFlashTimer > 32768) {
                            return;
                        }
                    }
                    textIntroCount.paint(g);
                    if (GameLogic.firstTimeCalibrate) {
                        textIntroInfo.paint(g);
                    }
                }
            }
        }
    }

    public void setIntroText(String text, int counter, boolean showCounter) {
        textIntroMessage.setText(text);
        textIntroMessage.clipRect.x0 = (short) ((displayWidth - textIntroMessage.clipRect.w) >> 1);
        textIntroMessage.clipRect.y0 = (short) ((displayHeight - textIntroMessage.clipRect.h) >> 1);
        this.showIntroCount = showCounter;
        if (showCounter) {
            textIntroCount.setText("" + counter);
            textIntroCount.clipRect.x0 = (short) ((displayWidth - textIntroCount.clipRect.w) >> 1);
            textIntroCount.clipRect.y0 = (short) (textIntroMessage.clipRect.y0 + textIntroMessage.clipRect.h + 4);
            if (GameLogic.firstTimeCalibrate) {
                int y = textIntroCount.clipRect.y0 + textIntroCount.clipRect.h;
                textIntroInfo.setText("Hold device in a comfortable position.");
                textIntroInfo.clipRect.x0 = (short) ((displayWidth - textIntroInfo.clipRect.w) >> 1);
                textIntroInfo.clipRect.y0 = (short) ((((displayHeight - y) - textIntroInfo.clipRect.h) / 2) + y);
                return;
            }
            return;
        }
        textIntroMessage.clipRect.y0 = (short) (textIntroMessage.clipRect.y0 + textIntroMessage.clipRect.h + 4);
    }

    public void setGameOverText(int score, boolean highScore) {
        textIntroMessage.setText("SCORE:   " + GameLogic.formatNumber(score));
        textIntroMessage.clipRect.x0 = (short) ((displayWidth - textIntroMessage.clipRect.w) >> 1);
        textIntroMessage.clipRect.y0 = (short) ((displayHeight - textIntroMessage.clipRect.h) >> 1);
        this.showIntroCount = highScore;
        if (highScore) {
            textIntroCount.setText("HIGH SCORE!");
            textIntroCount.clipRect.x0 = (short) ((displayWidth - textIntroCount.clipRect.w) >> 1);
            textIntroCount.clipRect.y0 = (short) (textIntroMessage.clipRect.y0 - (textIntroCount.clipRect.h + 4));
        }
    }

    public void pushGameOverMenu() {
        pushScreen(cellGameOver, true);
        this.fp_pausefade = 0;
        this.pauseFadeIn = true;
    }

    protected void saveGame(DataOutputStream dataStream) {
        try {
            dataStream.writeBoolean(true);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    protected void loadGame(DataInputStream inputStream) {
        try {
            boolean savedGame = inputStream.readBoolean();
            if (savedGame) {
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
