package com.slg.j2me.game;

import com.ju6.mms.pdu.CharacterSets;
import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gui.BitmapFont;
import com.slg.j2me.lib.gui.control.ControlHandler;
import com.slg.j2me.lib.gui.control.GuiControl;
import com.slg.j2me.lib.gui.image.AnimImage;
import com.slg.j2me.lib.gui.image.TextImage;
import com.slg.j2me.lib.gui.image.TextLayoutImage;
import com.slg.j2me.lib.gui.layout.CellLayout;
import com.slg.j2me.lib.gui.layout.ScreenLayout;
import com.slg.j2me.lib.gui.layout.TextLayout;
import com.slg.j2me.lib.snd.SoundBank;
import com.slg.j2me.lib.sys.Application;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.j2meImage;
/* JADX INFO: Access modifiers changed from: package-private */
/* loaded from: classes.dex */
public class HiscoreScreen extends CellLayout implements ControlHandler {
    static final int cHiscoreTableSize = 8;
    public static final int eActionDownloadBuddies = 3;
    public static final int eActionDownloadGlobal = 2;
    public static final int eActionNone = 0;
    public static final int eActionUpload = 1;
    AnimImage animDoingShit;
    CellLayout cellButtons;
    GuiControl ctrlAchievements;
    GuiControl ctrlBuddies;
    GuiControl ctrlDialogCancel;
    GuiControl ctrlDialogEnterName;
    GuiControl ctrlDialogEnterNameCancel;
    GuiControl ctrlDialogOK;
    GuiControl ctrlFacebookConnect;
    GuiControl ctrlFindMe;
    GuiControl ctrlFindTop;
    GuiControl ctrlGlobal;
    GuiControl ctrlLocal;
    GuiControl ctrlNext;
    GuiControl ctrlPrev;
    GuiControl ctrlUpload;
    int currentTable;
    j2meImage imgBackground;
    VirtualKeyboard keyboard;
    String keyboardText;
    boolean keyboardVisible;
    TextLayout onlineScoreDialog;
    int queuedAction;
    int readTableIndex;
    boolean requestFindMe;
    String[] scoreNamesBuddies;
    String[] scoreNamesGlobal;
    int[] scorePositionBuddies;
    int[] scorePositionGlobal;
    int[] scoreTimesBuddies;
    int[] scoreTimesGlobal;
    int[] scoresBuddies;
    int[] scoresGlobal;
    TextLayoutImage textHighScore;
    TextLayoutImage textHiscoreName;
    TextLayoutImage textHiscoreNameTitle;
    TextLayoutImage textHiscorePlace;
    TextLayoutImage textHiscorePlaceTitle;
    TextLayoutImage textHiscoreScore;
    TextLayoutImage textHiscoreScoreTitle;
    TextLayoutImage textHiscoreTime;
    TextLayoutImage textHiscoreTimeTitle;
    TextImage textHiscoreTitle;
    TextLayoutImage textRanking;
    boolean uploadingName;
    public static int colTableBorder = -16777216;
    public static int colSelected = -9763713;
    public static int colDark = -16037210;
    public static int colLight = -15706445;
    public static int globalPosition = -1;

    public HiscoreScreen() {
        super(4);
        this.ctrlLocal = new GuiControl(true);
        this.ctrlGlobal = new GuiControl(true);
        this.ctrlBuddies = new GuiControl(true);
        this.cellButtons = new CellLayout(5);
        this.ctrlAchievements = new GuiControl(true);
        this.ctrlUpload = new GuiControl(true);
        this.ctrlFindTop = new GuiControl(true);
        this.ctrlFindMe = new GuiControl(true);
        this.ctrlPrev = new GuiControl(true);
        this.ctrlNext = new GuiControl(true);
        this.ctrlFacebookConnect = new GuiControl(true);
        this.scoresGlobal = new int[8];
        this.scoresBuddies = new int[8];
        this.scoreTimesGlobal = new int[8];
        this.scoreTimesBuddies = new int[8];
        this.scoreNamesGlobal = new String[8];
        this.scoreNamesBuddies = new String[8];
        this.scorePositionGlobal = new int[1];
        this.scorePositionBuddies = new int[1];
        this.onlineScoreDialog = new TextLayout();
        this.ctrlDialogCancel = new GuiControl(true);
        this.ctrlDialogOK = new GuiControl(true);
        this.ctrlDialogEnterName = new GuiControl(true);
        this.ctrlDialogEnterNameCancel = new GuiControl(true);
        this.keyboardVisible = false;
        this.currentTable = 0;
        this.queuedAction = 0;
        setRow(0, 3, 2);
        setRow(1, 6, 2);
        setRow(2, 6, 8);
        setRow(3, 4, 2);
        this.controlHandler = this;
        this.cellButtons.setRow(0, 1, 1);
        this.cellButtons.setRow(1, 1, 1);
        this.cellButtons.setRow(2, 1, 1);
        this.cellButtons.setRow(3, 1, 1);
        this.cellButtons.setRow(4, 1, 0);
        this.cellButtons.controlHandler = this;
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void open() {
        updateHiscores(0);
        this.queuedAction = 0;
        this.requestFindMe = false;
        this.uploadingName = false;
        super.open();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void layout() {
        super.layout();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void close() {
        super.close();
    }

    public void setupHiscoreScreen() {
        BitmapFont font = FrontEnd.font;
        BitmapFont fontSmall = FrontEnd.fontSmall;
        this.animDoingShit = new AnimImage(FrontEnd.gfxProgress, 12);
        this.textHiscoreTitle = new TextImage(GameScreen.fontGame, "HI SCORES");
        this.textHiscorePlaceTitle = new TextLayoutImage(128, font, "Rank");
        this.textHiscoreScoreTitle = new TextLayoutImage(128, font, "Score");
        this.textHiscoreTimeTitle = new TextLayoutImage(128, font, "Time");
        this.textHiscoreNameTitle = new TextLayoutImage(128, font, "Name");
        this.textHiscorePlace = new TextLayoutImage(3, fontSmall, "1\n2\n3\n4\n5\n6\n7\n8\n");
        this.textHiscoreScore = new TextLayoutImage(3, fontSmall, "10,000\n8,000\n6,000\n5,000\n4,000\n3,000\n2,000\n1,000\n");
        this.textHiscoreTime = new TextLayoutImage(3, fontSmall, "20:00\n15:00\n12:00\n10:00\n8:00\n7:00\n5:00\n3:00\n");
        this.textHiscoreName = new TextLayoutImage(3, fontSmall, "IAN\nCHRIS\nMATT\nPAUL\nKRIS\nROB\nLINDSAY\nFONZ\n");
        this.ctrlLocal.controlImage = new MenuImage(FrontEnd.gfxMenuLocal, 0);
        this.ctrlGlobal.controlImage = new MenuImage(FrontEnd.gfxMenuGlobal, 0);
        this.ctrlBuddies.controlImage = new MenuImage(FrontEnd.gfxMenuBuddies, 0);
        this.ctrlLocal.autoHighlight = false;
        this.ctrlGlobal.autoHighlight = false;
        this.ctrlBuddies.autoHighlight = false;
        setCell(0, 0, this.ctrlLocal, 1, 3);
        setCell(0, 1, this.ctrlGlobal, 1, 3);
        setCell(0, 2, null, 0, 0);
        setCell(1, 0, null, 1, 0);
        setCell(1, 1, this.textHiscorePlaceTitle, 2, 3);
        setCell(1, 2, this.textHiscoreScoreTitle, 3, 3);
        setCell(1, 3, this.textHiscoreTimeTitle, 1, 3);
        setCell(1, 4, this.textHiscoreNameTitle, 4, 3);
        setCell(1, 5, null, 1, 0);
        setCell(2, 0, null, 1, 0);
        setCell(2, 1, this.textHiscorePlace, 2, 0);
        setCell(2, 2, this.textHiscoreScore, 3, 0);
        setCell(2, 3, this.textHiscoreTime, 1, 0);
        setCell(2, 4, this.textHiscoreName, 4, 0);
        setCell(2, 5, null, 1, 0);
        setCell(3, 0, null, 2, 0);
        setCell(3, 1, this.ctrlPrev, 1, 3);
        setCell(3, 2, this.ctrlNext, 1, 3);
        setCell(3, 3, null, 2, 0);
        this.ctrlAchievements.controlImage = new MenuImage(FrontEnd.gfxMenuAchievements, 0);
        this.ctrlUpload.controlImage = new MenuImage(FrontEnd.gfxMenuUpload, 0);
        this.ctrlFindTop.controlImage = new MenuImage(FrontEnd.gfxMenuFindTop, 0);
        this.ctrlFindMe.controlImage = new MenuImage(FrontEnd.gfxMenuFindMe, 0);
        this.ctrlPrev.controlImage = new MenuImage(FrontEnd.gfxTipsPrev, 0);
        this.ctrlNext.controlImage = new MenuImage(FrontEnd.gfxTipsNext, 0);
        this.ctrlFacebookConnect.controlImage = new TextImage(fontSmall, "Facebook");
        this.cellButtons.setCell(0, 0, this.ctrlAchievements, 1, 3);
        this.cellButtons.setCell(1, 0, this.ctrlUpload, 1, 3);
        this.cellButtons.setCell(2, 0, this.ctrlFindTop, 1, 3);
        this.cellButtons.setCell(3, 0, this.ctrlFindMe, 1, 3);
        this.cellButtons.setCell(4, 0, null, 0, 0);
        this.cellButtons.layout();
        this.ctrlDialogCancel.controlImage = new MenuImage(FrontEnd.gfxMenuCancel, 0);
        this.ctrlDialogOK.controlImage = new MenuImage(FrontEnd.gfxMenuOk, 0);
        this.ctrlDialogEnterName.controlImage = new MenuImage(FrontEnd.gfxMenuEnterName, 0);
        this.ctrlDialogEnterNameCancel.controlImage = new MenuImage(FrontEnd.gfxMenuCancel, 0);
        this.keyboard = new VirtualKeyboard(10);
        updateHiscores(0);
        layout();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        if (FrontEnd.imgBox != null) {
            g.drawRegionStretched(FrontEnd.imgBox, 0, 0, FrontEnd.imgBox.getWidth(), FrontEnd.imgBox.getHeight(), 0, this.clipRect.x0 + 8, this.clipRect.y0 - 6, this.clipRect.w - 18, this.clipRect.h + 22, 13);
        }
        if (globalPosition != -1 && this.currentTable != 0) {
            int x0 = this.clipRect.x0 + this.textHiscorePlace.clipRect.x0;
            int y0 = this.clipRect.y0 + this.textHiscorePlace.clipRect.y0 + (globalPosition * FrontEnd.fontSmall.getFontHeight()) + 2;
            int w = this.clipRect.w - 60;
            int h = FrontEnd.fontSmall.getFontHeight();
            g.setColor(2130771967);
            g.fillRect(x0, y0, w, h);
        }
        super.paint(g);
    }

    public void updateHiscores(int t) {
        int secs;
        BitmapFont fontSmall = FrontEnd.fontSmall;
        String strScores = "";
        String strTimes = "";
        String strNames = "";
        HiscoreTable table = GameApp.hiscoreTable;
        int firstPos = 1;
        if (t == 1) {
            firstPos = this.scorePositionGlobal[0];
        } else if (t == 2) {
            firstPos = this.scorePositionBuddies[0];
        }
        for (int i = 0; i < 8; i++) {
            int units = table.getScore(t, i);
            int thousands = units / CharacterSets.UCS2;
            int units2 = units % CharacterSets.UCS2;
            if (thousands > 0) {
                strScores = strScores + "" + thousands + "," + Application.formatNumber(units2, 3, '0') + "\n";
            } else {
                strScores = strScores + "" + units2 + "\n";
            }
            int secs2 = table.getTime(t, i);
            int mins = secs2 / 60;
            strTimes = strTimes + "" + mins + ":" + (secs2 % 60 < 10 ? "0" + secs : Integer.valueOf(secs)) + "\n";
            strNames = strNames + "" + table.getName(t, i) + "\n";
        }
        String positions = "";
        for (int i2 = 0; i2 < 8; i2++) {
            positions = positions + "" + (firstPos + i2) + "\n";
        }
        this.textHiscorePlace.setText(fontSmall, positions);
        this.textHiscoreScore.setText(fontSmall, strScores);
        this.textHiscoreTime.setText(fontSmall, strTimes);
        this.textHiscoreName.setText(fontSmall, strNames);
        this.textHiscorePlace.initialise();
        this.textHiscoreScore.initialise();
        this.textHiscoreTime.initialise();
        this.textHiscoreName.initialise();
        ((MenuImage) this.ctrlLocal.controlImage).image = t == 0 ? 1 : 0;
        ((MenuImage) this.ctrlGlobal.controlImage).image = t == 1 ? 1 : 0;
        ((MenuImage) this.ctrlBuddies.controlImage).image = t == 2 ? 1 : 0;
        setCell(1, 3, this.textHiscoreTimeTitle, 2, 3);
        setCell(2, 3, this.textHiscoreTime, 2, 0);
        this.ctrlFindTop.greyed = t == 0 || firstPos == 1;
        this.ctrlFindMe.greyed = t == 0 || globalPosition != -1;
        layout();
        layout();
        this.currentTable = t;
        this.ctrlUpload.greyed = !FrontEnd.canUploadHiScore;
        this.ctrlPrev.greyed = true;
        this.ctrlNext.greyed = true;
        this.ctrlFacebookConnect.greyed = ScoreloopManager.isConnectedToFacebook();
    }

    public void clearHiscores() {
        BitmapFont fontSmall = FrontEnd.fontSmall;
        this.textHiscorePlace.setText(fontSmall, "1\n2\n3\n4\n5\n6\n7\n8\n");
        this.textHiscoreScore.setText(fontSmall, "");
        this.textHiscoreTime.setText(fontSmall, "");
        this.textHiscoreName.setText(fontSmall, "");
        this.textHiscorePlace.initialise();
        this.textHiscoreScore.initialise();
        this.textHiscoreTime.initialise();
        this.textHiscoreName.initialise();
        ((MenuImage) this.ctrlLocal.controlImage).image = 0;
        ((MenuImage) this.ctrlGlobal.controlImage).image = 0;
        ((MenuImage) this.ctrlBuddies.controlImage).image = 0;
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void controlExecuted(ScreenLayout container, GuiControl control) {
        SoundBank.sfxPlay(14, false, 100, 0);
        if (control == this.ctrlLocal) {
            updateHiscores(0);
        }
        if (control == this.ctrlGlobal) {
            clearHiscores();
            if (ScoreloopManager.state != 0) {
                setupDialogDownloading();
                FrontEnd.instance.pushDialog(this.onlineScoreDialog);
                if (ScoreloopManager.cancelRequest) {
                    this.queuedAction = 2;
                } else {
                    this.readTableIndex = 1;
                    globalPosition = -1;
                    ScoreloopManager.downloadScoresGlobal(this.scoresGlobal, this.scoreTimesGlobal, this.scoreNamesGlobal, this.scorePositionGlobal, this.requestFindMe);
                }
            }
        }
        if (control == this.ctrlBuddies) {
            clearHiscores();
            if (ScoreloopManager.state != 0) {
                setupDialogDownloading();
                FrontEnd.instance.pushDialog(this.onlineScoreDialog);
                if (ScoreloopManager.cancelRequest) {
                    this.queuedAction = 3;
                } else {
                    this.readTableIndex = 2;
                    globalPosition = -1;
                    ScoreloopManager.downloadScoresBuddies(this.scoresBuddies, this.scoreTimesBuddies, this.scoreNamesBuddies, this.scorePositionBuddies, this.requestFindMe);
                }
            }
        }
        if (control == this.ctrlPrev && ScoreloopManager.state == 1) {
            clearHiscores();
            setupDialogDownloading();
            FrontEnd.instance.pushDialog(this.onlineScoreDialog);
            this.readTableIndex = this.currentTable;
            ScoreloopManager.downloadPreviousPage();
        }
        if (control == this.ctrlNext && ScoreloopManager.state == 1) {
            clearHiscores();
            setupDialogDownloading();
            FrontEnd.instance.pushDialog(this.onlineScoreDialog);
            this.readTableIndex = this.currentTable;
            ScoreloopManager.downloadNextPage();
        }
        if (control == this.ctrlAchievements) {
            FrontEnd.instance.pushScreen(FrontEnd.screenAchievements, true);
        }
        if (control == this.ctrlUpload) {
            int score = GameLogic.achievements[1];
            if (ScoreloopManager.state != 0) {
                if (score == 0) {
                    setupDialogScore0();
                    FrontEnd.instance.pushDialog(this.onlineScoreDialog);
                } else {
                    setupDialogUploading();
                    FrontEnd.instance.pushDialog(this.onlineScoreDialog);
                    if (ScoreloopManager.cancelRequest) {
                        this.queuedAction = 1;
                    } else {
                        this.uploadingName = false;
                        int scoreTime = findPlayerTime();
                        ScoreloopManager.uploadScore(score, scoreTime);
                    }
                }
            }
        }
        if (control == this.ctrlFindMe) {
            this.requestFindMe = true;
            controlExecuted(container, this.currentTable == 1 ? this.ctrlGlobal : this.ctrlBuddies);
        }
        if (control == this.ctrlFindTop) {
            this.requestFindMe = false;
            controlExecuted(container, this.currentTable == 1 ? this.ctrlGlobal : this.ctrlBuddies);
        }
        if (control == this.ctrlFacebookConnect) {
            setupDialogConnecting();
            FrontEnd.instance.pushDialog(this.onlineScoreDialog);
            ScoreloopManager.facebookConnect();
        }
        if (control == this.ctrlDialogCancel) {
            FrontEnd.instance.popDialog();
            if (ScoreloopManager.state != 0) {
                this.queuedAction = 0;
                ScoreloopManager.cancelRequest = true;
                updateHiscores(0);
            }
        }
        if (control == this.ctrlDialogOK) {
            FrontEnd.instance.popDialog();
        }
        if (control == this.ctrlDialogEnterNameCancel) {
            FrontEnd.instance.popDialog();
        }
        if (control == this.ctrlDialogEnterName) {
            this.keyboardText = findPlayerName();
            showKeyboard();
        }
        if (container == this.keyboard) {
            hideKeyboard();
            setupDialogUploading();
            String name = this.keyboardText;
            updatePlayerName(name);
            this.uploadingName = true;
            ScoreloopManager.updateUserName(name);
        }
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void pushScreen(ScreenLayout container, boolean transition) {
    }

    public void setupDialogCommon() {
        this.onlineScoreDialog.iLayoutFlags = 3;
        this.onlineScoreDialog.clearText();
        this.onlineScoreDialog.clipRect.x0 = (short) (BaseScreen.displayWidth >> 2);
        this.onlineScoreDialog.clipRect.y0 = (short) (BaseScreen.displayHeight >> 2);
        this.onlineScoreDialog.clipRect.w = (short) (BaseScreen.displayWidth >> 1);
        this.onlineScoreDialog.clipRect.h = (short) (BaseScreen.displayHeight >> 1);
        this.onlineScoreDialog.controlHandler = this;
    }

    public void setupDialogUploading() {
        setupDialogCommon();
        this.onlineScoreDialog.addControl(this.animDoingShit);
        this.onlineScoreDialog.formatText(FrontEnd.font, "\nUploading...\n");
        this.onlineScoreDialog.addControl(this.ctrlDialogCancel);
        this.onlineScoreDialog.layout();
    }

    public void setupDialogDownloading() {
        setupDialogCommon();
        this.onlineScoreDialog.addControl(this.animDoingShit);
        this.onlineScoreDialog.formatText(FrontEnd.font, "\nDownloading...\n");
        this.onlineScoreDialog.addControl(this.ctrlDialogCancel);
        this.onlineScoreDialog.layout();
    }

    public void setupDialogConnecting() {
        setupDialogCommon();
        this.onlineScoreDialog.addControl(this.animDoingShit);
        this.onlineScoreDialog.formatText(FrontEnd.font, "\nConnecting to Facebook...");
        this.onlineScoreDialog.layout();
    }

    public void setupDialogSuccess() {
        setupDialogCommon();
        this.onlineScoreDialog.formatText(FrontEnd.font, "Success\n");
        this.onlineScoreDialog.addControl(this.ctrlDialogOK);
        this.onlineScoreDialog.layout();
    }

    public void setupDialogFailure(int reason) {
        setupDialogCommon();
        this.onlineScoreDialog.formatText(FrontEnd.font, "Failed\n");
        this.onlineScoreDialog.formatText(FrontEnd.font, "Reason: " + getFailReasonText(reason) + "\n");
        this.onlineScoreDialog.addControl(this.ctrlDialogOK);
        this.onlineScoreDialog.layout();
    }

    public void setupDialogNameTaken() {
        setupDialogCommon();
        this.onlineScoreDialog.formatText(FrontEnd.font, "Score uploaded, but user name already taken:\n");
        this.onlineScoreDialog.formatText(FrontEnd.font, findPlayerName() + "\n");
        this.onlineScoreDialog.addControl(this.ctrlDialogEnterName);
        this.onlineScoreDialog.addControl(this.ctrlDialogEnterNameCancel);
        this.onlineScoreDialog.layout();
    }

    public void setupDialogScore0() {
        setupDialogCommon();
        this.onlineScoreDialog.formatText(FrontEnd.font, "Highest score is 0!\n");
        this.onlineScoreDialog.addControl(this.ctrlDialogOK);
        this.onlineScoreDialog.layout();
    }

    public void showKeyboard() {
        this.keyboardVisible = true;
        this.keyboard.strText = this.keyboardText;
        this.keyboard.textEdit.textKey.setText(this.keyboardText);
        this.keyboard.layout();
        FrontEnd frontEnd = FrontEnd.instance;
        FrontEnd.currentDialog = this.keyboard;
    }

    public void hideKeyboard() {
        this.keyboardText = this.keyboard.strText;
        this.keyboardVisible = false;
        layout();
        FrontEnd frontEnd = FrontEnd.instance;
        FrontEnd.currentDialog = this.onlineScoreDialog;
    }

    public void processDialog() {
        switch (ScoreloopManager.state) {
            case 5:
                HiscoreTable table = GameApp.hiscoreTable;
                int[] scores = this.readTableIndex == 1 ? this.scoresGlobal : this.scoresBuddies;
                int[] times = this.readTableIndex == 1 ? this.scoreTimesGlobal : this.scoreTimesBuddies;
                String[] names = this.readTableIndex == 1 ? this.scoreNamesGlobal : this.scoreNamesBuddies;
                for (int i = 0; i < scores.length; i++) {
                    table.setScore(this.readTableIndex, i, scores[i]);
                    table.setTime(this.readTableIndex, i, times[i]);
                    table.setName(this.readTableIndex, i, names[i]);
                }
                updateHiscores(this.readTableIndex);
                ScoreloopManager.state = 1;
                FrontEnd.instance.popDialog();
                if (ScoreloopManager.hasPreviousPage()) {
                    this.ctrlPrev.greyed = false;
                }
                if (ScoreloopManager.hasNextPage()) {
                    this.ctrlNext.greyed = false;
                    return;
                }
                return;
            case 6:
                ScoreloopManager.state = 1;
                updateHiscores(0);
                setupDialogFailure(ScoreloopManager.failReason);
                return;
            case 7:
            case 10:
                ScoreloopManager.state = 1;
                switch (this.queuedAction) {
                    case 1:
                        int score = GameLogic.achievements[1];
                        this.uploadingName = false;
                        int scoreTime = findPlayerTime();
                        ScoreloopManager.uploadScore(score, scoreTime);
                        break;
                    case 2:
                        this.readTableIndex = 1;
                        globalPosition = -1;
                        ScoreloopManager.downloadScoresGlobal(this.scoresGlobal, this.scoreTimesGlobal, this.scoreNamesGlobal, this.scorePositionGlobal, this.requestFindMe);
                        break;
                    case 3:
                        this.readTableIndex = 2;
                        globalPosition = -1;
                        ScoreloopManager.downloadScoresBuddies(this.scoresBuddies, this.scoreTimesBuddies, this.scoreNamesBuddies, this.scorePositionBuddies, this.requestFindMe);
                        break;
                }
                this.queuedAction = 0;
                return;
            case 8:
                ScoreloopManager.state = 1;
                boolean finished = false;
                if (this.uploadingName) {
                    finished = true;
                    this.uploadingName = false;
                } else {
                    String name = findPlayerName();
                    this.uploadingName = true;
                    ScoreloopManager.updateUserName(name);
                }
                if (finished) {
                    FrontEnd.canUploadHiScore = false;
                    this.ctrlUpload.greyed = true;
                    if (this.currentTable == 0) {
                        FrontEnd.instance.popDialog();
                        return;
                    }
                    setupDialogDownloading();
                    this.readTableIndex = this.currentTable;
                    globalPosition = -1;
                    if (this.currentTable == 1) {
                        ScoreloopManager.downloadScoresGlobal(this.scoresGlobal, this.scoreTimesGlobal, this.scoreNamesGlobal, this.scorePositionGlobal, this.requestFindMe);
                        return;
                    } else if (this.currentTable == 2) {
                        ScoreloopManager.downloadScoresBuddies(this.scoresBuddies, this.scoreTimesBuddies, this.scoreNamesBuddies, this.scorePositionBuddies, this.requestFindMe);
                        return;
                    } else {
                        return;
                    }
                }
                return;
            case 9:
                ScoreloopManager.state = 1;
                updateHiscores(0);
                if (this.uploadingName) {
                    if (ScoreloopManager.failReason == 5) {
                        setupDialogNameTaken();
                    } else {
                        setupDialogFailure(ScoreloopManager.failReason);
                    }
                    this.uploadingName = false;
                    return;
                }
                setupDialogFailure(ScoreloopManager.failReason);
                return;
            case 11:
                ScoreloopManager.state = 1;
                setupDialogSuccess();
                this.ctrlFacebookConnect.greyed = ScoreloopManager.isConnectedToFacebook();
                return;
            case 12:
                ScoreloopManager.state = 1;
                setupDialogFailure(ScoreloopManager.failReason);
                this.ctrlFacebookConnect.greyed = ScoreloopManager.isConnectedToFacebook();
                return;
            default:
                return;
        }
    }

    public String findPlayerName() {
        int score = GameLogic.achievements[1];
        if (score == 0) {
            return "";
        }
        HiscoreTable t = GameApp.hiscoreTable;
        for (int i = 0; i < 8; i++) {
            if (score == t.getScore(0, i)) {
                return t.getName(0, i);
            }
        }
        return "";
    }

    public int findPlayerTime() {
        int score = GameLogic.achievements[1];
        if (score == 0) {
            return 0;
        }
        HiscoreTable t = GameApp.hiscoreTable;
        for (int i = 0; i < 8; i++) {
            if (score == t.getScore(0, i)) {
                return t.getTime(0, i);
            }
        }
        return 0;
    }

    public void updatePlayerName(String name) {
        int score = GameLogic.achievements[1];
        if (score != 0) {
            HiscoreTable t = GameApp.hiscoreTable;
            for (int i = 0; i < 8; i++) {
                if (score == t.getScore(0, i)) {
                    t.setName(0, i, name);
                    if (this.currentTable == 0) {
                        updateHiscores(0);
                    }
                    GameScreen.strPlayerName = name;
                    return;
                }
            }
        }
    }

    public String getFailReasonText(int reason) {
        switch (reason) {
            case 1:
                return "Network Error";
            case 2:
                return "Request cancelled";
            case 3:
                return "Email address already taken";
            case 4:
                return "Invalid format for email address";
            case 5:
                return "User name already taken";
            case 6:
                return "menu.online.fail.reason.invalidcredentials$";
            default:
                return "Unknown";
        }
    }
}
