package com.slg.j2me.game;

import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gui.image.IconImage;
import com.slg.j2me.lib.sys.Application;
import com.slg.j2me.lib.sys.FixedPoint;
import javax.microedition.lcdui.Graphics;
import javax.microedition.midlet.SimpleGLRenderer;
/* loaded from: classes.dex */
public class MenuImage extends IconImage {
    static int count = 0;
    int border;
    int bounce_time;

    public MenuImage(ImageSequence _imgSeq, int _image) {
        super(_imgSeq, _image);
        this.border = 0;
        this.bounce_time = 0;
        int i = count;
        count = i + 1;
        this.bounce_time = i * 16384;
    }

    @Override // com.slg.j2me.lib.gui.image.IconImage, com.slg.j2me.lib.gui.control.GuiContainer
    public void initialise() {
        if (this.imgSeq != null) {
            this.clipRect.w = (short) (this.imgSeq.getRectWidth(this.image) + (this.border * 2));
            this.clipRect.h = (short) (this.imgSeq.getRectHeight(this.image) + (this.border * 2));
        }
    }

    @Override // com.slg.j2me.lib.gui.image.IconImage, com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        this.bounce_time += Application.fp_deltatime / 4;
        while (this.bounce_time < 0) {
            this.bounce_time += 65537;
        }
        while (this.bounce_time > 65536) {
            this.bounce_time -= 65537;
        }
        int fp_scale = 65536 + (FixedPoint.sinLut(this.bounce_time * SimpleGLRenderer.cMaxResID) / 8);
        this.imgSeq.drawImageRotated(g, this.image, (this.clipRect.w / 2) + this.clipRect.x0, (this.clipRect.h / 2) + this.clipRect.y0, 0, fp_scale, 0);
    }
}
