package com.slg.j2me.game;

import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gfx.ImageSet;
import com.slg.j2me.lib.gui.control.ControlHandler;
import com.slg.j2me.lib.gui.control.GuiControl;
import com.slg.j2me.lib.gui.image.IconImage;
import com.slg.j2me.lib.gui.image.TextImage;
import com.slg.j2me.lib.gui.layout.CellLayout;
import com.slg.j2me.lib.gui.layout.ScreenLayout;
import com.slg.j2me.lib.snd.SoundBank;
import com.slg.j2me.lib.sys.VecMath;
import javax.microedition.lcdui.Graphics;
/* JADX INFO: Access modifiers changed from: package-private */
/* loaded from: classes.dex */
public class OptionsScreen extends CellLayout implements ControlHandler {
    public static TextImage textTitle;
    private ImageSequence gfxDot;
    private ImageSequence gfxTank;
    private ImageSet isFishTank;
    public static GuiControl ctrlCalibrate = new GuiControl(true);
    public static GuiControl ctrlVibrate = new GuiControl(true);
    public static GuiControl ctrlSound = new GuiControl(true);
    public static SliderControl ctrlSensitivity = new SliderControl(true);
    private static int[] fpTilt = new int[2];

    public OptionsScreen() {
        super(4);
        setRow(0, 1, 1);
        setRow(1, 2, 2);
        setRow(2, 2, 2);
        setRow(3, 2, 2);
        this.isFishTank = new ImageSet("/fishtank.is", false);
        this.gfxTank = this.isFishTank.getImageSequence("circle");
        this.gfxDot = this.isFishTank.getImageSequence("dot");
        textTitle = new TextImage(GameScreen.fontGame, "OPTIONS");
        ctrlCalibrate.controlImage = new MenuImage(FrontEnd.gfxMenuCalibrate, 0);
        ctrlSound.controlImage = new MenuImage(FrontEnd.sound ? FrontEnd.gfxMenuSoundOn : FrontEnd.gfxMenuSoundOff, 0);
        ctrlVibrate.controlImage = new MenuImage(FrontEnd.vibration ? FrontEnd.gfxMenuVibOn : FrontEnd.gfxMenuVibOff, 0);
        ctrlSensitivity.controlImage = new IconImage(FrontEnd.gfxMenuSliderRail, 0);
        ctrlSensitivity.buttonImage = new IconImage(FrontEnd.gfxMenuSliderButton, 0);
        ctrlSensitivity.textLabel = new TextImage(FrontEnd.font, "Tilt Sensitivity");
        setCell(0, 0, textTitle, 1, 3);
        setCell(1, 0, ctrlSound, 1, 3);
        setCell(2, 0, ctrlVibrate, 1, 3);
        setCell(3, 0, ctrlCalibrate, 1, 3);
        setCell(1, 1, null, 3, 3);
        setCell(2, 1, null, 3, 3);
        setCell(3, 1, ctrlSensitivity, 3, 3);
        this.controlHandler = this;
        layout();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void open() {
        super.open();
        ctrlSensitivity.fp_value = GameScreen.game.fpControlSensitivity;
        this.isFishTank.reloadImages();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void close() {
        super.close();
        this.isFishTank.unloadImages();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void process() {
        super.process();
        GameScreen.game.refreshControlTilt();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        int i;
        int i2;
        int x0 = (this.clipRect.x0 + (this.clipRect.w / 3)) - 16;
        int y0 = this.clipRect.y0 + (this.clipRect.h / 4);
        int iw = ((this.clipRect.w * 2) / 3) - 16;
        int ih = (this.clipRect.h * 2) / 4;
        int fpSensitivity = 65536 + GameScreen.game.fpControlSensitivity;
        int[] iArr = fpTilt;
        if ((((GameScreen.game.fpControlTiltX ^ fpSensitivity) & 134217728) != 0 ? -((int) (((-GameScreen.game.fpControlTiltX) * fpSensitivity) >> 16)) : (int) ((GameScreen.game.fpControlTiltX * fpSensitivity) >> 16)) < -8192) {
            i = -8192;
        } else {
            i = (((GameScreen.game.fpControlTiltX ^ fpSensitivity) & 134217728) != 0 ? -((int) ((((long) (-GameScreen.game.fpControlTiltX)) * ((long) fpSensitivity)) >> 16)) : (int) ((((long) GameScreen.game.fpControlTiltX) * ((long) fpSensitivity)) >> 16)) > 8192 ? 8192 : ((GameScreen.game.fpControlTiltX ^ fpSensitivity) & 134217728) != 0 ? -((int) (((-GameScreen.game.fpControlTiltX) * fpSensitivity) >> 16)) : (int) ((GameScreen.game.fpControlTiltX * fpSensitivity) >> 16);
        }
        iArr[0] = i << 3;
        int[] iArr2 = fpTilt;
        if ((((GameScreen.game.fpControlTiltY ^ fpSensitivity) & 134217728) != 0 ? -((int) (((-GameScreen.game.fpControlTiltY) * fpSensitivity) >> 16)) : (int) ((GameScreen.game.fpControlTiltY * fpSensitivity) >> 16)) < -8192) {
            i2 = -8192;
        } else {
            i2 = (((GameScreen.game.fpControlTiltY ^ fpSensitivity) & 134217728) != 0 ? -((int) ((((long) (-GameScreen.game.fpControlTiltY)) * ((long) fpSensitivity)) >> 16)) : (int) ((((long) GameScreen.game.fpControlTiltY) * ((long) fpSensitivity)) >> 16)) > 8192 ? 8192 : ((GameScreen.game.fpControlTiltY ^ fpSensitivity) & 134217728) != 0 ? -((int) (((-GameScreen.game.fpControlTiltY) * fpSensitivity) >> 16)) : (int) ((GameScreen.game.fpControlTiltY * fpSensitivity) >> 16);
        }
        iArr2[1] = i2 << 3;
        int len = (((fpTilt[0] ^ fpTilt[0]) & 134217728) != 0 ? -((int) (((-fpTilt[0]) * fpTilt[0]) >> 16)) : (int) ((fpTilt[0] * fpTilt[0]) >> 16)) + (((fpTilt[1] ^ fpTilt[1]) & 134217728) != 0 ? -((int) (((-fpTilt[1]) * fpTilt[1]) >> 16)) : (int) ((fpTilt[1] * fpTilt[1]) >> 16));
        if (len > 65536) {
            VecMath.norm2d(fpTilt, fpTilt);
        }
        int vx = (fpTilt[0] * this.gfxTank.getRectWidth(0)) / 2 < 0 ? -((-((fpTilt[0] * this.gfxTank.getRectWidth(0)) / 2)) >> 16) : ((fpTilt[0] * this.gfxTank.getRectWidth(0)) / 2) >> 16;
        int vy = ((-fpTilt[1]) * this.gfxTank.getRectHeight(0)) / 2 < 0 ? -((-(((-fpTilt[1]) * this.gfxTank.getRectHeight(0)) / 2)) >> 16) : (((-fpTilt[1]) * this.gfxTank.getRectHeight(0)) / 2) >> 16;
        if (this.gfxTank != null) {
            this.gfxTank.drawImage(g, 0, ((iw - this.gfxTank.getRectWidth(0)) / 2) + x0, ((ih - this.gfxTank.getRectHeight(0)) / 2) + y0);
            this.gfxDot.drawImage(g, 0, x0 + vx + ((iw - this.gfxDot.getRectWidth(0)) / 2), y0 + vy + ((ih - this.gfxDot.getRectHeight(0)) / 2));
        }
        super.paint(g);
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void controlExecuted(ScreenLayout container, GuiControl control) {
        if (control == ctrlCalibrate) {
            SoundBank.sfxPlay(31, false, 100, 0);
            GameApp.calibrateSensor();
            GameLogic.firstTimeCalibrate = false;
            FrontEnd.firstPlaySinceBoot = false;
        }
        if (control == ctrlVibrate) {
            FrontEnd.instance.controlExecuted(FrontEnd.menuOptions, FrontEnd.controlOptionsVibration);
            ((MenuImage) ctrlVibrate.controlImage).imgSeq = FrontEnd.vibration ? FrontEnd.gfxMenuVibOn : FrontEnd.gfxMenuVibOff;
        }
        if (control == ctrlSound) {
            FrontEnd.instance.controlExecuted(FrontEnd.menuOptions, FrontEnd.controlOptionsSound);
            ((MenuImage) ctrlSound.controlImage).imgSeq = FrontEnd.sound ? FrontEnd.gfxMenuSoundOn : FrontEnd.gfxMenuSoundOff;
        }
        if (control == ctrlSensitivity) {
            GameScreen.game.fpControlSensitivity = ctrlSensitivity.fp_value;
        }
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void pushScreen(ScreenLayout container, boolean transition) {
    }
}
