package com.slg.j2me.game;

import com.scoreloop.client.android.core.controller.RequestController;
import com.scoreloop.client.android.core.controller.RequestControllerObserver;
import com.scoreloop.client.android.core.model.User;
import java.util.List;
/* JADX INFO: Access modifiers changed from: package-private */
/* loaded from: classes.dex */
public class ScoreRequestObserver implements RequestControllerObserver {
    @Override // com.scoreloop.client.android.core.controller.RequestControllerObserver
    public void requestControllerDidFail(RequestController requestController, Exception exception) {
        if (requestController == ScoreloopControllers.instance.scoresController) {
            if (ScoreloopControllers.isRequestCancellation(exception)) {
                ScoreloopManager.failReason = 2;
                ScoreloopManager.state = 6;
                return;
            }
            ScoreloopManager.resetSessionRequest = true;
            ScoreloopManager.failReason = 1;
            ScoreloopManager.state = 6;
        }
    }

    @Override // com.scoreloop.client.android.core.controller.RequestControllerObserver
    public void requestControllerDidReceiveResponse(RequestController aRequestController) {
        if (ScoreloopManager.cancelRequest) {
            ScoreloopManager.state = 7;
            ScoreloopManager.cancelRequest = false;
            return;
        }
        int maxScores = ScoreloopManager.readScores.length;
        List<com.scoreloop.client.android.core.model.Score> scores = ScoreloopControllers.instance.scoresController.getScores();
        int numScores = scores.size();
        ScoreloopManager.readTableStart[0] = ScoreloopControllers.instance.scoresController.getLoadedRange().getLocation() + 1;
        HiscoreScreen.globalPosition = -1;
        String currentUserIdentifier = ScoreloopManager.getCurrentUser().getIdentifier();
        for (int i = 0; i < numScores; i++) {
            com.scoreloop.client.android.core.model.Score score = scores.get(i);
            double dResult = score.getResult().doubleValue();
            double dMinorResult = score.getMinorResult().doubleValue();
            int result = (int) dResult;
            int minorResult = (int) dMinorResult;
            User user = score.getUser();
            String name = user.getLogin();
            ScoreloopManager.readScores[i] = result;
            ScoreloopManager.readTimes[i] = minorResult;
            ScoreloopManager.readNames[i] = name;
            if (user.getIdentifier().equals(currentUserIdentifier)) {
                HiscoreScreen.globalPosition = i;
            }
        }
        if (numScores < maxScores) {
            for (int i2 = numScores; i2 < maxScores; i2++) {
                ScoreloopManager.readScores[i2] = 0;
                ScoreloopManager.readTimes[i2] = 0;
                ScoreloopManager.readNames[i2] = "";
            }
        }
        ScoreloopManager.state = 5;
    }
}
