package com.slg.j2me.game;

import android.content.Context;
import com.scoreloop.client.android.core.model.Client;
import com.scoreloop.client.android.core.model.Range;
import com.scoreloop.client.android.core.model.Session;
import com.scoreloop.client.android.core.model.User;
import com.slg.j2me.lib.sys.Application;
/* loaded from: classes.dex */
abstract class ScoreloopManager {
    public static boolean cancelRequest = false;
    private static Client client = null;
    private static ScoreloopControllers controllers = null;
    public static final int eReasonEmailInvalidFormat = 4;
    public static final int eReasonEmailTaken = 3;
    public static final int eReasonInvalidCredentials = 6;
    public static final int eReasonNetworkError = 1;
    public static final int eReasonNone = 0;
    public static final int eReasonRequestCancel = 2;
    public static final int eReasonUsernameTaken = 5;
    public static final int eStateFacebookConnectFail = 12;
    public static final int eStateFacebookConnectSuccess = 11;
    public static final int eStateFacebookConnecting = 4;
    public static final int eStateInvalid = 0;
    public static final int eStateReadCancel = 7;
    public static final int eStateReadFail = 6;
    public static final int eStateReadSuccess = 5;
    public static final int eStateReading = 2;
    public static final int eStateReady = 1;
    public static final int eStateWriteCancel = 10;
    public static final int eStateWriteFail = 9;
    public static final int eStateWriteSuccess = 8;
    public static final int eStateWriting = 3;
    public static String[] readNames;
    public static int[] readScores;
    public static int[] readTableStart;
    public static int[] readTimes;
    public static boolean resetSessionRequest;
    public static int state = 0;
    public static int failReason = 0;

    ScoreloopManager() {
    }

    public static void init(Context context, String gameID, String gameSecret) {
        if (client == null) {
            try {
                client = new Client(gameID, gameSecret, null);
                Session session = client.getSession();
                session.getDevice().setAndroidContext(context);
                controllers = new ScoreloopControllers(session);
                if (client != null && session != null && controllers != null && !controllers.invalid) {
                    state = 1;
                }
                cancelRequest = false;
                resetSessionRequest = false;
                failReason = 0;
            } catch (Exception e) {
            }
        }
    }

    public static void uploadScore(int score, int time) {
        if (state == 0) {
        }
        if (state == 1 && score != 0) {
            checkResetSession();
            com.scoreloop.client.android.core.model.Score scoreObj = new com.scoreloop.client.android.core.model.Score(new Double(score), null, client.getSession().getUser());
            scoreObj.setMinorResult(new Double(time));
            controllers.scoreController.submitScore(scoreObj);
            state = 3;
        }
    }

    public static void updateUserName(String name) {
        if (state == 1) {
            checkResetSession();
            User user = client.getSession().getUser();
            user.setLogin(name);
            controllers.userController.updateUser();
            state = 3;
        }
    }

    public static boolean downloadScoresGlobal(int[] outScores, int[] outTimes, String[] outNames, int[] outTableStart, boolean showMyPosition) {
        if (state == 0) {
        }
        if (state != 1) {
            return false;
        }
        checkResetSession();
        client.getSession();
        readScores = outScores;
        readTimes = outTimes;
        readNames = outNames;
        readTableStart = outTableStart;
        int numScores = outScores.length;
        controllers.scoresController.setRange(new Range(0, numScores));
        controllers.scoresController.setSearchList(controllers.scoresController.getGlobalSearchList());
        if (showMyPosition) {
            controllers.scoresController.loadRangeForUser(client.getSession().getUser());
        } else {
            controllers.scoresController.loadRange();
        }
        state = 2;
        return true;
    }

    public static boolean downloadScoresBuddies(int[] outScores, int[] outTimes, String[] outNames, int[] outTableStart, boolean showMyPosition) {
        if (state == 0) {
        }
        if (state != 1) {
            return false;
        }
        checkResetSession();
        readScores = outScores;
        readTimes = outTimes;
        readNames = outNames;
        readTableStart = outTableStart;
        int numScores = outScores.length;
        controllers.scoresController.setRange(new Range(0, numScores));
        controllers.scoresController.setSearchList(controllers.scoresController.getBuddiesSearchList());
        if (showMyPosition) {
            controllers.scoresController.loadRangeForUser(client.getSession().getUser());
        } else {
            controllers.scoresController.loadRange();
        }
        state = 2;
        return true;
    }

    public static boolean hasNextPage() {
        return controllers.scoresController.hasNextRange();
    }

    public static boolean hasPreviousPage() {
        return controllers.scoresController.hasPreviousRange();
    }

    public static void downloadNextPage() {
        controllers.scoresController.loadNextRange();
        state = 2;
    }

    public static void downloadPreviousPage() {
        controllers.scoresController.loadPreviousRange();
        state = 2;
    }

    private static void checkResetSession() {
    }

    public static User getCurrentUser() {
        Session session = client.getSession();
        return session.getUser();
    }

    public static void facebookConnect() {
        controllers.facebookController.connect(Application.instance);
        state = 4;
    }

    public static boolean isConnectedToFacebook() {
        return controllers.facebookProvider.isUserConnected(getCurrentUser());
    }
}
