package com.slg.j2me.game;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gui.control.GuiControl;
import com.slg.j2me.lib.gui.image.IconImage;
import com.slg.j2me.lib.gui.image.TextImage;
import com.slg.j2me.lib.gui.layout.ScreenLayout;
import javax.microedition.lcdui.Graphics;
/* loaded from: classes.dex */
class SliderControl extends GuiControl {
    public IconImage buttonImage;
    public int fp_value;
    public TextImage textLabel;

    public SliderControl(boolean _enabled) {
        super(_enabled);
    }

    public SliderControl(ScreenLayout _menu) {
        super(_menu);
    }

    @Override // com.slg.j2me.lib.gui.control.GuiControl, com.slg.j2me.lib.gui.control.GuiContainer
    public void initialise() {
        super.initialise();
    }

    @Override // com.slg.j2me.lib.gui.control.GuiControl, com.slg.j2me.lib.gui.control.GuiContainer
    public void process() {
        int i;
        if (this.buttonImage != null) {
            if (BaseScreen.keysDown(2048)) {
                if (this.buttonImage.isOver(BaseScreen.pointerX, BaseScreen.pointerY) || this.buttonImage.image == 1) {
                    this.buttonImage.image = 1;
                    this.fp_value = ((BaseScreen.pointerX - this.clipRect.x0) * 65536) / this.clipRect.w;
                    if (this.fp_value < 0) {
                        i = 0;
                    } else {
                        i = this.fp_value > 65536 ? 65536 : this.fp_value;
                    }
                    this.fp_value = i;
                    execute();
                }
            } else if (this.controlImage instanceof IconImage) {
                this.buttonImage.image = 0;
            }
            this.buttonImage.clipRect.x0 = (short) ((this.clipRect.x0 + (this.fp_value * this.clipRect.w < 0 ? -((-(this.fp_value * this.clipRect.w)) >> 16) : (this.fp_value * this.clipRect.w) >> 16)) - (this.buttonImage.clipRect.w / 2));
            this.buttonImage.clipRect.y0 = (short) (this.clipRect.y0 + ((this.clipRect.h - this.buttonImage.clipRect.h) / 2));
            if (this.textLabel != null) {
                this.textLabel.clipRect.x0 = (short) (this.clipRect.x0 + ((this.clipRect.w - this.textLabel.clipRect.w) / 2));
                this.textLabel.clipRect.y0 = (short) (this.clipRect.y0 + this.clipRect.h);
            }
        }
    }

    @Override // com.slg.j2me.lib.gui.control.GuiControl, com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        super.paint(g);
        if (this.buttonImage != null) {
            this.buttonImage.paint(g);
        }
        if (this.textLabel != null) {
            this.textLabel.paint(g);
        }
    }
}
