package com.slg.j2me.game;

import com.slg.j2me.lib.sys.FixedPoint;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.lang.reflect.Array;
/* JADX INFO: Access modifiers changed from: package-private */
/* loaded from: classes.dex */
public class Spawner {
    public static final int cFlyingBirdRandomPerc = 10;
    public static final int cMaxBirds = 4;
    public static final int cMaxShoals = 8;
    public static final int cMaxSpawnerUpdate = 100;
    public static final int cMaxSpawners = 450;
    public static final int cfpBirdSpawnActiveTimeMax = 262144;
    public static final int cfpBirdSpawnActiveTimeMin = 196608;
    public static final int cfpBirdSpawnInactiveTimeMax = 1310720;
    public static final int cfpBirdSpawnInactiveTimeMin = 1048576;
    public static final int cfpFlyingBirdHeight = 262144;
    public static final int eNumSpawnObj = 35;
    public static final int eShoalDefFlags = 8;
    public static final int eShoalDefNumAttributes = 9;
    public static final int eShoalDefRadiusRate = 7;
    public static final int eShoalDefRadiusX = 2;
    public static final int eShoalDefRadiusY = 3;
    public static final int eShoalDefRangeX = 0;
    public static final int eShoalDefRangeY = 1;
    public static final int eShoalDefRotRate = 6;
    public static final int eShoalDefSpeedX = 4;
    public static final int eShoalDefSpeedY = 5;
    public static final int eShoalInitNumActive = 4;
    public static final int eShoalNone = 0;
    public static final int eShoalNumAttributes = 7;
    public static final int eShoalPosX = 2;
    public static final int eShoalPosY = 3;
    public static final int eShoalScale = 5;
    public static final int eShoalSimple = 1;
    public static final int eShoalSimpleHorizontal = 3;
    public static final int eShoalSimpleLongRange = 2;
    public static final int eShoalSpawnerID = 0;
    public static final int eShoalSwarm = 4;
    public static final int eShoalTime = 6;
    public static final int eShoalType = 1;
    public static final int eSpawnGroupSizeMax = 3;
    public static final int eSpawnGroupSizeMin = 2;
    public static final int eSpawnMainAnimSet = 0;
    public static final int eSpawnObjAnglerfish = 5;
    public static final int eSpawnObjBarracuda = 2;
    public static final int eSpawnObjBigSub = 12;
    public static final int eSpawnObjBlobfish = 6;
    public static final int eSpawnObjBlowfish = 4;
    public static final int eSpawnObjBonusAmphora = 24;
    public static final int eSpawnObjBonusBoot = 32;
    public static final int eSpawnObjBonusCarTyre = 25;
    public static final int eSpawnObjBonusCrystalSkull = 33;
    public static final int eSpawnObjBonusMoonOnAStick = 26;
    public static final int eSpawnObjBonusNumberPlate = 27;
    public static final int eSpawnObjBonusRoadCone = 28;
    public static final int eSpawnObjBonusShoppingTrolley = 29;
    public static final int eSpawnObjBonusSpaceHelmet = 30;
    public static final int eSpawnObjBonusTrike = 31;
    public static final int eSpawnObjBuoy = 34;
    public static final int eSpawnObjCrab = 7;
    public static final int eSpawnObjFishermanOnBoat = 19;
    public static final int eSpawnObjGiantCrab = 23;
    public static final int eSpawnObjJellyfishGroup = 16;
    public static final int eSpawnObjKnifeScuba = 10;
    public static final int eSpawnObjKnifeScubaGroup = 17;
    public static final int eSpawnObjMine = 22;
    public static final int eSpawnObjPelican = 1;
    public static final int eSpawnObjPenguinGroup = 21;
    public static final int eSpawnObjPlayer = 0;
    public static final int eSpawnObjSailfishGroup = 15;
    public static final int eSpawnObjSardineGroup = 13;
    public static final int eSpawnObjSharkHunterOnBoat = 20;
    public static final int eSpawnObjSmallSub = 11;
    public static final int eSpawnObjSwimmerFemale = 9;
    public static final int eSpawnObjSwimmerMale = 8;
    public static final int eSpawnObjTouristInDinghy = 18;
    public static final int eSpawnObjTropical = 3;
    public static final int eSpawnObjTunaGroup = 14;
    public static final int eSpawnParentAnimSet = 1;
    public static final int eSpawnRandomRadius = 4;
    public static final int eSpawnRespawnTime = 7;
    public static final int eSpawnShoalType = 5;
    public static final int eSpawnStartLevel = 6;
    public static final int eSpawnerDetachedParent = 9;
    public static final int eSpawnerLastUpdateTimeMillis = 7;
    public static final int eSpawnerNumActive = 4;
    public static final int eSpawnerNumAttributes = 10;
    public static final int eSpawnerNumSleeping = 5;
    public static final int eSpawnerNumSpawned = 8;
    public static final int eSpawnerPosX = 1;
    public static final int eSpawnerPosY = 2;
    public static final int eSpawnerState = 3;
    public static final int eSpawnerStateActive = 1;
    public static final int eSpawnerStateDead = 3;
    public static final int eSpawnerStateInvalid = 0;
    public static final int eSpawnerStateWaiting = 2;
    public static final int eSpawnerTimer = 6;
    public static final int eSpawnerType = 0;
    public boolean birdSpawnerActive;
    public int fpBirdSpawnTimer;
    public int fpBubbleSpawnTimer;
    public int nextUpdateIndex;
    public int numActiveBirds;
    public int numSpawners;
    public static final int cfpFishermanBoatOffsetX = FixedPoint.stringToFP("-4.5");
    public static final int cfpFishermanBoatOffsetY = FixedPoint.stringToFP("-2");
    public static final int cfpFishingBoatWaterOffset = FixedPoint.stringToFP("-5");
    public static final int cfpHunterBoatOffsetX = FixedPoint.stringToFP("-6");
    public static final int cfpHunterBoatOffsetY = FixedPoint.stringToFP("-1");
    public static final int cfpHuntingBoatWaterOffset = FixedPoint.stringToFP("-5");
    public static final int cfpBubbleSpawnRate = FixedPoint.stringToFP("2");
    public static final int cfpBubbleSpawnDuration = (int) (4294967296L / cfpBubbleSpawnRate);
    public static final int cfpBubbleSpawnPredictXTime = FixedPoint.stringToFP("2");
    public static GameLogic game = null;
    public static int[][] spawnTable = {new int[]{-1, -1, 0, 0, 0, 0, 0, 0}, new int[]{10, -1, 1, 1, 0, 0, 0, 0}, new int[]{3, -1, 1, 1, 524288, 0, 0, FixedPoint.stringToFP("90")}, new int[]{8, -1, 1, 1, 524288, 0, 0, FixedPoint.stringToFP("85")}, new int[]{7, -1, 1, 1, 524288, 0, 1, FixedPoint.stringToFP("75")}, new int[]{9, -1, 1, 1, 524288, 0, 0, FixedPoint.stringToFP("90")}, new int[]{17, -1, 1, 1, 524288, 0, 0, FixedPoint.stringToFP("130")}, new int[]{-1, -1, 1, 1, 0, 0, 0, 0}, new int[]{1, -1, 1, 1, 524288, 0, 0, FixedPoint.stringToFP("110")}, new int[]{12, -1, 1, 1, 524288, 0, 0, FixedPoint.stringToFP("110")}, new int[]{13, -1, 1, 1, 524288, 0, 2, FixedPoint.stringToFP("75")}, new int[]{18, -1, 1, 1, 524288, 0, 9, FixedPoint.stringToFP("80")}, new int[]{18, -1, 1, 1, 524288, 0, 9, FixedPoint.stringToFP("80")}, new int[]{4, -1, 10, 20, 524288, 4, 0, FixedPoint.stringToFP("80")}, new int[]{2, -1, 3, 8, 524288, 1, 0, FixedPoint.stringToFP("110")}, new int[]{5, -1, 1, 3, 524288, 2, 2, FixedPoint.stringToFP("80")}, new int[]{6, -1, 1, 5, 524288, 3, 0, 1310720}, new int[]{13, -1, 2, 2, 524288, 3, 2, 1966080}, new int[]{-1, -1, 1, 1, 0, 0, 0, 0}, new int[]{16, 15, 1, 1, 0, 0, 3, FixedPoint.stringToFP("100")}, new int[]{21, 22, 1, 1, 0, 0, 5, FixedPoint.stringToFP("80")}, new int[]{14, -1, 2, 3, 524288, 1, 0, FixedPoint.stringToFP("115")}, new int[]{11, -1, 1, 1, 131072, 0, 0, -1}, new int[]{-1, -1, 1, 1, 0, 0, 0, 0}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{23, -1, 1, 1, 0, 0, 0, -1}, new int[]{24, -1, 1, 1, 0, 0, 0, -1}};
    public static int[][] shoalTypeTable = {new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0}, new int[]{1310720, 262144, 786432, 589824, FixedPoint.stringToFP("30"), FixedPoint.stringToFP("23"), GameObj.cfpLungeSpeed, 458752, 0}, new int[]{3932160, 262144, 393216, 262144, FixedPoint.stringToFP("20"), FixedPoint.stringToFP("13"), 0, 0, 0}, new int[]{1310720, 0, 786432, 589824, FixedPoint.stringToFP("60"), 0, 0, 0, 0}, new int[]{655360, 131072, 131072, 98304, FixedPoint.stringToFP("60"), FixedPoint.stringToFP("49"), GameObj.cfpDynamiteRotSpeedWater, 4915200, 0}};
    public int[][] spawners = (int[][]) Array.newInstance(Integer.TYPE, cMaxSpawners, 10);
    public int[][] shoals = (int[][]) Array.newInstance(Integer.TYPE, 8, 7);

    public Spawner() {
        reset();
    }

    public void reset() {
        this.numSpawners = 0;
        this.nextUpdateIndex = 0;
        for (int i = 0; i < 8; i++) {
            this.shoals[i][0] = -1;
        }
        this.fpBubbleSpawnTimer = cfpBubbleSpawnDuration;
        this.numActiveBirds = 0;
        this.birdSpawnerActive = false;
        this.fpBirdSpawnTimer = 1310720;
    }

    public void process() {
        if (this.numSpawners <= 100) {
            for (int i = 0; i < this.numSpawners; i++) {
                updateSpawner(i);
            }
        } else {
            int idx = this.nextUpdateIndex;
            for (int i2 = 0; i2 < 100; i2++) {
                updateSpawner(idx);
                idx++;
                if (idx >= this.numSpawners) {
                    idx = 0;
                }
            }
            this.nextUpdateIndex = idx;
        }
        updateShoals();
        updateBubbleSpawning();
        updateBirdSpawning();
    }

    public void spawnObject(int id, int posX, int posY, int spawner) {
        int[] table = spawnTable[id];
        int mainAnimSet = table[0];
        int parentAnimSet = table[1];
        int groupMin = table[2];
        int groupMax = table[3];
        int spawnRadius = table[4];
        int shoalType = table[5];
        if (mainAnimSet >= 0) {
            int numSpawn = 1;
            if (this.spawners[spawner][5] > 0) {
                numSpawn = this.spawners[spawner][5];
                this.spawners[spawner][5] = 0;
            } else if (groupMax > 1) {
                numSpawn = GameLogic.randRange(groupMin, groupMax);
                this.spawners[spawner][8] = numSpawn;
            }
            int shoalID = -1;
            int shoalRot = 0;
            int shoalRotStep = 0;
            if (shoalType != 0) {
                shoalID = initShoal(spawner, numSpawn);
                shoalRotStep = 16777216 / numSpawn;
            }
            for (int i = 0; i < numSpawn; i++) {
                GameObj obj = game.allocateGameObj();
                int spawnR = GameLogic.randRange(0, spawnRadius);
                int spawnAng = GameLogic.randAngle();
                int spawnX = posX + (((FixedPoint.sinLut(4194304 + spawnAng) ^ spawnR) & 134217728) != 0 ? -((int) (((-spawnR) * FixedPoint.sinLut(4194304 + spawnAng)) >> 16)) : (int) ((spawnR * FixedPoint.sinLut(4194304 + spawnAng)) >> 16));
                int spawnY = posY + (((FixedPoint.sinLut(spawnAng) ^ spawnR) & 134217728) != 0 ? -((int) (((-spawnR) * FixedPoint.sinLut(spawnAng)) >> 16)) : (int) ((spawnR * FixedPoint.sinLut(spawnAng)) >> 16));
                GameScreen gameScreen = GameApp.gameScreen;
                if (GameScreen.tiledLevel.isSolidWorldSpace(spawnX, spawnY)) {
                    spawnX = posX;
                    spawnY = posY;
                }
                if (GameObj.collTestPointVsRect(spawnX, spawnY, game.rectVisible)) {
                    spawnX = posX;
                    spawnY = posY;
                }
                int typeFlags = GameObj.typeData[mainAnimSet][9];
                if ((typeFlags & 9) == 0 && spawnY <= GameObj.cfpWaterHeight) {
                    spawnY = posY;
                }
                if (id == 34) {
                    spawnY = GameObj.cfpWaterHeight - 262144;
                }
                obj.initNewObj(mainAnimSet, spawnX, spawnY, spawner, shoalID);
                if (shoalID != -1) {
                    obj.fpShoalRadiusPhase = GameLogic.randAngle();
                    obj.fpShoalRotPhase = shoalRot;
                    shoalRot += shoalRotStep;
                }
                if (obj.objType == 9) {
                    int bonusID = (id - 24) + 0;
                    obj.initBonusItem(bonusID);
                }
                if (parentAnimSet >= 0) {
                    if (this.spawners[spawner][9] == 0) {
                        GameObj obj2 = game.allocateGameObj();
                        obj2.initNewObj(parentAnimSet, spawnX, spawnY, -1, shoalID);
                        switch (parentAnimSet) {
                            case 15:
                            case 22:
                                int wy = Water.cfpWaterLevel;
                                if (mainAnimSet == 16) {
                                    obj2.fpPos[1] = cfpFishingBoatWaterOffset + wy;
                                    int[] iArr = obj.fpPos;
                                    iArr[0] = iArr[0] + cfpFishermanBoatOffsetX;
                                    obj.fpPos[1] = obj2.fpPos[1] + cfpFishermanBoatOffsetY;
                                } else if (mainAnimSet == 21) {
                                    obj2.fpPos[1] = cfpHuntingBoatWaterOffset + wy;
                                    int[] iArr2 = obj.fpPos;
                                    iArr2[0] = iArr2[0] + cfpHunterBoatOffsetX;
                                    obj.fpPos[1] = obj2.fpPos[1] + cfpHunterBoatOffsetY;
                                }
                                obj.attachToParent(obj2);
                                continue;
                        }
                    } else {
                        switch (mainAnimSet) {
                            case 16:
                            case 21:
                                obj.fpPos[1] = GameObj.cfpWaterHeight + GameObj.cfpFishermanTreadWaterOffsetY;
                                obj.fpVel[0] = 0;
                                obj.fpVel[1] = 0;
                                obj.nextAnimState(2);
                                GameObj obj22 = game.allocateGameObj();
                                obj22.initNewObj(parentAnimSet, spawnX, spawnY, -1, shoalID);
                                int wy2 = Water.cfpWaterLevel;
                                GameLogic gameLogic = game;
                                if (spawnX < GameLogic.player.fpPos[0]) {
                                    int[] iArr3 = obj.fpPos;
                                    iArr3[0] = iArr3[0] - 524288;
                                } else {
                                    int[] iArr4 = obj22.fpPos;
                                    iArr4[0] = iArr4[0] + 524288;
                                }
                                if (mainAnimSet == 16) {
                                    obj22.fpPos[1] = cfpFishingBoatWaterOffset + wy2;
                                } else if (mainAnimSet == 21) {
                                    obj22.fpPos[1] = cfpHuntingBoatWaterOffset + wy2;
                                }
                                obj.detachedParent = obj22;
                                obj22.detachedChild = obj;
                                continue;
                        }
                    }
                }
            }
            int[] iArr5 = this.spawners[spawner];
            iArr5[4] = iArr5[4] + numSpawn;
        }
    }

    public void addSpawner(int id, int posX, int posY) {
        int n = this.numSpawners;
        this.numSpawners = n + 1;
        int[] s = this.spawners[n];
        s[0] = id;
        s[1] = posX;
        s[2] = posY;
        s[3] = 2;
        s[4] = 0;
        s[5] = 0;
        s[6] = 0;
        s[7] = game.gameTime;
        s[8] = 0;
        s[9] = 0;
    }

    private void updateSpawner(int n) {
        int state;
        int[] s = this.spawners[n];
        int dt = (game.gameTime - s[7]) * 66;
        s[7] = game.gameTime;
        int spawnerType = s[0];
        if (spawnerType != 0 && (state = s[3]) != 3) {
            int startLevel = spawnTable[spawnerType][6];
            if (GameObj.sharkLevel >= startLevel) {
                int posX = s[1];
                int posY = s[2];
                if (state == 1) {
                    if (!GameObj.collTestPointVsRect(posX, posY, game.rectCullSpawner)) {
                        s[3] = 2;
                    }
                } else if (state == 2) {
                    int timer = s[6];
                    if (timer > 0) {
                        s[6] = timer - dt < 0 ? 0 : timer - dt;
                    } else if (GameObj.collTestPointVsRect(posX, posY, game.rectActivateSpawner)) {
                        if (s[4] == 0 && !GameObj.collTestPointVsRect(posX, posY, game.rectVisible)) {
                            spawnObject(spawnerType, posX, posY, n);
                        }
                        s[3] = 1;
                    }
                }
            }
        }
    }

    public void notifyObjectDeleted(int n) {
        int[] s = this.spawners[n];
        s[4] = s[4] - 1;
        if (s[4] <= 0 && s[5] == 0) {
            int spawnerType = s[0];
            int fpRespawnTime = spawnTable[spawnerType][7];
            if (fpRespawnTime == -1) {
                s[3] = 3;
            } else {
                s[6] = fpRespawnTime;
            }
            s[9] = 0;
        }
    }

    public void notifyObjectCulled(int n) {
        int[] s = this.spawners[n];
        s[5] = s[5] + 1;
    }

    public void notifyBirdDeleted() {
        this.numActiveBirds--;
    }

    public int getSpawnerState(int n) {
        return this.spawners[n][3];
    }

    private int initShoal(int spawnerID, int numSpawn) {
        for (int i = 0; i < 8; i++) {
            int[] s = this.shoals[i];
            if (s[0] == -1) {
                s[0] = spawnerID;
                int spawnType = this.spawners[spawnerID][0];
                s[1] = spawnTable[spawnType][5];
                s[4] = numSpawn;
                s[6] = 0;
                updateShoal(i);
                s[5] = 65536;
                return i;
            }
        }
        return -1;
    }

    private void updateShoals() {
        for (int i = 0; i < 8; i++) {
            int[] s = this.shoals[i];
            int spawnerID = s[0];
            if (spawnerID != -1) {
                int[] sp = this.spawners[spawnerID];
                if (sp[4] <= 0) {
                    s[0] = -1;
                } else {
                    updateShoal(i);
                }
            }
        }
    }

    private void updateShoal(int n) {
        int[] s = this.shoals[n];
        int spawnerID = s[0];
        int[] sp = this.spawners[spawnerID];
        int time = s[6];
        int[] def = shoalTypeTable[s[1]];
        int fpOffsetX = FixedPoint.sinLut((((def[4] ^ time) & 134217728) != 0 ? -((int) (((-def[4]) * time) >> 16)) : (int) ((def[4] * time) >> 16)) & 16777215);
        int fpOffsetY = FixedPoint.sinLut((((def[5] ^ time) & 134217728) != 0 ? -((int) (((-def[5]) * time) >> 16)) : (int) ((def[5] * time) >> 16)) & 16777215);
        s[2] = sp[1] + (((def[0] ^ fpOffsetX) & 134217728) != 0 ? -((int) (((-fpOffsetX) * def[0]) >> 16)) : (int) ((fpOffsetX * def[0]) >> 16));
        s[3] = sp[2] + (((def[1] ^ fpOffsetY) & 134217728) != 0 ? -((int) (((-fpOffsetY) * def[1]) >> 16)) : (int) ((fpOffsetY * def[1]) >> 16));
        s[6] = s[6] + GameApp.fp_deltatime;
        s[5] = (int) ((sp[4] << 16) / s[4]);
    }

    private void updateBubbleSpawning() {
        int i;
        this.fpBubbleSpawnTimer -= GameApp.fp_deltatime;
        if (this.fpBubbleSpawnTimer <= 0) {
            this.fpBubbleSpawnTimer = cfpBubbleSpawnDuration;
            int[] visible = game.rectVisible;
            int minX = visible[0];
            int maxX = minX + visible[2];
            int px = GameLogic.randRange(minX, maxX);
            int py = visible[1] + visible[3];
            GameLogic gameLogic = game;
            if (((GameLogic.player.fpVel[0] ^ cfpBubbleSpawnPredictXTime) & 134217728) != 0) {
                GameLogic gameLogic2 = game;
                i = -((int) (((-GameLogic.player.fpVel[0]) * cfpBubbleSpawnPredictXTime) >> 16));
            } else {
                GameLogic gameLogic3 = game;
                i = (int) ((GameLogic.player.fpVel[0] * cfpBubbleSpawnPredictXTime) >> 16);
            }
            GameScreen.effects.create(0, 1, px + i, py);
        }
    }

    private void updateBirdSpawning() {
        int spawnX;
        this.fpBirdSpawnTimer -= GameApp.fp_deltatime;
        if (this.fpBirdSpawnTimer <= 0) {
            if (this.birdSpawnerActive) {
                this.birdSpawnerActive = false;
                this.fpBirdSpawnTimer = GameLogic.randRange(1048576, 1310720);
            } else {
                this.birdSpawnerActive = true;
                this.fpBirdSpawnTimer = GameLogic.randRange(196608, 262144);
            }
        }
        if (this.birdSpawnerActive && this.numActiveBirds < 4 && game.rectVisible[1] <= Water.cfpWaterLevel) {
            GameObj obj = game.allocateGameObj();
            int spawnX2 = game.rectVisible[0] + GameLogic.randRange(0, game.rectVisible[2]);
            GameLogic gameLogic = game;
            if (GameLogic.player.fpVel[0] < 0) {
                spawnX = spawnX2 - game.rectVisible[2];
            } else {
                spawnX = spawnX2 + game.rectVisible[2];
            }
            int spawnY = Water.cfpWaterLevel - 163840;
            obj.initNewObj(10, spawnX, spawnY, -1, -1);
            if (GameLogic.randRange(0, 100) < 10) {
                int[] iArr = obj.fpPos;
                iArr[1] = iArr[1] - 262144;
                obj.aiGotoStateFlyAway();
                obj.fpVel[1] = 0;
            }
            this.numActiveBirds++;
        }
    }

    public void spawnProjectile(GameObj parent) {
        switch (parent.animSet) {
            case 18:
                GameObj obj = game.allocateGameObj();
                obj.initNewObj(20, parent.fpPos[0], parent.fpPos[1], -1, -1);
                obj.initTorpedo(parent);
                return;
            case 19:
            case 20:
            default:
                return;
            case 21:
                GameObj obj2 = game.allocateGameObj();
                obj2.initNewObj(19, parent.fpPos[0], parent.fpPos[1], -1, -1);
                obj2.initDynamite(parent);
                return;
        }
    }

    public void saveState(DataOutputStream outputStream) {
        for (int i = 0; i < 450; i++) {
            try {
                GameApp.outputStreamWriteIntArray(outputStream, this.spawners[i]);
            } catch (Exception e) {
                return;
            }
        }
        outputStream.writeInt(this.numSpawners);
        outputStream.writeInt(this.nextUpdateIndex);
        for (int i2 = 0; i2 < 8; i2++) {
            GameApp.outputStreamWriteIntArray(outputStream, this.shoals[i2]);
        }
        outputStream.writeInt(this.fpBubbleSpawnTimer);
        outputStream.writeInt(this.numActiveBirds);
        outputStream.writeInt(this.fpBirdSpawnTimer);
        outputStream.writeInt(this.birdSpawnerActive ? 1 : 0);
    }

    public void loadState(DataInputStream inputStream) {
        for (int i = 0; i < 450; i++) {
            try {
                GameApp.inputStreamReadIntArray(inputStream, this.spawners[i]);
            } catch (Exception e) {
                return;
            }
        }
        this.numSpawners = inputStream.readInt();
        this.nextUpdateIndex = inputStream.readInt();
        for (int i2 = 0; i2 < 8; i2++) {
            GameApp.inputStreamReadIntArray(inputStream, this.shoals[i2]);
        }
        this.fpBubbleSpawnTimer = inputStream.readInt();
        this.numActiveBirds = inputStream.readInt();
        this.fpBirdSpawnTimer = inputStream.readInt();
        this.birdSpawnerActive = inputStream.readInt() != 0;
    }
}
