package com.slg.j2me.game;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.sys.Application;
import com.slg.j2me.lib.sys.FixedPoint;
import com.slg.j2me.lib.sys.VecMath;
import java.io.DataInputStream;
import java.io.InputStream;
import java.lang.reflect.Array;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.j2meImage;
/* loaded from: classes.dex */
public class TiledLevel {
    public static final int cfpGameCameraInvScaleX = 4096;
    public static final int cfpGameCameraInvScaleY = 4096;
    public static final int cfpGameCameraScaleX = 1048576;
    public static final int cfpGameCameraScaleY = 1048576;
    public static int fpGameMapScaleX;
    public static int fpGameMapScaleY;
    public static int fpWorldCameraMaxX;
    public static int fpWorldCameraMaxY;
    public static int fpWorldMaxX;
    public static int fpWorldMaxY;
    private short[][] boundsMapCode;
    private j2meImage imgTiles;
    private j2meImage imgTiles2;
    private int[] layersUsedArray;
    private int[][] mapCeilingData;
    public int mapCount;
    private short[][] mapData;
    private int[][] mapFloorData;
    public int[] mapHeight;
    public int[] mapWidth;
    public int[] mapXScale;
    public int[] mapYScale;
    private String strTileSet;
    private String strTileSet2;
    private int[] tileCollisionData;
    public int tileHeight;
    private int tileSetHeight;
    private int tileSetWidth;
    public int tileWidth;
    public int[] totalLayerHeight;
    public int[] totalLayerWidth;
    public static int fpGameCameraX = 0;
    public static int fpGameCameraY = 0;
    public static final int cfpDisplayWidthMetres = BaseScreen.displayWidth * 4096;
    public static final int cfpDisplayHeightMetres = BaseScreen.displayHeight * 4096;
    public static int[] collResultPosition = new int[2];
    public static int[] collResultNormal = new int[2];
    public static int[] tempPos = new int[2];
    private static int[] vA = new int[2];
    private static int[] vAn = new int[2];
    private static int[] vB = new int[2];
    private static int[] vBn = new int[2];
    private static int[] tempFrom = new int[2];
    private static int[] tempTo = new int[2];
    private static int[] tempNormal = new int[2];
    public int fpPlayerStartX = 0;
    public int fpPlayerStartY = 0;
    public int m_x = 0;
    public int m_y = 0;
    private int cCollisionLayers = 20;
    public int fp_tileScale = 65536;
    private int realTileWidth = 0;
    private int realTileHeight = 0;
    public int tilesPerTilesetRow = 11;
    int[] ptScreenPos = new int[2];
    int[] ptNorm = new int[2];
    int[] fpWorldPos = new int[2];
    int[] fpNorm = new int[2];
    long time = 0;
    private boolean debugCanMoveTo = false;

    public void reload() {
        loadTileset();
    }

    public void unload() {
    }

    public void paint(Graphics g) {
        for (int m = this.mapCount - 1; m >= 0; m--) {
            drawTiles(g, m);
        }
    }

    public void drawTiles(Graphics g, int m) {
        int x0 = this.mapXScale[m] * this.m_x < 0 ? -((-(this.mapXScale[m] * this.m_x)) >> 16) : (this.mapXScale[m] * this.m_x) >> 16;
        int y0 = this.mapYScale[m] * this.m_y < 0 ? -((-(this.mapYScale[m] * this.m_y)) >> 16) : (this.mapYScale[m] * this.m_y) >> 16;
        int tilesPerRow = this.tileSetWidth / this.realTileWidth;
        int tilesPerCol = this.tileSetHeight / this.realTileHeight;
        int maxTile = tilesPerRow * tilesPerCol;
        int min_j = (-y0) / this.realTileHeight;
        int min_i = (-x0) / this.realTileWidth;
        int max_j = (BaseScreen.displayHeight / this.realTileHeight) + min_j + 2;
        int max_i = (BaseScreen.displayWidth / this.realTileWidth) + min_i + 2;
        if (min_i < 0) {
            min_i = 0;
        } else if (min_i > this.mapWidth[m]) {
            min_i = this.mapWidth[m];
        }
        if (max_i < 0) {
            max_i = 0;
        } else if (max_i > this.mapWidth[m]) {
            max_i = this.mapWidth[m];
        }
        if (min_j < 0) {
            min_j = 0;
        } else if (min_j > this.mapHeight[m]) {
            min_j = this.mapHeight[m];
        }
        if (max_j < 0) {
            max_j = 0;
        } else if (max_j > this.mapHeight[m]) {
            max_j = this.mapHeight[m];
        }
        int mapwidth = this.mapWidth[m];
        short[] map = this.mapData[m];
        for (int j = min_j; j < max_j; j++) {
            int start_i = j * mapwidth;
            for (int i = min_i; i < max_i; i++) {
                short s = map[start_i + i];
                if (s >= 0 && (s & 255) < maxTile) {
                    boolean mirror = (s & 256) != 0;
                    boolean flip = (s & 512) != 0;
                    int transform = 0;
                    if (mirror && flip) {
                        transform = 6;
                    }
                    if (mirror && !flip) {
                        transform = 1;
                    }
                    if (!mirror && flip) {
                        transform = 2;
                    }
                    int tile = s & 255;
                    int tileRow = tile / tilesPerRow;
                    int tileCol = tile % tilesPerRow;
                    int x = x0 + (this.realTileWidth * i);
                    int y = y0 + (this.realTileHeight * j);
                    g.drawRegion(this.imgTiles, tileCol * this.realTileWidth, tileRow * this.realTileHeight, this.realTileWidth, this.realTileHeight, transform, x, y, 0);
                }
            }
        }
    }

    public void drawTilesScaled(Graphics g, int m, int scaledWidth, int scaledHeight) {
        int x0 = ((this.mapXScale[m] * this.m_x < 0 ? -((-(this.mapXScale[m] * this.m_x)) >> 16) : (this.mapXScale[m] * this.m_x) >> 16) * scaledWidth) / this.realTileWidth;
        int y0 = ((this.mapYScale[m] * this.m_y < 0 ? -((-(this.mapYScale[m] * this.m_y)) >> 16) : (this.mapYScale[m] * this.m_y) >> 16) * scaledHeight) / this.realTileHeight;
        int tilesPerRow = this.tileSetWidth / this.realTileWidth;
        int tilesPerCol = this.tileSetHeight / this.realTileHeight;
        int maxTile = tilesPerRow * tilesPerCol;
        int min_j = (-y0) / scaledHeight;
        int min_i = (-x0) / scaledWidth;
        int max_j = (BaseScreen.displayHeight / scaledHeight) + min_j + 2;
        int max_i = (BaseScreen.displayWidth / scaledWidth) + min_i + 2;
        if (min_i < 0) {
            min_i = 0;
        } else if (min_i > this.mapWidth[m]) {
            min_i = this.mapWidth[m];
        }
        if (max_i < 0) {
            max_i = 0;
        } else if (max_i > this.mapWidth[m]) {
            max_i = this.mapWidth[m];
        }
        if (min_j < 0) {
            min_j = 0;
        } else if (min_j > this.mapHeight[m]) {
            min_j = this.mapHeight[m];
        }
        if (max_j < 0) {
            max_j = 0;
        } else if (max_j > this.mapHeight[m]) {
            max_j = this.mapHeight[m];
        }
        int mapwidth = this.mapWidth[m];
        short[] map = this.mapData[m];
        for (int j = min_j; j < max_j; j++) {
            int start_i = j * mapwidth;
            for (int i = min_i; i < max_i; i++) {
                short s = map[start_i + i];
                if (s >= 0 && (s & 255) < maxTile) {
                    boolean mirror = (s & 256) != 0;
                    boolean flip = (s & 512) != 0;
                    int transform = 0;
                    if (mirror && flip) {
                        transform = 6;
                    }
                    if (mirror && !flip) {
                        transform = 1;
                    }
                    if (!mirror && flip) {
                        transform = 2;
                    }
                    int tile = s & 255;
                    int tileRow = tile / tilesPerRow;
                    int tileCol = tile % tilesPerRow;
                    int x = x0 + (i * scaledWidth);
                    int y = y0 + (j * scaledHeight);
                    g.drawRegionStretched(this.imgTiles, tileCol * this.realTileWidth, tileRow * this.realTileHeight, this.realTileWidth, this.realTileHeight, transform, x, y, scaledWidth, scaledHeight, 0);
                }
            }
        }
    }

    public void drawFloorCollision(Graphics g) {
        this.fpWorldPos[0] = GameLogic.player.fpPos[0];
        this.fpWorldPos[1] = getFloorWorldSpace(this.fpWorldPos[0], GameLogic.player.fpPos[1]);
        this.fpNorm[0] = 0;
        this.fpNorm[1] = 65536;
        getFloorNormalWorldSpace(this.fpWorldPos[0], GameLogic.player.fpPos[1], this.fpNorm);
        this.fpNorm[0] = this.fpWorldPos[0] + (((this.fpNorm[0] ^ 262144) & 134217728) != 0 ? -((int) (((-this.fpNorm[0]) * 262144) >> 16)) : (int) ((this.fpNorm[0] * 262144) >> 16));
        this.fpNorm[1] = this.fpWorldPos[1] + (((this.fpNorm[1] ^ 262144) & 134217728) != 0 ? -((int) (((-this.fpNorm[1]) * 262144) >> 16)) : (int) ((this.fpNorm[1] * 262144) >> 16));
        worldToScreenPos(this.ptScreenPos, this.fpWorldPos);
        worldToScreenPos(this.ptNorm, this.fpNorm);
        g.setColor(-16711936);
        g.drawLine(this.ptScreenPos[0], this.ptScreenPos[1], this.ptNorm[0], this.ptNorm[1]);
    }

    public void drawCeilingCollision(Graphics g) {
        this.fpWorldPos[0] = GameLogic.player.fpPos[0];
        this.fpWorldPos[1] = getCeilingWorldSpace(this.fpWorldPos[0], GameLogic.player.fpPos[1]);
        this.fpNorm[0] = 0;
        this.fpNorm[1] = 65536;
        getCeilingNormalWorldSpace(this.fpWorldPos[0], GameLogic.player.fpPos[1], this.fpNorm);
        this.fpNorm[0] = this.fpWorldPos[0] + (((this.fpNorm[0] ^ 262144) & 134217728) != 0 ? -((int) (((-this.fpNorm[0]) * 262144) >> 16)) : (int) ((this.fpNorm[0] * 262144) >> 16));
        this.fpNorm[1] = this.fpWorldPos[1] + (((this.fpNorm[1] ^ 262144) & 134217728) != 0 ? -((int) (((-this.fpNorm[1]) * 262144) >> 16)) : (int) ((this.fpNorm[1] * 262144) >> 16));
        worldToScreenPos(this.ptScreenPos, this.fpWorldPos);
        worldToScreenPos(this.ptNorm, this.fpNorm);
        g.setColor(GameObj.cfpSharkWakePosYMin);
        g.drawLine(this.ptScreenPos[0], this.ptScreenPos[1], this.ptNorm[0], this.ptNorm[1]);
    }

    public void drawCollision(Graphics g) {
        int x0 = this.mapXScale[0] * this.m_x < 0 ? -((-(this.mapXScale[0] * this.m_x)) >> 16) : (this.mapXScale[0] * this.m_x) >> 16;
        int y0 = this.mapYScale[0] * this.m_y < 0 ? -((-(this.mapYScale[0] * this.m_y)) >> 16) : (this.mapYScale[0] * this.m_y) >> 16;
        int min_j = (-y0) / this.realTileHeight;
        int min_i = (-x0) / this.realTileWidth;
        int i = (BaseScreen.displayHeight / this.realTileHeight) + min_j + 2;
        int max_i = (BaseScreen.displayWidth / this.realTileWidth) + min_i + 2;
        if (min_i < 0) {
            min_i = 0;
        } else if (min_i > this.mapWidth[0]) {
            min_i = this.mapWidth[0];
        }
        if (max_i < 0) {
            max_i = 0;
        } else if (max_i > this.mapWidth[0]) {
            max_i = this.mapWidth[0];
        }
        int db = 0;
        int[] x = new int[2];
        int[] y = new int[2];
        int px = ((GameLogic.player.fpPos[0] ^ fpGameMapScaleX) & 134217728) != 0 ? -((int) (((-GameLogic.player.fpPos[0]) * fpGameMapScaleX) >> 16)) : (int) ((GameLogic.player.fpPos[0] * fpGameMapScaleX) >> 16);
        int py = ((GameLogic.player.fpPos[1] ^ fpGameMapScaleY) & 134217728) != 0 ? -((int) (((-GameLogic.player.fpPos[1]) * fpGameMapScaleY) >> 16)) : (int) ((GameLogic.player.fpPos[1] * fpGameMapScaleY) >> 16);
        int px2 = (px < 0 ? -((-px) >> 16) : px >> 16) + (BaseScreen.displayWidth >> 1);
        int py2 = (py < 0 ? -((-py) >> 16) : py >> 16) + (BaseScreen.displayHeight >> 1);
        for (int layer = 0; layer < this.cCollisionLayers; layer++) {
            g.setColor(-16711936);
            for (int i2 = min_i * 4; i2 < max_i * 4 && i2 < this.mapFloorData[layer].length; i2++) {
                x[db] = ((this.realTileWidth * i2) / 4) + x0 + (this.realTileWidth / 8);
                y[db] = this.mapFloorData[layer][i2] + y0;
                if (i2 > min_i * 4 && y[0] > 0 && y[1] > 0) {
                    g.drawLine(x[1 - db], y[1 - db], x[db], y[db]);
                }
                db = 1 - db;
            }
        }
        for (int layer2 = 0; layer2 < this.cCollisionLayers; layer2++) {
            g.setColor(GameObj.cfpSharkWakePosYMin);
            for (int i3 = min_i * 4; i3 < max_i * 4 && i3 < this.mapFloorData[layer2].length; i3++) {
                x[db] = ((this.realTileWidth * i3) / 4) + x0 + (this.realTileWidth / 8);
                y[db] = this.mapCeilingData[layer2][i3] + y0;
                if (i3 > min_i * 4 && y[0] > 0 && y[1] > 0) {
                    g.drawLine(x[1 - db], y[1 - db], x[db], y[db]);
                }
                db = 1 - db;
            }
        }
        if (BaseScreen.keysDown(2048)) {
            int[] scr_to = {BaseScreen.pointerX, BaseScreen.pointerY};
            int[] world_to = new int[2];
            int[] scr_from = new int[2];
            screenToWorldPos(world_to, scr_to);
            worldToScreenPos(scr_from, GameLogic.player.fpPos);
            boolean hit = false;
            this.debugCanMoveTo = true;
            try {
                hit = !canMoveTo(GameLogic.player.fpPos, world_to);
            } catch (Exception e) {
            }
            this.debugCanMoveTo = false;
            g.setColor(hit ? -256 : -65281);
            if (hit) {
                worldToScreenPos(scr_to, collResultPosition);
                g.drawLine(scr_from[0], scr_from[1], scr_to[0], scr_to[1]);
                worldToScreenPos(scr_from, collResultPosition);
                collResultPosition[0] = collResultPosition[0] + (((collResultNormal[0] ^ 196608) & 134217728) != 0 ? -((int) (((-collResultNormal[0]) * 196608) >> 16)) : (int) ((collResultNormal[0] * 196608) >> 16));
                collResultPosition[1] = collResultPosition[1] + (((collResultNormal[1] ^ 196608) & 134217728) != 0 ? -((int) (((-collResultNormal[1]) * 196608) >> 16)) : (int) ((collResultNormal[1] * 196608) >> 16));
                worldToScreenPos(scr_to, collResultPosition);
                g.drawLine(scr_from[0], scr_from[1], scr_to[0], scr_to[1]);
            } else {
                g.drawLine(scr_from[0], scr_from[1], scr_to[0], scr_to[1]);
            }
        }
        for (int i4 = 0; i4 < 4; i4++) {
            int[] scr_to2 = new int[2];
            int[] world_to2 = new int[2];
            int[] scr_from2 = new int[2];
            worldToScreenPos(scr_from2, GameLogic.player.fpPos);
            worldToScreenPos(scr_to2, GameLogic.player.fpPos);
            switch (i4) {
                case 0:
                    scr_to2[0] = scr_to2[0] - 128;
                    break;
                case 1:
                    scr_to2[0] = scr_to2[0] + 128;
                    break;
                case 2:
                    scr_to2[1] = scr_to2[1] - 96;
                    break;
                case 3:
                    scr_to2[1] = scr_to2[1] + 96;
                    break;
            }
            screenToWorldPos(world_to2, scr_to2);
            boolean hit2 = false;
            try {
                hit2 = !canMoveTo(GameLogic.player.fpPos, world_to2);
            } catch (Exception e2) {
            }
            g.setColor(hit2 ? -256 : -65281);
            if (hit2) {
                worldToScreenPos(scr_to2, collResultPosition);
                g.drawLine(scr_from2[0], scr_from2[1], scr_to2[0], scr_to2[1]);
                worldToScreenPos(scr_from2, collResultPosition);
                collResultPosition[0] = collResultPosition[0] + (((collResultNormal[0] ^ 196608) & 134217728) != 0 ? -((int) (((-collResultNormal[0]) * 196608) >> 16)) : (int) ((collResultNormal[0] * 196608) >> 16));
                collResultPosition[1] = collResultPosition[1] + (((collResultNormal[1] ^ 196608) & 134217728) != 0 ? -((int) (((-collResultNormal[1]) * 196608) >> 16)) : (int) ((collResultNormal[1] * 196608) >> 16));
                worldToScreenPos(scr_to2, collResultPosition);
                g.drawLine(scr_from2[0], scr_from2[1], scr_to2[0], scr_to2[1]);
            } else {
                g.drawLine(scr_from2[0], scr_from2[1], scr_to2[0], scr_to2[1]);
            }
        }
    }

    public void drawSolidSpace(Graphics g) {
        int x0 = this.mapXScale[0] * this.m_x < 0 ? -((-(this.mapXScale[0] * this.m_x)) >> 16) : (this.mapXScale[0] * this.m_x) >> 16;
        int y0 = this.mapYScale[0] * this.m_y < 0 ? -((-(this.mapYScale[0] * this.m_y)) >> 16) : (this.mapYScale[0] * this.m_y) >> 16;
        int min_j = (-y0) / this.realTileHeight;
        int min_i = (-x0) / this.realTileWidth;
        int max_j = (BaseScreen.displayHeight / this.realTileHeight) + min_j + 2;
        int max_i = (BaseScreen.displayWidth / this.realTileWidth) + min_i + 2;
        if (min_i < 0) {
            min_i = 0;
        } else if (min_i > this.mapWidth[0]) {
            min_i = this.mapWidth[0];
        }
        if (max_i < 0) {
            max_i = 0;
        } else if (max_i > this.mapWidth[0]) {
            max_i = this.mapWidth[0];
        }
        if (min_j < 0) {
            min_j = 0;
        } else if (min_j > this.mapHeight[0]) {
            min_j = this.mapHeight[0];
        }
        if (max_j < 0) {
            max_j = 0;
        } else if (max_j > this.mapHeight[0]) {
            max_j = this.mapHeight[0];
        }
        int mapwidth = this.mapWidth[0];
        short[] map = this.mapData[0];
        for (int j = min_j; j < max_j; j++) {
            int start_i = j * mapwidth;
            for (int i = min_i; i < max_i; i++) {
                short s = map[start_i + i];
                if (s != -1) {
                    boolean mirror = (s & 256) != 0;
                    int tile = s & 255;
                    for (int k = 0; k < 4; k++) {
                        int index = mirror ? (tile * 4) + (3 - k) : (tile * 4) + k;
                        int value = this.tileCollisionData[index];
                        if (value > 112) {
                            g.setColor(mirror ? 1593835775 : 1593835695);
                            int x1 = (this.realTileWidth * i) + x0 + ((this.realTileWidth * k) / 4);
                            int y1 = y0 + (this.realTileHeight * j);
                            g.fillRect(x1, y1, this.realTileWidth / 4, this.realTileHeight);
                        }
                    }
                }
            }
        }
    }

    public void process() {
        int i;
        int i2;
        if ((((fpGameCameraX ^ 1048576) & 134217728) != 0 ? -((int) (((-fpGameCameraX) * 1048576) >> 16)) : (int) ((fpGameCameraX * 1048576) >> 16)) < 0) {
            i = -((-(((fpGameCameraX ^ 1048576) & 134217728) != 0 ? -((int) (((-fpGameCameraX) * 1048576) >> 16)) : (int) ((fpGameCameraX * 1048576) >> 16))) >> 16);
        } else {
            i = (((fpGameCameraX ^ 1048576) & 134217728) != 0 ? -((int) (((-fpGameCameraX) * 1048576) >> 16)) : (int) ((fpGameCameraX * 1048576) >> 16)) >> 16;
        }
        this.m_x = -i;
        if ((((fpGameCameraY ^ 1048576) & 134217728) != 0 ? -((int) (((-fpGameCameraY) * 1048576) >> 16)) : (int) ((fpGameCameraY * 1048576) >> 16)) < 0) {
            i2 = -((-(((fpGameCameraY ^ 1048576) & 134217728) != 0 ? -((int) (((-fpGameCameraY) * 1048576) >> 16)) : (int) ((fpGameCameraY * 1048576) >> 16))) >> 16);
        } else {
            i2 = (((fpGameCameraY ^ 1048576) & 134217728) != 0 ? -((int) (((-fpGameCameraY) * 1048576) >> 16)) : (int) ((fpGameCameraY * 1048576) >> 16)) >> 16;
        }
        this.m_y = -i2;
    }

    public void loadLevel(String filename) {
        InputStream inputstream = Application.openResourceAsStream(filename);
        DataInputStream datain = new DataInputStream(inputstream);
        try {
            this.mapCount = datain.readInt();
            this.mapXScale = new int[this.mapCount];
            this.mapYScale = new int[this.mapCount];
            this.mapWidth = new int[this.mapCount];
            this.mapHeight = new int[this.mapCount];
            this.totalLayerWidth = new int[this.mapCount];
            this.totalLayerHeight = new int[this.mapCount];
            this.mapData = new short[this.mapCount];
            this.boundsMapCode = new short[this.mapCount];
            for (int m = 0; m < this.mapCount; m++) {
                if (m == 0) {
                    this.strTileSet = datain.readUTF();
                } else {
                    this.strTileSet2 = datain.readUTF();
                }
                this.mapWidth[m] = datain.readInt();
                this.mapHeight[m] = datain.readInt();
                this.tileWidth = datain.readInt();
                this.tileHeight = datain.readInt();
                this.totalLayerWidth[m] = this.mapWidth[m] * this.tileWidth;
                this.totalLayerHeight[m] = this.mapHeight[m] * this.tileHeight;
                this.mapData[m] = new short[this.mapHeight[m] * this.mapWidth[m]];
                for (int j = 0; j < this.mapHeight[m]; j++) {
                    int i = 0;
                    while (i < this.mapWidth[m]) {
                        this.mapData[m][(this.mapWidth[m] * j) + i] = datain.readShort();
                        if (this.mapData[m][(this.mapWidth[m] * j) + i] == -275) {
                            short length = datain.readShort();
                            short value = datain.readShort();
                            for (int k = 0; k < length; k++) {
                                this.mapData[m][(this.mapWidth[m] * j) + i + k] = value;
                            }
                            i += length - 1;
                        }
                        i++;
                    }
                }
                this.boundsMapCode[m] = new short[this.mapHeight[m] * this.mapWidth[m]];
                for (int j2 = 0; j2 < this.mapHeight[m]; j2++) {
                    int i2 = 0;
                    while (i2 < this.mapWidth[m]) {
                        this.boundsMapCode[m][(this.mapWidth[m] * j2) + i2] = datain.readShort();
                        if (this.boundsMapCode[m][(this.mapWidth[m] * j2) + i2] == -275) {
                            short length2 = datain.readShort();
                            short value2 = datain.readShort();
                            for (int k2 = 0; k2 < length2; k2++) {
                                this.boundsMapCode[m][(this.mapWidth[m] * j2) + i2 + k2] = value2;
                            }
                            i2 += length2 - 1;
                        }
                        i2++;
                    }
                }
                if (m == 0) {
                    int tiles = datain.readInt();
                    this.tileCollisionData = new int[tiles * 4];
                    for (int i3 = 0; i3 < tiles; i3++) {
                        for (int k3 = 0; k3 < 4; k3++) {
                            this.tileCollisionData[(i3 * 4) + k3] = datain.readByte();
                        }
                    }
                    this.cCollisionLayers = datain.readInt();
                    this.mapFloorData = (int[][]) Array.newInstance(Integer.TYPE, this.cCollisionLayers, this.mapWidth[0] * 4);
                    this.mapCeilingData = (int[][]) Array.newInstance(Integer.TYPE, this.cCollisionLayers, this.mapWidth[0] * 4);
                    for (int l = 0; l < this.cCollisionLayers; l++) {
                        for (int x = 0; x < this.mapWidth[0] * 4; x++) {
                            this.mapFloorData[l][x] = datain.readInt();
                            this.mapCeilingData[l][x] = datain.readInt();
                        }
                    }
                    int layersUsedLength = datain.readInt();
                    this.layersUsedArray = new int[layersUsedLength];
                    for (int i4 = 0; i4 < layersUsedLength; i4++) {
                        this.layersUsedArray[i4] = datain.readInt();
                    }
                }
            }
            datain.close();
            if (this.imgTiles != null) {
                calcTilesetScale();
            }
        } catch (Exception e) {
        }
    }

    public void loadTileset() {
        if (this.imgTiles == null) {
            try {
                this.imgTiles = j2meImage.createImage(this.strTileSet);
                this.imgTiles.pointSampling = true;
                calcTilesetScale();
            } catch (Exception e) {
            }
        }
    }

    public void calcTilesetScale() {
        try {
            this.tileSetWidth = this.imgTiles.getWidth();
            this.tileSetHeight = this.imgTiles.getHeight();
            this.realTileWidth = this.tileSetWidth / this.tilesPerTilesetRow;
            this.realTileHeight = this.realTileWidth;
            this.fp_tileScale = (int) (((this.realTileWidth << 16) << 16) / (this.tileWidth << 16));
            int screen_tile_width = BaseScreen.displayWidth / this.realTileWidth;
            int screen_tile_height = BaseScreen.displayHeight / this.realTileHeight;
            for (int m = 0; m < this.mapCount; m++) {
                if (this.mapWidth[0] - screen_tile_width != 0) {
                    this.mapXScale[m] = (int) ((((this.mapWidth[m] - screen_tile_width) << 16) << 16) / ((this.mapWidth[0] - screen_tile_width) << 16));
                } else {
                    this.mapXScale[m] = 65536;
                }
                if (this.mapHeight[0] - screen_tile_height != 0) {
                    this.mapYScale[m] = (int) ((((this.mapHeight[m] - screen_tile_height) << 16) << 16) / ((this.mapHeight[0] - screen_tile_height) << 16));
                } else {
                    this.mapYScale[m] = 65536;
                }
            }
            fpGameMapScaleX = ((this.mapXScale[0] ^ 1048576) & 134217728) != 0 ? -((int) (((-1048576) * this.mapXScale[0]) >> 16)) : (int) ((1048576 * this.mapXScale[0]) >> 16);
            fpGameMapScaleY = ((this.mapYScale[0] ^ 1048576) & 134217728) != 0 ? -((int) (((-1048576) * this.mapYScale[0]) >> 16)) : (int) ((1048576 * this.mapYScale[0]) >> 16);
            calcWorldMaxLimits();
        } catch (Exception e) {
        }
    }

    public void calcWorldMaxLimits() {
        tempPos[0] = this.totalLayerWidth[0];
        tempPos[1] = this.totalLayerHeight[0];
        mapToWorldSpace(tempPos, tempPos);
        fpWorldMaxX = tempPos[0];
        fpWorldMaxY = tempPos[1];
        tempPos[0] = this.totalLayerWidth[0] - BaseScreen.displayWidth;
        tempPos[1] = this.totalLayerHeight[0] - BaseScreen.displayHeight;
        mapToWorldSpace(tempPos, tempPos);
        fpWorldCameraMaxX = tempPos[0];
        fpWorldCameraMaxY = tempPos[1];
    }

    public void unloadTileset() {
        this.imgTiles = null;
    }

    public boolean isSolidWorldSpace(int fpX, int fpY) {
        int x = ((fpGameMapScaleX ^ fpX) & 134217728) != 0 ? -((int) (((-fpX) * fpGameMapScaleX) >> 16)) : (int) ((fpX * fpGameMapScaleX) >> 16);
        int y = ((fpGameMapScaleY ^ fpY) & 134217728) != 0 ? -((int) (((-fpY) * fpGameMapScaleY) >> 16)) : (int) ((fpY * fpGameMapScaleY) >> 16);
        return isSolidMapSpace((x < 0 ? -((-x) >> 16) : x >> 16) + (BaseScreen.displayWidth >> 1), (y < 0 ? -((-y) >> 16) : y >> 16) + (BaseScreen.displayHeight >> 1));
    }

    public boolean isSolidMapSpace(int mapx, int mapy) {
        int mapwidth = this.mapWidth[0];
        short[] map = this.mapData[0];
        int coll_x = (int) ((262144 * (mapx - (this.tileWidth / 8))) / this.tileWidth);
        int coll_x2 = coll_x < 0 ? -((-coll_x) >> 16) : coll_x >> 16;
        int tile_x = coll_x2 / 4;
        int k = coll_x2 % 4;
        int tile_y = mapy / this.tileHeight;
        if (tile_x < 0 || tile_x >= mapwidth || tile_y >= this.mapHeight[0]) {
            return true;
        }
        short s = map[(tile_y * mapwidth) + tile_x];
        if (s != -1) {
            boolean mirror = (s & 256) != 0;
            int tile = s & 255;
            int index = mirror ? (tile * 4) + (3 - k) : (tile * 4) + k;
            int value = this.tileCollisionData[index];
            if (value > 112) {
                return true;
            }
        }
        return false;
    }

    public int getFloorLayer(int mapx, int mapy) {
        int i;
        int x = (int) ((262144 * (mapx - (this.tileWidth / 8))) / this.tileWidth);
        if (x < 0) {
            int i2 = (-x) & 65535;
        } else {
            int i3 = 65535 & x;
        }
        int x2 = x < 0 ? -((-x) >> 16) : x >> 16;
        if (x2 < 0) {
            i = 0;
        } else {
            i = x2 > this.mapFloorData[0].length - 1 ? this.mapFloorData[0].length - 1 : x2;
        }
        int closest = -1;
        int dist = Integer.MAX_VALUE;
        int layers = this.layersUsedArray[i >> 6];
        for (int l = 0; l < layers; l++) {
            int d = this.mapFloorData[l][i] - mapy;
            if (this.mapFloorData[l][i] > 0) {
                if ((d < 0 ? -d : d) < dist) {
                    closest = l;
                    dist = d < 0 ? -d : d;
                }
            }
        }
        return closest;
    }

    public int getFloorWorldSpace(int fpX, int fpY) {
        int x = ((fpGameMapScaleX ^ fpX) & 134217728) != 0 ? -((int) (((-fpX) * fpGameMapScaleX) >> 16)) : (int) ((fpX * fpGameMapScaleX) >> 16);
        int y = ((fpGameMapScaleY ^ fpY) & 134217728) != 0 ? -((int) (((-fpY) * fpGameMapScaleY) >> 16)) : (int) ((fpY * fpGameMapScaleY) >> 16);
        int x2 = (x < 0 ? -((-x) >> 16) : x >> 16) + (BaseScreen.displayWidth >> 1);
        int layer = getFloorLayer(x2, (y < 0 ? -((-y) >> 16) : y >> 16) + (BaseScreen.displayHeight >> 1));
        int h = getFloorMapSpace(layer, x2);
        if (h == 0) {
            return 0;
        }
        return (int) (((h - (BaseScreen.displayHeight >> 1) < 0 ? -((-(h - (BaseScreen.displayHeight >> 1))) << 16) : (h - (BaseScreen.displayHeight >> 1)) << 16) << 16) / fpGameMapScaleY);
    }

    public int getFloorMapSpace(int layer, int mapx) {
        int i;
        int j;
        if (layer == -1) {
            return 0;
        }
        int x = (int) ((262144 * (mapx - (this.tileWidth / 8))) / this.tileWidth);
        int frac = x < 0 ? (-x) & 65535 : x & 65535;
        int x2 = x < 0 ? -((-x) >> 16) : x >> 16;
        int[] data = this.mapFloorData[layer];
        if (x2 < 0) {
            i = 0;
        } else {
            i = x2 > data.length - 1 ? data.length - 1 : x2;
        }
        if (x2 + 1 < 0) {
            j = 0;
        } else {
            j = x2 + 1 > data.length - 1 ? data.length - 1 : x2 + 1;
        }
        if (data[i] == 0 || data[j] == 0) {
            return 0;
        }
        return FixedPoint.linearInterpolate(frac, data[i], data[j]);
    }

    public void getFloorNormalWorldSpace(int fpX, int fpY, int[] fp_norm) {
        int x = ((fpGameMapScaleX ^ fpX) & 134217728) != 0 ? -((int) (((-fpX) * fpGameMapScaleX) >> 16)) : (int) ((fpX * fpGameMapScaleX) >> 16);
        int y = ((fpGameMapScaleY ^ fpY) & 134217728) != 0 ? -((int) (((-fpY) * fpGameMapScaleY) >> 16)) : (int) ((fpY * fpGameMapScaleY) >> 16);
        int x2 = (x < 0 ? -((-x) >> 16) : x >> 16) + (BaseScreen.displayWidth >> 1);
        int layer = getFloorLayer(x2, (y < 0 ? -((-y) >> 16) : y >> 16) + (BaseScreen.displayHeight >> 1));
        getFloorNormalMapSpace(layer, x2, fp_norm);
    }

    public void getFloorNormalMapSpace(int layer, int mapx, int[] fp_norm) {
        int i;
        int j;
        if (layer != -1) {
            int x = (int) ((262144 * (mapx - (this.tileWidth / 8))) / this.tileWidth);
            int x2 = x < 0 ? -((-x) >> 16) : x >> 16;
            int[] data = this.mapFloorData[layer];
            if (x2 < 0) {
                i = 0;
            } else {
                i = x2 > data.length - 1 ? data.length - 1 : x2;
            }
            if (x2 + 1 < 0) {
                j = 0;
            } else {
                j = x2 + 1 > data.length - 1 ? data.length - 1 : x2 + 1;
            }
            if (data[i] != 0 && data[j] != 0) {
                fp_norm[0] = data[j] - data[i] < 0 ? -((-(data[j] - data[i])) << 16) : (data[j] - data[i]) << 16;
                fp_norm[1] = (-this.tileWidth) * 16384;
                VecMath.norm2d(fp_norm, fp_norm);
            }
        }
    }

    public int getCeilingLayer(int mapx, int mapy) {
        int i;
        int x = (int) ((262144 * (mapx - (this.tileWidth / 8))) / this.tileWidth);
        if (x < 0) {
            int i2 = (-x) & 65535;
        } else {
            int i3 = 65535 & x;
        }
        int x2 = x < 0 ? -((-x) >> 16) : x >> 16;
        if (x2 < 0) {
            i = 0;
        } else {
            i = x2 > this.mapCeilingData[0].length - 1 ? this.mapCeilingData[0].length - 1 : x2;
        }
        int closest = -1;
        int dist = Integer.MAX_VALUE;
        int layers = this.layersUsedArray[i >> 6];
        for (int l = 0; l < layers; l++) {
            int d = this.mapCeilingData[l][i] - mapy;
            if (this.mapCeilingData[l][i] > 0) {
                if ((d < 0 ? -d : d) < dist) {
                    closest = l;
                    dist = d < 0 ? -d : d;
                }
            }
        }
        return closest;
    }

    public int getCeilingWorldSpace(int fpX, int fpY) {
        int x = ((fpGameMapScaleX ^ fpX) & 134217728) != 0 ? -((int) (((-fpX) * fpGameMapScaleX) >> 16)) : (int) ((fpX * fpGameMapScaleX) >> 16);
        int y = ((fpGameMapScaleY ^ fpY) & 134217728) != 0 ? -((int) (((-fpY) * fpGameMapScaleY) >> 16)) : (int) ((fpY * fpGameMapScaleY) >> 16);
        int x2 = (x < 0 ? -((-x) >> 16) : x >> 16) + (BaseScreen.displayWidth >> 1);
        int layer = getCeilingLayer(x2, (y < 0 ? -((-y) >> 16) : y >> 16) + (BaseScreen.displayHeight >> 1));
        int h = getCeilingMapSpace(layer, x2);
        if (h == 0) {
            return 0;
        }
        return (int) (((h - (BaseScreen.displayHeight >> 1) < 0 ? -((-(h - (BaseScreen.displayHeight >> 1))) << 16) : (h - (BaseScreen.displayHeight >> 1)) << 16) << 16) / fpGameMapScaleY);
    }

    public int getCeilingMapSpace(int layer, int mapx) {
        int i;
        int j;
        if (layer == -1) {
            return 0;
        }
        int x = (int) ((262144 * (mapx - (this.tileWidth / 8))) / this.tileWidth);
        int frac = x < 0 ? (-x) & 65535 : x & 65535;
        int x2 = x < 0 ? -((-x) >> 16) : x >> 16;
        int[] data = this.mapCeilingData[layer];
        if (x2 < 0) {
            i = 0;
        } else {
            i = x2 > data.length - 1 ? data.length - 1 : x2;
        }
        if (x2 + 1 < 0) {
            j = 0;
        } else {
            j = x2 + 1 > data.length - 1 ? data.length - 1 : x2 + 1;
        }
        if (data[i] == 0 || data[j] == 0) {
            return 0;
        }
        return FixedPoint.linearInterpolate(frac, data[i], data[j]);
    }

    public void getCeilingNormalWorldSpace(int fpX, int fpY, int[] fp_norm) {
        int x = ((fpGameMapScaleX ^ fpX) & 134217728) != 0 ? -((int) (((-fpX) * fpGameMapScaleX) >> 16)) : (int) ((fpX * fpGameMapScaleX) >> 16);
        int y = ((fpGameMapScaleY ^ fpY) & 134217728) != 0 ? -((int) (((-fpY) * fpGameMapScaleY) >> 16)) : (int) ((fpY * fpGameMapScaleY) >> 16);
        int x2 = (x < 0 ? -((-x) >> 16) : x >> 16) + (BaseScreen.displayWidth >> 1);
        int layer = getCeilingLayer(x2, (y < 0 ? -((-y) >> 16) : y >> 16) + (BaseScreen.displayHeight >> 1));
        getCeilingNormalMapSpace(layer, x2, fp_norm);
    }

    public void getCeilingNormalMapSpace(int layer, int mapx, int[] fp_norm) {
        int i;
        int j;
        if (layer != -1) {
            int x = (int) ((262144 * (mapx - (this.tileWidth / 8))) / this.tileWidth);
            int x2 = x < 0 ? -((-x) >> 16) : x >> 16;
            int[] data = this.mapCeilingData[layer];
            if (x2 < 0) {
                i = 0;
            } else {
                i = x2 > data.length - 1 ? data.length - 1 : x2;
            }
            if (x2 + 1 < 0) {
                j = 0;
            } else {
                j = x2 + 1 > data.length - 1 ? data.length - 1 : x2 + 1;
            }
            if (data[i] != 0 && data[j] != 0) {
                fp_norm[0] = -(data[j] - data[i] < 0 ? -((-(data[j] - data[i])) << 16) : (data[j] - data[i]) << 16);
                fp_norm[1] = this.tileWidth * 16384;
                VecMath.norm2d(fp_norm, fp_norm);
            }
        }
    }

    public static int getLineLineIntersect(int[] vA2, int[] vAn2, int[] vB2, int[] vBn2) {
        int a2 = ((vAn2[0] ^ (vB2[1] - vA2[1])) & 134217728) != 0 ? -((int) (((-vAn2[0]) * (vB2[1] - vA2[1])) >> 16)) : (int) ((vAn2[0] * (vB2[1] - vA2[1])) >> 16);
        int b = ((vAn2[1] ^ (vB2[0] - vA2[0])) & 134217728) != 0 ? -((int) (((-vAn2[1]) * (vB2[0] - vA2[0])) >> 16)) : (int) ((vAn2[1] * (vB2[0] - vA2[0])) >> 16);
        int c = (((vAn2[1] ^ vBn2[0]) & 134217728) != 0 ? -((int) (((-vAn2[1]) * vBn2[0]) >> 16)) : (int) ((vAn2[1] * vBn2[0]) >> 16)) - (((vAn2[0] ^ vBn2[1]) & 134217728) != 0 ? -((int) (((-vAn2[0]) * vBn2[1]) >> 16)) : (int) ((vAn2[0] * vBn2[1]) >> 16));
        if (c != 0) {
            int tb = (int) (((a2 - b) << 16) / c);
            return tb;
        }
        return 0;
    }

    public boolean canMoveTo(int[] from, int[] to) {
        try {
            int x0 = ((from[0] ^ fpGameMapScaleX) & 134217728) != 0 ? -((int) (((-from[0]) * fpGameMapScaleX) >> 16)) : (int) ((from[0] * fpGameMapScaleX) >> 16);
            int y0 = ((from[1] ^ fpGameMapScaleY) & 134217728) != 0 ? -((int) (((-from[1]) * fpGameMapScaleY) >> 16)) : (int) ((from[1] * fpGameMapScaleY) >> 16);
            int x02 = (x0 < 0 ? -((-x0) >> 16) : x0 >> 16) + (BaseScreen.displayWidth >> 1);
            int y02 = (y0 < 0 ? -((-y0) >> 16) : y0 >> 16) + (BaseScreen.displayHeight >> 1);
            int x1 = ((to[0] ^ fpGameMapScaleX) & 134217728) != 0 ? -((int) (((-to[0]) * fpGameMapScaleX) >> 16)) : (int) ((to[0] * fpGameMapScaleX) >> 16);
            int y1 = ((to[1] ^ fpGameMapScaleY) & 134217728) != 0 ? -((int) (((-to[1]) * fpGameMapScaleY) >> 16)) : (int) ((to[1] * fpGameMapScaleY) >> 16);
            int x12 = (x1 < 0 ? -((-x1) >> 16) : x1 >> 16) + (BaseScreen.displayWidth >> 1);
            int y12 = (y1 < 0 ? -((-y1) >> 16) : y1 >> 16) + (BaseScreen.displayHeight >> 1);
            int cx0 = (int) ((262144 * (x02 - (this.tileWidth / 8))) / this.tileWidth);
            int cx1 = (int) ((262144 * (x12 - (this.tileWidth / 8))) / this.tileWidth);
            int cx02 = cx0 < 0 ? -((-cx0) >> 16) : cx0 >> 16;
            int cx12 = cx1 < 0 ? -((-cx1) >> 16) : cx1 >> 16;
            if (cx02 > cx12) {
                int tmp = cx02;
                cx02 = cx12;
                cx12 = tmp;
            }
            int y = y02;
            int dx = (this.tileWidth * 16384) + 65536;
            int dy = (y12 - y02) / ((cx12 - cx02) + 1);
            int max = this.mapCeilingData[0].length;
            int fp_mindist = Integer.MAX_VALUE;
            vA[0] = x02 < 0 ? -((-x02) << 16) : x02 << 16;
            vA[1] = y02 < 0 ? -((-y02) << 16) : y02 << 16;
            vAn[0] = x12 - x02 < 0 ? -((-(x12 - x02)) << 16) : (x12 - x02) << 16;
            vAn[1] = y12 - y02 < 0 ? -((-(y12 - y02)) << 16) : (y12 - y02) << 16;
            int len2 = VecMath.norm2d(vAn, vAn);
            boolean solid_collision = false;
            int[] iArr = {(int) ((4 * vA[0]) / this.realTileWidth), vA[1] / 24};
            int[] iArr2 = {(int) ((4 * vAn[0]) / this.realTileWidth), vAn[1] / 24};
            if (this.debugCanMoveTo) {
            }
            if (this.debugCanMoveTo) {
            }
            for (int i = cx02; i <= cx12 && i < max; i++) {
                int x = (int) (((i * this.tileWidth) / 4) + (this.tileWidth / 8));
                if (this.debugCanMoveTo) {
                }
                if (i == cx02) {
                    y -= ((x02 - x) * dy) / dx;
                }
                int f_layer = getFloorLayer(x + 1, y);
                int c_layer = getCeilingLayer(x + 1, y);
                if (c_layer != -1) {
                    int[] c_data = this.mapCeilingData[c_layer];
                    vB[0] = x < 0 ? -((-x) << 16) : x << 16;
                    vB[1] = c_data[i] < 0 ? -((-c_data[i]) << 16) : c_data[i] << 16;
                    if (c_data[i + 1] != 0) {
                        vBn[0] = dx;
                        vBn[1] = c_data[i + 1] - c_data[i] < 0 ? -((-(c_data[i + 1] - c_data[i])) << 16) : (c_data[i + 1] - c_data[i]) << 16;
                    } else {
                        vBn[0] = 0;
                        vBn[1] = 65536;
                    }
                    int[] iArr3 = {(int) ((4 * vB[0]) / this.realTileWidth), vB[1] / 24};
                    int[] iArr4 = {(int) ((4 * vBn[0]) / this.realTileWidth), vBn[1] / 24};
                    if (this.debugCanMoveTo) {
                    }
                    int len1 = VecMath.norm2d(vBn, vBn);
                    int t1 = getLineLineIntersect(vA, vAn, vB, vBn);
                    int t2 = getLineLineIntersect(vB, vBn, vA, vAn);
                    if (t1 >= 0 && t1 <= len1 && t2 >= 0 && t2 <= len2 && (t1 != 0 || t2 != 0)) {
                        if ((t2 < 0 ? -t2 : t2) < fp_mindist || solid_collision) {
                            fp_mindist = t2 < 0 ? -t2 : t2;
                            solid_collision = false;
                            if (this.debugCanMoveTo) {
                            }
                            collResultPosition[0] = vB[0] + (((vBn[0] ^ t1) & 134217728) != 0 ? -((int) (((-t1) * vBn[0]) >> 16)) : (int) ((t1 * vBn[0]) >> 16));
                            collResultPosition[1] = vB[1] + (((vBn[1] ^ t1) & 134217728) != 0 ? -((int) (((-t1) * vBn[1]) >> 16)) : (int) ((t1 * vBn[1]) >> 16));
                            collResultPosition[0] = collResultPosition[0] < 0 ? -((-collResultPosition[0]) >> 16) : collResultPosition[0] >> 16;
                            collResultPosition[1] = collResultPosition[1] < 0 ? -((-collResultPosition[1]) >> 16) : collResultPosition[1] >> 16;
                            getCeilingNormalMapSpace(c_layer, collResultPosition[0], collResultNormal);
                            mapToWorldSpace(collResultPosition, collResultPosition);
                        }
                    }
                    if (this.debugCanMoveTo) {
                    }
                    if (this.debugCanMoveTo) {
                    }
                } else if (this.debugCanMoveTo) {
                }
                if (f_layer != -1) {
                    int[] f_data = this.mapFloorData[f_layer];
                    vB[0] = x < 0 ? -((-x) << 16) : x << 16;
                    vB[1] = f_data[i] < 0 ? -((-f_data[i]) << 16) : f_data[i] << 16;
                    if (f_data[i + 1] != 0) {
                        vBn[0] = dx;
                        vBn[1] = f_data[i + 1] - f_data[i] < 0 ? -((-(f_data[i + 1] - f_data[i])) << 16) : (f_data[i + 1] - f_data[i]) << 16;
                    } else {
                        vBn[0] = 0;
                        vBn[1] = -65536;
                    }
                    int[] iArr5 = {(int) ((4 * vB[0]) / this.realTileWidth), vB[1] / 24};
                    int[] iArr6 = {(int) ((4 * vBn[0]) / this.realTileWidth), vBn[1] / 24};
                    if (this.debugCanMoveTo) {
                    }
                    int len12 = VecMath.norm2d(vBn, vBn);
                    int t12 = getLineLineIntersect(vA, vAn, vB, vBn);
                    int t22 = getLineLineIntersect(vB, vBn, vA, vAn);
                    if (t12 >= 0 && t12 <= len12 && t22 >= 0 && t22 <= len2 && (t12 != 0 || t22 != 0)) {
                        if ((t22 < 0 ? -t22 : t22) < fp_mindist || solid_collision) {
                            fp_mindist = t22 < 0 ? -t22 : t22;
                            solid_collision = false;
                            if (this.debugCanMoveTo) {
                            }
                            collResultPosition[0] = vB[0] + (((vBn[0] ^ t12) & 134217728) != 0 ? -((int) (((-t12) * vBn[0]) >> 16)) : (int) ((t12 * vBn[0]) >> 16));
                            collResultPosition[1] = vB[1] + (((vBn[1] ^ t12) & 134217728) != 0 ? -((int) (((-t12) * vBn[1]) >> 16)) : (int) ((t12 * vBn[1]) >> 16));
                            collResultPosition[0] = collResultPosition[0] < 0 ? -((-collResultPosition[0]) >> 16) : collResultPosition[0] >> 16;
                            collResultPosition[1] = collResultPosition[1] < 0 ? -((-collResultPosition[1]) >> 16) : collResultPosition[1] >> 16;
                            getFloorNormalMapSpace(f_layer, collResultPosition[0], collResultNormal);
                            mapToWorldSpace(collResultPosition, collResultPosition);
                        }
                    }
                    if (this.debugCanMoveTo) {
                    }
                    if (this.debugCanMoveTo) {
                    }
                } else if (this.debugCanMoveTo) {
                }
                y += dy;
            }
            return fp_mindist >= Integer.MAX_VALUE;
        } catch (Exception e) {
            collResultPosition[0] = from[0];
            collResultPosition[1] = from[1];
            collResultNormal[0] = from[0] - to[0];
            collResultNormal[1] = from[1] - to[1];
            VecMath.norm2d(collResultNormal, collResultNormal);
            return true;
        }
    }

    public boolean canMoveTo(int[] from, int[] to, int fp_halfwidth, int fp_halfheight) {
        int collisions = 0;
        tempNormal[0] = 0;
        tempNormal[1] = 0;
        for (int i = 0; i < 4; i++) {
            tempFrom[0] = from[0];
            tempFrom[1] = from[1];
            tempTo[0] = to[0];
            tempTo[1] = to[1];
            switch (i) {
                case 0:
                    int[] iArr = tempFrom;
                    iArr[0] = iArr[0] - fp_halfwidth;
                    int[] iArr2 = tempTo;
                    iArr2[0] = iArr2[0] - fp_halfwidth;
                    break;
                case 1:
                    int[] iArr3 = tempFrom;
                    iArr3[0] = iArr3[0] + fp_halfwidth;
                    int[] iArr4 = tempTo;
                    iArr4[0] = iArr4[0] + fp_halfwidth;
                    break;
                case 2:
                    int[] iArr5 = tempFrom;
                    iArr5[1] = iArr5[1] - fp_halfheight;
                    int[] iArr6 = tempTo;
                    iArr6[1] = iArr6[1] - fp_halfheight;
                    break;
                case 3:
                    int[] iArr7 = tempFrom;
                    iArr7[1] = iArr7[1] + fp_halfheight;
                    int[] iArr8 = tempTo;
                    iArr8[1] = iArr8[1] + fp_halfheight;
                    break;
            }
            if (!canMoveTo(tempFrom, tempTo)) {
                collisions++;
                tempNormal[0] = tempNormal[0] + collResultNormal[0];
                tempNormal[1] = tempNormal[1] + collResultNormal[1];
            }
        }
        if (collisions > 0) {
            VecMath.norm2d(collResultNormal, tempNormal);
        }
        return collisions == 0;
    }

    public static void worldToScreenPos(int[] out, int[] in) {
        int i;
        int i2;
        if (((((in[0] - fpGameCameraX) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[0] - fpGameCameraX)) * 1048576) >> 16)) : (int) (((in[0] - fpGameCameraX) * 1048576) >> 16)) < 0) {
            i = -((-((((in[0] - fpGameCameraX) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[0] - fpGameCameraX)) * 1048576) >> 16)) : (int) (((in[0] - fpGameCameraX) * 1048576) >> 16))) >> 16);
        } else {
            i = ((((in[0] - fpGameCameraX) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[0] - fpGameCameraX)) * 1048576) >> 16)) : (int) (((in[0] - fpGameCameraX) * 1048576) >> 16)) >> 16;
        }
        out[0] = i + (BaseScreen.displayWidth >> 1);
        if (((((in[1] - fpGameCameraY) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[1] - fpGameCameraY)) * 1048576) >> 16)) : (int) (((in[1] - fpGameCameraY) * 1048576) >> 16)) < 0) {
            i2 = -((-((((in[1] - fpGameCameraY) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[1] - fpGameCameraY)) * 1048576) >> 16)) : (int) (((in[1] - fpGameCameraY) * 1048576) >> 16))) >> 16);
        } else {
            i2 = ((((in[1] - fpGameCameraY) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[1] - fpGameCameraY)) * 1048576) >> 16)) : (int) (((in[1] - fpGameCameraY) * 1048576) >> 16)) >> 16;
        }
        out[1] = i2 + (BaseScreen.displayHeight >> 1);
    }

    public static void screenToWorldPos(int[] out, int[] in) {
        out[0] = ((int) (((in[0] - (BaseScreen.displayWidth >> 1) < 0 ? -((-(in[0] - (BaseScreen.displayWidth >> 1))) << 16) : (in[0] - (BaseScreen.displayWidth >> 1)) << 16) << 16) / 1048576)) + fpGameCameraX;
        out[1] = ((int) (((in[1] - (BaseScreen.displayHeight >> 1) < 0 ? -((-(in[1] - (BaseScreen.displayHeight >> 1))) << 16) : (in[1] - (BaseScreen.displayHeight >> 1)) << 16) << 16) / 1048576)) + fpGameCameraY;
    }

    public static void worldToMapSpace(int[] out, int[] in) {
        out[0] = ((in[0] ^ fpGameMapScaleX) & 134217728) != 0 ? -((int) (((-in[0]) * fpGameMapScaleX) >> 16)) : (int) ((in[0] * fpGameMapScaleX) >> 16);
        out[1] = ((in[1] ^ fpGameMapScaleY) & 134217728) != 0 ? -((int) (((-in[1]) * fpGameMapScaleY) >> 16)) : (int) ((in[1] * fpGameMapScaleY) >> 16);
        out[0] = (out[0] < 0 ? -((-out[0]) >> 16) : out[0] >> 16) + (BaseScreen.displayWidth >> 1);
        out[1] = (out[1] < 0 ? -((-out[1]) >> 16) : out[1] >> 16) + (BaseScreen.displayHeight >> 1);
    }

    public static void mapToWorldSpace(int[] out, int[] in) {
        out[0] = in[0] - (BaseScreen.displayWidth >> 1) < 0 ? -((-(in[0] - (BaseScreen.displayWidth >> 1))) << 16) : (in[0] - (BaseScreen.displayWidth >> 1)) << 16;
        out[1] = in[1] - (BaseScreen.displayHeight >> 1) < 0 ? -((-(in[1] - (BaseScreen.displayHeight >> 1))) << 16) : (in[1] - (BaseScreen.displayHeight >> 1)) << 16;
        out[0] = (int) ((out[0] << 16) / fpGameMapScaleX);
        out[1] = (int) ((out[1] << 16) / fpGameMapScaleY);
    }

    public static void worldToScreenRect(int[] out, int[] in) {
        int i;
        int i2;
        int i3;
        int i4;
        if (((((in[0] - fpGameCameraX) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[0] - fpGameCameraX)) * 1048576) >> 16)) : (int) (((in[0] - fpGameCameraX) * 1048576) >> 16)) < 0) {
            i = -((-((((in[0] - fpGameCameraX) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[0] - fpGameCameraX)) * 1048576) >> 16)) : (int) (((in[0] - fpGameCameraX) * 1048576) >> 16))) >> 16);
        } else {
            i = ((((in[0] - fpGameCameraX) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[0] - fpGameCameraX)) * 1048576) >> 16)) : (int) (((in[0] - fpGameCameraX) * 1048576) >> 16)) >> 16;
        }
        out[0] = i + (BaseScreen.displayWidth >> 1);
        if (((((in[1] - fpGameCameraY) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[1] - fpGameCameraY)) * 1048576) >> 16)) : (int) (((in[1] - fpGameCameraY) * 1048576) >> 16)) < 0) {
            i2 = -((-((((in[1] - fpGameCameraY) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[1] - fpGameCameraY)) * 1048576) >> 16)) : (int) (((in[1] - fpGameCameraY) * 1048576) >> 16))) >> 16);
        } else {
            i2 = ((((in[1] - fpGameCameraY) ^ 1048576) & 134217728) != 0 ? -((int) (((-(in[1] - fpGameCameraY)) * 1048576) >> 16)) : (int) (((in[1] - fpGameCameraY) * 1048576) >> 16)) >> 16;
        }
        out[1] = i2 + (BaseScreen.displayHeight >> 1);
        if ((((in[2] ^ 1048576) & 134217728) != 0 ? -((int) (((-in[2]) * 1048576) >> 16)) : (int) ((in[2] * 1048576) >> 16)) < 0) {
            i3 = -((-(((in[2] ^ 1048576) & 134217728) != 0 ? -((int) (((-in[2]) * 1048576) >> 16)) : (int) ((in[2] * 1048576) >> 16))) >> 16);
        } else {
            i3 = (((in[2] ^ 1048576) & 134217728) != 0 ? -((int) (((-in[2]) * 1048576) >> 16)) : (int) ((in[2] * 1048576) >> 16)) >> 16;
        }
        out[2] = i3;
        if ((((in[3] ^ 1048576) & 134217728) != 0 ? -((int) (((-in[3]) * 1048576) >> 16)) : (int) ((in[3] * 1048576) >> 16)) < 0) {
            i4 = -((-(((in[3] ^ 1048576) & 134217728) != 0 ? -((int) (((-in[3]) * 1048576) >> 16)) : (int) ((in[3] * 1048576) >> 16))) >> 16);
        } else {
            i4 = (((in[3] ^ 1048576) & 134217728) != 0 ? -((int) (((-in[3]) * 1048576) >> 16)) : (int) ((in[3] * 1048576) >> 16)) >> 16;
        }
        out[3] = i4;
    }

    public void createSpawners() {
        GameLogic gameLogic = GameScreen.game;
        Spawner spawner = GameLogic.spawner;
        spawner.reset();
        if (this.realTileWidth == 0) {
            this.realTileHeight = 93;
            this.realTileWidth = 93;
        }
        for (int j = 0; j < this.mapHeight[0]; j++) {
            for (int i = 0; i < this.mapWidth[0]; i++) {
                short s = this.boundsMapCode[0][(this.mapWidth[0] * j) + i];
                if (s != 0) {
                    int px = (((this.realTileWidth * i) + (this.realTileWidth >> 1)) - (BaseScreen.displayWidth >> 1)) * 4096;
                    int py = (((this.realTileHeight * j) + (this.realTileHeight >> 1)) - (BaseScreen.displayHeight >> 1)) * 4096;
                    if (s == 255) {
                        this.fpPlayerStartX = px;
                        this.fpPlayerStartY = py;
                    } else {
                        spawner.addSpawner(s, px, py);
                    }
                }
            }
        }
    }
}
