package com.slg.j2me.game;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gui.control.ControlHandler;
import com.slg.j2me.lib.gui.control.GuiControl;
import com.slg.j2me.lib.gui.layout.CellLayout;
import com.slg.j2me.lib.gui.layout.ScreenLayout;
/* JADX INFO: Access modifiers changed from: package-private */
/* loaded from: classes.dex */
public class VirtualKeyboard extends CellLayout implements ControlHandler {
    public static String[][] strKeys = {new String[]{"Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P"}, new String[]{"A", "S", "D", "F", "G", "H", "J", "K", "L"}, new String[]{"Z", "X", "C", "V", "B", "N", "M"}, new String[]{"DELETE", "SPACE", "OK"}};
    public GuiControl[][] ctrlKeys;
    public GuiControl ctrlOk;
    public int maxLength;
    public String strText;
    public KeyImage textEdit;

    public VirtualKeyboard(int _maxLength) {
        super(5);
        this.strText = "";
        this.ctrlOk = new GuiControl(true);
        setRow(0, 1, 1);
        setRow(1, strKeys[0].length, 1);
        setRow(2, strKeys[1].length, 1);
        setRow(3, strKeys[2].length, 1);
        setRow(4, strKeys[3].length, 1);
        this.textEdit = new KeyImage(this.strText);
        setCell(0, 0, this.textEdit, 1, 0);
        this.ctrlKeys = new GuiControl[strKeys.length];
        this.maxLength = _maxLength;
        for (int j = 0; j < strKeys.length; j++) {
            this.ctrlKeys[j] = new GuiControl[strKeys[j].length];
            for (int i = 0; i < strKeys[j].length; i++) {
                this.ctrlKeys[j][i] = new GuiControl(true);
                this.ctrlKeys[j][i].border = 0;
                this.ctrlKeys[j][i].controlImage = new KeyImage(strKeys[j][i]);
                setCell(j + 1, i, this.ctrlKeys[j][i], 1, 0);
            }
        }
        this.controlHandler = this;
        layout();
    }

    @Override // com.slg.j2me.lib.gui.layout.CellLayout, com.slg.j2me.lib.gui.layout.ScreenLayout
    public void layout() {
        this.clipRect.w = (short) BaseScreen.displayWidth;
        this.clipRect.h = (short) ((BaseScreen.displayHeight * 3) / 4);
        this.clipRect.x0 = (short) 0;
        this.clipRect.y0 = (short) (BaseScreen.displayHeight - this.clipRect.h);
        super.layout();
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void pushScreen(ScreenLayout container, boolean transition) {
    }

    @Override // com.slg.j2me.lib.gui.control.ControlHandler
    public void controlExecuted(ScreenLayout container, GuiControl control) {
        for (int j = 0; j < strKeys.length; j++) {
            for (int i = 0; i < strKeys[j].length; i++) {
                if (control == this.ctrlKeys[j][i]) {
                    if (j < 3) {
                        if (this.strText.length() < this.maxLength) {
                            this.strText += strKeys[j][i];
                        }
                    } else {
                        if (i == 0) {
                            if (this.strText.length() > 1) {
                                this.strText = this.strText.substring(0, this.strText.length() - 1);
                            } else {
                                this.strText = "";
                            }
                        }
                        if (i == 1 && this.strText.length() < this.maxLength && this.strText.length() > 0) {
                            this.strText += " ";
                        }
                        if (i == 2 && this.strText.length() > 0) {
                            GameScreen gameScreen = GameApp.gameScreen;
                            if (GameScreen.currentDialog == this) {
                                GameScreen gameScreen2 = GameApp.gameScreen;
                                GameScreen.cellGameOver.controlExecuted(this, this.ctrlOk);
                            } else {
                                FrontEnd.screenHiscores.controlExecuted(this, this.ctrlOk);
                            }
                        }
                    }
                    this.textEdit.textKey.setText(this.strText);
                }
            }
        }
        for (int j2 = 0; j2 < strKeys.length - 1; j2++) {
            for (int i2 = 0; i2 < strKeys[j2].length; i2++) {
                this.ctrlKeys[j2][i2].greyed = this.strText.length() == this.maxLength;
            }
        }
        this.ctrlKeys[3][0].greyed = this.strText.length() == 0;
        this.ctrlKeys[3][1].greyed = this.strText.length() == this.maxLength || this.strText.length() == 0;
        this.ctrlKeys[3][2].greyed = this.strText.length() == 0;
    }
}
