package com.slg.j2me.game;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gfx.GfxUtils;
import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gfx.ImageSet;
import com.slg.j2me.lib.sys.Application;
import com.slg.j2me.lib.sys.FixedPoint;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.j2meImage;
/* JADX INFO: Access modifiers changed from: package-private */
/* loaded from: classes.dex */
public class Water {
    public static j2meImage imgBackground;
    int[] band;
    ImageSequence gfxBg;
    ImageSequence gfxCloud;
    ImageSequence gfxExtra1;
    ImageSequence gfxExtra2;
    ImageSequence gfxIceberg;
    ImageSequence gfxIsland;
    ImageSequence[] gfxSunken;
    ImageSequence gfxWaves;
    ImageSet isBackground;
    ImageSet isExtra;
    TiledLevel tiledLevel;
    public static final int cfpWaterLevel = FixedPoint.stringToFP("4");
    public static Water instance = null;
    public static String[] strSunken = {"ruin", "shipwreck", "rocket"};
    public static int[][] ptSunken = {new int[]{1652, 252}, new int[]{8825, 4291}, new int[]{12340, 4455}};
    public static int[][] ptIsland_0 = {new int[]{414, 55}, new int[]{2634, 55}, new int[]{9564, 55}};
    public static int[][] ptIsland_1 = {new int[]{2276, 34}, new int[]{6386, 34}, new int[]{8888, 34}};
    public static int[][] ptIceberg_0 = {new int[]{13874, 38}, new int[]{15555, 38}, new int[]{16789, 38}};
    public static int[][] ptIceberg_1 = {new int[]{14638, 36}, new int[]{16478, 59}};
    public static int[][] ptExtra_1 = {new int[]{9746, -43}};
    public static int[][] ptExtra_2 = {new int[]{95, -60}};
    public static int cWaveFrameTime = 8192;
    int tile = 32;
    int[] colour = {-16501641, -16777216};
    private int wave_frame = 0;
    private int wave_time = 0;
    final int dark = -16710871;
    final int light = -15230769;
    int fp_t = 0;
    int fp_time = 0;
    final int plankton_dark = -16710887;
    final int plankton_light = -13125393;
    public int slowframecount = 0;

    public Water() {
        instance = this;
        this.isBackground = new ImageSet("/background.is", true);
        this.gfxBg = this.isBackground.getImageSequence("layer");
        this.gfxWaves = this.isBackground.getImageSequence("wave");
        this.gfxIsland = this.isBackground.getImageSequence("island");
        this.gfxIceberg = this.isBackground.getImageSequence("iceberg");
        this.gfxCloud = this.isBackground.getImageSequence("cloud");
        this.gfxSunken = new ImageSequence[strSunken.length];
        for (int i = 0; i < strSunken.length; i++) {
            this.gfxSunken[i] = this.isBackground.getImageSequence(strSunken[i]);
        }
        if (!Application.crapDevice) {
            imgBackground = ImageSet.loadImage("/plankton_bg.png");
            this.isExtra = new ImageSet("/extra.is", true);
            this.gfxExtra1 = this.isExtra.getImageSequence("island");
            this.gfxExtra2 = this.isExtra.getImageSequence("palmtrees");
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public void process() {
    }

    void draw(Graphics g, ImageSequence gfx, int idx, int y, int fp_z) {
        int x = (((this.tiledLevel.m_x < 0 ? -((-this.tiledLevel.m_x) << 16) : this.tiledLevel.m_x << 16) ^ fp_z) & 134217728) != 0 ? -((int) (((-(this.tiledLevel.m_x < 0 ? -((-this.tiledLevel.m_x) << 16) : this.tiledLevel.m_x << 16)) * fp_z) >> 16)) : (int) (((this.tiledLevel.m_x < 0 ? -((-this.tiledLevel.m_x) << 16) : this.tiledLevel.m_x << 16) * fp_z) >> 16);
        int cx0 = ((x < 0 ? -((-x) >> 16) : x >> 16) % gfx.getRectWidth(idx)) - gfx.getRectWidth(idx);
        int cy0 = this.tiledLevel.m_y + y;
        int tiles = (BaseScreen.displayWidth / gfx.getRectWidth(idx)) + 3;
        for (int t = 0; t < tiles; t++) {
            gfx.drawImageCropEdges(g, idx, ((gfx.getRectWidth(idx) - 2) * t) + cx0, cy0);
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public void paint(Graphics g) {
        int i;
        int i2;
        GameScreen gameScreen = GameApp.gameScreen;
        this.tiledLevel = GameScreen.tiledLevel;
        int displayWidth = BaseScreen.displayWidth;
        int displayHeight = BaseScreen.displayHeight;
        this.wave_time += GameApp.fp_deltatime;
        if (this.wave_time > cWaveFrameTime) {
            this.wave_time -= cWaveFrameTime;
            this.wave_frame++;
            while (this.wave_frame < 0) {
                this.wave_frame += ((this.gfxWaves.numFrames - 1) - 0) + 1;
            }
            while (this.wave_frame > this.gfxWaves.numFrames - 1) {
                this.wave_frame -= ((this.gfxWaves.numFrames - 1) - 0) + 1;
            }
        }
        GameScreen gameScreen2 = GameApp.gameScreen;
        TiledLevel level = GameScreen.tiledLevel;
        this.fp_t = (GameObj.cfpSharkWakePosYMin * level.m_y) / level.totalLayerHeight[0];
        if (this.fp_t < 0) {
            i = 0;
        } else {
            i = this.fp_t > 65536 ? 65536 : this.fp_t;
        }
        this.fp_t = i;
        int col = GfxUtils.lerpColour(this.fp_t, -15230769, -16710871);
        g.setColor(col);
        g.fillRect(0, 0, displayWidth, displayHeight);
        if (this.tiledLevel.mapCount > 1 && !Application.crapDevice) {
            g.setBlendColor(1073741823);
            this.tiledLevel.drawTilesScaled(g, 1, 80, 80);
            g.setBlendColor(-1);
        }
        drawSunken(g);
        this.fp_time += GameApp.fp_deltatime;
        while (this.fp_time < 0) {
            this.fp_time += 1048577;
        }
        while (this.fp_time > 1048576) {
            this.fp_time -= 1048577;
        }
        if (imgBackground != null && this.slowframecount < 10) {
            int w = imgBackground.getWidth();
            int h = imgBackground.getHeight();
            int tiles = ((BaseScreen.displayWidth / w) * 2) + 1;
            int scroll_x = FixedPoint.sinLut(this.fp_time * 16) * 32;
            int scroll_x2 = level.m_x + (scroll_x < 0 ? -((-scroll_x) >> 16) : scroll_x >> 16);
            int scroll_y = FixedPoint.sinLut((this.fp_time * 16) + 4194304) * 16;
            int scroll_y2 = level.m_y + (scroll_y < 0 ? -((-scroll_y) >> 16) : scroll_y >> 16);
            while (scroll_x2 < 0) {
                scroll_x2 += (w - 0) + 1;
            }
            while (scroll_x2 > w) {
                scroll_x2 -= (w - 0) + 1;
            }
            while (scroll_y2 < (-h)) {
                scroll_y2 += (0 - (-h)) + 1;
            }
            while (scroll_y2 > 0) {
                scroll_y2 -= (0 - (-h)) + 1;
            }
            if (this.fp_t + 21845 < 0) {
                i2 = 0;
            } else {
                i2 = this.fp_t + 21845 > 65536 ? 65536 : this.fp_t + 21845;
            }
            g.setBlendColor(GfxUtils.lerpColour(i2, -13125393, -16710887));
            for (int b = 0; b < tiles; b++) {
                g.drawImage(imgBackground, (b * w) + scroll_x2, scroll_y2, 13);
                g.drawImage(imgBackground, (b * w) + scroll_x2, scroll_y2 + h, 13);
            }
            g.setBlendColor(-1);
        }
        draw(g, this.gfxBg, 0, 0, FixedPoint.stringToFP("0.15"));
        ImageSequence imageSequence = this.gfxBg;
        int y = 0 + (this.gfxBg.getRectHeight(0) - 2);
        draw(g, imageSequence, 1, y, FixedPoint.stringToFP("0.35"));
        drawFarAway(g, ptIsland_0, this.gfxIsland, 0);
        drawFarAway(g, ptIsland_1, this.gfxIsland, 1);
        drawFarAway(g, ptIceberg_0, this.gfxIceberg, 0);
        drawFarAway(g, ptIceberg_1, this.gfxIceberg, 1);
        g.setBlendColor(-1342177281);
        draw(g, this.gfxWaves, this.wave_frame, y + (this.gfxBg.getRectHeight(1) - 8), FixedPoint.stringToFP("0.65"));
        g.setBlendColor(-1);
    }

    void drawSunken(Graphics g) {
        g.setBlendColor(1073741823);
        for (int i = 0; i < ptSunken.length; i++) {
            int dx = this.tiledLevel.m_x + ptSunken[i][0];
            int dy = this.tiledLevel.m_y + ptSunken[i][1];
            int dx2 = dx - (dx / 4);
            int dy2 = dy - (dy / 8);
            if (i == 0) {
                this.gfxSunken[i].drawImageStretched(g, 0, dx2, dy2, 0, this.gfxSunken[i].getRectWidth(0) * 2, this.gfxSunken[i].getRectHeight(0) * 2);
            } else {
                this.gfxSunken[i].drawImageStretched(g, 0, dx2, dy2, 0, this.gfxSunken[i].getRectWidth(0) * 3, this.gfxSunken[i].getRectHeight(0) * 3);
            }
        }
        g.setBlendColor(-1);
    }

    void drawFarAway(Graphics g, int[][] pts, ImageSequence gfx, int frame) {
        for (int i = 0; i < pts.length; i++) {
            int dx = this.tiledLevel.m_x + pts[i][0];
            int dy = this.tiledLevel.m_y + pts[i][1] + 48;
            gfx.drawImage(g, frame, dx - ((dx * 4) / 5), dy);
        }
    }

    void drawExtra(Graphics g, int[][] pts, ImageSequence gfx, int frame) {
        for (int i = 0; i < pts.length; i++) {
            int dx = this.tiledLevel.m_x + pts[i][0];
            int dy = this.tiledLevel.m_y + pts[i][1] + 48;
            gfx.drawImage(g, frame, dx, dy);
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public void paintWaterDepth(Graphics g) {
        int i;
        int y;
        GameScreen gameScreen = GameApp.gameScreen;
        TiledLevel level = GameScreen.tiledLevel;
        this.fp_t = (GameObj.cfpSharkWakePosYMin * level.m_y) / level.totalLayerHeight[0];
        if (this.fp_t < 0) {
            i = 0;
        } else {
            i = this.fp_t > 65536 ? 65536 : this.fp_t;
        }
        this.fp_t = i;
        int col = GfxUtils.lerpColour(this.fp_t, -15230769, -16710871) & 1073741823;
        if (level.m_y + 192 < 0) {
            y = 0;
        } else {
            y = level.m_y + 192 > 192 ? 192 : level.m_y + 192;
        }
        g.setColor(col);
        g.fillRect(0, y, BaseScreen.displayWidth, BaseScreen.displayHeight - y);
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public void paintOverlays(Graphics g) {
        int alpha;
        int i;
        GameScreen gameScreen = GameApp.gameScreen;
        TiledLevel level = GameScreen.tiledLevel;
        if (imgBackground != null && this.slowframecount < 10) {
            int w = imgBackground.getWidth();
            int h = imgBackground.getHeight();
            int tiles = ((BaseScreen.displayWidth / w) * 2) + 1;
            int scroll_x = ((FixedPoint.sinLut(this.fp_time * 16) * 32) * 3) / 2;
            int scroll_x2 = ((level.m_x * 3) / 2) + (scroll_x < 0 ? -((-scroll_x) >> 16) : scroll_x >> 16);
            int scroll_y = ((FixedPoint.sinLut((this.fp_time * 16) + 4194304) * 16) * 3) / 2;
            int scroll_y2 = ((level.m_y * 3) / 2) + (scroll_y < 0 ? -((-scroll_y) >> 16) : scroll_y >> 16);
            while (scroll_x2 < (-w) * 2) {
                scroll_x2 += (0 - ((-w) * 2)) + 1;
            }
            while (scroll_x2 > 0) {
                scroll_x2 -= (0 - ((-w) * 2)) + 1;
            }
            while (scroll_y2 < (-h) * 2) {
                scroll_y2 += (0 - ((-h) * 2)) + 1;
            }
            while (scroll_y2 > 0) {
                scroll_y2 -= (0 - ((-h) * 2)) + 1;
            }
            if ((-level.m_y) < 0) {
                alpha = 0;
            } else {
                alpha = (-level.m_y) > 255 ? 255 : -level.m_y;
            }
            if (this.fp_t - 21845 < 0) {
                i = 0;
            } else {
                i = this.fp_t - 21845 > 65536 ? 65536 : this.fp_t - 21845;
            }
            g.setBlendColor(GfxUtils.lerpColour(i, -13125393, -16710887) & ((alpha << 24) | 16777215));
            for (int b = 0; b < tiles; b++) {
                g.drawRegionStretched(imgBackground, 0, 0, w, h, 0, (b * w * 2) + scroll_x2, scroll_y2, w * 2, h * 2, 13);
                g.drawRegionStretched(imgBackground, 0, 0, w, h, 0, (b * w * 2) + scroll_x2, scroll_y2 + (h * 2), w * 2, h * 2, 13);
            }
            g.setBlendColor(-1);
        }
        if (this.gfxExtra1 != null) {
            drawExtra(g, ptExtra_1, this.gfxExtra1, 0);
        }
        if (this.gfxExtra2 != null) {
            drawExtra(g, ptExtra_2, this.gfxExtra2, 0);
        }
        draw(g, this.gfxWaves, this.wave_frame, this.gfxBg.getRectHeight(0) + this.gfxBg.getRectHeight(1) + 8, FixedPoint.stringToFP("1.25"));
    }
}
