package com.slg.j2me.lib.gfx;

import com.slg.j2me.lib.sys.Application;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.j2meCanvas;
import javax.microedition.lcdui.j2meImage;
import javax.microedition.midlet.SimpleGLRenderer;
/* loaded from: classes.dex */
public abstract class BaseScreen extends j2meCanvas {
    public static int pointerStartX;
    public static int pointerStartY;
    public static int pointerX;
    public static int pointerY;
    public static ClipRect visibleRect = new ClipRect(0, 0, 533, 320);
    public static int displayWidth = 533;
    public static int displayHeight = 320;
    private static int cMaxRectStack = 5;
    private static ClipRect[] rectStack = new ClipRect[cMaxRectStack];
    private static int rectStackTop = 0;
    private static boolean isInProcessLoop = false;
    public static int fp_sx = 65536;
    public static int fp_sy = 65536;
    public static int frameNumber = 0;
    private static int liveInputState = 0;
    private static int liveQuickPressRelease = 0;
    public static int lastInputState = 0;
    public static int quickPressRelease = 0;
    public static int userInputState = 0;
    public static int numberKey = -1;
    public static BaseScreen currentScreen = null;
    public static boolean takingScreenshot = false;

    public abstract void paintInternal(Graphics graphics);

    public BaseScreen(boolean supressKeyEvents) {
        for (int i = 0; i < rectStack.length; i++) {
            rectStack[i] = new ClipRect(0, 0, displayWidth, displayHeight);
        }
    }

    public static void setDefaultRes(int w, int h) {
        fp_sx = (int) (((displayWidth < 0 ? -((-displayWidth) << 16) : displayWidth << 16) << 16) / (w < 0 ? -((-w) << 16) : w << 16));
        fp_sy = (int) (((displayHeight < 0 ? -((-displayHeight) << 16) : displayHeight << 16) << 16) / (h < 0 ? -((-h) << 16) : h << 16));
    }

    public static int getScaledX(int x) {
        int fp_nx;
        if (((fp_sx ^ (x < 0 ? -((-x) << 16) : x << 16)) & 134217728) != 0) {
            fp_nx = -((int) (((-fp_sx) * (x < 0 ? -((-x) << 16) : x << 16)) >> 16));
        } else {
            fp_nx = (int) ((fp_sx * (x < 0 ? -((-x) << 16) : x << 16)) >> 16);
        }
        return fp_nx < 0 ? -((-fp_nx) >> 16) : fp_nx >> 16;
    }

    public static int getScaledY(int y) {
        int fp_ny;
        if (((fp_sy ^ (y < 0 ? -((-y) << 16) : y << 16)) & 134217728) != 0) {
            fp_ny = -((int) (((-fp_sy) * (y < 0 ? -((-y) << 16) : y << 16)) >> 16));
        } else {
            fp_ny = (int) ((fp_sy * (y < 0 ? -((-y) << 16) : y << 16)) >> 16);
        }
        return fp_ny < 0 ? -((-fp_ny) >> 16) : fp_ny >> 16;
    }

    public static void pushVisibleRect(ClipRect newRect) {
        rectStack[rectStackTop].x0 = visibleRect.x0;
        rectStack[rectStackTop].y0 = visibleRect.y0;
        rectStack[rectStackTop].w = visibleRect.w;
        rectStack[rectStackTop].h = visibleRect.h;
        int x1 = newRect.x0 + newRect.w;
        int y1 = newRect.y0 + newRect.h;
        int x2 = visibleRect.x0 + visibleRect.w;
        int y2 = visibleRect.y0 + visibleRect.h;
        visibleRect.x0 = newRect.x0 > visibleRect.x0 ? newRect.x0 : visibleRect.x0;
        visibleRect.y0 = newRect.y0 > visibleRect.y0 ? newRect.y0 : visibleRect.y0;
        visibleRect.w = (short) ((x1 < x2 ? x1 : x2) - visibleRect.x0);
        visibleRect.h = (short) ((y1 < y2 ? y1 : y2) - visibleRect.y0);
        rectStackTop++;
    }

    public static void popVisibleRect() {
        if (rectStackTop > 0) {
            rectStackTop--;
            visibleRect.x0 = rectStack[rectStackTop].x0;
            visibleRect.y0 = rectStack[rectStackTop].y0;
            visibleRect.w = rectStack[rectStackTop].w;
            visibleRect.h = rectStack[rectStackTop].h;
        }
    }

    public static void clearVisibleRect() {
        while (rectStackTop > 0) {
            popVisibleRect();
        }
    }

    public static void setCurrent(BaseScreen screen) {
        currentScreen = screen;
        Application.display.setCurrent(screen);
    }

    public static void forcePaint() {
        if (currentScreen != null) {
            currentScreen.repaint();
            currentScreen.serviceRepaints();
        }
    }

    @Override // javax.microedition.lcdui.j2meCanvas, javax.microedition.lcdui.Displayable
    public void paint(Graphics g) {
        if (Application.loaded && !takingScreenshot) {
            clearVisibleRect();
            try {
                paintInternal(g);
            } catch (Exception e) {
                e.printStackTrace();
            }
            frameNumber++;
        }
    }

    @Override // javax.microedition.lcdui.j2meCanvas
    public void hideNotify() {
        resetKeys();
        super.hideNotify();
    }

    @Override // javax.microedition.lcdui.j2meCanvas
    public void showNotify() {
        resetKeys();
        super.showNotify();
    }

    public static void beginInputProcessing() {
        userInputState = liveInputState;
        quickPressRelease = liveQuickPressRelease;
        isInProcessLoop = true;
    }

    public static void endInputProcessing() {
        isInProcessLoop = false;
        liveQuickPressRelease &= quickPressRelease ^ (-1);
        lastInputState = userInputState;
    }

    public static boolean keysDown(int keys) {
        return ((userInputState | quickPressRelease) & keys) != 0;
    }

    public static boolean keysPressed(int keys) {
        return ((((userInputState ^ lastInputState) & userInputState) & keys) == 0 && (quickPressRelease & keys) == 0) ? false : true;
    }

    public static boolean keysReleased(int keys) {
        return ((((userInputState ^ lastInputState) & lastInputState) & keys) == 0 && (quickPressRelease & keys) == 0) ? false : true;
    }

    @Override // javax.microedition.lcdui.j2meCanvas
    public final void keyPressed(int keyCode) {
        if (Application.loaded) {
            Application.applicationPaused = false;
            numberKey = -1;
            if (keyCode >= 7 && keyCode <= 16) {
                numberKey = keyCode - 7;
                liveInputState |= 131072;
            }
            if (keyCode == -6) {
                liveInputState |= 32768;
            }
            if (keyCode == -7) {
                liveInputState |= 65536;
            }
            try {
                switch (getGameAction(keyCode)) {
                    case 1:
                        liveInputState |= 8;
                        break;
                    case 2:
                        if (keyCode != -6 && keyCode != -7 && keyCode != -11) {
                            liveInputState |= 16;
                            break;
                        }
                        break;
                    case 19:
                        liveInputState |= 2;
                        break;
                    case 20:
                        liveInputState |= 4;
                        break;
                    case 21:
                        liveInputState |= 1;
                        break;
                }
                switch (keyCode) {
                    case 7:
                        liveInputState |= 4096;
                        return;
                    case 8:
                        liveInputState |= 32;
                        return;
                    case 9:
                        liveInputState |= 1;
                        return;
                    case 10:
                        liveInputState |= 64;
                        return;
                    case 11:
                        liveInputState |= 2;
                        return;
                    case 12:
                        liveInputState |= 16;
                        return;
                    case 13:
                        liveInputState |= 4;
                        return;
                    case 14:
                        liveInputState |= 128;
                        return;
                    case 15:
                        liveInputState |= 8;
                        return;
                    case 16:
                        liveInputState |= SimpleGLRenderer.cMaxResID;
                        return;
                    case 17:
                        liveInputState |= 8192;
                        return;
                    case 18:
                        liveInputState |= 16384;
                        return;
                    default:
                        return;
                }
            } catch (Exception e) {
            }
        }
    }

    @Override // javax.microedition.lcdui.j2meCanvas
    public final void keyReleased(int keyCode) {
        super.keyReleased(keyCode);
        if (Application.loaded) {
            int stateBefore = liveInputState;
            if (keyCode == -6) {
                liveInputState &= -32769;
            }
            if (keyCode == -7) {
                liveInputState &= -65537;
            }
            if (keyCode >= 7 && keyCode <= 16) {
                liveInputState &= -131073;
            }
            try {
                switch (getGameAction(keyCode)) {
                    case 1:
                        liveInputState &= -9;
                        break;
                    case 2:
                        liveInputState &= -17;
                        break;
                    case 19:
                        liveInputState &= -3;
                        break;
                    case 20:
                        liveInputState &= -5;
                        break;
                    case 21:
                        liveInputState &= -2;
                        break;
                }
                switch (keyCode) {
                    case 7:
                        liveInputState &= -4097;
                        break;
                    case 8:
                        liveInputState &= -33;
                        break;
                    case 9:
                        liveInputState &= -2;
                        break;
                    case 10:
                        liveInputState &= -65;
                        break;
                    case 11:
                        liveInputState &= -3;
                        break;
                    case 12:
                        liveInputState &= -17;
                        break;
                    case 13:
                        liveInputState &= -5;
                        break;
                    case 14:
                        liveInputState &= -129;
                        break;
                    case 15:
                        liveInputState &= -9;
                        break;
                    case 16:
                        liveInputState &= -257;
                        break;
                    case 17:
                        liveInputState &= -8193;
                        break;
                    case 18:
                        liveInputState &= -16385;
                        break;
                }
            } catch (Exception e) {
            }
            int keyCleared = stateBefore ^ liveInputState;
            if (keyCleared != 0 && (userInputState & keyCleared) == 0) {
                liveQuickPressRelease |= keyCleared;
            }
        }
    }

    public static void resetKeys() {
        liveInputState = 0;
        liveQuickPressRelease = 0;
        userInputState = 0;
        numberKey = -1;
        lastInputState = 0;
        quickPressRelease = 0;
    }

    @Override // javax.microedition.lcdui.j2meCanvas
    public final void pointerPressed(int x, int y) {
        pointerStartX = x;
        pointerX = x;
        pointerStartY = y;
        pointerY = y;
        liveInputState |= 2048;
    }

    @Override // javax.microedition.lcdui.j2meCanvas
    public final void pointerDragged(int x, int y) {
        pointerX = x;
        pointerY = y;
    }

    @Override // javax.microedition.lcdui.j2meCanvas
    public final void pointerReleased(int x, int y) {
        int stateBefore = liveInputState;
        liveInputState &= -2049;
        pointerX = x;
        pointerY = y;
        int keyCleared = stateBefore ^ liveInputState;
        if (keyCleared != 0 && (userInputState & keyCleared) == 0) {
            liveQuickPressRelease |= keyCleared;
        }
    }

    public void process() {
    }

    public j2meImage takeScreenShot() {
        j2meImage j2meimage;
        try {
            takingScreenshot = true;
            j2meImage screenshot = j2meImage.createImage(displayWidth, displayHeight);
            if (screenshot == null) {
                takingScreenshot = false;
                j2meimage = null;
            } else {
                Graphics rendertarget = screenshot.getGraphics();
                if (rendertarget == null) {
                    takingScreenshot = false;
                    j2meimage = null;
                } else {
                    paintInternal(rendertarget);
                    takingScreenshot = false;
                    j2meimage = screenshot;
                }
            }
            return j2meimage;
        } catch (Exception e) {
            takingScreenshot = false;
            return null;
        }
    }
}
