package com.slg.j2me.lib.gfx;

import com.slg.j2me.lib.sys.FixedPoint;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.j2meImage;
/* loaded from: classes.dex */
public class GfxUtils {
    private static int colour = -1;
    public static final int rgbToGreyR = FixedPoint.stringToFP("0.30") / 3;
    public static final int rgbToGreyG = FixedPoint.stringToFP("0.59") / 3;
    public static final int rgbToGreyB = FixedPoint.stringToFP("0.11") / 3;

    public static final void drawCircle(Graphics g, int x, int y, int r, int points) {
        if (ImageSequence.clipSet) {
            g.setClip(0, 0, BaseScreen.displayWidth * 2, BaseScreen.displayHeight * 2);
            ImageSequence.clipSet = false;
        }
        int fp_r = r < 0 ? -((-r) << 16) : r << 16;
        int fp_i_to_angle = (int) (1099511627776L / (points < 0 ? -((-points) << 16) : points << 16));
        int y0 = 0;
        int x0 = 0;
        int i = 0;
        while (i <= points) {
            int fp_i = i < 0 ? -((-i) << 16) : i << 16;
            int x1 = FixedPoint.sinLut(((fp_i ^ fp_i_to_angle) & 134217728) != 0 ? -((int) (((-fp_i) * fp_i_to_angle) >> 16)) : (int) ((fp_i * fp_i_to_angle) >> 16));
            int y1 = FixedPoint.sinLut((((fp_i ^ fp_i_to_angle) & 134217728) != 0 ? -((int) (((-fp_i) * fp_i_to_angle) >> 16)) : (int) ((fp_i * fp_i_to_angle) >> 16)) + 4194304);
            int x12 = ((x1 ^ fp_r) & 134217728) != 0 ? -((int) (((-x1) * fp_r) >> 16)) : (int) ((x1 * fp_r) >> 16);
            int x13 = (x12 < 0 ? -((-x12) >> 16) : x12 >> 16) + x;
            int y12 = ((y1 ^ fp_r) & 134217728) != 0 ? -((int) (((-y1) * fp_r) >> 16)) : (int) ((y1 * fp_r) >> 16);
            int y13 = (y12 < 0 ? -((-y12) >> 16) : y12 >> 16) + y;
            if (i > 0) {
                g.drawLine(x0, y0, x13, y13);
            }
            x0 = x13;
            i++;
            y0 = y13;
        }
    }

    public static final void drawPoint(Graphics g, int x, int y) {
        if (ImageSequence.clipSet) {
            g.setClip(0, 0, BaseScreen.displayWidth * 2, BaseScreen.displayHeight * 2);
            ImageSequence.clipSet = false;
        }
        g.drawLine(x - 1, y, x + 1, y);
        g.drawLine(x, y - 1, x, y + 1);
    }

    public static void setColor(Graphics g, int col) {
        colour = (-16777216) | col;
        g.setColor(colour);
    }

    public static void drawTriangle(Graphics g, int x0, int y0, int x1, int y1, int x2, int y2) {
        if (ImageSequence.clipSet) {
            g.setClip(0, 0, BaseScreen.displayWidth * 2, BaseScreen.displayHeight * 2);
            ImageSequence.clipSet = false;
        }
        g.fillTriangle(x0, y0, x1, y1, x2, y2);
    }

    public static final void drawCrossHatch(Graphics g, int col, int x0, int y0, int w, int h) {
        g.setClip(x0, y0, w, h);
        ImageSequence.clipSet = true;
        g.setColor(col);
        for (int x = 0; x < w; x += 2) {
            g.drawLine(x0 + x, y0, x0 + x + w, y0 + w);
        }
        for (int y = 0; y < h; y += 2) {
            g.drawLine(x0, y0 + y, x0 + h, y0 + y + h);
        }
    }

    public static final int lerpColour(int t, int rgb0, int rgb1) {
        int red = ((rgb1 >> 16) & 255) - ((rgb0 >> 16) & 255);
        int green = ((rgb1 >> 8) & 255) - ((rgb0 >> 8) & 255);
        int blue = (rgb1 & 255) - (rgb0 & 255);
        int red2 = red < 0 ? -((-red) << 16) : red << 16;
        int red3 = ((red2 ^ t) & 134217728) != 0 ? -((int) (((-red2) * t) >> 16)) : (int) ((red2 * t) >> 16);
        int red4 = (red3 < 0 ? -((-red3) >> 16) : red3 >> 16) + ((rgb0 >> 16) & 255);
        int green2 = green < 0 ? -((-green) << 16) : green << 16;
        int green3 = ((green2 ^ t) & 134217728) != 0 ? -((int) (((-green2) * t) >> 16)) : (int) ((green2 * t) >> 16);
        int green4 = (green3 < 0 ? -((-green3) >> 16) : green3 >> 16) + ((rgb0 >> 8) & 255);
        int blue2 = blue < 0 ? -((-blue) << 16) : blue << 16;
        int blue3 = ((blue2 ^ t) & 134217728) != 0 ? -((int) (((-blue2) * t) >> 16)) : (int) ((blue2 * t) >> 16);
        return (-16777216) | ((red4 & 255) << 16) | ((green4 & 255) << 8) | (((blue3 < 0 ? -((-blue3) >> 16) : blue3 >> 16) + (rgb0 & 255)) & 255);
    }

    public static final int modulateColour(int rgb0, int rgb1) {
        int red = (((rgb1 >> 16) & 255) * ((rgb0 >> 16) & 255)) >> 8;
        int green = (((rgb1 >> 8) & 255) * ((rgb0 >> 8) & 255)) >> 8;
        int blue = ((rgb1 & 255) * (rgb0 & 255)) >> 8;
        return (-16777216) | ((red & 255) << 16) | ((green & 255) << 8) | (blue & 255);
    }

    public static final int lerpColourWithAlpha(int t, int rgb0, int rgb1) {
        int red = ((rgb1 >> 16) & 255) - ((rgb0 >> 16) & 255);
        int green = ((rgb1 >> 8) & 255) - ((rgb0 >> 8) & 255);
        int blue = (rgb1 & 255) - (rgb0 & 255);
        int alpha = ((rgb1 >> 24) & 255) - ((rgb0 >> 24) & 255);
        int red2 = red < 0 ? -((-red) << 16) : red << 16;
        int red3 = ((red2 ^ t) & 134217728) != 0 ? -((int) (((-red2) * t) >> 16)) : (int) ((red2 * t) >> 16);
        int red4 = (red3 < 0 ? -((-red3) >> 16) : red3 >> 16) + ((rgb0 >> 16) & 255);
        int green2 = green < 0 ? -((-green) << 16) : green << 16;
        int green3 = ((green2 ^ t) & 134217728) != 0 ? -((int) (((-green2) * t) >> 16)) : (int) ((green2 * t) >> 16);
        int green4 = (green3 < 0 ? -((-green3) >> 16) : green3 >> 16) + ((rgb0 >> 8) & 255);
        int blue2 = blue < 0 ? -((-blue) << 16) : blue << 16;
        int blue3 = ((blue2 ^ t) & 134217728) != 0 ? -((int) (((-blue2) * t) >> 16)) : (int) ((blue2 * t) >> 16);
        int blue4 = (blue3 < 0 ? -((-blue3) >> 16) : blue3 >> 16) + (rgb0 & 255);
        int alpha2 = alpha < 0 ? -((-alpha) << 16) : alpha << 16;
        int alpha3 = ((alpha2 ^ t) & 134217728) != 0 ? -((int) (((-alpha2) * t) >> 16)) : (int) ((alpha2 * t) >> 16);
        return ((((alpha3 < 0 ? -((-alpha3) >> 16) : alpha3 >> 16) + ((rgb0 >> 24) & 255)) & 255) << 24) | ((red4 & 255) << 16) | ((green4 & 255) << 8) | (blue4 & 255);
    }

    public static final int[] resampleImage(j2meImage src, int dst_width, int dst_height) {
        int y0;
        if (src == null) {
            return null;
        }
        int src_width = src.getWidth();
        int src_height = src.getHeight();
        try {
            int[] src_rgb = new int[src_width * src_height];
            if (src_rgb == null) {
                return null;
            }
            src.getRGB(src_rgb, 0, src_width, 0, 0, src_width, src_height);
            int[] dst_rgb = new int[dst_width * dst_height];
            int count = src_width < 0 ? -((-src_width) << 16) : src_width << 16;
            int fp_scale_x = (int) ((count << 16) / (dst_width < 0 ? -((-dst_width) << 16) : dst_width << 16));
            int fp_scale_y = (int) (((src_height < 0 ? -((-src_height) << 16) : src_height << 16) << 16) / (dst_height < 0 ? -((-dst_height) << 16) : dst_height << 16));
            int y = 0;
            while (true) {
                int y2 = y;
                if (y2 >= dst_height) {
                    return dst_rgb;
                }
                int ib = 0;
                while (true) {
                    int x = ib;
                    if (x < dst_width) {
                        int count2 = 0;
                        long r = 0;
                        long g = 0;
                        long b = 0;
                        int y02 = y2 * fp_scale_y < 0 ? -((-(y2 * fp_scale_y)) >> 16) : (y2 * fp_scale_y) >> 16;
                        int y03 = y02;
                        while (true) {
                            int y04 = y2 + 1;
                            if (y03 >= (y04 * fp_scale_y < 0 ? -((-((y2 + 1) * fp_scale_y)) >> 16) : ((y2 + 1) * fp_scale_y) >> 16)) {
                                break;
                            }
                            int x0 = x * fp_scale_x < 0 ? -((-(x * fp_scale_x)) >> 16) : (x * fp_scale_x) >> 16;
                            int x02 = x0;
                            long r2 = r;
                            while (true) {
                                if (x02 < ((x + 1) * fp_scale_x < 0 ? -((-((x + 1) * fp_scale_x)) >> 16) : ((x + 1) * fp_scale_x) >> 16)) {
                                    int pixel = src_rgb[(y03 * src_width) + x02];
                                    r2 += (pixel >> 16) & 255;
                                    g += (pixel >> 8) & 255;
                                    b += pixel & 255;
                                    count2++;
                                    x02++;
                                }
                            }
                            y03++;
                            r = r2;
                        }
                        if (count2 == 0) {
                            int count3 = y2 * fp_scale_y;
                            if (count3 < 0) {
                                int count4 = y2 * fp_scale_y;
                                y0 = -((-count4) >> 16);
                            } else {
                                y0 = (y2 * fp_scale_y) >> 16;
                            }
                            int x03 = x * fp_scale_x < 0 ? -((-(x * fp_scale_x)) >> 16) : (x * fp_scale_x) >> 16;
                            int pixel2 = src_rgb[x03 + (y0 * src_width)];
                            r = (pixel2 >> 16) & 255;
                            g = (pixel2 >> 8) & 255;
                            b = pixel2 & 255;
                            count2 = 1;
                        }
                        int ir = (int) (r / count2);
                        int ig = (int) (g / count2);
                        int ib2 = (int) (b / count2);
                        dst_rgb[(y2 * dst_width) + x] = (ib2 & 255) | (-16777216) | ((ir & 255) << 16) | ((ig & 255) << 8);
                        ib = x + 1;
                    }
                }
                y = y2 + 1;
            }
        } catch (Exception e) {
            return null;
        }
    }

    public void colourizePng(byte[] png_file, int colour2) {
        int palOffset = 0;
        int i = 0;
        while (true) {
            if (i >= png_file.length - 4) {
                break;
            } else if (png_file[i] != 80 || png_file[i + 1] != 76 || png_file[i + 2] != 84) {
                i++;
            } else {
                palOffset = i;
                break;
            }
        }
        int dataOffset = palOffset - 4;
        int numColors = (((png_file[dataOffset] & 255) << 24) | ((png_file[dataOffset + 1] & 255) << 16) | ((png_file[dataOffset + 2] & 255) << 8) | (png_file[dataOffset + 3] & 255)) & (-1);
        int dataOffset2 = dataOffset + 8;
        int r = (colour2 >> 16) & 255;
        int g = (colour2 >> 8) & 255;
        int b = colour2 & 255;
        for (int i2 = dataOffset2; i2 < dataOffset2 + numColors; i2 += 3) {
            int r_c = png_file[i2] & 255;
            int g_c = png_file[i2 + 1] & 255;
            int b_c = png_file[i2 + 2] & 255;
            png_file[i2] = (byte) ((r * r_c) >> 8);
            png_file[i2 + 1] = (byte) ((g * g_c) >> 8);
            png_file[i2 + 2] = (byte) ((b * b_c) >> 8);
        }
    }

    public static final j2meImage createDarkImage(j2meImage image, int x0, int y0, int w, int h) {
        int area = w * h;
        try {
            int[] rgb = new int[area];
            if (rgb == null) {
                return null;
            }
            image.getRGB(rgb, 0, image.getWidth(), x0, y0, w, h);
            for (int i = 0; i < area; i++) {
                int old = rgb[i];
                int g = (old >> 8) & 255;
                int grey = (((old & 255) * rgbToGreyB) + ((g * rgbToGreyG) + (((old >> 16) & 255) * rgbToGreyR))) >> 16;
                int grey2 = lerpColour(16384, (grey & 255) | (-16777216) | ((grey & 255) << 16) | ((grey & 255) << 8), old);
                int r = (grey2 >> 16) & 255;
                int g2 = (grey2 >> 8) & 255;
                int b = grey2 & 255;
                int g3 = (((g2 - (g2 >> 2)) & 255) << 8) | (((r - (r >> 2)) & 255) << 16) | (-16777216);
                int r2 = b >> 2;
                rgb[i] = ((b - r2) & 255) | g3;
            }
            return j2meImage.createRGBImage(rgb, w, h, false);
        } catch (Exception e) {
            return null;
        }
    }
}
