package com.slg.j2me.lib.gfx;

import java.util.Vector;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.j2meGraphics;
import javax.microedition.lcdui.j2meImage;
/* loaded from: classes.dex */
public class ImageSequence {
    public static final int IS_HEIGHT = 3;
    public static final int IS_MAX = 8;
    public static final int IS_OFFSETX = 4;
    public static final int IS_OFFSETY = 5;
    public static final int IS_ORIGHEIGHT = 7;
    public static final int IS_ORIGWIDTH = 6;
    public static final int IS_SHIFT = 3;
    public static final int IS_WIDTH = 2;
    public static final int IS_X = 0;
    public static final int IS_Y = 1;
    public short[] clipRects;
    public byte clipRectsStride;
    public int currentFrame;
    byte flags;
    public j2meImage[] imageFrame;
    public byte[] imageIndex;
    public int numFrames;
    public Vector vecImageFilenames = new Vector();
    public static boolean doNotClip = false;
    private static int[] tempClip = new int[4];
    private static int[] clip = new int[4];
    public static boolean clipSet = false;

    public void setup(byte lFlags, int lFrames, int liTotalNumPages) {
        this.flags = lFlags;
        this.numFrames = lFrames;
        if ((this.flags & 2) != 0) {
        }
        this.clipRectsStride = (this.flags & 2) != 0 ? (byte) 8 : (byte) 4;
        this.clipRects = new short[this.numFrames * this.clipRectsStride];
        if (liTotalNumPages > 1) {
            this.imageIndex = new byte[this.numFrames];
        }
        this.imageFrame = new j2meImage[liTotalNumPages];
    }

    public short getRectWidth(int frame) {
        return (this.flags & 2) != 0 ? this.clipRects[(this.clipRectsStride * frame) + 6] : this.clipRects[(this.clipRectsStride * frame) + 2];
    }

    public short getRectHeight(int frame) {
        return (this.flags & 2) != 0 ? this.clipRects[(this.clipRectsStride * frame) + 7] : this.clipRects[(this.clipRectsStride * frame) + 3];
    }

    public short getClipRectX(int frame) {
        return this.clipRects[(this.clipRectsStride * frame) + 0];
    }

    public short getClipRectY(int frame) {
        return this.clipRects[(this.clipRectsStride * frame) + 1];
    }

    public short getClipRectWidth(int frame) {
        return this.clipRects[(this.clipRectsStride * frame) + 2];
    }

    public short getClipRectHeight(int frame) {
        return this.clipRects[(this.clipRectsStride * frame) + 3];
    }

    private short getOffsetX(int frame) {
        if ((this.flags & 2) != 0) {
            return this.clipRects[(this.clipRectsStride * frame) + 4];
        }
        return (short) 0;
    }

    private short getOffsetY(int frame) {
        if ((this.flags & 2) != 0) {
            return this.clipRects[(this.clipRectsStride * frame) + 5];
        }
        return (short) 0;
    }

    public void setRect(int frame, int x0, int y0, int w, int h, int offsetX, int offsetY, int originalWidth, int originalHeight) {
        if ((this.flags & 2) != 0) {
            this.clipRects[(this.clipRectsStride * frame) + 0] = (short) x0;
            this.clipRects[(this.clipRectsStride * frame) + 1] = (short) y0;
            this.clipRects[(this.clipRectsStride * frame) + 4] = (short) offsetX;
            this.clipRects[(this.clipRectsStride * frame) + 5] = (short) offsetY;
            this.clipRects[(this.clipRectsStride * frame) + 2] = (short) originalWidth;
            this.clipRects[(this.clipRectsStride * frame) + 3] = (short) originalHeight;
            this.clipRects[(this.clipRectsStride * frame) + 6] = (short) w;
            this.clipRects[(this.clipRectsStride * frame) + 7] = (short) h;
            return;
        }
        this.clipRects[(this.clipRectsStride * frame) + 0] = (short) x0;
        this.clipRects[(this.clipRectsStride * frame) + 1] = (short) y0;
        this.clipRects[(this.clipRectsStride * frame) + 2] = (short) w;
        this.clipRects[(this.clipRectsStride * frame) + 3] = (short) h;
    }

    public void copyRect(int dst_frame, ImageSequence other, int src_frame) {
        this.clipRects[(this.clipRectsStride * dst_frame) + 0] = other.clipRects[(this.clipRectsStride * src_frame) + 0];
        this.clipRects[(this.clipRectsStride * dst_frame) + 1] = other.clipRects[(this.clipRectsStride * src_frame) + 1];
        this.clipRects[(this.clipRectsStride * dst_frame) + 2] = other.clipRects[(this.clipRectsStride * src_frame) + 2];
        this.clipRects[(this.clipRectsStride * dst_frame) + 3] = other.clipRects[(this.clipRectsStride * src_frame) + 3];
        if ((this.flags & 2) != 0 && (other.flags & 2) != 0) {
            this.clipRects[(this.clipRectsStride * dst_frame) + 4] = other.clipRects[(this.clipRectsStride * src_frame) + 4];
            this.clipRects[(this.clipRectsStride * dst_frame) + 5] = other.clipRects[(this.clipRectsStride * src_frame) + 5];
            this.clipRects[(this.clipRectsStride * dst_frame) + 6] = other.clipRects[(this.clipRectsStride * src_frame) + 6];
            this.clipRects[(this.clipRectsStride * dst_frame) + 7] = other.clipRects[(this.clipRectsStride * src_frame) + 7];
        }
    }

    public int addImageIfNew(String filename) {
        int i = getImageIndex(filename);
        if (i == -1) {
            int i2 = this.vecImageFilenames.size();
            this.vecImageFilenames.addElement(filename);
            return i2;
        }
        return i;
    }

    public int getImageIndex(String filename) {
        for (int i = 0; i < this.vecImageFilenames.size(); i++) {
            String str = (String) this.vecImageFilenames.elementAt(i);
            if (str.equals(filename)) {
                return i;
            }
        }
        return -1;
    }

    public j2meImage getImage(int frame) {
        return this.imageIndex == null ? this.imageFrame[0] : this.imageFrame[this.imageIndex[frame]];
    }

    public static ImageSequence createFromImage(String filename) {
        ImageSequence seq = new ImageSequence();
        if (filename.startsWith("/")) {
            filename = filename.substring(1, filename.length());
        }
        seq.vecImageFilenames = new Vector();
        seq.addImageIfNew(filename);
        seq.setup((byte) 0, 1, 1);
        seq.imageFrame[0] = ImageSet.loadImage("/" + filename);
        if (seq.imageFrame[0] != null) {
            seq.setRect(0, 0, 0, seq.imageFrame[0].getWidth(), seq.imageFrame[0].getHeight(), 0, 0, 0, 0);
        } else {
            seq.setRect(0, 0, 0, 0, 0, 0, 0, 0, 0);
        }
        return seq;
    }

    public static ImageSequence createFromImage(j2meImage image) {
        ImageSequence seq = new ImageSequence();
        seq.setup((byte) 0, 1, 1);
        seq.imageFrame[0] = image;
        if (seq.imageFrame[0] != null) {
            seq.setRect(0, 0, 0, image.getWidth(), image.getHeight(), 0, 0, 0, 0);
            seq.numFrames = 1;
            return seq;
        }
        seq.setRect(0, 0, 0, 0, 0, 0, 0, 0, 0);
        return null;
    }

    public static ImageSequence createBlank(int width, int height, int frames, byte flags) {
        try {
            ImageSequence seq = new ImageSequence();
            seq.setup(flags, frames, 1);
            for (int i = 0; i < frames; i++) {
                seq.clipRects[(seq.clipRectsStride * i) + 0] = (short) ((i * width) / frames);
                seq.clipRects[(seq.clipRectsStride * i) + 1] = 0;
                seq.clipRects[(seq.clipRectsStride * i) + 2] = (short) (width / frames);
                seq.clipRects[(seq.clipRectsStride * i) + 3] = (short) height;
            }
            seq.imageFrame[0] = j2meImage.createImage(width, height);
            return seq;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    public void copyFrame(ImageSequence seq, int src_frame, int dst_frame) {
        try {
            setRect(dst_frame, dst_frame * seq.getClipRectWidth(src_frame), 0, seq.getClipRectWidth(src_frame), seq.getClipRectHeight(src_frame), seq.getOffsetX(src_frame), seq.getOffsetY(src_frame), seq.getRectWidth(src_frame), seq.getRectHeight(src_frame));
            if (seq.getImage(src_frame) != null) {
                j2meGraphics g = getImage(dst_frame).getGraphics();
                seq.drawImage(g, src_frame, getClipRectX(dst_frame), getClipRectY(dst_frame));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void copyFrame(j2meImage imgSrc, int dst_frame) {
        try {
            j2meGraphics g = getImage(dst_frame).getGraphics();
            g.drawImage(imgSrc, getClipRectX(dst_frame), 0, 13);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void drawIntoFrame(j2meImage src_img, int dst_frame) {
        try {
            setRect(dst_frame, dst_frame * src_img.getWidth(), 0, src_img.getWidth(), src_img.getHeight(), 0, 0, 0, 0);
            j2meGraphics g = getImage(dst_frame).getGraphics();
            g.drawImage(src_img, src_img.getWidth() * dst_frame, 0, 13);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void unload() {
        for (int i = 0; i < this.imageFrame.length; i++) {
            this.imageFrame[i] = null;
        }
    }

    public void reload() {
        for (int i = 0; i < this.vecImageFilenames.size(); i++) {
            String filename = (String) this.vecImageFilenames.elementAt(i);
            if (this.imageFrame[i] == null) {
                this.imageFrame[i] = ImageSet.loadImage("/" + filename);
            }
        }
    }

    public void drawImage(Graphics g, int frame, int x, int y) {
        tempClip[0] = BaseScreen.visibleRect.x0;
        tempClip[1] = BaseScreen.visibleRect.y0;
        tempClip[2] = BaseScreen.visibleRect.w;
        tempClip[3] = BaseScreen.visibleRect.h;
        drawImageClipped(g, frame, x, y, tempClip);
    }

    public void drawImageCropEdges(Graphics g, int frame, int x, int y) {
        if (getImage(frame) != null) {
            if ((this.flags & 2) != 0) {
                x += getOffsetX(frame);
                y += getOffsetY(frame);
            }
            tempClip[0] = BaseScreen.visibleRect.x0;
            tempClip[1] = BaseScreen.visibleRect.y0;
            tempClip[2] = BaseScreen.visibleRect.w;
            tempClip[3] = BaseScreen.visibleRect.h;
            int[] rect = tempClip;
            clip[0] = x > rect[0] ? x : rect[0];
            clip[1] = y > rect[1] ? y : rect[1];
            int w = (getClipRectX(frame) + getClipRectWidth(frame) < getImage(frame).getWidth() ? getClipRectX(frame) + getClipRectWidth(frame) : getImage(frame).getWidth()) - getClipRectX(frame);
            int h = (getClipRectY(frame) + getClipRectHeight(frame) < getImage(frame).getHeight() ? getClipRectY(frame) + getClipRectHeight(frame) : getImage(frame).getHeight()) - getClipRectY(frame);
            clip[2] = (x + w < rect[0] + rect[2] ? x + w : rect[0] + rect[2]) - clip[0];
            clip[3] = (y + h < rect[1] + rect[3] ? y + h : rect[1] + rect[3]) - clip[1];
            if (clip[2] > 0 && clip[3] > 0) {
                g.drawRegion(getImage(frame), getClipRectX(frame) + (clip[0] - x) + 1, getClipRectY(frame) + (clip[1] - y) + 1, clip[2] - 2, clip[3] - 2, 0, clip[0], clip[1], 13);
            }
        }
    }

    public void drawImageTrans(Graphics g, int frame, int x, int y, int trans) {
        if (getImage(frame) != null) {
            if ((this.flags & 2) != 0) {
                x += getOffsetX(frame);
                y += getOffsetY(frame);
            }
            if (getClipRectWidth(frame) + x > BaseScreen.visibleRect.x0 && x - BaseScreen.visibleRect.x0 < BaseScreen.displayWidth && getClipRectHeight(frame) + y > BaseScreen.visibleRect.y0 && y - BaseScreen.visibleRect.y0 < BaseScreen.displayHeight) {
                g.drawRegion(getImage(frame), getClipRectX(frame), getClipRectY(frame), getClipRectWidth(frame), getClipRectHeight(frame), trans, x, y, 13);
            }
        }
    }

    public void drawImageStretched(Graphics g, int frame, int x, int y, int trans, int w, int h) {
        if (getImage(frame) != null) {
            if ((this.flags & 2) != 0) {
                x += getOffsetX(frame);
                y += getOffsetY(frame);
            }
            if (x + w > BaseScreen.visibleRect.x0 && x - BaseScreen.visibleRect.x0 < BaseScreen.displayWidth && y + h > BaseScreen.visibleRect.y0 && y - BaseScreen.visibleRect.y0 < BaseScreen.displayHeight) {
                g.drawRegionStretched(getImage(frame), getClipRectX(frame), getClipRectY(frame), getClipRectWidth(frame), getClipRectHeight(frame), trans, x, y, w, h, 13);
            }
        }
    }

    public void drawImageScaled(Graphics g, int frame, int cx, int cy, int fp_scale, int trans) {
        if (getImage(frame) != null) {
            if ((this.flags & 2) != 0) {
                cx += getOffsetX(frame);
                cy += getOffsetY(frame);
            }
            int x = cx - (getRectWidth(frame) >> 1);
            int y = cy - (getRectHeight(frame) >> 1);
            int w = getClipRectWidth(frame);
            int h = getClipRectHeight(frame);
            int sw = fp_scale * w;
            int sh = fp_scale * h;
            int sw2 = sw < 0 ? -((-sw) >> 16) : sw >> 16;
            int sh2 = sh < 0 ? -((-sh) >> 16) : sh >> 16;
            int x2 = x + ((w - sw2) / 2);
            int y2 = y + ((h - sh2) / 2);
            if (x2 + sw2 > BaseScreen.visibleRect.x0 && x2 - BaseScreen.visibleRect.x0 < BaseScreen.displayWidth && y2 + sh2 > BaseScreen.visibleRect.y0 && y2 - BaseScreen.visibleRect.y0 < BaseScreen.displayHeight) {
                g.drawRegionStretched(getImage(frame), getClipRectX(frame) + 1, getClipRectY(frame) + 1, w - 2, h - 2, trans, x2, y2, sw2, sh2, 13);
            }
        }
    }

    public void drawImageRotated(Graphics g, int frame, int cx, int cy, int fp_zrot, int fp_scale, int trans) {
        if (getImage(frame) != null) {
            g.drawSpriteRotated(getImage(frame), getClipRectX(frame), getClipRectY(frame), getClipRectWidth(frame), getClipRectHeight(frame), trans, cx, cy, fp_zrot, fp_scale);
        }
    }

    public void drawImageClipped(Graphics g, int frame, int x, int y, int[] rect) {
        if (getImage(frame) != null) {
            if ((this.flags & 2) != 0) {
                x += getOffsetX(frame);
                y += getOffsetY(frame);
            }
            clip[0] = x > rect[0] ? x : rect[0];
            clip[1] = y > rect[1] ? y : rect[1];
            int w = (getClipRectX(frame) + getClipRectWidth(frame) < getImage(frame).getWidth() ? getClipRectX(frame) + getClipRectWidth(frame) : getImage(frame).getWidth()) - getClipRectX(frame);
            int h = (getClipRectY(frame) + getClipRectHeight(frame) < getImage(frame).getHeight() ? getClipRectY(frame) + getClipRectHeight(frame) : getImage(frame).getHeight()) - getClipRectY(frame);
            clip[2] = (x + w < rect[0] + rect[2] ? x + w : rect[0] + rect[2]) - clip[0];
            clip[3] = (y + h < rect[1] + rect[3] ? y + h : rect[1] + rect[3]) - clip[1];
            if (clip[2] > 0 && clip[3] > 0) {
                g.drawRegion(getImage(frame), (clip[0] - x) + getClipRectX(frame), (clip[1] - y) + getClipRectY(frame), clip[2], clip[3], 0, clip[0], clip[1], 13);
            }
        }
    }
}
