package com.slg.j2me.lib.gfx;

import com.ju6.mms.pdu.PduHeaders;
import com.slg.j2me.lib.sys.Application;
import com.slg.j2me.lib.sys.FixedPoint;
import com.slg.j2me.lib.sys.VecMath;
import java.io.DataInputStream;
import java.io.InputStream;
import java.lang.reflect.Array;
import javax.microedition.lcdui.Graphics;
/* loaded from: classes.dex */
public class Software3D {
    public static int[] loadedCameraFOV;
    public static int[] loadedCameraFarClip;
    public static int[][][] loadedCameraMatrix;
    public static int[] loadedCameraNearClip;
    private static int[][] worldTrans;
    public static boolean drawNormals = false;
    public static int clipMinZ = 65536;
    public static int[][] matrixCamera = (int[][]) Array.newInstance(Integer.TYPE, 4, 4);
    public static int[][] matrixComposite = (int[][]) Array.newInstance(Integer.TYPE, 4, 4);
    public static int[] matrixCompositeFast = new int[16];
    public static int[][] matrixInvWorldTrans = (int[][]) Array.newInstance(Integer.TYPE, 4, 4);
    public static int fp_viewport_x0 = 0;
    public static int fp_viewport_y0 = 0;
    public static int renderWidth = 533;
    public static int renderHeight = 320;
    public static int halfWidth = 266;
    public static int halfHeight = PduHeaders.PREVIOUSLY_SENT_BY;
    private static int[] vAB = new int[3];
    private static int[] vAC = new int[3];
    private static int[] vNorm = new int[3];
    private static int[] vR = new int[3];
    public static Plane nearPlane = new Plane();
    public static Plane nearPlaneWS = new Plane();
    private static int[] nearFrom = new int[3];
    private static int[] nearNormal = new int[3];
    private static int[][] mat33 = (int[][]) Array.newInstance(Integer.TYPE, 3, 3);
    private static int[] temp3 = new int[3];
    private static int[] dst = new int[16];
    private static int[] tmp = new int[12];
    private static int[] src = new int[16];
    private static int[] localFrom = new int[4];
    private static int[] localNormal = new int[4];
    private static int[][] temp_matView = (int[][]) Array.newInstance(Integer.TYPE, 4, 4);
    private static int[][] temp_matProj = (int[][]) Array.newInstance(Integer.TYPE, 4, 4);
    private static int[] newup = new int[3];
    private static int[] right = new int[3];
    private static int[] view = new int[3];
    private static int[] vdist = new int[3];
    private static int[][] vert = (int[][]) Array.newInstance(Integer.TYPE, 3, 3);
    private static int[][] p = (int[][]) Array.newInstance(Integer.TYPE, 4, 4);
    private static int[] near_dist = new int[2];

    /* loaded from: classes.dex */
    public static class Plane {
        public int[] normal;
        public int offset;

        public void makePlane(int[] pt, int[] norm) {
            this.normal = norm;
            this.offset = (((pt[0] ^ norm[0]) & 134217728) != 0 ? -((int) (((-pt[0]) * norm[0]) >> 16)) : (int) ((pt[0] * norm[0]) >> 16)) + (((pt[1] ^ norm[1]) & 134217728) != 0 ? -((int) (((-pt[1]) * norm[1]) >> 16)) : (int) ((pt[1] * norm[1]) >> 16)) + (((pt[2] ^ norm[2]) & 134217728) != 0 ? -((int) (((-pt[2]) * norm[2]) >> 16)) : (int) ((pt[2] * norm[2]) >> 16));
        }

        public int getDistFromPlane(int[] pt) {
            return (((((this.normal[0] ^ pt[0]) & 134217728) != 0 ? -((int) (((-this.normal[0]) * pt[0]) >> 16)) : (int) ((this.normal[0] * pt[0]) >> 16)) + (((this.normal[1] ^ pt[1]) & 134217728) != 0 ? -((int) (((-this.normal[1]) * pt[1]) >> 16)) : (int) ((this.normal[1] * pt[1]) >> 16))) + (((this.normal[2] ^ pt[2]) & 134217728) != 0 ? -((int) (((-this.normal[2]) * pt[2]) >> 16)) : (int) ((this.normal[2] * pt[2]) >> 16))) - this.offset;
        }

        public int intersection(int[] pt, int[] dir) {
            int vd = (((this.normal[0] ^ dir[0]) & 134217728) != 0 ? -((int) (((-this.normal[0]) * dir[0]) >> 16)) : (int) ((this.normal[0] * dir[0]) >> 16)) + (((this.normal[1] ^ dir[1]) & 134217728) != 0 ? -((int) (((-this.normal[1]) * dir[1]) >> 16)) : (int) ((this.normal[1] * dir[1]) >> 16)) + (((this.normal[2] ^ dir[2]) & 134217728) != 0 ? -((int) (((-this.normal[2]) * dir[2]) >> 16)) : (int) ((this.normal[2] * dir[2]) >> 16));
            if ((vd < 0 ? -vd : vd) < 66) {
                return 0;
            }
            int v0 = -((((((this.normal[0] ^ pt[0]) & 134217728) != 0 ? -((int) (((-this.normal[0]) * pt[0]) >> 16)) : (int) ((this.normal[0] * pt[0]) >> 16)) + (((this.normal[1] ^ pt[1]) & 134217728) != 0 ? -((int) (((-this.normal[1]) * pt[1]) >> 16)) : (int) ((this.normal[1] * pt[1]) >> 16))) + (((this.normal[2] ^ pt[2]) & 134217728) != 0 ? -((int) (((-this.normal[2]) * pt[2]) >> 16)) : (int) ((this.normal[2] * pt[2]) >> 16))) - this.offset);
            return (int) ((v0 << 16) / vd);
        }
    }

    public static int getClipPlaneDist(int[] pt) {
        return nearPlaneWS.getDistFromPlane(pt);
    }

    public static final void setIdentity(int[][] mat) {
        int j = 0;
        while (j < 4) {
            int i = 0;
            while (i < 4) {
                mat[j][i] = j == i ? 65536 : 0;
                i++;
            }
            j++;
        }
    }

    public static final void setTranslate(int[][] matrixWorldTrans, int[] pos) {
        setIdentity(matrixWorldTrans);
        matrixWorldTrans[3][0] = pos[0];
        matrixWorldTrans[3][1] = pos[1];
        matrixWorldTrans[3][2] = pos[2];
    }

    public static final void preRotateY(int[][] matrixWorldTrans, int angle) {
        while (angle < 0) {
            angle += 16777216;
        }
        matrixWorldTrans[0][0] = FixedPoint.sinLut(4194304 + angle);
        matrixWorldTrans[0][2] = -FixedPoint.sinLut(angle);
        matrixWorldTrans[2][0] = -matrixWorldTrans[0][2];
        matrixWorldTrans[2][2] = matrixWorldTrans[0][0];
    }

    public static final void setRotateZVec3(int[] vec, int angle) {
        makeRotateZ33(mat33, angle);
        temp3[0] = vec[0];
        temp3[1] = vec[1];
        temp3[2] = vec[2];
        setMulVec3(vec, temp3, mat33);
        VecMath.norm3d(vec, vec);
    }

    public static final void setRotateAxisVec3(int[] vec, int[] axis, int angle) {
        makeRotateAxis33(mat33, axis, angle);
        temp3[0] = vec[0];
        temp3[1] = vec[1];
        temp3[2] = vec[2];
        setMulVec3(vec, temp3, mat33);
        VecMath.norm3d(vec, vec);
    }

    public static final void makeRotateZ33(int[][] mat, int theta) {
        while (theta < 0) {
            theta += 16777216;
        }
        int sintheta = FixedPoint.sinLut(theta);
        int costheta = FixedPoint.sinLut(4194304 + theta);
        mat[0][0] = costheta;
        mat[0][1] = sintheta;
        mat[0][2] = 0;
        mat[1][0] = -sintheta;
        mat[1][1] = costheta;
        mat[1][2] = 0;
        mat[2][0] = 0;
        mat[2][1] = 0;
        mat[2][2] = 65536;
    }

    public static final void makeRotateAxis33(int[][] mat, int[] d, int theta) {
        while (theta < 0) {
            theta += 16777216;
        }
        int s = FixedPoint.sinLut(theta);
        int theta2 = FixedPoint.sinLut(theta + 4194304);
        int t = 65536 - theta2;
        mat[0][0] = ((d[0] ^ d[0]) & 134217728) != 0 ? -((int) (((-d[0]) * d[0]) >> 16)) : (int) ((d[0] * d[0]) >> 16);
        mat[0][0] = ((mat[0][0] ^ t) & 134217728) != 0 ? -((int) (((-mat[0][0]) * t) >> 16)) : (int) ((mat[0][0] * t) >> 16);
        mat[0][1] = ((d[0] ^ d[1]) & 134217728) != 0 ? -((int) (((-d[0]) * d[1]) >> 16)) : (int) ((d[0] * d[1]) >> 16);
        mat[0][1] = ((mat[0][1] ^ t) & 134217728) != 0 ? -((int) (((-mat[0][1]) * t) >> 16)) : (int) ((mat[0][1] * t) >> 16);
        mat[0][2] = ((d[0] ^ d[2]) & 134217728) != 0 ? -((int) (((-d[0]) * d[2]) >> 16)) : (int) ((d[0] * d[2]) >> 16);
        mat[0][2] = ((mat[0][2] ^ t) & 134217728) != 0 ? -((int) (((-mat[0][2]) * t) >> 16)) : (int) ((mat[0][2] * t) >> 16);
        mat[1][1] = ((d[1] ^ d[1]) & 134217728) != 0 ? -((int) (((-d[1]) * d[1]) >> 16)) : (int) ((d[1] * d[1]) >> 16);
        mat[1][1] = ((mat[1][1] ^ t) & 134217728) != 0 ? -((int) (((-mat[1][1]) * t) >> 16)) : (int) ((mat[1][1] * t) >> 16);
        mat[1][2] = ((d[1] ^ d[2]) & 134217728) != 0 ? -((int) (((-d[1]) * d[2]) >> 16)) : (int) ((d[1] * d[2]) >> 16);
        mat[1][2] = ((mat[1][2] ^ t) & 134217728) != 0 ? -((int) (((-mat[1][2]) * t) >> 16)) : (int) ((mat[1][2] * t) >> 16);
        mat[2][2] = ((d[2] ^ d[2]) & 134217728) != 0 ? -((int) (((-d[2]) * d[2]) >> 16)) : (int) ((d[2] * d[2]) >> 16);
        mat[2][2] = ((mat[2][2] ^ t) & 134217728) != 0 ? -((int) (((-mat[2][2]) * t) >> 16)) : (int) ((mat[2][2] * t) >> 16);
        mat[1][0] = mat[0][1];
        mat[2][0] = mat[0][2];
        mat[2][1] = mat[1][2];
        int[] iArr = mat[0];
        iArr[0] = iArr[0] + theta2;
        int[] iArr2 = mat[0];
        iArr2[1] = iArr2[1] + (((d[2] ^ s) & 134217728) != 0 ? -((int) (((-s) * d[2]) >> 16)) : (int) ((s * d[2]) >> 16));
        int[] iArr3 = mat[0];
        iArr3[2] = iArr3[2] - (((d[1] ^ s) & 134217728) != 0 ? -((int) (((-s) * d[1]) >> 16)) : (int) ((s * d[1]) >> 16));
        int[] iArr4 = mat[1];
        iArr4[0] = iArr4[0] - (((d[2] ^ s) & 134217728) != 0 ? -((int) (((-s) * d[2]) >> 16)) : (int) ((s * d[2]) >> 16));
        int[] iArr5 = mat[1];
        iArr5[1] = iArr5[1] + theta2;
        int[] iArr6 = mat[1];
        iArr6[2] = iArr6[2] + (((d[0] ^ s) & 134217728) != 0 ? -((int) (((-s) * d[0]) >> 16)) : (int) ((s * d[0]) >> 16));
        int[] iArr7 = mat[2];
        iArr7[0] = iArr7[0] + (((d[1] ^ s) & 134217728) != 0 ? -((int) (((-s) * d[1]) >> 16)) : (int) ((s * d[1]) >> 16));
        int[] iArr8 = mat[2];
        iArr8[1] = iArr8[1] - (((d[0] ^ s) & 134217728) != 0 ? -((int) (((-s) * d[0]) >> 16)) : (int) ((s * d[0]) >> 16));
        int[] iArr9 = mat[2];
        int c = theta2 + iArr9[2];
        iArr9[2] = c;
    }

    public static void copyMatrix(int[][] out, int[][] in) {
        for (int j = 0; j < 4; j++) {
            for (int i = 0; i < 4; i++) {
                out[j][i] = in[j][i];
            }
        }
    }

    public static void copyMatrix43(int[][] out, int[][] in) {
        for (int j = 0; j < 4; j++) {
            for (int i = 0; i < 3; i++) {
                out[j][i] = in[j][i];
            }
        }
    }

    public static void convertMatrix44(int[] out, int[][] in) {
        for (int j = 0; j < 4; j++) {
            for (int i = 0; i < 4; i++) {
                out[(j * 4) + i] = in[j][i];
            }
        }
    }

    public static void setMulVec3(int[] out_vec3, int[] in_vec3, int[][] in_matrix) {
        out_vec3[0] = (((in_vec3[0] ^ in_matrix[0][0]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][0]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][0]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][0]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][0]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][0]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][0]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][0]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][0]) >> 16));
        out_vec3[1] = (((in_vec3[0] ^ in_matrix[0][1]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][1]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][1]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][1]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][1]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][1]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][1]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][1]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][1]) >> 16));
        out_vec3[2] = (((in_vec3[0] ^ in_matrix[0][2]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][2]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][2]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][2]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][2]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][2]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][2]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][2]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][2]) >> 16));
    }

    public static void setMulVec4(int[] out_vec4, int[] in_vec3, int[][] in_matrix) {
        out_vec4[0] = (((in_vec3[0] ^ in_matrix[0][0]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][0]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][0]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][0]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][0]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][0]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][0]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][0]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][0]) >> 16)) + in_matrix[3][0];
        out_vec4[1] = (((in_vec3[0] ^ in_matrix[0][1]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][1]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][1]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][1]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][1]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][1]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][1]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][1]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][1]) >> 16)) + in_matrix[3][1];
        out_vec4[2] = (((in_vec3[0] ^ in_matrix[0][2]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][2]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][2]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][2]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][2]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][2]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][2]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][2]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][2]) >> 16)) + in_matrix[3][2];
        out_vec4[3] = (((in_vec3[0] ^ in_matrix[0][3]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][3]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][3]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][3]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][3]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][3]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][3]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][3]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][3]) >> 16)) + in_matrix[3][3];
    }

    public static void setMulVec4Fast(int[] out_vec4, int[] in_vec3, int[] in_matrix) {
        out_vec4[0] = (((in_vec3[0] ^ in_matrix[0]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0]) >> 16)) + (((in_vec3[1] ^ in_matrix[4]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[4]) >> 16)) : (int) ((in_vec3[1] * in_matrix[4]) >> 16)) + (((in_vec3[2] ^ in_matrix[8]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[8]) >> 16)) : (int) ((in_vec3[2] * in_matrix[8]) >> 16)) + in_matrix[12];
        out_vec4[1] = (((in_vec3[0] ^ in_matrix[1]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[1]) >> 16)) : (int) ((in_vec3[0] * in_matrix[1]) >> 16)) + (((in_vec3[1] ^ in_matrix[5]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[5]) >> 16)) : (int) ((in_vec3[1] * in_matrix[5]) >> 16)) + (((in_vec3[2] ^ in_matrix[9]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[9]) >> 16)) : (int) ((in_vec3[2] * in_matrix[9]) >> 16)) + in_matrix[13];
        out_vec4[2] = (((in_vec3[0] ^ in_matrix[2]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[2]) >> 16)) : (int) ((in_vec3[0] * in_matrix[2]) >> 16)) + (((in_vec3[1] ^ in_matrix[6]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[6]) >> 16)) : (int) ((in_vec3[1] * in_matrix[6]) >> 16)) + (((in_vec3[2] ^ in_matrix[10]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[10]) >> 16)) : (int) ((in_vec3[2] * in_matrix[10]) >> 16)) + in_matrix[14];
        out_vec4[3] = (((in_vec3[0] ^ in_matrix[3]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[3]) >> 16)) : (int) ((in_vec3[0] * in_matrix[3]) >> 16)) + (((in_vec3[1] ^ in_matrix[7]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[7]) >> 16)) : (int) ((in_vec3[1] * in_matrix[7]) >> 16)) + (((in_vec3[2] ^ in_matrix[11]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[11]) >> 16)) : (int) ((in_vec3[2] * in_matrix[11]) >> 16)) + in_matrix[15];
    }

    public static void setMulRotVec4(int[] out_vec4, int[] in_vec3, int[][] in_matrix) {
        out_vec4[0] = (((in_vec3[0] ^ in_matrix[0][0]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][0]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][0]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][0]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][0]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][0]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][0]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][0]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][0]) >> 16));
        out_vec4[1] = (((in_vec3[0] ^ in_matrix[0][1]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][1]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][1]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][1]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][1]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][1]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][1]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][1]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][1]) >> 16));
        out_vec4[2] = (((in_vec3[0] ^ in_matrix[0][2]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][2]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][2]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][2]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][2]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][2]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][2]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][2]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][2]) >> 16));
        out_vec4[3] = (((in_vec3[0] ^ in_matrix[0][3]) & 134217728) != 0 ? -((int) (((-in_vec3[0]) * in_matrix[0][3]) >> 16)) : (int) ((in_vec3[0] * in_matrix[0][3]) >> 16)) + (((in_vec3[1] ^ in_matrix[1][3]) & 134217728) != 0 ? -((int) (((-in_vec3[1]) * in_matrix[1][3]) >> 16)) : (int) ((in_vec3[1] * in_matrix[1][3]) >> 16)) + (((in_vec3[2] ^ in_matrix[2][3]) & 134217728) != 0 ? -((int) (((-in_vec3[2]) * in_matrix[2][3]) >> 16)) : (int) ((in_vec3[2] * in_matrix[2][3]) >> 16));
    }

    public static void setMulMat4(int[][] out, int[][] arg1, int[][] arg2) {
        for (int j = 0; j < 4; j++) {
            out[j][0] = (((arg1[j][0] ^ arg2[0][0]) & 134217728) != 0 ? -((int) (((-arg1[j][0]) * arg2[0][0]) >> 16)) : (int) ((arg1[j][0] * arg2[0][0]) >> 16)) + (((arg1[j][1] ^ arg2[1][0]) & 134217728) != 0 ? -((int) (((-arg1[j][1]) * arg2[1][0]) >> 16)) : (int) ((arg1[j][1] * arg2[1][0]) >> 16)) + (((arg1[j][2] ^ arg2[2][0]) & 134217728) != 0 ? -((int) (((-arg1[j][2]) * arg2[2][0]) >> 16)) : (int) ((arg1[j][2] * arg2[2][0]) >> 16)) + (((arg1[j][3] ^ arg2[3][0]) & 134217728) != 0 ? -((int) (((-arg1[j][3]) * arg2[3][0]) >> 16)) : (int) ((arg1[j][3] * arg2[3][0]) >> 16));
            out[j][1] = (((arg1[j][0] ^ arg2[0][1]) & 134217728) != 0 ? -((int) (((-arg1[j][0]) * arg2[0][1]) >> 16)) : (int) ((arg1[j][0] * arg2[0][1]) >> 16)) + (((arg1[j][1] ^ arg2[1][1]) & 134217728) != 0 ? -((int) (((-arg1[j][1]) * arg2[1][1]) >> 16)) : (int) ((arg1[j][1] * arg2[1][1]) >> 16)) + (((arg1[j][2] ^ arg2[2][1]) & 134217728) != 0 ? -((int) (((-arg1[j][2]) * arg2[2][1]) >> 16)) : (int) ((arg1[j][2] * arg2[2][1]) >> 16)) + (((arg1[j][3] ^ arg2[3][1]) & 134217728) != 0 ? -((int) (((-arg1[j][3]) * arg2[3][1]) >> 16)) : (int) ((arg1[j][3] * arg2[3][1]) >> 16));
            out[j][2] = (((arg1[j][0] ^ arg2[0][2]) & 134217728) != 0 ? -((int) (((-arg1[j][0]) * arg2[0][2]) >> 16)) : (int) ((arg1[j][0] * arg2[0][2]) >> 16)) + (((arg1[j][1] ^ arg2[1][2]) & 134217728) != 0 ? -((int) (((-arg1[j][1]) * arg2[1][2]) >> 16)) : (int) ((arg1[j][1] * arg2[1][2]) >> 16)) + (((arg1[j][2] ^ arg2[2][2]) & 134217728) != 0 ? -((int) (((-arg1[j][2]) * arg2[2][2]) >> 16)) : (int) ((arg1[j][2] * arg2[2][2]) >> 16)) + (((arg1[j][3] ^ arg2[3][2]) & 134217728) != 0 ? -((int) (((-arg1[j][3]) * arg2[3][2]) >> 16)) : (int) ((arg1[j][3] * arg2[3][2]) >> 16));
            out[j][3] = (((arg1[j][0] ^ arg2[0][3]) & 134217728) != 0 ? -((int) (((-arg1[j][0]) * arg2[0][3]) >> 16)) : (int) ((arg1[j][0] * arg2[0][3]) >> 16)) + (((arg1[j][1] ^ arg2[1][3]) & 134217728) != 0 ? -((int) (((-arg1[j][1]) * arg2[1][3]) >> 16)) : (int) ((arg1[j][1] * arg2[1][3]) >> 16)) + (((arg1[j][2] ^ arg2[2][3]) & 134217728) != 0 ? -((int) (((-arg1[j][2]) * arg2[2][3]) >> 16)) : (int) ((arg1[j][2] * arg2[2][3]) >> 16)) + (((arg1[j][3] ^ arg2[3][3]) & 134217728) != 0 ? -((int) (((-arg1[j][3]) * arg2[3][3]) >> 16)) : (int) ((arg1[j][3] * arg2[3][3]) >> 16));
        }
    }

    public static void setMulMat43(int[][] out, int[][] arg1, int[][] arg2) {
        for (int j = 0; j < 4; j++) {
            out[j][0] = (((arg1[j][0] ^ arg2[0][0]) & 134217728) != 0 ? -((int) (((-arg1[j][0]) * arg2[0][0]) >> 16)) : (int) ((arg1[j][0] * arg2[0][0]) >> 16)) + (((arg1[j][1] ^ arg2[1][0]) & 134217728) != 0 ? -((int) (((-arg1[j][1]) * arg2[1][0]) >> 16)) : (int) ((arg1[j][1] * arg2[1][0]) >> 16)) + (((arg1[j][2] ^ arg2[2][0]) & 134217728) != 0 ? -((int) (((-arg1[j][2]) * arg2[2][0]) >> 16)) : (int) ((arg1[j][2] * arg2[2][0]) >> 16)) + (((arg1[j][3] ^ arg2[3][0]) & 134217728) != 0 ? -((int) (((-arg1[j][3]) * arg2[3][0]) >> 16)) : (int) ((arg1[j][3] * arg2[3][0]) >> 16));
            out[j][1] = (((arg1[j][0] ^ arg2[0][1]) & 134217728) != 0 ? -((int) (((-arg1[j][0]) * arg2[0][1]) >> 16)) : (int) ((arg1[j][0] * arg2[0][1]) >> 16)) + (((arg1[j][1] ^ arg2[1][1]) & 134217728) != 0 ? -((int) (((-arg1[j][1]) * arg2[1][1]) >> 16)) : (int) ((arg1[j][1] * arg2[1][1]) >> 16)) + (((arg1[j][2] ^ arg2[2][1]) & 134217728) != 0 ? -((int) (((-arg1[j][2]) * arg2[2][1]) >> 16)) : (int) ((arg1[j][2] * arg2[2][1]) >> 16)) + (((arg1[j][3] ^ arg2[3][1]) & 134217728) != 0 ? -((int) (((-arg1[j][3]) * arg2[3][1]) >> 16)) : (int) ((arg1[j][3] * arg2[3][1]) >> 16));
            out[j][2] = (((arg1[j][0] ^ arg2[0][2]) & 134217728) != 0 ? -((int) (((-arg1[j][0]) * arg2[0][2]) >> 16)) : (int) ((arg1[j][0] * arg2[0][2]) >> 16)) + (((arg1[j][1] ^ arg2[1][2]) & 134217728) != 0 ? -((int) (((-arg1[j][1]) * arg2[1][2]) >> 16)) : (int) ((arg1[j][1] * arg2[1][2]) >> 16)) + (((arg1[j][2] ^ arg2[2][2]) & 134217728) != 0 ? -((int) (((-arg1[j][2]) * arg2[2][2]) >> 16)) : (int) ((arg1[j][2] * arg2[2][2]) >> 16)) + (((arg1[j][3] ^ arg2[3][2]) & 134217728) != 0 ? -((int) (((-arg1[j][3]) * arg2[3][2]) >> 16)) : (int) ((arg1[j][3] * arg2[3][2]) >> 16));
        }
    }

    public static void setMatInv(int[][] out, int[][] in) {
        for (int i = 0; i < 4; i++) {
            src[i] = in[i][0];
            src[i + 4] = in[i][1];
            src[i + 8] = in[i][2];
            src[i + 12] = in[i][3];
        }
        tmp[0] = ((src[10] ^ src[15]) & 134217728) != 0 ? -((int) (((-src[10]) * src[15]) >> 16)) : (int) ((src[10] * src[15]) >> 16);
        tmp[1] = ((src[11] ^ src[14]) & 134217728) != 0 ? -((int) (((-src[11]) * src[14]) >> 16)) : (int) ((src[11] * src[14]) >> 16);
        tmp[2] = ((src[9] ^ src[15]) & 134217728) != 0 ? -((int) (((-src[9]) * src[15]) >> 16)) : (int) ((src[9] * src[15]) >> 16);
        tmp[3] = ((src[11] ^ src[13]) & 134217728) != 0 ? -((int) (((-src[11]) * src[13]) >> 16)) : (int) ((src[11] * src[13]) >> 16);
        tmp[4] = ((src[9] ^ src[14]) & 134217728) != 0 ? -((int) (((-src[9]) * src[14]) >> 16)) : (int) ((src[9] * src[14]) >> 16);
        tmp[5] = ((src[10] ^ src[13]) & 134217728) != 0 ? -((int) (((-src[10]) * src[13]) >> 16)) : (int) ((src[10] * src[13]) >> 16);
        tmp[6] = ((src[8] ^ src[15]) & 134217728) != 0 ? -((int) (((-src[8]) * src[15]) >> 16)) : (int) ((src[8] * src[15]) >> 16);
        tmp[7] = ((src[11] ^ src[12]) & 134217728) != 0 ? -((int) (((-src[11]) * src[12]) >> 16)) : (int) ((src[11] * src[12]) >> 16);
        tmp[8] = ((src[8] ^ src[14]) & 134217728) != 0 ? -((int) (((-src[8]) * src[14]) >> 16)) : (int) ((src[8] * src[14]) >> 16);
        tmp[9] = ((src[10] ^ src[12]) & 134217728) != 0 ? -((int) (((-src[10]) * src[12]) >> 16)) : (int) ((src[10] * src[12]) >> 16);
        tmp[10] = ((src[8] ^ src[13]) & 134217728) != 0 ? -((int) (((-src[8]) * src[13]) >> 16)) : (int) ((src[8] * src[13]) >> 16);
        tmp[11] = ((src[9] ^ src[12]) & 134217728) != 0 ? -((int) (((-src[9]) * src[12]) >> 16)) : (int) ((src[9] * src[12]) >> 16);
        dst[0] = (((tmp[0] ^ src[5]) & 134217728) != 0 ? -((int) (((-tmp[0]) * src[5]) >> 16)) : (int) ((tmp[0] * src[5]) >> 16)) + (((tmp[3] ^ src[6]) & 134217728) != 0 ? -((int) (((-tmp[3]) * src[6]) >> 16)) : (int) ((tmp[3] * src[6]) >> 16)) + (((tmp[4] ^ src[7]) & 134217728) != 0 ? -((int) (((-tmp[4]) * src[7]) >> 16)) : (int) ((tmp[4] * src[7]) >> 16));
        int[] iArr = dst;
        iArr[0] = iArr[0] - (((((tmp[1] ^ src[5]) & 134217728) != 0 ? -((int) (((-tmp[1]) * src[5]) >> 16)) : (int) ((tmp[1] * src[5]) >> 16)) + (((tmp[2] ^ src[6]) & 134217728) != 0 ? -((int) (((-tmp[2]) * src[6]) >> 16)) : (int) ((tmp[2] * src[6]) >> 16))) + (((tmp[5] ^ src[7]) & 134217728) != 0 ? -((int) (((-tmp[5]) * src[7]) >> 16)) : (int) ((tmp[5] * src[7]) >> 16)));
        dst[1] = (((tmp[1] ^ src[4]) & 134217728) != 0 ? -((int) (((-tmp[1]) * src[4]) >> 16)) : (int) ((tmp[1] * src[4]) >> 16)) + (((tmp[6] ^ src[6]) & 134217728) != 0 ? -((int) (((-tmp[6]) * src[6]) >> 16)) : (int) ((tmp[6] * src[6]) >> 16)) + (((tmp[9] ^ src[7]) & 134217728) != 0 ? -((int) (((-tmp[9]) * src[7]) >> 16)) : (int) ((tmp[9] * src[7]) >> 16));
        int[] iArr2 = dst;
        iArr2[1] = iArr2[1] - (((((tmp[0] ^ src[4]) & 134217728) != 0 ? -((int) (((-tmp[0]) * src[4]) >> 16)) : (int) ((tmp[0] * src[4]) >> 16)) + (((tmp[7] ^ src[6]) & 134217728) != 0 ? -((int) (((-tmp[7]) * src[6]) >> 16)) : (int) ((tmp[7] * src[6]) >> 16))) + (((tmp[8] ^ src[7]) & 134217728) != 0 ? -((int) (((-tmp[8]) * src[7]) >> 16)) : (int) ((tmp[8] * src[7]) >> 16)));
        dst[2] = (((tmp[2] ^ src[4]) & 134217728) != 0 ? -((int) (((-tmp[2]) * src[4]) >> 16)) : (int) ((tmp[2] * src[4]) >> 16)) + (((tmp[7] ^ src[5]) & 134217728) != 0 ? -((int) (((-tmp[7]) * src[5]) >> 16)) : (int) ((tmp[7] * src[5]) >> 16)) + (((tmp[10] ^ src[7]) & 134217728) != 0 ? -((int) (((-tmp[10]) * src[7]) >> 16)) : (int) ((tmp[10] * src[7]) >> 16));
        int[] iArr3 = dst;
        iArr3[2] = iArr3[2] - (((((tmp[3] ^ src[4]) & 134217728) != 0 ? -((int) (((-tmp[3]) * src[4]) >> 16)) : (int) ((tmp[3] * src[4]) >> 16)) + (((tmp[6] ^ src[5]) & 134217728) != 0 ? -((int) (((-tmp[6]) * src[5]) >> 16)) : (int) ((tmp[6] * src[5]) >> 16))) + (((tmp[11] ^ src[7]) & 134217728) != 0 ? -((int) (((-tmp[11]) * src[7]) >> 16)) : (int) ((tmp[11] * src[7]) >> 16)));
        dst[3] = (((tmp[5] ^ src[4]) & 134217728) != 0 ? -((int) (((-tmp[5]) * src[4]) >> 16)) : (int) ((tmp[5] * src[4]) >> 16)) + (((tmp[8] ^ src[5]) & 134217728) != 0 ? -((int) (((-tmp[8]) * src[5]) >> 16)) : (int) ((tmp[8] * src[5]) >> 16)) + (((tmp[11] ^ src[6]) & 134217728) != 0 ? -((int) (((-tmp[11]) * src[6]) >> 16)) : (int) ((tmp[11] * src[6]) >> 16));
        int[] iArr4 = dst;
        iArr4[3] = iArr4[3] - (((((tmp[4] ^ src[4]) & 134217728) != 0 ? -((int) (((-tmp[4]) * src[4]) >> 16)) : (int) ((tmp[4] * src[4]) >> 16)) + (((tmp[9] ^ src[5]) & 134217728) != 0 ? -((int) (((-tmp[9]) * src[5]) >> 16)) : (int) ((tmp[9] * src[5]) >> 16))) + (((tmp[10] ^ src[6]) & 134217728) != 0 ? -((int) (((-tmp[10]) * src[6]) >> 16)) : (int) ((tmp[10] * src[6]) >> 16)));
        dst[4] = (((tmp[1] ^ src[1]) & 134217728) != 0 ? -((int) (((-tmp[1]) * src[1]) >> 16)) : (int) ((tmp[1] * src[1]) >> 16)) + (((tmp[2] ^ src[2]) & 134217728) != 0 ? -((int) (((-tmp[2]) * src[2]) >> 16)) : (int) ((tmp[2] * src[2]) >> 16)) + (((tmp[5] ^ src[3]) & 134217728) != 0 ? -((int) (((-tmp[5]) * src[3]) >> 16)) : (int) ((tmp[5] * src[3]) >> 16));
        int[] iArr5 = dst;
        iArr5[4] = iArr5[4] - (((((tmp[0] ^ src[1]) & 134217728) != 0 ? -((int) (((-tmp[0]) * src[1]) >> 16)) : (int) ((tmp[0] * src[1]) >> 16)) + (((tmp[3] ^ src[2]) & 134217728) != 0 ? -((int) (((-tmp[3]) * src[2]) >> 16)) : (int) ((tmp[3] * src[2]) >> 16))) + (((tmp[4] ^ src[3]) & 134217728) != 0 ? -((int) (((-tmp[4]) * src[3]) >> 16)) : (int) ((tmp[4] * src[3]) >> 16)));
        dst[5] = (((tmp[0] ^ src[0]) & 134217728) != 0 ? -((int) (((-tmp[0]) * src[0]) >> 16)) : (int) ((tmp[0] * src[0]) >> 16)) + (((tmp[7] ^ src[2]) & 134217728) != 0 ? -((int) (((-tmp[7]) * src[2]) >> 16)) : (int) ((tmp[7] * src[2]) >> 16)) + (((tmp[8] ^ src[3]) & 134217728) != 0 ? -((int) (((-tmp[8]) * src[3]) >> 16)) : (int) ((tmp[8] * src[3]) >> 16));
        int[] iArr6 = dst;
        iArr6[5] = iArr6[5] - (((((tmp[1] ^ src[0]) & 134217728) != 0 ? -((int) (((-tmp[1]) * src[0]) >> 16)) : (int) ((tmp[1] * src[0]) >> 16)) + (((tmp[6] ^ src[2]) & 134217728) != 0 ? -((int) (((-tmp[6]) * src[2]) >> 16)) : (int) ((tmp[6] * src[2]) >> 16))) + (((tmp[9] ^ src[3]) & 134217728) != 0 ? -((int) (((-tmp[9]) * src[3]) >> 16)) : (int) ((tmp[9] * src[3]) >> 16)));
        dst[6] = (((tmp[3] ^ src[0]) & 134217728) != 0 ? -((int) (((-tmp[3]) * src[0]) >> 16)) : (int) ((tmp[3] * src[0]) >> 16)) + (((tmp[6] ^ src[1]) & 134217728) != 0 ? -((int) (((-tmp[6]) * src[1]) >> 16)) : (int) ((tmp[6] * src[1]) >> 16)) + (((tmp[11] ^ src[3]) & 134217728) != 0 ? -((int) (((-tmp[11]) * src[3]) >> 16)) : (int) ((tmp[11] * src[3]) >> 16));
        int[] iArr7 = dst;
        iArr7[6] = iArr7[6] - (((((tmp[2] ^ src[0]) & 134217728) != 0 ? -((int) (((-tmp[2]) * src[0]) >> 16)) : (int) ((tmp[2] * src[0]) >> 16)) + (((tmp[7] ^ src[1]) & 134217728) != 0 ? -((int) (((-tmp[7]) * src[1]) >> 16)) : (int) ((tmp[7] * src[1]) >> 16))) + (((tmp[10] ^ src[3]) & 134217728) != 0 ? -((int) (((-tmp[10]) * src[3]) >> 16)) : (int) ((tmp[10] * src[3]) >> 16)));
        dst[7] = (((tmp[4] ^ src[0]) & 134217728) != 0 ? -((int) (((-tmp[4]) * src[0]) >> 16)) : (int) ((tmp[4] * src[0]) >> 16)) + (((tmp[9] ^ src[1]) & 134217728) != 0 ? -((int) (((-tmp[9]) * src[1]) >> 16)) : (int) ((tmp[9] * src[1]) >> 16)) + (((tmp[10] ^ src[2]) & 134217728) != 0 ? -((int) (((-tmp[10]) * src[2]) >> 16)) : (int) ((tmp[10] * src[2]) >> 16));
        int[] iArr8 = dst;
        iArr8[7] = iArr8[7] - (((((tmp[5] ^ src[0]) & 134217728) != 0 ? -((int) (((-tmp[5]) * src[0]) >> 16)) : (int) ((tmp[5] * src[0]) >> 16)) + (((tmp[8] ^ src[1]) & 134217728) != 0 ? -((int) (((-tmp[8]) * src[1]) >> 16)) : (int) ((tmp[8] * src[1]) >> 16))) + (((tmp[11] ^ src[2]) & 134217728) != 0 ? -((int) (((-tmp[11]) * src[2]) >> 16)) : (int) ((tmp[11] * src[2]) >> 16)));
        tmp[0] = ((src[2] ^ src[7]) & 134217728) != 0 ? -((int) (((-src[2]) * src[7]) >> 16)) : (int) ((src[2] * src[7]) >> 16);
        tmp[1] = ((src[3] ^ src[6]) & 134217728) != 0 ? -((int) (((-src[3]) * src[6]) >> 16)) : (int) ((src[3] * src[6]) >> 16);
        tmp[2] = ((src[1] ^ src[7]) & 134217728) != 0 ? -((int) (((-src[1]) * src[7]) >> 16)) : (int) ((src[1] * src[7]) >> 16);
        tmp[3] = ((src[3] ^ src[5]) & 134217728) != 0 ? -((int) (((-src[3]) * src[5]) >> 16)) : (int) ((src[3] * src[5]) >> 16);
        tmp[4] = ((src[1] ^ src[6]) & 134217728) != 0 ? -((int) (((-src[1]) * src[6]) >> 16)) : (int) ((src[1] * src[6]) >> 16);
        tmp[5] = ((src[2] ^ src[5]) & 134217728) != 0 ? -((int) (((-src[2]) * src[5]) >> 16)) : (int) ((src[2] * src[5]) >> 16);
        tmp[6] = ((src[0] ^ src[7]) & 134217728) != 0 ? -((int) (((-src[0]) * src[7]) >> 16)) : (int) ((src[0] * src[7]) >> 16);
        tmp[7] = ((src[3] ^ src[4]) & 134217728) != 0 ? -((int) (((-src[3]) * src[4]) >> 16)) : (int) ((src[3] * src[4]) >> 16);
        tmp[8] = ((src[0] ^ src[6]) & 134217728) != 0 ? -((int) (((-src[0]) * src[6]) >> 16)) : (int) ((src[0] * src[6]) >> 16);
        tmp[9] = ((src[2] ^ src[4]) & 134217728) != 0 ? -((int) (((-src[2]) * src[4]) >> 16)) : (int) ((src[2] * src[4]) >> 16);
        tmp[10] = ((src[0] ^ src[5]) & 134217728) != 0 ? -((int) (((-src[0]) * src[5]) >> 16)) : (int) ((src[0] * src[5]) >> 16);
        tmp[11] = ((src[1] ^ src[4]) & 134217728) != 0 ? -((int) (((-src[1]) * src[4]) >> 16)) : (int) ((src[1] * src[4]) >> 16);
        dst[8] = (((tmp[0] ^ src[13]) & 134217728) != 0 ? -((int) (((-tmp[0]) * src[13]) >> 16)) : (int) ((tmp[0] * src[13]) >> 16)) + (((tmp[3] ^ src[14]) & 134217728) != 0 ? -((int) (((-tmp[3]) * src[14]) >> 16)) : (int) ((tmp[3] * src[14]) >> 16)) + (((tmp[4] ^ src[15]) & 134217728) != 0 ? -((int) (((-tmp[4]) * src[15]) >> 16)) : (int) ((tmp[4] * src[15]) >> 16));
        int[] iArr9 = dst;
        iArr9[8] = iArr9[8] - (((((tmp[1] ^ src[13]) & 134217728) != 0 ? -((int) (((-tmp[1]) * src[13]) >> 16)) : (int) ((tmp[1] * src[13]) >> 16)) + (((tmp[2] ^ src[14]) & 134217728) != 0 ? -((int) (((-tmp[2]) * src[14]) >> 16)) : (int) ((tmp[2] * src[14]) >> 16))) + (((tmp[5] ^ src[15]) & 134217728) != 0 ? -((int) (((-tmp[5]) * src[15]) >> 16)) : (int) ((tmp[5] * src[15]) >> 16)));
        dst[9] = (((tmp[1] ^ src[12]) & 134217728) != 0 ? -((int) (((-tmp[1]) * src[12]) >> 16)) : (int) ((tmp[1] * src[12]) >> 16)) + (((tmp[6] ^ src[14]) & 134217728) != 0 ? -((int) (((-tmp[6]) * src[14]) >> 16)) : (int) ((tmp[6] * src[14]) >> 16)) + (((tmp[9] ^ src[15]) & 134217728) != 0 ? -((int) (((-tmp[9]) * src[15]) >> 16)) : (int) ((tmp[9] * src[15]) >> 16));
        int[] iArr10 = dst;
        iArr10[9] = iArr10[9] - (((((tmp[0] ^ src[12]) & 134217728) != 0 ? -((int) (((-tmp[0]) * src[12]) >> 16)) : (int) ((tmp[0] * src[12]) >> 16)) + (((tmp[7] ^ src[14]) & 134217728) != 0 ? -((int) (((-tmp[7]) * src[14]) >> 16)) : (int) ((tmp[7] * src[14]) >> 16))) + (((tmp[8] ^ src[15]) & 134217728) != 0 ? -((int) (((-tmp[8]) * src[15]) >> 16)) : (int) ((tmp[8] * src[15]) >> 16)));
        dst[10] = (((tmp[2] ^ src[12]) & 134217728) != 0 ? -((int) (((-tmp[2]) * src[12]) >> 16)) : (int) ((tmp[2] * src[12]) >> 16)) + (((tmp[7] ^ src[13]) & 134217728) != 0 ? -((int) (((-tmp[7]) * src[13]) >> 16)) : (int) ((tmp[7] * src[13]) >> 16)) + (((tmp[10] ^ src[15]) & 134217728) != 0 ? -((int) (((-tmp[10]) * src[15]) >> 16)) : (int) ((tmp[10] * src[15]) >> 16));
        int[] iArr11 = dst;
        iArr11[10] = iArr11[10] - (((((tmp[3] ^ src[12]) & 134217728) != 0 ? -((int) (((-tmp[3]) * src[12]) >> 16)) : (int) ((tmp[3] * src[12]) >> 16)) + (((tmp[6] ^ src[13]) & 134217728) != 0 ? -((int) (((-tmp[6]) * src[13]) >> 16)) : (int) ((tmp[6] * src[13]) >> 16))) + (((tmp[11] ^ src[15]) & 134217728) != 0 ? -((int) (((-tmp[11]) * src[15]) >> 16)) : (int) ((tmp[11] * src[15]) >> 16)));
        dst[11] = (((tmp[5] ^ src[12]) & 134217728) != 0 ? -((int) (((-tmp[5]) * src[12]) >> 16)) : (int) ((tmp[5] * src[12]) >> 16)) + (((tmp[8] ^ src[13]) & 134217728) != 0 ? -((int) (((-tmp[8]) * src[13]) >> 16)) : (int) ((tmp[8] * src[13]) >> 16)) + (((tmp[11] ^ src[14]) & 134217728) != 0 ? -((int) (((-tmp[11]) * src[14]) >> 16)) : (int) ((tmp[11] * src[14]) >> 16));
        int[] iArr12 = dst;
        iArr12[11] = iArr12[11] - (((((tmp[4] ^ src[12]) & 134217728) != 0 ? -((int) (((-tmp[4]) * src[12]) >> 16)) : (int) ((tmp[4] * src[12]) >> 16)) + (((tmp[9] ^ src[13]) & 134217728) != 0 ? -((int) (((-tmp[9]) * src[13]) >> 16)) : (int) ((tmp[9] * src[13]) >> 16))) + (((tmp[10] ^ src[14]) & 134217728) != 0 ? -((int) (((-tmp[10]) * src[14]) >> 16)) : (int) ((tmp[10] * src[14]) >> 16)));
        dst[12] = (((tmp[2] ^ src[10]) & 134217728) != 0 ? -((int) (((-tmp[2]) * src[10]) >> 16)) : (int) ((tmp[2] * src[10]) >> 16)) + (((tmp[5] ^ src[11]) & 134217728) != 0 ? -((int) (((-tmp[5]) * src[11]) >> 16)) : (int) ((tmp[5] * src[11]) >> 16)) + (((tmp[1] ^ src[9]) & 134217728) != 0 ? -((int) (((-tmp[1]) * src[9]) >> 16)) : (int) ((tmp[1] * src[9]) >> 16));
        int[] iArr13 = dst;
        iArr13[12] = iArr13[12] - (((((tmp[4] ^ src[11]) & 134217728) != 0 ? -((int) (((-tmp[4]) * src[11]) >> 16)) : (int) ((tmp[4] * src[11]) >> 16)) + (((tmp[0] ^ src[9]) & 134217728) != 0 ? -((int) (((-tmp[0]) * src[9]) >> 16)) : (int) ((tmp[0] * src[9]) >> 16))) + (((tmp[3] ^ src[10]) & 134217728) != 0 ? -((int) (((-tmp[3]) * src[10]) >> 16)) : (int) ((tmp[3] * src[10]) >> 16)));
        dst[13] = (((tmp[8] ^ src[11]) & 134217728) != 0 ? -((int) (((-tmp[8]) * src[11]) >> 16)) : (int) ((tmp[8] * src[11]) >> 16)) + (((tmp[0] ^ src[8]) & 134217728) != 0 ? -((int) (((-tmp[0]) * src[8]) >> 16)) : (int) ((tmp[0] * src[8]) >> 16)) + (((tmp[7] ^ src[10]) & 134217728) != 0 ? -((int) (((-tmp[7]) * src[10]) >> 16)) : (int) ((tmp[7] * src[10]) >> 16));
        int[] iArr14 = dst;
        iArr14[13] = iArr14[13] - (((((tmp[6] ^ src[10]) & 134217728) != 0 ? -((int) (((-tmp[6]) * src[10]) >> 16)) : (int) ((tmp[6] * src[10]) >> 16)) + (((tmp[9] ^ src[11]) & 134217728) != 0 ? -((int) (((-tmp[9]) * src[11]) >> 16)) : (int) ((tmp[9] * src[11]) >> 16))) + (((tmp[1] ^ src[8]) & 134217728) != 0 ? -((int) (((-tmp[1]) * src[8]) >> 16)) : (int) ((tmp[1] * src[8]) >> 16)));
        dst[14] = (((tmp[6] ^ src[9]) & 134217728) != 0 ? -((int) (((-tmp[6]) * src[9]) >> 16)) : (int) ((tmp[6] * src[9]) >> 16)) + (((tmp[11] ^ src[11]) & 134217728) != 0 ? -((int) (((-tmp[11]) * src[11]) >> 16)) : (int) ((tmp[11] * src[11]) >> 16)) + (((tmp[3] ^ src[8]) & 134217728) != 0 ? -((int) (((-tmp[3]) * src[8]) >> 16)) : (int) ((tmp[3] * src[8]) >> 16));
        int[] iArr15 = dst;
        iArr15[14] = iArr15[14] - (((((tmp[10] ^ src[11]) & 134217728) != 0 ? -((int) (((-tmp[10]) * src[11]) >> 16)) : (int) ((tmp[10] * src[11]) >> 16)) + (((tmp[2] ^ src[8]) & 134217728) != 0 ? -((int) (((-tmp[2]) * src[8]) >> 16)) : (int) ((tmp[2] * src[8]) >> 16))) + (((tmp[7] ^ src[9]) & 134217728) != 0 ? -((int) (((-tmp[7]) * src[9]) >> 16)) : (int) ((tmp[7] * src[9]) >> 16)));
        dst[15] = (((tmp[10] ^ src[10]) & 134217728) != 0 ? -((int) (((-tmp[10]) * src[10]) >> 16)) : (int) ((tmp[10] * src[10]) >> 16)) + (((tmp[4] ^ src[8]) & 134217728) != 0 ? -((int) (((-tmp[4]) * src[8]) >> 16)) : (int) ((tmp[4] * src[8]) >> 16)) + (((tmp[9] ^ src[9]) & 134217728) != 0 ? -((int) (((-tmp[9]) * src[9]) >> 16)) : (int) ((tmp[9] * src[9]) >> 16));
        int[] iArr16 = dst;
        iArr16[15] = iArr16[15] - (((((tmp[8] ^ src[9]) & 134217728) != 0 ? -((int) (((-tmp[8]) * src[9]) >> 16)) : (int) ((tmp[8] * src[9]) >> 16)) + (((tmp[11] ^ src[10]) & 134217728) != 0 ? -((int) (((-tmp[11]) * src[10]) >> 16)) : (int) ((tmp[11] * src[10]) >> 16))) + (((tmp[5] ^ src[8]) & 134217728) != 0 ? -((int) (((-tmp[5]) * src[8]) >> 16)) : (int) ((tmp[5] * src[8]) >> 16)));
        int det = (int) (4294967296L / ((((((src[0] ^ dst[0]) & 134217728) != 0 ? -((int) (((-src[0]) * dst[0]) >> 16)) : (int) ((src[0] * dst[0]) >> 16)) + (((src[1] ^ dst[1]) & 134217728) != 0 ? -((int) (((-src[1]) * dst[1]) >> 16)) : (int) ((src[1] * dst[1]) >> 16))) + (((src[2] ^ dst[2]) & 134217728) != 0 ? -((int) (((-src[2]) * dst[2]) >> 16)) : (int) ((src[2] * dst[2]) >> 16))) + (((src[3] ^ dst[3]) & 134217728) != 0 ? -((int) (((-src[3]) * dst[3]) >> 16)) : (int) ((src[3] * dst[3]) >> 16))));
        for (int j = 0; j < 16; j++) {
            dst[j] = ((dst[j] ^ det) & 134217728) != 0 ? -((int) (((-dst[j]) * det) >> 16)) : (int) ((dst[j] * det) >> 16);
        }
        for (int det2 = 0; det2 < 4; det2++) {
            out[det2][0] = dst[(det2 << 2) + 0];
            out[det2][1] = dst[(det2 << 2) + 1];
            out[det2][2] = dst[(det2 << 2) + 2];
            out[det2][3] = dst[(det2 << 2) + 3];
        }
    }

    public static void setWorldTrans(int[][] worldtrans) {
        if (worldtrans == null) {
            copyMatrix(matrixComposite, matrixCamera);
            nearPlane.normal = nearPlaneWS.normal;
            nearPlane.offset = nearPlaneWS.offset;
        } else {
            setMulMat4(matrixComposite, worldtrans, matrixCamera);
        }
        convertMatrix44(matrixCompositeFast, matrixComposite);
        worldTrans = worldtrans;
    }

    public static void setCamera(int[] from, int[] to, int[] up, int near, int far, int fov, int aspect) {
        makeView(temp_matView, from, to, up);
        makeProjection(temp_matProj, near, far, fov, aspect);
        setCamera(temp_matView, temp_matProj, from);
    }

    public static void setCamera(int[][] matView, int[][] matProj, int[] from) {
        setMulMat4(matrixCamera, matView, matProj);
        nearNormal[0] = matView[0][2];
        nearNormal[1] = matView[1][2];
        nearNormal[2] = matView[2][2];
        nearFrom[0] = from[0];
        nearFrom[1] = from[1];
        nearFrom[2] = from[2];
        nearPlaneWS.makePlane(nearFrom, nearNormal);
        setWorldTrans(null);
    }

    public static int loadCameras(String filename, int z_offset, int unit_scale) {
        InputStream inputstream = Application.openResourceAsStream(filename);
        DataInputStream datain = new DataInputStream(inputstream);
        try {
            int num_cams = datain.readInt();
            try {
                loadedCameraMatrix = (int[][][]) Array.newInstance(Integer.TYPE, num_cams, 4, 3);
                loadedCameraFOV = new int[num_cams];
                loadedCameraNearClip = new int[num_cams];
                loadedCameraFarClip = new int[num_cams];
                for (int c = 0; c < num_cams; c++) {
                    int j = 0;
                    while (j < 4) {
                        for (int i = 0; i < 3; i++) {
                            loadedCameraMatrix[c][j][i] = datain.readInt();
                            if (j == 3) {
                                loadedCameraMatrix[c][j][i] = ((loadedCameraMatrix[c][j][i] ^ unit_scale) & 134217728) != 0 ? -((int) (((-loadedCameraMatrix[c][j][i]) * unit_scale) >> 16)) : (int) ((loadedCameraMatrix[c][j][i] * unit_scale) >> 16);
                            }
                            if (j == 3 && i == 2) {
                                int[] iArr = loadedCameraMatrix[c][j];
                                iArr[i] = iArr[i] + z_offset;
                            }
                        }
                        int i2 = j + 1;
                        j = i2;
                    }
                    int[] iArr2 = loadedCameraFOV;
                    int j2 = datain.readInt();
                    iArr2[c] = j2;
                }
                return num_cams;
            } catch (Exception e) {
                return num_cams;
            }
        } catch (Exception e2) {
            return 0;
        }
    }

    public static void releaseCameras() {
        loadedCameraMatrix = null;
        loadedCameraFOV = null;
        loadedCameraNearClip = null;
        loadedCameraFarClip = null;
    }

    public static void setViewport(int x0, int y0, int w, int h) {
        renderWidth = w;
        renderHeight = h;
        halfWidth = renderWidth >> 1;
        halfHeight = renderHeight >> 1;
        fp_viewport_x0 = x0 < 0 ? -((-x0) << 16) : x0 << 16;
        fp_viewport_y0 = y0 < 0 ? -((-y0) << 16) : y0 << 16;
    }

    public static void translate(int dx, int dy) {
        fp_viewport_x0 += dx < 0 ? -((-dx) << 16) : dx << 16;
        fp_viewport_y0 += dy < 0 ? -((-dy) << 16) : dy << 16;
    }

    public static void makeView(int[][] data, int[] from, int[] to, int[] up) {
        view[0] = to[0] - from[0];
        view[1] = to[1] - from[1];
        view[2] = to[2] - from[2];
        VecMath.norm3d(view, view);
        right[0] = (((up[1] ^ view[2]) & 134217728) != 0 ? -((int) (((-up[1]) * view[2]) >> 16)) : (int) ((up[1] * view[2]) >> 16)) - (((up[2] ^ view[1]) & 134217728) != 0 ? -((int) (((-up[2]) * view[1]) >> 16)) : (int) ((up[2] * view[1]) >> 16));
        right[1] = (((up[2] ^ view[0]) & 134217728) != 0 ? -((int) (((-up[2]) * view[0]) >> 16)) : (int) ((up[2] * view[0]) >> 16)) - (((up[0] ^ view[2]) & 134217728) != 0 ? -((int) (((-up[0]) * view[2]) >> 16)) : (int) ((up[0] * view[2]) >> 16));
        right[2] = (((up[0] ^ view[1]) & 134217728) != 0 ? -((int) (((-up[0]) * view[1]) >> 16)) : (int) ((up[0] * view[1]) >> 16)) - (((up[1] ^ view[0]) & 134217728) != 0 ? -((int) (((-up[1]) * view[0]) >> 16)) : (int) ((up[1] * view[0]) >> 16));
        newup[0] = (((view[1] ^ right[2]) & 134217728) != 0 ? -((int) (((-view[1]) * right[2]) >> 16)) : (int) ((view[1] * right[2]) >> 16)) - (((view[2] ^ right[1]) & 134217728) != 0 ? -((int) (((-view[2]) * right[1]) >> 16)) : (int) ((view[2] * right[1]) >> 16));
        newup[1] = (((view[2] ^ right[0]) & 134217728) != 0 ? -((int) (((-view[2]) * right[0]) >> 16)) : (int) ((view[2] * right[0]) >> 16)) - (((view[0] ^ right[2]) & 134217728) != 0 ? -((int) (((-view[0]) * right[2]) >> 16)) : (int) ((view[0] * right[2]) >> 16));
        newup[2] = (((view[0] ^ right[1]) & 134217728) != 0 ? -((int) (((-view[0]) * right[1]) >> 16)) : (int) ((view[0] * right[1]) >> 16)) - (((view[1] ^ right[0]) & 134217728) != 0 ? -((int) (((-view[1]) * right[0]) >> 16)) : (int) ((view[1] * right[0]) >> 16));
        VecMath.norm3d(right, right);
        VecMath.norm3d(newup, newup);
        makeView(data, from, right, newup, view);
    }

    public static void makeView(int[][] out_view, int[] from, int[] right2, int[] up, int[] view2) {
        out_view[0][0] = right2[0];
        out_view[1][0] = right2[1];
        out_view[2][0] = right2[2];
        out_view[0][1] = up[0];
        out_view[1][1] = up[1];
        out_view[2][1] = up[2];
        out_view[0][2] = view2[0];
        out_view[1][2] = view2[1];
        out_view[2][2] = view2[2];
        out_view[3][0] = -((((right2[0] ^ from[0]) & 134217728) != 0 ? -((int) (((-right2[0]) * from[0]) >> 16)) : (int) ((right2[0] * from[0]) >> 16)) + (((right2[1] ^ from[1]) & 134217728) != 0 ? -((int) (((-right2[1]) * from[1]) >> 16)) : (int) ((right2[1] * from[1]) >> 16)) + (((right2[2] ^ from[2]) & 134217728) != 0 ? -((int) (((-right2[2]) * from[2]) >> 16)) : (int) ((right2[2] * from[2]) >> 16)));
        out_view[3][1] = -((((up[0] ^ from[0]) & 134217728) != 0 ? -((int) (((-up[0]) * from[0]) >> 16)) : (int) ((up[0] * from[0]) >> 16)) + (((up[1] ^ from[1]) & 134217728) != 0 ? -((int) (((-up[1]) * from[1]) >> 16)) : (int) ((up[1] * from[1]) >> 16)) + (((up[2] ^ from[2]) & 134217728) != 0 ? -((int) (((-up[2]) * from[2]) >> 16)) : (int) ((up[2] * from[2]) >> 16)));
        out_view[3][2] = -((((view2[0] ^ from[0]) & 134217728) != 0 ? -((int) (((-view2[0]) * from[0]) >> 16)) : (int) ((view2[0] * from[0]) >> 16)) + (((view2[1] ^ from[1]) & 134217728) != 0 ? -((int) (((-view2[1]) * from[1]) >> 16)) : (int) ((view2[1] * from[1]) >> 16)) + (((view2[2] ^ from[2]) & 134217728) != 0 ? -((int) (((-view2[2]) * from[2]) >> 16)) : (int) ((view2[2] * from[2]) >> 16)));
        out_view[0][3] = 0;
        out_view[1][3] = 0;
        out_view[2][3] = 0;
        out_view[3][3] = 65536;
    }

    public static void makeProjection(int[][] data, int near_plane, int far_plane, int fov, int aspect) {
        int i;
        int fov_horiz;
        int near_plane2;
        if (((32768 ^ fov) & 134217728) != 0) {
            i = -((int) (((-fov) * 32768) >> 16));
        } else {
            i = (int) ((fov * 32768) >> 16);
        }
        long sinLut = FixedPoint.sinLut(i) << 16;
        if (((32768 ^ fov) & 134217728) != 0) {
            int fov_horiz2 = -fov;
            fov_horiz = -((int) ((fov_horiz2 * 32768) >> 16));
        } else {
            fov_horiz = (int) ((fov * 32768) >> 16);
        }
        int w = (int) (4294967296L / ((int) (sinLut / FixedPoint.sinLut(fov_horiz + 4194304))));
        int h = ((aspect ^ w) & 134217728) != 0 ? -((int) (((-aspect) * w) >> 16)) : (int) ((aspect * w) >> 16);
        int far_plane2 = (int) ((far_plane << 16) / (near_plane - far_plane));
        data[0][0] = w;
        data[0][1] = 0;
        data[0][2] = 0;
        data[0][3] = 0;
        data[1][0] = 0;
        data[1][1] = h;
        data[1][2] = 0;
        data[1][3] = 0;
        data[2][0] = 0;
        data[2][1] = 0;
        data[2][2] = far_plane2;
        data[2][3] = 65536;
        data[3][0] = 0;
        data[3][1] = 0;
        int[] iArr = data[3];
        if (((far_plane2 ^ near_plane) & 134217728) != 0) {
            int Q = -far_plane2;
            near_plane2 = -((int) ((near_plane * Q) >> 16));
        } else {
            near_plane2 = (int) ((near_plane * far_plane2) >> 16);
        }
        iArr[2] = -near_plane2;
        data[3][3] = 0;
    }

    public static boolean project(int[] outpos, int[] pos) {
        setMulVec4Fast(outpos, pos, matrixCompositeFast);
        int fRHW = (int) (4294967296L / outpos[3]);
        outpos[0] = (((outpos[0] ^ (-fRHW)) & 134217728) != 0 ? -((int) (((-outpos[0]) * (-fRHW)) >> 16)) : (int) ((outpos[0] * (-fRHW)) >> 16)) + 65536;
        outpos[0] = (outpos[0] * halfWidth) + fp_viewport_x0;
        outpos[1] = (((outpos[1] ^ (-fRHW)) & 134217728) != 0 ? -((int) (((-outpos[1]) * (-fRHW)) >> 16)) : (int) ((outpos[1] * (-fRHW)) >> 16)) + 65536;
        outpos[1] = (outpos[1] * halfHeight) + fp_viewport_y0;
        outpos[2] = ((outpos[2] ^ fRHW) & 134217728) != 0 ? -((int) (((-outpos[2]) * fRHW) >> 16)) : (int) ((outpos[2] * fRHW) >> 16);
        outpos[3] = fRHW;
        return outpos[2] >= 0;
    }

    public static int clipProjectLine(int[][] p2, int[] v0, int[] v1) {
        vdist[0] = nearPlane.getDistFromPlane(v0);
        vdist[1] = nearPlane.getDistFromPlane(v1);
        int count = 0;
        for (int i = 0; i < 2; i++) {
            if (vdist[i] < clipMinZ) {
                count++;
            }
        }
        switch (count) {
            case 0:
                project(p2[0], v0);
                project(p2[1], v1);
                return 2;
            case 1:
                for (int count2 = 0; count2 < 3; count2++) {
                    vert[0][count2] = v0[count2];
                    vert[1][count2] = v1[count2];
                }
                int i2 = 0;
                while (true) {
                    int i3 = i2;
                    if (i3 < 2) {
                        if (vdist[i3] >= clipMinZ) {
                            int b = 1 - i3;
                            vAB[0] = vert[b][0] - vert[i3][0];
                            vAB[1] = vert[b][1] - vert[i3][1];
                            vAB[2] = vert[b][2] - vert[i3][2];
                            VecMath.norm3d(vAB, vAB);
                            int d_b = nearPlane.intersection(vert[i3], vAB) - 65536;
                            vert[b][0] = vert[i3][0] + (((vAB[0] ^ d_b) & 134217728) != 0 ? -((int) (((-vAB[0]) * d_b) >> 16)) : (int) ((vAB[0] * d_b) >> 16));
                            vert[b][1] = vert[i3][1] + (((vAB[1] ^ d_b) & 134217728) != 0 ? -((int) (((-vAB[1]) * d_b) >> 16)) : (int) ((vAB[1] * d_b) >> 16));
                            vert[b][2] = (((vAB[2] ^ d_b) & 134217728) != 0 ? -((int) (((-vAB[2]) * d_b) >> 16)) : (int) ((vAB[2] * d_b) >> 16)) + vert[i3][2];
                            project(p2[0], vert[i3]);
                            project(p2[1], vert[b]);
                        }
                        i2 = i3 + 1;
                    } else {
                        return 2;
                    }
                }
            case 2:
                return 0;
            default:
                return 0;
        }
    }

    /* JADX WARN: Removed duplicated region for block: B:52:0x02a5 A[LOOP:3: B:50:0x02a2->B:52:0x02a5, LOOP_END] */
    /* JADX WARN: Removed duplicated region for block: B:56:0x02c8  */
    /* JADX WARN: Removed duplicated region for block: B:95:0x04ee A[SYNTHETIC] */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static int clipProjectTriangle(int[] v0, int[] v1, int[] v2) {
        int i;
        int a2;
        int i2;
        vdist[0] = nearPlane.getDistFromPlane(v0);
        vdist[1] = nearPlane.getDistFromPlane(v1);
        vdist[2] = nearPlane.getDistFromPlane(v2);
        int count = 0;
        for (int i3 = 0; i3 < 3; i3++) {
            if (vdist[i3] < clipMinZ) {
                count++;
            }
        }
        switch (count) {
            case 0:
                project(p[0], v0);
                project(p[1], v1);
                project(p[2], v2);
                return 3;
            case 1:
                for (int count2 = 0; count2 < 3; count2++) {
                    vert[0][count2] = v0[count2];
                    vert[1][count2] = v1[count2];
                    vert[2][count2] = v2[count2];
                }
                int i4 = 0;
                while (true) {
                    int i5 = i4;
                    if (i5 < 3) {
                        if (vdist[i5] >= clipMinZ) {
                            i4 = i5 + 1;
                        } else {
                            int b = (i5 + 1) % 3;
                            int c = (i5 + 2) % 3;
                            vAB[0] = vert[b][0] - vert[i5][0];
                            vAB[1] = vert[b][1] - vert[i5][1];
                            vAB[2] = vert[b][2] - vert[i5][2];
                            vAC[0] = vert[c][0] - vert[i5][0];
                            vAC[1] = vert[c][1] - vert[i5][1];
                            vAC[2] = vert[c][2] - vert[i5][2];
                            VecMath.norm3d(vAB, vAB);
                            VecMath.norm3d(vAC, vAC);
                            int d_b = nearPlane.intersection(vert[i5], vAB) + 65536;
                            int d_c = nearPlane.intersection(vert[i5], vAC) + 65536;
                            vAB[0] = vert[i5][0] + (((vAB[0] ^ d_b) & 134217728) != 0 ? -((int) (((-vAB[0]) * d_b) >> 16)) : (int) ((vAB[0] * d_b) >> 16));
                            vAB[1] = vert[i5][1] + (((vAB[1] ^ d_b) & 134217728) != 0 ? -((int) (((-vAB[1]) * d_b) >> 16)) : (int) ((vAB[1] * d_b) >> 16));
                            vAB[2] = (((vAB[2] ^ d_b) & 134217728) != 0 ? -((int) (((-vAB[2]) * d_b) >> 16)) : (int) ((vAB[2] * d_b) >> 16)) + vert[i5][2];
                            vAC[0] = vert[i5][0] + (((vAC[0] ^ d_c) & 134217728) != 0 ? -((int) (((-vAC[0]) * d_c) >> 16)) : (int) ((vAC[0] * d_c) >> 16));
                            vAC[1] = vert[i5][1] + (((vAC[1] ^ d_c) & 134217728) != 0 ? -((int) (((-vAC[1]) * d_c) >> 16)) : (int) ((vAC[1] * d_c) >> 16));
                            vAC[2] = vert[i5][2] + (((vAC[2] ^ d_c) & 134217728) != 0 ? -((int) (((-vAC[2]) * d_c) >> 16)) : (int) ((vAC[2] * d_c) >> 16));
                            project(p[0], vAB);
                            project(p[1], vert[b]);
                            project(p[2], vert[c]);
                            project(p[3], vAC);
                            return 4;
                        }
                    }
                }
                for (i = 0; i < 3; i++) {
                    vert[0][i] = v0[i];
                    vert[1][i] = v1[i];
                    vert[2][i] = v2[i];
                }
                a2 = 0;
                while (true) {
                    i2 = a2;
                    if (i2 < 3) {
                        break;
                    } else if (vdist[i2] < clipMinZ) {
                        a2 = i2 + 1;
                    } else {
                        int b2 = (i2 + 1) % 3;
                        int c2 = (i2 + 2) % 3;
                        vAB[0] = vert[b2][0] - vert[i2][0];
                        vAB[1] = vert[b2][1] - vert[i2][1];
                        vAB[2] = vert[b2][2] - vert[i2][2];
                        vAC[0] = vert[c2][0] - vert[i2][0];
                        vAC[1] = vert[c2][1] - vert[i2][1];
                        vAC[2] = vert[c2][2] - vert[i2][2];
                        VecMath.norm3d(vAB, vAB);
                        VecMath.norm3d(vAC, vAC);
                        int d_b2 = nearPlane.intersection(vert[i2], vAB) - 65536;
                        int d_c2 = nearPlane.intersection(vert[i2], vAC) - 65536;
                        vert[b2][0] = vert[i2][0] + (((vAB[0] ^ d_b2) & 134217728) != 0 ? -((int) (((-vAB[0]) * d_b2) >> 16)) : (int) ((vAB[0] * d_b2) >> 16));
                        vert[b2][1] = vert[i2][1] + (((vAB[1] ^ d_b2) & 134217728) != 0 ? -((int) (((-vAB[1]) * d_b2) >> 16)) : (int) ((vAB[1] * d_b2) >> 16));
                        vert[b2][2] = (((vAB[2] ^ d_b2) & 134217728) != 0 ? -((int) (((-vAB[2]) * d_b2) >> 16)) : (int) ((vAB[2] * d_b2) >> 16)) + vert[i2][2];
                        vert[c2][0] = vert[i2][0] + (((vAC[0] ^ d_c2) & 134217728) != 0 ? -((int) (((-vAC[0]) * d_c2) >> 16)) : (int) ((vAC[0] * d_c2) >> 16));
                        vert[c2][1] = vert[i2][1] + (((vAC[1] ^ d_c2) & 134217728) != 0 ? -((int) (((-vAC[1]) * d_c2) >> 16)) : (int) ((vAC[1] * d_c2) >> 16));
                        vert[c2][2] = (((vAC[2] ^ d_c2) & 134217728) != 0 ? -((int) (((-vAC[2]) * d_c2) >> 16)) : (int) ((vAC[2] * d_c2) >> 16)) + vert[i2][2];
                        project(p[0], vert[i2]);
                        project(p[1], vert[b2]);
                        project(p[2], vert[c2]);
                        return 3;
                    }
                }
            case 2:
                while (i < 3) {
                }
                a2 = 0;
                while (true) {
                    i2 = a2;
                    if (i2 < 3) {
                    }
                    a2 = i2 + 1;
                }
                break;
            case 3:
                return 0;
            default:
                return 0;
        }
    }

    public static void drawScreenClippedLine(Graphics g, int x0, int y0, int x1, int y1) {
        if ((x0 >= 0 && x0 < renderWidth && y0 >= 0 && y0 < renderHeight) || (x1 >= 0 && x1 < renderWidth && y1 >= 0 && y1 < renderHeight)) {
            g.drawLine(x0, y0, x1, y1);
        }
    }

    public static void drawScreenClippedTri(Graphics g, int x0, int y0, int x1, int y1, int x2, int y2) {
        if ((x0 >= 0 && x0 < renderWidth && y0 >= 0 && y0 < renderHeight) || ((x1 >= 0 && x1 < renderWidth && y1 >= 0 && y1 < renderHeight) || (x2 >= 0 && x2 < renderWidth && y2 >= 0 && y2 < renderHeight))) {
            GfxUtils.drawTriangle(g, x0, y0, x1, y1, x2, y2);
        }
    }

    public static void drawPoint3D(Graphics g, int[] pt, int fp_size) {
        project(p[0], pt);
        GfxUtils.drawPoint(g, p[0][0] < 0 ? -((-p[0][0]) >> 16) : p[0][0] >> 16, p[0][1] < 0 ? -((-p[0][1]) >> 16) : p[0][1] >> 16);
        int r = (((65536 - p[0][2]) ^ fp_size) & 134217728) != 0 ? -((int) (((-fp_size) * (65536 - p[0][2])) >> 16)) : (int) ((fp_size * (65536 - p[0][2])) >> 16);
        if (r < 131072) {
            r = 131072;
        } else if (r > 1048576) {
            r = 1048576;
        }
        GfxUtils.drawCircle(g, p[0][0] < 0 ? -((-p[0][0]) >> 16) : p[0][0] >> 16, p[0][1] < 0 ? -((-p[0][1]) >> 16) : p[0][1] >> 16, r < 0 ? -((-r) >> 16) : r >> 16, 12);
    }

    public static void drawLine3D(Graphics g, int[][] line_pts, int start, int end) {
        int db = 0;
        if (end < start) {
            end = start;
        } else if (end > line_pts.length) {
            end = line_pts.length;
        }
        if (start < 0) {
            start = 0;
        } else if (start > end - 1) {
            start = end - 1;
        }
        for (int i = start; i < end; i++) {
            project(p[db], line_pts[i]);
            near_dist[db] = nearPlane.getDistFromPlane(line_pts[i]);
            if (i > start && near_dist[db] > clipMinZ && near_dist[1 - db] > clipMinZ) {
                g.drawLine(p[db][0] < 0 ? -((-p[db][0]) >> 16) : p[db][0] >> 16, p[db][1] < 0 ? -((-p[db][1]) >> 16) : p[db][1] >> 16, p[1 - db][0] < 0 ? -((-p[1 - db][0]) >> 16) : p[1 - db][0] >> 16, p[1 - db][1] < 0 ? -((-p[1 - db][1]) >> 16) : p[1 - db][1] >> 16);
                g.drawLine((p[db][0] < 0 ? -((-p[db][0]) >> 16) : p[db][0] >> 16) + 1, p[db][1] < 0 ? -((-p[db][1]) >> 16) : p[db][1] >> 16, (p[1 - db][0] < 0 ? -((-p[1 - db][0]) >> 16) : p[1 - db][0] >> 16) + 1, p[1 - db][1] < 0 ? -((-p[1 - db][1]) >> 16) : p[1 - db][1] >> 16);
            }
            p[1 - db][0] = p[db][0];
            p[1 - db][1] = p[db][1];
            near_dist[1 - db] = near_dist[db];
            db = 1 - db;
        }
    }

    public static void drawIndexedLine3D(Graphics g, int[][] line_pts, short[] line_idx) {
        for (int i = 1; i < line_idx.length; i++) {
            if (clipProjectLine(p, line_pts[line_idx[i - 1]], line_pts[line_idx[i]]) == 2) {
                drawScreenClippedLine(g, p[0][0] < 0 ? -((-p[0][0]) >> 16) : p[0][0] >> 16, p[0][1] < 0 ? -((-p[0][1]) >> 16) : p[0][1] >> 16, p[1][0] < 0 ? -((-p[1][0]) >> 16) : p[1][0] >> 16, p[1][1] < 0 ? -((-p[1][1]) >> 16) : p[1][1] >> 16);
                drawScreenClippedLine(g, (p[0][0] < 0 ? -((-p[0][0]) >> 16) : p[0][0] >> 16) - 1, p[0][1] < 0 ? -((-p[0][1]) >> 16) : p[0][1] >> 16, (p[1][0] < 0 ? -((-p[1][0]) >> 16) : p[1][0] >> 16) - 1, p[1][1] < 0 ? -((-p[1][1]) >> 16) : p[1][1] >> 16);
            }
        }
    }

    public static void drawIndexedTri3D(Graphics g, int[][] line_pts, short[] line_idx) {
        int a2;
        int b;
        int c;
        int i = 0;
        while (true) {
            int i2 = i;
            int i3 = line_idx.length;
            if (i2 < i3) {
                if (line_idx[i2 + 0] < 0) {
                    a2 = 0;
                } else {
                    a2 = line_idx[i2 + 0] > line_pts.length - 1 ? line_pts.length - 1 : line_idx[i2 + 0];
                }
                if (line_idx[i2 + 1] < 0) {
                    b = 0;
                } else {
                    b = line_idx[i2 + 1] > line_pts.length - 1 ? line_pts.length - 1 : line_idx[i2 + 1];
                }
                if (line_idx[i2 + 2] < 0) {
                    c = 0;
                } else {
                    c = line_idx[i2 + 2] > line_pts.length - 1 ? line_pts.length - 1 : line_idx[i2 + 2];
                }
                int verts = clipProjectTriangle(line_pts[a2], line_pts[b], line_pts[c]);
                if (verts >= 3) {
                    drawScreenClippedTri(g, p[0][0] < 0 ? -((-p[0][0]) >> 16) : p[0][0] >> 16, p[0][1] < 0 ? -((-p[0][1]) >> 16) : p[0][1] >> 16, p[1][0] < 0 ? -((-p[1][0]) >> 16) : p[1][0] >> 16, p[1][1] < 0 ? -((-p[1][1]) >> 16) : p[1][1] >> 16, p[2][0] < 0 ? -((-p[2][0]) >> 16) : p[2][0] >> 16, p[2][1] < 0 ? -((-p[2][1]) >> 16) : p[2][1] >> 16);
                    if (verts == 4) {
                        drawScreenClippedTri(g, p[3][0] < 0 ? -((-p[3][0]) >> 16) : p[3][0] >> 16, p[3][1] < 0 ? -((-p[3][1]) >> 16) : p[3][1] >> 16, p[1][0] < 0 ? -((-p[1][0]) >> 16) : p[1][0] >> 16, p[1][1] < 0 ? -((-p[1][1]) >> 16) : p[1][1] >> 16, p[2][0] < 0 ? -((-p[2][0]) >> 16) : p[2][0] >> 16, p[2][1] < 0 ? -((-p[2][1]) >> 16) : p[2][1] >> 16);
                    }
                }
                i = i2 + 3;
            } else {
                return;
            }
        }
    }
}
