package com.slg.j2me.lib.gui;

import com.slg.j2me.lib.gfx.ClipRect;
import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gfx.ImageSet;
import javax.microedition.lcdui.Graphics;
/* loaded from: classes.dex */
public class BitmapFont {
    private static boolean characterRemapped = false;
    private static int[] rect = new int[4];
    public String fontName;
    private int iFontHeight;
    private short iMaxAscii;
    public int iMaxLetterWidth;
    private short iMinAscii;
    public int iOffsetBottom;
    public int iOffsetLeft;
    public int iOffsetRight;
    public int iOffsetTop;
    public int iSpaceWidth;
    public int iSpacing;
    public ImageSequence imgCharacters;
    private short[] mapAsciiToImage;
    private String sCharacters;
    public boolean uppercaseOnly;

    public static String slgToUpperCase(String str) {
        if (str == null || str.length() == 0) {
            return str;
        }
        boolean isUpper = true;
        int len = str.length();
        int i = 0;
        while (true) {
            if (i < len) {
                if (!Character.isLowerCase(str.charAt(i))) {
                    i++;
                } else {
                    isUpper = false;
                    break;
                }
            } else {
                break;
            }
        }
        if (isUpper) {
            return str;
        }
        StringBuffer buf = new StringBuffer(str.length() + 6);
        for (int i2 = 0; i2 < len; i2++) {
            char c = str.charAt(i2);
            if (c == 223) {
                buf.append("SS");
            } else {
                buf.append(Character.toUpperCase(c));
            }
        }
        return buf.toString();
    }

    public BitmapFont(ImageSet imageSet, String _fontName) {
        this.iMaxAscii = (short) 0;
        this.iMinAscii = (short) 255;
        this.iFontHeight = 0;
        this.iSpacing = 1;
        this.iSpaceWidth = 4;
        this.iMaxLetterWidth = 0;
        this.iOffsetTop = 0;
        this.iOffsetBottom = 0;
        this.iOffsetLeft = 0;
        this.iOffsetRight = 0;
        if (imageSet != null) {
            this.sCharacters = ImageSet.sCharacters;
            ImageSet.sCharacters = null;
            this.fontName = _fontName;
            this.imgCharacters = imageSet.getImageSequence(this.fontName);
            if (this.imgCharacters != null) {
                for (short i = 0; i < this.imgCharacters.numFrames; i = (short) (i + 1)) {
                    this.iMaxLetterWidth = this.imgCharacters.getRectWidth(i) > this.iMaxLetterWidth ? this.imgCharacters.getRectWidth(i) : this.iMaxLetterWidth;
                }
                for (short i2 = 0; i2 < this.sCharacters.length(); i2 = (short) (i2 + 1)) {
                    if (this.sCharacters.charAt(i2) > this.iMaxAscii) {
                        this.iMaxAscii = (short) this.sCharacters.charAt(i2);
                    }
                    if (this.sCharacters.charAt(i2) < this.iMinAscii) {
                        this.iMinAscii = (short) this.sCharacters.charAt(i2);
                    }
                }
                this.mapAsciiToImage = new short[(this.iMaxAscii - this.iMinAscii) + 1];
                for (short i3 = 0; i3 < (this.iMaxAscii - this.iMinAscii) + 1; i3 = (short) (i3 + 1)) {
                    this.mapAsciiToImage[i3] = -1;
                }
                this.uppercaseOnly = true;
                for (short i4 = 0; i4 < this.sCharacters.length(); i4 = (short) (i4 + 1)) {
                    this.mapAsciiToImage[((short) this.sCharacters.charAt(i4)) - this.iMinAscii] = i4;
                    this.iFontHeight = this.imgCharacters.getRectHeight(i4) > this.iFontHeight ? this.imgCharacters.getRectHeight(i4) : this.iFontHeight;
                    int ch = this.sCharacters.charAt(i4);
                    if (this.uppercaseOnly && ch >= 97 && ch <= 122) {
                        this.uppercaseOnly = false;
                    }
                }
            }
        }
    }

    public BitmapFont(BitmapFont source) {
        this.iMaxAscii = (short) 0;
        this.iMinAscii = (short) 255;
        this.iFontHeight = 0;
        this.iSpacing = 1;
        this.iSpaceWidth = 4;
        this.iMaxLetterWidth = 0;
        this.iOffsetTop = 0;
        this.iOffsetBottom = 0;
        this.iOffsetLeft = 0;
        this.iOffsetRight = 0;
        this.sCharacters = source.sCharacters;
        this.imgCharacters = source.imgCharacters;
        this.iMaxLetterWidth = source.iMaxLetterWidth;
        this.iMaxAscii = source.iMaxAscii;
        this.iMinAscii = source.iMinAscii;
        this.mapAsciiToImage = source.mapAsciiToImage;
        this.iFontHeight = source.iFontHeight;
        this.fontName = source.fontName;
        this.uppercaseOnly = source.uppercaseOnly;
        this.iOffsetTop = source.iOffsetTop;
        this.iOffsetBottom = source.iOffsetBottom;
        this.iOffsetLeft = source.iOffsetLeft;
        this.iOffsetRight = source.iOffsetRight;
    }

    public final short getFontHeight() {
        return (short) (this.iFontHeight + this.iOffsetTop + this.iOffsetBottom);
    }

    public final short getCharacterIndexInternal(char character) {
        int idx = ((short) character) - this.iMinAscii;
        if (idx < 0 || idx > this.iMaxAscii - this.iMinAscii) {
            return (short) -1;
        }
        return this.mapAsciiToImage[idx];
    }

    public final short getCharacterIndex(char character) {
        int i = ((short) character) - this.iMinAscii;
        short rtn_idx = getCharacterIndexInternal(character);
        return rtn_idx;
    }

    public short getTextWidth(String text) {
        if (this.uppercaseOnly) {
            text = slgToUpperCase(text);
        }
        int width = 0;
        int length = text.length();
        for (int i = 0; i < length; i++) {
            char chr = text.charAt(i);
            if (chr == ' ') {
                width += this.iSpaceWidth;
            } else {
                int idx = getCharacterIndex(chr);
                if (idx != -1) {
                    width += this.imgCharacters.getRectWidth(idx) + this.iOffsetLeft + this.iOffsetRight;
                }
            }
            if (i < length - 1) {
                width += this.iSpacing;
            }
        }
        return (short) width;
    }

    public short getFixedWidth(String text) {
        int charwidth;
        if (this.uppercaseOnly) {
            text = slgToUpperCase(text);
        }
        int fixedwidth = 0;
        for (int i = 0; i < text.length(); i++) {
            short idx = getCharacterIndex(text.charAt(i));
            if (idx != -1 && fixedwidth <= (charwidth = this.imgCharacters.getRectWidth(idx))) {
                fixedwidth = charwidth;
            }
        }
        return (short) fixedwidth;
    }

    public short getTextWidth(String text, int fixedwidth) {
        if (this.uppercaseOnly) {
            text = slgToUpperCase(text);
        }
        return fixedwidth == 0 ? getTextWidth(text) : (short) ((text.length() * fixedwidth) + (this.iSpacing * (text.length() - 1)));
    }

    public void drawText(Graphics g, String text, int x0, int y0, ClipRect cliprect) {
        if (this.uppercaseOnly) {
            text = slgToUpperCase(text);
        }
        rect[0] = cliprect.x0;
        rect[1] = cliprect.y0;
        rect[2] = cliprect.w;
        rect[3] = cliprect.h;
        int length = text.length();
        int x = x0;
        for (int i = 0; i < length; i++) {
            char chr = text.charAt(i);
            if (chr == ' ') {
                x += this.iSpaceWidth;
            } else {
                int idx = getCharacterIndex(chr);
                if (idx != -1) {
                    this.imgCharacters.drawImageClipped(g, idx, x + this.iOffsetLeft, y0 + this.iOffsetTop, rect);
                    x += this.imgCharacters.getRectWidth(idx) + this.iOffsetLeft + this.iOffsetRight;
                }
            }
            x += this.iSpacing;
        }
    }

    public void drawText(Graphics g, String text, int x0, int y0, ClipRect cliprect, int fixedwidth) {
        if (this.uppercaseOnly) {
            text = slgToUpperCase(text);
        }
        if (fixedwidth == 0) {
            drawText(g, text, x0, y0, cliprect);
            return;
        }
        rect[0] = cliprect.x0;
        rect[1] = cliprect.y0;
        rect[2] = cliprect.w;
        rect[3] = cliprect.h;
        int length = text.length();
        int x = x0;
        for (int i = 0; i < length; i++) {
            char chr = text.charAt(i);
            if (chr == ' ') {
                x += fixedwidth;
            } else {
                int idx = getCharacterIndex(chr);
                if (idx != -1) {
                    int iCentre = fixedwidth > this.imgCharacters.getRectWidth(idx) ? (fixedwidth - this.imgCharacters.getRectWidth(idx)) >> 1 : 0;
                    this.imgCharacters.drawImageClipped(g, idx, this.iOffsetLeft + x + iCentre, y0 + this.iOffsetTop, rect);
                    x += this.iOffsetLeft + fixedwidth + this.iOffsetRight;
                }
            }
            x += this.iSpacing;
        }
    }
}
