package com.slg.j2me.lib.gui.control;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gfx.ClipRect;
import com.slg.j2me.lib.gui.image.IconImage;
import com.slg.j2me.lib.gui.layout.ScreenLayout;
import javax.microedition.lcdui.Graphics;
/* loaded from: classes.dex */
public class GuiControl extends GuiContainer {
    public boolean autoHighlight;
    public int border;
    public GuiContainer controlImage;
    public boolean enabled;
    public boolean greyed;
    public boolean hidden;
    public ScreenLayout menu;
    ClipRect newRect;
    ClipRect oldRect;

    public GuiControl(boolean isenabled) {
        this.border = 8;
        this.autoHighlight = true;
        this.hidden = false;
        this.enabled = false;
        this.greyed = false;
        this.menu = null;
        this.newRect = new ClipRect(0, 0, 0, 0);
        this.enabled = isenabled;
    }

    public GuiControl(ScreenLayout _menu) {
        this.border = 8;
        this.autoHighlight = true;
        this.hidden = false;
        this.enabled = false;
        this.greyed = false;
        this.menu = null;
        this.newRect = new ClipRect(0, 0, 0, 0);
        this.menu = _menu;
        this.enabled = true;
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void initialise() {
        if (this.controlImage != null) {
            this.controlImage.initialise();
            this.clipRect.w = this.controlImage.clipRect.w;
            this.clipRect.h = this.controlImage.clipRect.h;
        }
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        if (!this.hidden && this.controlImage != null) {
            this.oldRect = this.controlImage.clipRect;
            this.newRect.x0 = (short) (this.clipRect.x0 + this.controlImage.clipRect.x0);
            this.newRect.y0 = (short) (this.clipRect.y0 + this.controlImage.clipRect.y0);
            this.newRect.w = (short) ((this.newRect.x0 + this.controlImage.clipRect.w < this.clipRect.x0 + this.clipRect.w ? this.newRect.x0 + this.controlImage.clipRect.w : this.clipRect.x0 + this.clipRect.w) - this.newRect.x0);
            this.newRect.h = (short) ((this.newRect.y0 + this.controlImage.clipRect.h < this.clipRect.y0 + this.clipRect.h ? this.newRect.y0 + this.controlImage.clipRect.h : this.clipRect.y0 + this.clipRect.h) - this.newRect.y0);
            this.controlImage.clipRect = this.newRect;
            if (this.greyed) {
                g.setBlendColor(1610612735);
            }
            this.controlImage.paint(g);
            if (this.greyed) {
                g.setBlendColor(-1);
            }
            this.controlImage.clipRect = this.oldRect;
        }
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void process() {
        if (!this.hidden && !this.greyed) {
            if (BaseScreen.keysDown(2048)) {
                int rw = this.clipRect.w / 2;
                int rh = this.clipRect.h / 2;
                int dx = (this.clipRect.x0 + rw) - BaseScreen.pointerX;
                int dy = (this.clipRect.y0 + rh) - BaseScreen.pointerY;
                if ((dx < 0 ? -dx : dx) < this.border + rw) {
                    if ((dy < 0 ? -dy : dy) < this.border + rh && (this.controlImage instanceof IconImage)) {
                        IconImage icon = (IconImage) this.controlImage;
                        icon.image = 1;
                    }
                }
            } else if (this.autoHighlight && (this.controlImage instanceof IconImage)) {
                IconImage icon2 = (IconImage) this.controlImage;
                icon2.image = 0;
            }
            if (BaseScreen.keysReleased(2048)) {
                int rw2 = this.clipRect.w / 2;
                int rh2 = this.clipRect.h / 2;
                int dx2 = (this.clipRect.x0 + rw2) - BaseScreen.pointerX;
                int dy2 = (this.clipRect.y0 + rh2) - BaseScreen.pointerY;
                if ((dx2 < 0 ? -dx2 : dx2) < this.border + rw2) {
                    if ((dy2 < 0 ? -dy2 : dy2) < this.border + rh2) {
                        execute();
                    }
                }
            }
        }
    }

    public void execute() {
        if (this.enabled) {
            this.clipRect.untranslate(this.parentLayout.clipRect);
            this.parentLayout.controlHandler.controlExecuted(this.parentLayout, this);
            this.clipRect.translate(this.parentLayout.clipRect);
            if (this.menu != null) {
                this.parentLayout.controlHandler.pushScreen(this.menu, true);
            }
        }
    }
}
