package com.slg.j2me.lib.gui.image;

import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gui.control.GuiContainer;
import javax.microedition.lcdui.Graphics;
/* loaded from: classes.dex */
public class IconImage extends GuiContainer {
    public int image;
    public ImageSequence imgSeq;

    public IconImage(ImageSequence _imgSeq, int _image) {
        this.image = 0;
        this.imgSeq = _imgSeq;
        this.image = _image;
        initialise();
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void initialise() {
        if (this.imgSeq != null && this.image != -1 && this.imgSeq.numFrames > this.image) {
            this.clipRect.w = this.imgSeq.getRectWidth(this.image);
            this.clipRect.h = this.imgSeq.getRectHeight(this.image);
        }
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        if (this.imgSeq != null && this.image != -1 && this.image < this.imgSeq.numFrames) {
            this.imgSeq.drawImage(g, this.image, this.clipRect.x0, this.clipRect.y0);
        }
        if (this.overlay != null) {
            this.overlay.clipRect.x0 = (short) (this.clipRect.x0 + ((this.clipRect.w - this.overlay.clipRect.w) / 2));
            this.overlay.clipRect.y0 = (short) (this.clipRect.y0 + ((this.clipRect.h - this.overlay.clipRect.h) / 2));
            this.overlay.paint(g);
        }
    }
}
