package com.slg.j2me.lib.gui.image;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gui.BitmapFont;
import com.slg.j2me.lib.gui.control.GuiContainer;
import javax.microedition.lcdui.Graphics;
/* loaded from: classes.dex */
public class TextImage extends GuiContainer {
    private BitmapFont font;
    public String text;
    public boolean visible = true;

    public TextImage(BitmapFont _font, String _text) {
        this.font = _font;
        setText(_text);
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void initialise() {
        if (this.font != null) {
            this.clipRect.w = this.font.getTextWidth(this.text);
            this.clipRect.h = this.font.getFontHeight();
        }
    }

    public void setText(String _text) {
        if (this.font.uppercaseOnly) {
            this.text = BitmapFont.slgToUpperCase(_text);
        } else {
            this.text = _text;
        }
        initialise();
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        if (this.visible) {
            if (ImageSequence.clipSet) {
                g.setClip(0, 0, BaseScreen.displayWidth * 2, BaseScreen.displayHeight * 2);
                ImageSequence.clipSet = false;
            }
            this.font.drawText(g, this.text, this.clipRect.x0, this.clipRect.y0, BaseScreen.visibleRect);
        }
    }
}
