package com.slg.j2me.lib.gui.image;

import com.slg.j2me.lib.gui.BitmapFont;
import com.slg.j2me.lib.gui.control.GuiContainer;
import com.slg.j2me.lib.gui.layout.TextLayout;
import javax.microedition.lcdui.Graphics;
/* loaded from: classes.dex */
public class TextLayoutImage extends GuiContainer {
    public boolean visible = true;
    public TextLayout textLayout = new TextLayout();

    public TextLayoutImage(int layoutFlags) {
        this.textLayout.iLayoutFlags = layoutFlags;
    }

    public TextLayoutImage(int layoutFlags, BitmapFont font, String text) {
        this.textLayout.iLayoutFlags = layoutFlags;
        this.textLayout.iLineHeight = font.getFontHeight();
        this.textLayout.formatText(font, text);
    }

    public void setText(BitmapFont font, String text) {
        this.textLayout.clearText();
        this.textLayout.formatText(font, text);
        initialise();
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void initialise() {
        this.textLayout.clipRect.x0 = this.clipRect.x0;
        this.textLayout.clipRect.y0 = this.clipRect.y0;
        this.textLayout.clipRect.w = this.clipRect.w;
        this.textLayout.clipRect.h = this.clipRect.h;
        this.textLayout.layout();
        this.clipRect.w = this.textLayout.rectDocument.w;
        this.clipRect.h = this.textLayout.rectDocument.h;
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        if (this.visible) {
            this.textLayout.clipRect.x0 = this.clipRect.x0;
            this.textLayout.clipRect.y0 = this.clipRect.y0;
            this.textLayout.paint(g);
        }
    }
}
