package com.slg.j2me.lib.gui.layout;

import com.slg.j2me.lib.gfx.ClipRect;
import com.slg.j2me.lib.gui.control.GuiControl;
import javax.microedition.lcdui.glGraphics;
/* loaded from: classes.dex */
public class MenuLayout extends ScreenLayout {
    public int iSelected = -1;
    public int iLayoutFlags = 1;

    public GuiControl getSelected() {
        return (GuiControl) this.controlList.elementAt(this.iSelected);
    }

    public void up() {
        int sanity = this.controlList.size() * 2;
        while (true) {
            this.iSelected--;
            while (this.iSelected < 0) {
                this.iSelected += ((this.controlList.size() - 1) - 0) + 1;
            }
            while (this.iSelected > this.controlList.size() - 1) {
                this.iSelected -= ((this.controlList.size() - 1) - 0) + 1;
            }
            GuiControl item = (GuiControl) this.controlList.elementAt(this.iSelected);
            sanity--;
            if (sanity <= 0) {
                return;
            }
            if (item.enabled && !item.hidden) {
                return;
            }
        }
    }

    public void down() {
        int sanity = this.controlList.size() * 2;
        while (true) {
            this.iSelected++;
            while (this.iSelected < 0) {
                this.iSelected += ((this.controlList.size() - 1) - 0) + 1;
            }
            while (this.iSelected > this.controlList.size() - 1) {
                this.iSelected -= ((this.controlList.size() - 1) - 0) + 1;
            }
            GuiControl item = (GuiControl) this.controlList.elementAt(this.iSelected);
            sanity--;
            if (sanity <= 0) {
                return;
            }
            if (item.enabled && !item.hidden) {
                return;
            }
        }
    }

    private void execute() {
        ((GuiControl) this.controlList.elementAt(this.iSelected)).execute();
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenLayout
    public void open() {
        super.open();
        this.iSelected = -1;
        layout();
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenLayout
    public void layout() {
        int iControls = this.controlList.size();
        int vertical_size = 0;
        int visible_controls = 0;
        int max_width = 0;
        for (int i = 0; i < iControls; i++) {
            GuiControl control = (GuiControl) this.controlList.elementAt(i);
            if (!control.hidden) {
                vertical_size += control.clipRect.h;
                if (control.clipRect.w > max_width) {
                    max_width = control.clipRect.w;
                }
                visible_controls++;
            }
        }
        int spacing = (this.clipRect.h - vertical_size) / (visible_controls + 1);
        int vertical_size2 = spacing;
        for (int i2 = 0; i2 < iControls; i2++) {
            GuiControl control2 = (GuiControl) this.controlList.elementAt(i2);
            if (!control2.hidden) {
                ClipRect itemRect = control2.clipRect;
                if ((this.iLayoutFlags & 1) != 0) {
                    itemRect.x0 = (short) (this.clipRect.x0 + ((this.clipRect.w - itemRect.w) / 2));
                } else if ((this.iLayoutFlags & glGraphics.cMaxLines) != 0) {
                    itemRect.x0 = (short) (this.clipRect.x0 + (this.clipRect.w - itemRect.w));
                } else {
                    itemRect.x0 = this.clipRect.x0;
                }
                itemRect.y0 = (short) (this.clipRect.y0 + vertical_size2);
                vertical_size2 += itemRect.h + spacing;
            }
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void process() {
        if (keysPressed(1)) {
            up();
        } else if (keysPressed(8)) {
            down();
        } else if (keysPressed(32784)) {
            execute();
        } else if (keysPressed(32768)) {
            execute();
        }
        super.process();
    }
}
