package com.slg.j2me.lib.gui.layout;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gui.control.ControlHandler;
import com.slg.j2me.lib.gui.control.GuiContainer;
import java.util.Vector;
import javax.microedition.lcdui.Graphics;
/* loaded from: classes.dex */
public class ScreenLayout extends GuiContainer {
    public ControlHandler controlHandler;
    public Vector controlList = new Vector();

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void initialise() {
        layout();
    }

    public void addControl(GuiContainer item) {
        this.controlList.addElement(item);
        item.parentLayout = this;
    }

    public void open() {
        for (int i = 0; i < this.controlList.size(); i++) {
            GuiContainer control = (GuiContainer) this.controlList.elementAt(i);
            control.initialise();
        }
    }

    public void close() {
    }

    public void layout() {
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        for (int i = 0; i < this.controlList.size(); i++) {
            GuiContainer ctrl = (GuiContainer) this.controlList.elementAt(i);
            ctrl.paint(g);
        }
    }

    @Override // com.slg.j2me.lib.gui.control.GuiContainer
    public void process() {
        for (int i = 0; i < this.controlList.size(); i++) {
            GuiContainer ctrl = (GuiContainer) this.controlList.elementAt(i);
            ctrl.process();
        }
    }

    public static final boolean keysDown(int keys) {
        return BaseScreen.keysDown(keys);
    }

    public static final boolean keysPressed(int keys) {
        return BaseScreen.keysPressed(keys);
    }

    public static final boolean keysReleased(int keys) {
        return BaseScreen.keysReleased(keys);
    }

    public static final int getScaledX(int x) {
        return BaseScreen.getScaledX(x);
    }

    public static final int getScaledY(int x) {
        return BaseScreen.getScaledX(x);
    }
}
