package com.slg.j2me.lib.gui.layout;

import com.slg.j2me.lib.gfx.BaseScreen;
import com.slg.j2me.lib.gfx.ClipRect;
import com.slg.j2me.lib.gfx.ImageSequence;
import com.slg.j2me.lib.gui.BitmapFont;
import com.slg.j2me.lib.gui.control.GuiContainer;
import com.slg.j2me.lib.gui.image.IconImage;
import com.slg.j2me.lib.gui.image.TextImage;
import java.util.Vector;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.glGraphics;
import javax.microedition.midlet.SimpleGLRenderer;
/* loaded from: classes.dex */
public class TextLayout extends ScreenLayout {
    ClipRect oldRect;
    public Vector vecNewLines = new Vector();
    public int iLayoutFlags = 0;
    public int iLineHeight = -1;
    boolean takeNewLine = false;
    public ClipRect rectDocument = new ClipRect(0, 0, 0, 0);
    public int iXScroll = 0;
    public int iYScroll = 0;
    public boolean initialised = true;
    public int fp_y = 0;
    private int textColour = -1;
    ClipRect newRect = new ClipRect(0, 0, 0, 0);

    @Override // com.slg.j2me.lib.gui.layout.ScreenLayout
    public void addControl(GuiContainer item) {
        this.controlList.addElement(item);
        if (this.takeNewLine) {
            setNewLine(this.controlList.size());
            this.takeNewLine = false;
        }
        item.parentLayout = this;
    }

    public void addImage(ImageSequence imgSeq, int frame) {
        if (imgSeq != null) {
            addControl(new IconImage(imgSeq, frame));
        }
    }

    public void clearText() {
        this.takeNewLine = false;
        this.controlList.removeAllElements();
        this.vecNewLines.removeAllElements();
        this.rectDocument.h = (short) 0;
        this.initialised = false;
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenLayout
    public void open() {
        layout();
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenLayout
    public void close() {
        clearText();
    }

    public void setNewLine(int word) {
        this.vecNewLines.addElement(new Integer(word));
    }

    public boolean isNewLine(int word) {
        for (int i = 0; i < this.vecNewLines.size(); i++) {
            Integer newlinepos = (Integer) this.vecNewLines.elementAt(i);
            if (newlinepos.intValue() == word) {
                return true;
            }
        }
        return false;
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenLayout
    public void layout() {
        int i;
        this.initialised = false;
        this.iXScroll = 0;
        this.iYScroll = 0;
        this.fp_y = 0;
        int iItems = this.controlList.size();
        for (int i2 = 0; i2 < iItems; i2++) {
            GuiContainer container = (GuiContainer) this.controlList.elementAt(i2);
            container.initialise();
        }
        int x = 0;
        int y = 0;
        int word = 0;
        Vector vecLineLength = new Vector();
        Vector vecWords = new Vector();
        int maxLineWidth = 0;
        if ((this.iLayoutFlags & 128) != 0) {
            this.clipRect.w = (short) BaseScreen.displayWidth;
        }
        int line_height = 0;
        for (int i3 = 0; i3 < iItems; i3++) {
            GuiContainer control = (GuiContainer) this.controlList.elementAt(i3);
            ClipRect itemRect = control.clipRect;
            if ((word > 0 && itemRect.w + x > this.clipRect.w) || isNewLine(i3)) {
                y += this.iLineHeight == -1 ? line_height : this.iLineHeight;
                if (maxLineWidth <= x) {
                    maxLineWidth = x;
                }
                vecLineLength.addElement(new Integer(x));
                vecWords.addElement(new Integer(word));
                x = 0;
                word = 0;
                line_height = 0;
            }
            if (line_height <= itemRect.h) {
                line_height = itemRect.h;
            }
            itemRect.x0 = (short) x;
            itemRect.y0 = (short) y;
            x += itemRect.w;
            word++;
        }
        int y2 = y + (this.iLineHeight == -1 ? line_height : this.iLineHeight);
        if (maxLineWidth <= x) {
            maxLineWidth = x;
        }
        vecLineLength.addElement(new Integer(x));
        vecWords.addElement(new Integer(word));
        if ((this.iLayoutFlags & 128) != 0) {
            this.clipRect.w = (short) maxLineWidth;
        }
        if (this.iLayoutFlags != 0) {
            int line = 0;
            int lines = vecLineLength.size();
            int words = ((Integer) vecWords.elementAt(0)).intValue();
            int width = ((Integer) vecLineLength.elementAt(0)).intValue();
            int word2 = 0;
            int y3 = 0;
            int line_height2 = 0;
            for (int i4 = 0; i4 < iItems; i4++) {
                GuiContainer control2 = (GuiContainer) this.controlList.elementAt(i4);
                ClipRect itemRect2 = control2.clipRect;
                if (y3 != itemRect2.y0 || isNewLine(i4)) {
                    y3 = itemRect2.y0;
                    word2 = 0;
                    line++;
                    width = ((Integer) vecLineLength.elementAt(line)).intValue();
                    words = ((Integer) vecWords.elementAt(line)).intValue();
                    line_height2 = 0;
                }
                if (line_height2 <= itemRect2.h) {
                    line_height2 = itemRect2.h;
                }
                if ((this.iLayoutFlags & 1) != 0) {
                    itemRect2.x0 = (short) (itemRect2.x0 + ((this.clipRect.w - width) / 2));
                } else if ((this.iLayoutFlags & 4) != 0) {
                    if ((this.iLayoutFlags & 20) != 0) {
                        if (words > 1) {
                            itemRect2.x0 = (short) (itemRect2.x0 + (((this.clipRect.w - width) * word2) / (words - 1)));
                        } else {
                            itemRect2.x0 = (short) (itemRect2.x0 + ((this.clipRect.w - width) / 2));
                        }
                    } else {
                        itemRect2.x0 = (short) (itemRect2.x0 + (((this.clipRect.w - width) * (word2 + 1)) / (words + 2)));
                    }
                } else if ((this.iLayoutFlags & glGraphics.cMaxLines) != 0) {
                    itemRect2.x0 = (short) (itemRect2.x0 + (this.clipRect.w - width));
                }
                if ((this.iLayoutFlags & 2) != 0) {
                    int h = (this.clipRect.h - y2) / 2;
                    if (h > 0) {
                        itemRect2.y0 = (short) (itemRect2.y0 + h);
                    }
                } else if ((this.iLayoutFlags & 8) != 0) {
                    if ((this.iLayoutFlags & 40) == 0) {
                        itemRect2.y0 = (short) (itemRect2.y0 + ((this.clipRect.h - y2) / 2));
                    } else if (lines > 1) {
                        itemRect2.y0 = (short) (itemRect2.y0 + (((this.clipRect.h - y2) * line) / (lines - 1)));
                    }
                }
                if (this.iLineHeight != -1 && this.iLineHeight > itemRect2.h) {
                    itemRect2.y0 = (short) (itemRect2.y0 + ((this.iLineHeight - itemRect2.h) >> 1));
                }
                if (this.iLineHeight == -1 && line_height2 > itemRect2.h) {
                    itemRect2.y0 = (short) (itemRect2.y0 + ((line_height2 - itemRect2.h) >> 1));
                }
                word2++;
            }
        }
        this.rectDocument.x0 = (short) 0;
        ClipRect clipRect = this.rectDocument;
        if ((this.iLayoutFlags & 2) != 0) {
            i = (this.clipRect.h - y2) / 2;
        } else {
            i = 0;
        }
        clipRect.y0 = (short) i;
        this.rectDocument.y0 = this.rectDocument.y0 < 0 ? (short) 0 : this.rectDocument.y0;
        this.rectDocument.w = this.clipRect.w;
        this.rectDocument.h = (short) y2;
        if ((this.iLayoutFlags & SimpleGLRenderer.cMaxResID) != 0) {
            this.clipRect.h = this.rectDocument.h;
        }
        this.initialised = true;
    }

    public void formatText(BitmapFont font, String text, int colour) {
        this.textColour = colour;
        formatText(font, text);
        this.textColour = -1;
    }

    public void formatText(BitmapFont font, String text) {
        this.initialised = false;
        int nextwordstart = 0;
        while (nextwordstart < text.length()) {
            if (this.takeNewLine) {
                setNewLine(this.controlList.size());
                this.takeNewLine = false;
            }
            int wordstart = nextwordstart;
            int nextspace = text.indexOf(32, wordstart) + 1;
            int nextnewline = text.indexOf(10, wordstart) + 1;
            if (nextspace > 0 && (nextspace < nextnewline || nextnewline == 0)) {
                nextwordstart = nextspace;
            } else if (nextnewline > 0) {
                nextwordstart = nextnewline;
                this.takeNewLine = true;
            } else {
                nextwordstart = text.length();
            }
            String word = text.substring(wordstart, nextwordstart);
            addControl(new TextImage(font, word));
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void paint(Graphics g) {
        if (this.initialised) {
            BaseScreen.pushVisibleRect(this.clipRect);
            for (int i = 0; i < this.controlList.size(); i++) {
                GuiContainer item = (GuiContainer) this.controlList.elementAt(i);
                if (item.clipRect.x0 + item.clipRect.w + this.iXScroll > 0 && item.clipRect.x0 + this.iXScroll < this.clipRect.w + 0 && item.clipRect.y0 + item.clipRect.h + this.iYScroll > 0 && item.clipRect.y0 + this.iYScroll < this.clipRect.h + 0) {
                    if (!this.initialised) {
                        break;
                    }
                    this.oldRect = item.clipRect;
                    this.newRect.x0 = (short) (this.clipRect.x0 + item.clipRect.x0 + this.iXScroll);
                    this.newRect.y0 = (short) (this.clipRect.y0 + item.clipRect.y0 + this.iYScroll);
                    this.newRect.w = (short) ((this.newRect.x0 + item.clipRect.w < this.clipRect.x0 + this.clipRect.w ? this.newRect.x0 + item.clipRect.w : this.clipRect.x0 + this.clipRect.w) - this.newRect.x0);
                    this.newRect.h = (short) ((this.newRect.y0 + item.clipRect.h < this.clipRect.y0 + this.clipRect.h ? this.newRect.y0 + item.clipRect.h : this.clipRect.y0 + this.clipRect.h) - this.newRect.y0);
                    item.clipRect = this.newRect;
                    item.paint(g);
                    item.clipRect = this.oldRect;
                }
            }
            BaseScreen.popVisibleRect();
        }
    }

    @Override // com.slg.j2me.lib.gui.layout.ScreenLayout, com.slg.j2me.lib.gui.control.GuiContainer
    public void process() {
        for (int i = 0; i < this.controlList.size(); i++) {
            GuiContainer ctrl = (GuiContainer) this.controlList.elementAt(i);
            ctrl.clipRect.translate(this.clipRect);
            ctrl.process();
            ctrl.clipRect.untranslate(this.clipRect);
        }
    }

    public boolean scroll(int fp_moveamount) {
        int i;
        int fp_lastY = this.fp_y;
        int imax = -this.rectDocument.y0;
        int imin = -(this.rectDocument.h - this.clipRect.h < 0 ? 0 : this.rectDocument.h - this.clipRect.h);
        if (this.fp_y + fp_moveamount < (imin < 0 ? -((-imin) << 16) : imin << 16)) {
            i = imin < 0 ? -((-imin) << 16) : imin << 16;
        } else {
            i = this.fp_y + fp_moveamount > (imax < 0 ? -((-imax) << 16) : imax << 16) ? imax < 0 ? -((-imax) << 16) : imax << 16 : this.fp_y + fp_moveamount;
        }
        this.fp_y = i;
        this.iYScroll = this.fp_y < 0 ? -((-this.fp_y) >> 16) : this.fp_y >> 16;
        return fp_lastY != this.fp_y || fp_moveamount == 0;
    }
}
