package com.slg.j2me.lib.sys;

import com.slg.j2me.game.GameLogic;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
/* loaded from: classes.dex */
public class FixedPoint {
    public static int[] sinlut = null;
    public static int[] asinlut = null;
    private static final int asinLutLowIndexScalar = stringToFP("85.33333");

    public static final void startup() {
        Application application = Application.instance;
        InputStream inputstream = Application.openResourceAsStream("/math.bin");
        DataInputStream datain = new DataInputStream(inputstream);
        try {
            int readShort = datain.readShort();
            sinlut = new int[readShort];
            for (int i = 0; i < readShort; i++) {
                sinlut[i] = datain.readInt();
            }
            short asinsize = datain.readShort();
            short asinsize2 = datain.readShort();
            asinlut = new int[asinsize + asinsize2];
            for (int i2 = 0; i2 < asinsize + asinsize2; i2++) {
                asinlut[i2] = datain.readInt();
            }
        } catch (IOException e) {
        }
    }

    public static final int linearInterpolate(int t, int t0, int t1) {
        int b;
        if (t < 0) {
            b = 0;
        } else {
            b = t > 65536 ? 65536 : t;
        }
        int a2 = t1 - t0;
        return (((a2 ^ b) & 134217728) != 0 ? -((int) (((-a2) * b) >> 16)) : (int) ((a2 * b) >> 16)) + t0;
    }

    public static final int sinLut(int fp_angle) {
        int angle = (fp_angle >> 16) & 255;
        int fp_frac = fp_angle & 65535;
        return (((sinlut[angle] ^ (65536 - fp_frac)) & 134217728) != 0 ? -((int) (((-sinlut[angle]) * (65536 - fp_frac)) >> 16)) : (int) ((sinlut[angle] * (65536 - fp_frac)) >> 16)) + (((sinlut[angle + 1] ^ fp_frac) & 134217728) != 0 ? -((int) (((-sinlut[angle + 1]) * fp_frac) >> 16)) : (int) ((sinlut[angle + 1] * fp_frac) >> 16));
    }

    public static final int asinLut(int fp_sin) {
        int fp_index;
        int fp_asin;
        int start = 0;
        boolean neg = false;
        if (fp_sin < 0) {
            fp_sin = -fp_sin;
            neg = true;
        }
        if (fp_sin < 49152) {
            fp_index = (int) ((fp_sin * asinLutLowIndexScalar) >> 16);
        } else {
            fp_index = (fp_sin - GameLogic.cfpIntroFadeTime) * 768;
            start = 65;
        }
        if (fp_index >= 12582912) {
            fp_asin = 4194304;
        } else {
            int index = fp_index < 0 ? -((-fp_index) >> 16) : fp_index >> 16;
            int fp_frac = fp_index & 65535;
            fp_asin = (((asinlut[start + index] ^ (65536 - fp_frac)) & 134217728) != 0 ? -((int) (((-asinlut[start + index]) * (65536 - fp_frac)) >> 16)) : (int) ((asinlut[start + index] * (65536 - fp_frac)) >> 16)) + (((asinlut[(start + index) + 1] ^ fp_frac) & 134217728) != 0 ? -((int) (((-asinlut[(start + index) + 1]) * fp_frac) >> 16)) : (int) ((asinlut[(start + index) + 1] * fp_frac) >> 16));
        }
        return neg ? -fp_asin : fp_asin;
    }

    public static final int sqrt_bits(int sqr) {
        int delta = sqr > 65536 ? sqr : 65536;
        int M = sqr;
        int root = 0;
        do {
            long step = (delta * ((root << 1) + delta)) >> 16;
            if (step <= M) {
                M = (int) (M - step);
                root += delta;
            }
            delta >>= 1;
        } while (delta != 0);
        return root;
    }

    public static final int sqrt_bits(long sqr) {
        long delta = sqr > 65536 ? sqr : 65536L;
        long M = sqr;
        long root = 0;
        do {
            long step = (((root << 1) + delta) * delta) >> 16;
            if (step <= M) {
                M -= step;
                root += delta;
            }
            delta >>= 1;
        } while (delta != 0);
        return (int) root;
    }

    public static final String toString_fp(int fp) {
        String zeros;
        boolean negative = fp < 0;
        if (negative) {
            fp = -fp;
        }
        long frac = ((65535 & fp) * 100000) / 65536;
        if (frac < 10) {
            zeros = "0000";
        } else {
            zeros = frac < 100 ? "000" : frac < 1000 ? "00" : frac < 10000 ? "0" : "";
        }
        return (negative ? "-" : "") + (fp >> 16) + "." + zeros + frac;
    }

    public static final int stringToFP(String str) {
        long number = 0;
        int divisor = 0;
        boolean negative = false;
        for (int i = 0; i < str.length(); i++) {
            char c = str.charAt(i);
            if (c == '.') {
                if (divisor != 0) {
                }
                divisor = 1;
            } else if (c == '-') {
                if (negative || number != 0) {
                }
                negative = true;
            } else if (c >= '0' && c <= '9') {
                divisor *= 10;
                number = (number * 10) + (c - '0');
            }
        }
        if (negative) {
            number = -number;
        }
        if (divisor > 1) {
            return (int) ((((int) number) << 16) / divisor);
        }
        return ((int) number) < 0 ? -((-((int) number)) << 16) : ((int) number) << 16;
    }

    public static String maskToString(int mask, int start) {
        String ret = "";
        for (int i = start - 1; i >= 0; i--) {
            if (((1 << i) & mask) != 0) {
                ret = ret.concat("1");
            } else {
                ret = ret.concat("0");
            }
            if ((i & 7) == 0) {
                ret = ret.concat(" ");
            }
        }
        return ret;
    }

    public static int getNextSetBit(int mask, int start) {
        if (mask == 0 || start == 31) {
            return -1;
        }
        int start2 = start + 1;
        int startnibble = start2 >> 2;
        int nibble = startnibble;
        while (nibble < 8) {
            if (((15 << (nibble << 2)) & mask) != 0) {
                int startbit = startnibble == nibble ? start2 & 3 : 0;
                for (int bit = startbit; bit < 4; bit++) {
                    int checkbit = (nibble << 2) + bit;
                    if (((1 << checkbit) & mask) != 0) {
                        return checkbit;
                    }
                }
                continue;
            }
            nibble++;
        }
        return -1;
    }

    public static int getPrevSetBit(int mask, int start) {
        if (mask == 0 || start == 0) {
            return -1;
        }
        int start2 = start == -1 ? 31 : start - 1;
        int startnibble = start2 >> 2;
        int nibble = startnibble;
        while (nibble >= 0) {
            if (((15 << (nibble << 2)) & mask) != 0) {
                int startbit = startnibble == nibble ? start2 & 3 : 3;
                for (int bit = startbit; bit >= 0; bit--) {
                    int checkbit = (nibble << 2) + bit;
                    if (((1 << checkbit) & mask) != 0) {
                        return checkbit;
                    }
                }
                continue;
            }
            nibble--;
        }
        return -1;
    }

    public static int getBitCount(int mask) {
        int v = mask - ((mask >> 1) & 1431655765);
        int v2 = (v & 858993459) + ((v >> 2) & 858993459);
        return ((((v2 >> 4) + v2) & 252645135) * 16843009) >> 24;
    }
}
