package com.slg.j2me.lib.sys;
/* loaded from: classes.dex */
public class VecMath {
    public static final String toString_v2(int[] vec) {
        return "[" + FixedPoint.toString_fp(vec[0]) + "," + FixedPoint.toString_fp(vec[1]) + "]";
    }

    public static final String toString_v3(int[] vec) {
        return "[" + FixedPoint.toString_fp(vec[0]) + "," + FixedPoint.toString_fp(vec[1]) + "," + FixedPoint.toString_fp(vec[2]) + "]";
    }

    public static final String toString_m33(int[] mat) {
        String str = new String();
        for (int i = 0; i < 9; i += 3) {
            str = str + "[" + FixedPoint.toString_fp(mat[i + 0]) + "," + FixedPoint.toString_fp(mat[i + 1]) + "," + FixedPoint.toString_fp(mat[i + 2]) + "]\n";
        }
        return str;
    }

    public static final String toString_m44(int[] mat) {
        String str = new String();
        for (int i = 0; i < 16; i += 4) {
            str = str + "[" + FixedPoint.toString_fp(mat[i + 0]) + "," + FixedPoint.toString_fp(mat[i + 1]) + "," + FixedPoint.toString_fp(mat[i + 2]) + "," + FixedPoint.toString_fp(mat[i + 3]) + "]\n";
        }
        return str;
    }

    public static final int len3d(int[] in) {
        long llensq = ((in[0] * in[0]) >> 16) + ((in[1] * in[1]) >> 16) + ((in[2] * in[2]) >> 16);
        int lensq = (int) llensq;
        if (llensq <= 16) {
            return 0;
        }
        if (llensq < 2097152) {
            int[] scaled_in = new int[3];
            scaled_in[0] = in[0] < 0 ? -((-in[0]) << 5) : in[0] << 5;
            scaled_in[1] = in[1] < 0 ? -((-in[1]) << 5) : in[1] << 5;
            scaled_in[2] = in[2] < 0 ? -((-in[2]) << 5) : in[2] << 5;
            int lensq2 = (int) (((scaled_in[0] * scaled_in[0]) >> 16) + ((scaled_in[1] * scaled_in[1]) >> 16) + ((scaled_in[2] * scaled_in[2]) >> 16));
            int len = FixedPoint.sqrt_bits(lensq2);
            return len >> 5;
        } else if (llensq > 2147483647L) {
            int[] scaled_in2 = new int[3];
            scaled_in2[0] = in[0] < 0 ? -((-in[0]) >> 8) : in[0] >> 8;
            scaled_in2[1] = in[1] < 0 ? -((-in[1]) >> 8) : in[1] >> 8;
            scaled_in2[2] = in[2] < 0 ? -((-in[2]) >> 8) : in[2] >> 8;
            int lensq3 = (int) (((scaled_in2[0] * scaled_in2[0]) >> 16) + ((scaled_in2[1] * scaled_in2[1]) >> 16) + ((scaled_in2[2] * scaled_in2[2]) >> 16));
            int len2 = FixedPoint.sqrt_bits(lensq3);
            return len2 << 8;
        } else {
            int len3 = FixedPoint.sqrt_bits(lensq);
            return len3;
        }
    }

    public static final int norm3d(int[] out, int[] in) {
        long llensq = ((in[2] * in[2]) >> 16) + ((in[0] * in[0]) >> 16) + ((in[1] * in[1]) >> 16);
        int lensq = (int) llensq;
        if (llensq <= 16) {
            out[2] = 0;
            out[1] = 0;
            out[0] = 0;
            return 0;
        } else if (llensq < 2097152) {
            int[] scaled_in = new int[3];
            int lensq2 = in[0];
            scaled_in[0] = lensq2 < 0 ? -((-in[0]) << 5) : in[0] << 5;
            scaled_in[1] = in[1] < 0 ? -((-in[1]) << 5) : in[1] << 5;
            scaled_in[2] = in[2] < 0 ? -((-in[2]) << 5) : in[2] << 5;
            int lensq3 = (int) (((scaled_in[0] * scaled_in[0]) >> 16) + ((scaled_in[1] * scaled_in[1]) >> 16) + ((scaled_in[2] * scaled_in[2]) >> 16));
            int len = FixedPoint.sqrt_bits(lensq3);
            int oolen = (int) (4294967296L / len);
            out[0] = ((scaled_in[0] ^ oolen) & 134217728) != 0 ? -((int) (((-scaled_in[0]) * oolen) >> 16)) : (int) ((scaled_in[0] * oolen) >> 16);
            out[1] = ((scaled_in[1] ^ oolen) & 134217728) != 0 ? -((int) (((-scaled_in[1]) * oolen) >> 16)) : (int) ((scaled_in[1] * oolen) >> 16);
            out[2] = ((scaled_in[2] ^ oolen) & 134217728) != 0 ? -((int) ((oolen * (-scaled_in[2])) >> 16)) : (int) ((oolen * scaled_in[2]) >> 16);
            return len >> 5;
        } else if (llensq > 2147483647L) {
            int[] scaled_in2 = new int[3];
            int lensq4 = in[0];
            scaled_in2[0] = lensq4 < 0 ? -((-in[0]) >> 8) : in[0] >> 8;
            scaled_in2[1] = in[1] < 0 ? -((-in[1]) >> 8) : in[1] >> 8;
            scaled_in2[2] = in[2] < 0 ? -((-in[2]) >> 8) : in[2] >> 8;
            int lensq5 = (int) (((scaled_in2[0] * scaled_in2[0]) >> 16) + ((scaled_in2[1] * scaled_in2[1]) >> 16) + ((scaled_in2[2] * scaled_in2[2]) >> 16));
            int len2 = FixedPoint.sqrt_bits(lensq5);
            int oolen2 = (int) (4294967296L / len2);
            out[0] = ((scaled_in2[0] ^ oolen2) & 134217728) != 0 ? -((int) (((-scaled_in2[0]) * oolen2) >> 16)) : (int) ((scaled_in2[0] * oolen2) >> 16);
            out[1] = ((scaled_in2[1] ^ oolen2) & 134217728) != 0 ? -((int) (((-scaled_in2[1]) * oolen2) >> 16)) : (int) ((scaled_in2[1] * oolen2) >> 16);
            out[2] = ((scaled_in2[2] ^ oolen2) & 134217728) != 0 ? -((int) ((oolen2 * (-scaled_in2[2])) >> 16)) : (int) ((oolen2 * scaled_in2[2]) >> 16);
            return len2 << 8;
        } else {
            int len3 = FixedPoint.sqrt_bits(lensq);
            int oolen3 = (int) (4294967296L / len3);
            out[0] = ((in[0] ^ oolen3) & 134217728) != 0 ? -((int) (((-in[0]) * oolen3) >> 16)) : (int) ((in[0] * oolen3) >> 16);
            out[1] = ((in[1] ^ oolen3) & 134217728) != 0 ? -((int) (((-in[1]) * oolen3) >> 16)) : (int) ((in[1] * oolen3) >> 16);
            out[2] = ((in[2] ^ oolen3) & 134217728) != 0 ? -((int) (((-in[2]) * oolen3) >> 16)) : (int) ((in[2] * oolen3) >> 16);
            return len3;
        }
    }

    public static final int len2d(int[] in) {
        long llensq = ((in[0] * in[0]) >> 16) + ((in[1] * in[1]) >> 16);
        int lensq = (int) llensq;
        if (llensq <= 16) {
            return 0;
        }
        if (llensq < 2097152) {
            int[] scaled_in = new int[2];
            scaled_in[0] = in[0] < 0 ? -((-in[0]) << 5) : in[0] << 5;
            scaled_in[1] = in[1] < 0 ? -((-in[1]) >> 5) : in[1] >> 5;
            int lensq2 = (int) (((scaled_in[0] * scaled_in[0]) >> 16) + ((scaled_in[1] * scaled_in[1]) >> 16));
            int len = FixedPoint.sqrt_bits(lensq2);
            return len >> 5;
        } else if (llensq > 2147483647L) {
            int[] scaled_in2 = new int[2];
            scaled_in2[0] = in[0] < 0 ? -((-in[0]) >> 8) : in[0] >> 8;
            scaled_in2[1] = in[1] < 0 ? -((-in[1]) >> 8) : in[1] >> 8;
            int lensq3 = (int) (((scaled_in2[0] * scaled_in2[0]) >> 16) + ((scaled_in2[1] * scaled_in2[1]) >> 16));
            int len2 = FixedPoint.sqrt_bits(lensq3);
            return len2 << 8;
        } else {
            int len3 = FixedPoint.sqrt_bits(lensq);
            return len3;
        }
    }

    public static final int norm2d(int[] out, int[] in) {
        long llensq = ((in[1] * in[1]) >> 16) + ((in[0] * in[0]) >> 16);
        int lensq = (int) llensq;
        if (llensq <= 16) {
            out[1] = 0;
            out[0] = 0;
            return 0;
        } else if (llensq < 2097152) {
            int[] scaled_in = new int[2];
            int lensq2 = in[0];
            scaled_in[0] = lensq2 < 0 ? -((-in[0]) << 5) : in[0] << 5;
            scaled_in[1] = in[1] < 0 ? -((-in[1]) << 5) : in[1] << 5;
            int lensq3 = (int) (((scaled_in[0] * scaled_in[0]) >> 16) + ((scaled_in[1] * scaled_in[1]) >> 16));
            int len = FixedPoint.sqrt_bits(lensq3);
            int oolen = (int) (4294967296L / len);
            out[0] = ((scaled_in[0] ^ oolen) & 134217728) != 0 ? -((int) (((-scaled_in[0]) * oolen) >> 16)) : (int) ((scaled_in[0] * oolen) >> 16);
            out[1] = ((scaled_in[1] ^ oolen) & 134217728) != 0 ? -((int) ((oolen * (-scaled_in[1])) >> 16)) : (int) ((oolen * scaled_in[1]) >> 16);
            return len >> 5;
        } else if (llensq > 2147483647L) {
            int[] scaled_in2 = new int[2];
            int lensq4 = in[0];
            scaled_in2[0] = lensq4 < 0 ? -((-in[0]) >> 8) : in[0] >> 8;
            scaled_in2[1] = in[1] < 0 ? -((-in[1]) >> 8) : in[1] >> 8;
            int lensq5 = (int) (((scaled_in2[0] * scaled_in2[0]) >> 16) + ((scaled_in2[1] * scaled_in2[1]) >> 16));
            int len2 = FixedPoint.sqrt_bits(lensq5);
            int oolen2 = (int) (4294967296L / len2);
            out[0] = ((scaled_in2[0] ^ oolen2) & 134217728) != 0 ? -((int) (((-scaled_in2[0]) * oolen2) >> 16)) : (int) ((scaled_in2[0] * oolen2) >> 16);
            out[1] = ((scaled_in2[1] ^ oolen2) & 134217728) != 0 ? -((int) ((oolen2 * (-scaled_in2[1])) >> 16)) : (int) ((oolen2 * scaled_in2[1]) >> 16);
            return len2 << 8;
        } else {
            int len3 = FixedPoint.sqrt_bits(lensq);
            int oolen3 = (int) (4294967296L / len3);
            out[0] = ((in[0] ^ oolen3) & 134217728) != 0 ? -((int) (((-in[0]) * oolen3) >> 16)) : (int) ((in[0] * oolen3) >> 16);
            out[1] = ((in[1] ^ oolen3) & 134217728) != 0 ? -((int) (((-in[1]) * oolen3) >> 16)) : (int) ((in[1] * oolen3) >> 16);
            return len3;
        }
    }
}
