package com.slg.j2me.lib.util;

import com.slg.j2me.lib.sys.Application;
import java.io.DataInputStream;
import java.io.InputStream;
import java.util.Vector;
/* loaded from: classes.dex */
public class CSVLoader {
    public static final byte cTypeByte = 2;
    public static final byte cTypeDouble = 7;
    public static final byte cTypeFloat = 6;
    public static final byte cTypeInteger = 4;
    public static final byte cTypeLong = 5;
    public static final byte cTypeShort = 3;
    public static final byte cTypeString = 1;
    public static final byte cTypeUnknown = 0;

    public static String[] loadCSV(String filename, Vector outColumns) {
        String[] strHeadings;
        DataInputStream datain;
        int readShort;
        int readShort2;
        String[] strHeadings2;
        try {
            InputStream inputstream = Application.openResourceAsStream(filename);
            datain = new DataInputStream(inputstream);
            readShort = datain.readShort();
            readShort2 = datain.readShort();
            strHeadings2 = new String[readShort];
        } catch (Exception e) {
            strHeadings = null;
        }
        try {
            byte[] dataType = new byte[readShort];
            for (int i = 0; i < readShort; i++) {
                strHeadings2[i] = datain.readUTF();
                dataType[i] = datain.readByte();
                switch (dataType[i]) {
                    case 1:
                        String[] strHeadings3 = new String[readShort2];
                        outColumns.addElement(strHeadings3);
                        break;
                    case 2:
                        byte[] byte_array = new byte[readShort2];
                        outColumns.addElement(byte_array);
                        break;
                    case 3:
                        short[] short_array = new short[readShort2];
                        outColumns.addElement(short_array);
                        break;
                    default:
                        throw new Exception("Error - unknown datatype in binary CSV file: " + ((int) dataType[i]));
                }
            }
            int i2 = 0;
            while (i2 < readShort) {
                switch (dataType[i2]) {
                    case 1:
                        String[] str_array = (String[]) outColumns.elementAt(i2);
                        for (int j = 0; j < readShort2; j++) {
                            str_array[j] = datain.readUTF();
                        }
                        break;
                    case 2:
                        byte[] byte_array2 = (byte[]) outColumns.elementAt(i2);
                        for (int j2 = 0; j2 < readShort2; j2++) {
                            byte_array2[j2] = datain.readByte();
                        }
                        break;
                    case 3:
                        short[] short_array2 = (short[]) outColumns.elementAt(i2);
                        for (int j3 = 0; j3 < readShort2; j3++) {
                            short_array2[j3] = datain.readShort();
                        }
                        break;
                    default:
                        throw new Exception("Error - unknown datatype in binary CSV file: " + ((int) dataType[i2]));
                }
                int j4 = i2 + 1;
                i2 = j4;
            }
            return strHeadings2;
        } catch (Exception e2) {
            strHeadings = strHeadings2;
            return null;
        }
    }

    public static byte[] getCSVByteArray(Vector columns, int column) {
        return (byte[]) columns.elementAt(column);
    }

    public static short[] getCSVShortArray(Vector columns, int column) {
        return (short[]) columns.elementAt(column);
    }

    public static String[] getCSVStringArray(Vector columns, int column) {
        return (String[]) columns.elementAt(column);
    }
}
