package com.slg.j2me.lib.util;

import com.slg.j2me.lib.sys.Application;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
/* loaded from: classes.dex */
public class MultiLingual {
    public static String filename;
    public static String[] language;
    public static String[] languageLongName;
    public static byte[][] textdata;
    public static int lang = -1;
    public static int lines = 0;
    public static int languages = 0;

    public static final String getShortLanguageName() {
        return language[lang];
    }

    public static void load(String fn) {
        filename = fn;
        InputStream inputstream = Application.openResourceAsStream(fn);
        DataInputStream datain = new DataInputStream(inputstream);
        try {
            languages = datain.readShort();
            lines = datain.readShort();
            if (language == null) {
                language = new String[languages];
                languageLongName = new String[languages];
                textdata = new byte[lines];
            }
            for (int l = 0; l < language.length; l++) {
                language[l] = datain.readUTF();
                languageLongName[l] = datain.readUTF();
            }
            if (lang == -1) {
                autodetectLanguage();
            }
            int total_bytes = 0;
            int total_chars = 0;
            int total_lines = 0;
            for (int l2 = 0; l2 <= lang; l2++) {
                for (int i = 0; i < lines; i++) {
                    String line = datain.readUTF();
                    if (l2 == lang) {
                        ByteArrayOutputStream baos = new ByteArrayOutputStream();
                        DataOutputStream dos = new DataOutputStream(baos);
                        dos.writeUTF(line);
                        textdata[i] = baos.toByteArray();
                        total_bytes += textdata[i].length;
                        total_chars += line.length();
                        total_lines++;
                    }
                }
            }
            datain.close();
            inputstream.close();
        } catch (IOException e) {
        }
    }

    public static void autodetectLanguage() {
        String locale = System.getProperty("microedition.locale");
        int l = 0;
        while (true) {
            if (l >= languages) {
                break;
            } else if (!locale.startsWith(language[l])) {
                l++;
            } else {
                lang = l;
                break;
            }
        }
        if (lang == -1) {
            lang = 0;
        }
    }

    public static void setLanguage(int l) {
        lang = l;
        load(filename);
    }

    public static void loadLocale(DataInputStream inputStream) throws IOException {
        try {
            lang = inputStream.readShort();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveLocale(DataOutputStream dataStream) {
        try {
            dataStream.writeShort(lang);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static final String get(int index) {
        if (index >= 0 && index < lines) {
            try {
                ByteArrayInputStream bais = new ByteArrayInputStream(textdata[index]);
                DataInputStream dis = new DataInputStream(bais);
                return dis.readUTF();
            } catch (Exception e) {
                return e.toString();
            }
        }
        return "XX LANGUAGE ERROR XX";
    }
}
