package javax.microedition.lcdui;

import android.graphics.Canvas;
import java.util.Vector;
import javax.microedition.lcdui.game.BlendMode;
import javax.microedition.lcdui.game.Line2D;
import javax.microedition.lcdui.game.Sprite;
import javax.microedition.lcdui.game.SpriteEx;
import javax.microedition.lcdui.game.Triangle2D;
import javax.microedition.midlet.SimpleGLRenderer;
/* loaded from: classes.dex */
public class glGraphics extends Graphics {
    public static final int cMaxBlendModes = 64;
    public static final int cMaxLines = 512;
    public static final int cMaxSpriteExs = 128;
    public static final int cMaxSprites = 1024;
    public static final int cMaxTriangles = 128;
    public static glGraphics instance;
    private static BlendMode[] poolBlendModes;
    private static Line2D[] poolLines;
    private static SpriteEx[] poolSpriteExs;
    private static Sprite[] poolSprites;
    private static Triangle2D[] poolTriangles;
    public static Vector drawList = new Vector();
    private static int x0 = 0;
    private static int y0 = 0;
    private static int color = -1;
    private static int blend_color = -1;
    private static int clip_x = 0;
    private static int clip_y = 0;
    private static int clip_w = 533;
    private static int clip_h = 320;
    private static int stroke = 7;
    private static int nextSprite = 0;
    private static int nextLine = 0;
    private static int nextTriangle = 0;
    private static int nextSpriteEx = 0;
    private static int nextBlendMode = 0;

    public glGraphics() {
        instance = this;
        allocateObjectPools();
    }

    public static final void setCanvas(Canvas canvas) {
        drawList.removeAllElements();
        drawList.ensureCapacity(SimpleGLRenderer.cMaxResID);
        nextSprite = 0;
        nextSpriteEx = 0;
        nextLine = 0;
        nextTriangle = 0;
        nextBlendMode = 0;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void clipRect(int x, int y, int width, int height) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void copyArea(int x_src, int y_src, int width, int height, int x_dest, int y_dest, int anchor) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawArc(int x, int y, int width, int height, int startAngle, int arcAngle) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawChar(char character, int x, int y, int anchor) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawChars(char[] data, int offset, int length, int x, int y, int anchor) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawImage(j2meImage img, int x, int y, int anchor) {
        if (nextSprite < 1024) {
            Sprite[] spriteArr = poolSprites;
            int i = nextSprite;
            nextSprite = i + 1;
            Sprite spr = spriteArr[i];
            spr.image = img;
            spr.x = x;
            spr.y = y;
            spr.u = 0;
            spr.v = 0;
            int width = img.getWidth();
            spr.dw = width;
            spr.w = width;
            int height = img.getHeight();
            spr.dh = height;
            spr.h = height;
            spr.c = blend_color;
            drawList.add(spr);
        }
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawLine(int x1, int y1, int x2, int y2) {
        if (nextLine < 512) {
            Line2D[] line2DArr = poolLines;
            int i = nextLine;
            nextLine = i + 1;
            Line2D line = line2DArr[i];
            line.x0 = x1;
            line.y0 = y1;
            line.x1 = x2;
            line.y1 = y2;
            line.colour = color;
            drawList.add(line);
        }
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawRect(int x, int y, int width, int height) {
        drawLine(x, y, x + width, y);
        drawLine(x + width, y, x + width, y + height);
        drawLine(x + width, y + height, x, y + height);
        drawLine(x, y + height, x, y);
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawRegion(j2meImage src, int x_src, int y_src, int width, int height, int transform, int x_dest, int y_dest, int anchor) {
        if (nextSprite < 1024) {
            Sprite[] spriteArr = poolSprites;
            int i = nextSprite;
            nextSprite = i + 1;
            Sprite spr = spriteArr[i];
            spr.image = src;
            spr.x = x_dest;
            spr.y = y_dest;
            spr.u = x_src;
            spr.v = y_src;
            spr.dw = width;
            spr.w = width;
            spr.dh = height;
            spr.h = height;
            spr.trans = transform;
            spr.c = blend_color;
            drawList.add(spr);
        }
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawRegionStretched(j2meImage src, int x_src, int y_src, int width, int height, int transform, int x_dest, int y_dest, int width_dest, int height_dest, int anchor) {
        if (nextSprite < 1024) {
            Sprite[] spriteArr = poolSprites;
            int i = nextSprite;
            nextSprite = i + 1;
            Sprite spr = spriteArr[i];
            spr.image = src;
            spr.x = x_dest;
            spr.y = y_dest;
            spr.u = x_src;
            spr.v = y_src;
            spr.w = width;
            spr.h = height;
            spr.dw = width_dest;
            spr.dh = height_dest;
            spr.trans = transform;
            spr.c = blend_color;
            drawList.add(spr);
        }
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawSpriteRotated(j2meImage src, int x_src, int y_src, int width, int height, int transform, int x_dest, int y_dest, int fp_zrot, int fp_scale) {
        if (nextSpriteEx < 128) {
            SpriteEx[] spriteExArr = poolSpriteExs;
            int i = nextSpriteEx;
            nextSpriteEx = i + 1;
            SpriteEx spr = spriteExArr[i];
            spr.image = src;
            spr.x = x_dest;
            spr.y = y_dest;
            spr.u = x_src + 1;
            spr.v = y_src + 1;
            spr.w = width - 2;
            spr.h = height - 2;
            spr.r = fp_zrot;
            spr.s = fp_scale;
            spr.c = blend_color;
            spr.trans = transform;
            drawList.add(spr);
        }
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawRGB(int[] rgbData, int offset, int scanlength, int x, int y, int width, int height, boolean processAlpha) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawRoundRect(int x, int y, int width, int height, int arcWidth, int arcHeight) {
        drawRect(x, y, width, height);
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawString(String str, int x, int y, int anchor) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void drawSubstring(String str, int offset, int len, int x, int y, int anchor) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void fillArc(int x, int y, int width, int height, int startAngle, int arcAngle) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void fillRect(int x, int y, int width, int height) {
        fillTriangle(x, y, x + width, y, x + width, y + height);
        fillTriangle(x, y + height, x, y, x + width, y + height);
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void fillRoundRect(int x, int y, int width, int height, int arcWidth, int arcHeight) {
        fillRect(x, y, width, height);
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void fillTriangle(int x1, int y1, int x2, int y2, int x3, int y3) {
        if (nextTriangle < 128) {
            Triangle2D[] triangle2DArr = poolTriangles;
            int i = nextTriangle;
            nextTriangle = i + 1;
            Triangle2D triangle = triangle2DArr[i];
            triangle.x0 = x1;
            triangle.y0 = y1;
            triangle.x1 = x2;
            triangle.y1 = y2;
            triangle.x2 = x3;
            triangle.y2 = y3;
            triangle.colour = color;
            drawList.add(triangle);
        }
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getBlueComponent() {
        return color & 255;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getClipHeight() {
        return clip_h;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getClipWidth() {
        return clip_w;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getClipX() {
        return clip_x;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getClipY() {
        return clip_y;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getColor() {
        return color;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getDisplayColor(int color2) {
        return color2;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getGrayScale() {
        return 255;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getGreenComponent() {
        return (color >> 8) & 255;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getRedComponent() {
        return (color >> 16) & 255;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getStrokeStyle() {
        return stroke;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getTranslateX() {
        return x0;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final int getTranslateY() {
        return y0;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void setClip(int x, int y, int width, int height) {
        clip_x = x;
        clip_y = y;
        clip_w = width;
        clip_h = height;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void setColor(int RGB) {
        color = RGB;
    }

    @Override // javax.microedition.lcdui.Graphics
    public void setBlendColor(int ARGB) {
        blend_color = ARGB;
    }

    @Override // javax.microedition.lcdui.Graphics
    public void setBlendMode(int blend_mode) {
        if (nextBlendMode < 64) {
            BlendMode[] blendModeArr = poolBlendModes;
            int i = nextBlendMode;
            nextBlendMode = i + 1;
            BlendMode mode = blendModeArr[i];
            mode.blendMode = blend_mode;
            drawList.add(mode);
        }
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void setColor(int red, int green, int blue) {
        setColor(((red & 255) << 16) | ((green & 255) << 8) | (blue & 255));
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void setGrayScale(int value) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void setStrokeStyle(int style) {
        stroke = style;
    }

    @Override // javax.microedition.lcdui.Graphics
    public final void translate(int x, int y) {
        x0 = x;
        y0 = y;
    }

    private static void allocateObjectPools() {
        poolSprites = new Sprite[cMaxSprites];
        poolSpriteExs = new SpriteEx[128];
        poolLines = new Line2D[cMaxLines];
        poolTriangles = new Triangle2D[128];
        poolBlendModes = new BlendMode[64];
        for (int i = 0; i < 1024; i++) {
            poolSprites[i] = new Sprite();
        }
        for (int i2 = 0; i2 < 128; i2++) {
            poolSpriteExs[i2] = new SpriteEx();
        }
        for (int i3 = 0; i3 < 512; i3++) {
            poolLines[i3] = new Line2D();
        }
        for (int i4 = 0; i4 < 128; i4++) {
            poolTriangles[i4] = new Triangle2D();
        }
        for (int i5 = 0; i5 < 64; i5++) {
            poolBlendModes[i5] = new BlendMode();
        }
    }

    private static Sprite getNextSprite() {
        if (nextSprite < 1024) {
            Sprite[] spriteArr = poolSprites;
            int i = nextSprite;
            nextSprite = i + 1;
            return spriteArr[i];
        }
        return null;
    }

    private static SpriteEx getNextSpriteEx() {
        if (nextSpriteEx < 128) {
            SpriteEx[] spriteExArr = poolSpriteExs;
            int i = nextSpriteEx;
            nextSpriteEx = i + 1;
            return spriteExArr[i];
        }
        return null;
    }

    private static Line2D getNextLine2D() {
        if (nextLine < 512) {
            Line2D[] line2DArr = poolLines;
            int i = nextLine;
            nextLine = i + 1;
            return line2DArr[i];
        }
        return null;
    }

    private static Triangle2D getNextTriangle2D() {
        if (nextTriangle < 128) {
            Triangle2D[] triangle2DArr = poolTriangles;
            int i = nextTriangle;
            nextTriangle = i + 1;
            return triangle2DArr[i];
        }
        return null;
    }

    private static BlendMode getNextBlendMode() {
        if (nextBlendMode < 64) {
            BlendMode[] blendModeArr = poolBlendModes;
            int i = nextBlendMode;
            nextBlendMode = i + 1;
            return blendModeArr[i];
        }
        return null;
    }
}
