package javax.microedition.lcdui;

import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.RectF;
/* loaded from: classes.dex */
public class j2meGraphics extends Graphics {
    private static Canvas g;
    public static j2meGraphics instance;
    static Rect rect_src = new Rect();
    static Rect rect_dst = new Rect();
    private static int[] xPoints = new int[3];
    private static int[] yPoints = new int[3];
    private static float[] points = new float[6];
    private Paint paint_fill = new Paint();
    private Paint paint_outline = new Paint();
    private Paint paint_text = new Paint();
    private RectF oval = new RectF();
    private int x0 = 0;
    private int y0 = 0;
    private int color = 16777215;
    private int clip_x = 0;
    private int clip_y = 0;
    private int clip_w = 533;
    private int clip_h = 320;
    private int stroke = 7;

    public j2meGraphics() {
        this.paint_fill.setStyle(Paint.Style.FILL);
        this.paint_text.setStyle(Paint.Style.FILL);
        this.paint_outline.setStyle(Paint.Style.STROKE);
        this.paint_text.setARGB(255, 255, 255, 255);
    }

    public void setCanvas(Canvas canvas) {
        g = canvas;
    }

    @Override // javax.microedition.lcdui.Graphics
    public void clipRect(int x, int y, int width, int height) {
        this.oval.top = y;
        this.oval.bottom = y + height;
        this.oval.left = x;
        this.oval.right = x + width;
        g.clipRect(this.oval);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void copyArea(int x_src, int y_src, int width, int height, int x_dest, int y_dest, int anchor) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawArc(int x, int y, int width, int height, int startAngle, int arcAngle) {
        this.oval.top = y;
        this.oval.bottom = y + height;
        this.oval.left = x;
        this.oval.right = x + width;
        g.drawArc(this.oval, startAngle, arcAngle, false, this.paint_outline);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawChar(char character, int x, int y, int anchor) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawChars(char[] data, int offset, int length, int x, int y, int anchor) {
        g.drawText(data, offset, length, x, y, this.paint_fill);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawImage(j2meImage img, int x, int y, int anchor) {
        g.drawBitmap(img.bitmap, x, y, this.paint_fill);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawLine(int x1, int y1, int x2, int y2) {
        g.drawLine(x1, y1, x2, y2, this.paint_outline);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawRect(int x, int y, int width, int height) {
        g.drawRect(x, y, x + width, y + height, this.paint_outline);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawRegion(j2meImage src, int x_src, int y_src, int width, int height, int transform, int x_dest, int y_dest, int anchor) {
        int cx = x_dest + (width >> 1);
        int cy = y_dest + (height >> 1);
        switch (transform) {
            case 6:
                g.rotate(180.0f, cx, cy);
                break;
            case 7:
                g.rotate(270.0f, cx, cy);
                break;
            case 8:
                g.rotate(90.0f, cx, cy);
                break;
        }
        rect_src.left = x_src;
        rect_src.top = y_src;
        rect_src.right = x_src + width;
        rect_src.bottom = y_src + height;
        rect_dst.left = x_dest;
        rect_dst.top = y_dest;
        rect_dst.right = x_dest + width;
        rect_dst.bottom = y_dest + height;
        g.drawBitmap(src.bitmap, rect_src, rect_dst, this.paint_fill);
        switch (transform) {
            case 6:
                g.rotate(-180.0f, cx, cy);
                return;
            case 7:
                g.rotate(-270.0f, cx, cy);
                return;
            case 8:
                g.rotate(-90.0f, cx, cy);
                return;
            default:
                return;
        }
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawRGB(int[] rgbData, int offset, int scanlength, int x, int y, int width, int height, boolean processAlpha) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawRoundRect(int x, int y, int width, int height, int arcWidth, int arcHeight) {
        RectF rectf = new RectF(x, y, x + width, y + height);
        g.drawRoundRect(rectf, arcWidth, arcHeight, this.paint_outline);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawString(String str, int x, int y, int anchor) {
        g.drawText(str, x, y, this.paint_text);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void drawSubstring(String str, int offset, int len, int x, int y, int anchor) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public void fillArc(int x, int y, int width, int height, int startAngle, int arcAngle) {
        this.oval.top = y;
        this.oval.bottom = y + height;
        this.oval.left = x;
        this.oval.right = x + width;
        g.drawArc(this.oval, startAngle, arcAngle, false, this.paint_fill);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void fillRect(int x, int y, int width, int height) {
        g.drawRect(x, y, x + width, y + height, this.paint_fill);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void fillRoundRect(int x, int y, int width, int height, int arcWidth, int arcHeight) {
        RectF rectf = new RectF(x, y, x + width, y + height);
        g.drawRoundRect(rectf, arcWidth, arcHeight, this.paint_fill);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void fillTriangle(int x1, int y1, int x2, int y2, int x3, int y3) {
        points[0] = x1;
        points[1] = y1;
        points[2] = x2;
        points[3] = y2;
        points[4] = x3;
        points[5] = y3;
        g.drawVertices(Canvas.VertexMode.TRIANGLE_FAN, points.length, points, 0, null, 0, null, 0, null, 0, 0, this.paint_fill);
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getBlueComponent() {
        return this.color & 255;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getClipHeight() {
        return this.clip_h;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getClipWidth() {
        return this.clip_w;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getClipX() {
        return this.clip_x;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getClipY() {
        return this.clip_y;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getColor() {
        return this.color;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getDisplayColor(int color) {
        return color;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getGrayScale() {
        return 255;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getGreenComponent() {
        return (this.color >> 8) & 255;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getRedComponent() {
        return (this.color >> 16) & 255;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getStrokeStyle() {
        return this.stroke;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getTranslateX() {
        return this.x0;
    }

    @Override // javax.microedition.lcdui.Graphics
    public int getTranslateY() {
        return this.y0;
    }

    @Override // javax.microedition.lcdui.Graphics
    public void setClip(int x, int y, int width, int height) {
        this.clip_x = x;
        this.clip_y = y;
        this.clip_w = width;
        this.clip_h = height;
    }

    @Override // javax.microedition.lcdui.Graphics
    public void setColor(int RGB) {
        this.color = RGB;
        this.paint_fill.setColor(this.color);
        this.paint_outline.setColor(this.color);
        this.paint_fill.setAlpha(255);
        this.paint_outline.setAlpha(255);
    }

    @Override // javax.microedition.lcdui.Graphics
    public void setColor(int red, int green, int blue) {
        setColor(((red & 255) << 16) | ((green & 255) << 8) | (blue & 255));
    }

    @Override // javax.microedition.lcdui.Graphics
    public void setGrayScale(int value) {
    }

    @Override // javax.microedition.lcdui.Graphics
    public void setStrokeStyle(int style) {
        this.stroke = style;
    }

    @Override // javax.microedition.lcdui.Graphics
    public void translate(int x, int y) {
        this.x0 = x;
        this.y0 = y;
        g.translate(x, y);
    }
}
