package javax.microedition.lcdui;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import java.io.InputStream;
import java.nio.Buffer;
/* loaded from: classes.dex */
public class j2meImage {
    public static int dynamicImageCount = 0;
    public Bitmap bitmap;
    public int compressedFormat;
    public Buffer compressedTexture;
    public String filename;
    public float ooHeight;
    public float ooWidth;
    public int origHeight;
    public int origWidth;
    public int resourceID;
    public boolean isDynamic = false;
    public boolean invalidated = false;
    public boolean pointSampling = false;
    public int pixelFormat = -1;
    public boolean alpha = false;

    public static j2meImage createImage(int width, int height) {
        j2meImage img = new j2meImage(Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888), 0);
        img.origWidth = width;
        img.origHeight = height;
        img.resourceID = 255;
        img.isDynamic = true;
        return img;
    }

    public static j2meImage createImage(j2meImage source) {
        return new j2meImage(source.bitmap, source.resourceID);
    }

    public static j2meImage createImage(byte[] imageData, int imageOffset, int imageLength) {
        return createImage(16, 16);
    }

    public static j2meImage createImage(InputStream stream) {
        return createImage(16, 16);
    }

    public static j2meImage createImage(String name) {
        return ImageLoader.createImage(name);
    }

    public static j2meImage createRGBImage(int[] rgb, int width, int height, boolean processAlpha) {
        return createImage(16, 16);
    }

    public static j2meImage createImage(j2meImage bitmap, int x, int y, int width, int height, int transform) {
        return createImage(16, 16);
    }

    public j2meImage(Bitmap bitmap, int resourceID) {
        this.resourceID = 0;
        this.bitmap = bitmap;
        this.resourceID = resourceID;
    }

    public j2meImage(Buffer buffer, int resourceID) {
        this.resourceID = 0;
        this.compressedTexture = buffer;
        this.resourceID = resourceID;
    }

    public void reload() {
        j2meImage freshImg = ImageLoader.createImage(this.filename);
        if (freshImg != null) {
            this.compressedTexture = freshImg.compressedTexture;
            this.bitmap = freshImg.bitmap;
        }
    }

    public void invalidate() {
        this.invalidated = true;
    }

    public j2meGraphics getGraphics() {
        Canvas canvas = new Canvas(this.bitmap);
        j2meGraphics g = new j2meGraphics();
        g.setCanvas(canvas);
        return g;
    }

    public int getWidth() {
        return this.origWidth;
    }

    public int getHeight() {
        return this.origHeight;
    }

    public void getRGB(int[] rgbData, int offset, int scanlength, int x, int y, int width, int height) {
        this.bitmap.getPixels(rgbData, offset, scanlength, x, y, width, height);
    }

    public boolean isMutable() {
        return this.bitmap.isMutable();
    }
}
