package javax.microedition.midlet;

import android.content.Context;
import android.graphics.Canvas;
import android.opengl.GLSurfaceView;
import android.util.AttributeSet;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;
import com.slg.j2me.lib.sys.Application;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.glGraphics;
import javax.microedition.lcdui.j2meCanvas;
/* loaded from: classes.dex */
public class GLGameView extends GLSurfaceView {
    static final int cTimeBetweenMoves = 100;
    private int frameCount;
    private glGraphics g;
    private SimpleGLRenderer renderer;

    public GLGameView(Context context, AttributeSet attrs) {
        super(context, attrs);
        this.g = new glGraphics();
        this.renderer = null;
        this.frameCount = 0;
        this.renderer = new BatchGLRenderer(context, this);
    }

    public void startAnimation() {
        setFocusable(true);
        setRenderer(this.renderer);
        SimpleGLRenderer simpleGLRenderer = this.renderer;
        glGraphics glgraphics = this.g;
        simpleGLRenderer.setSprites(glGraphics.drawList);
    }

    public void process() {
        if (Application.hasFocus) {
            Application.instance.processInternal();
            glGraphics glgraphics = this.g;
            glGraphics.setCanvas(null);
            Display.screen.paint(this.g);
        }
    }

    public void onFocusChanged(View v, boolean hasFocus) {
    }

    @Override // android.view.View
    public void onDraw(Canvas canvas) {
        super.onDraw(canvas);
    }

    @Override // android.opengl.GLSurfaceView
    public void onPause() {
        super.onPause();
    }

    @Override // android.opengl.GLSurfaceView
    public void onResume() {
        super.onResume();
    }

    @Override // android.view.View
    public boolean onTouchEvent(MotionEvent e) {
        j2meCanvas canvas = (j2meCanvas) Display.screen;
        int x = (int) e.getX();
        int y = (int) e.getY();
        if (canvas != null) {
            switch (e.getAction()) {
                case 0:
                    canvas.pointerPressed(x, y);
                    return true;
                case 1:
                    canvas.pointerReleased(x, y);
                    return true;
                case 2:
                    try {
                        Thread.sleep(Application.lastFrameTime);
                    } catch (Exception e2) {
                    }
                    canvas.pointerDragged(x, y);
                    return true;
                default:
                    return false;
            }
        }
        return false;
    }

    @Override // android.view.View, android.view.KeyEvent.Callback
    public boolean onKeyDown(int keyCode, KeyEvent e) {
        j2meCanvas canvas = (j2meCanvas) Display.screen;
        if (canvas != null) {
            switch (e.getKeyCode()) {
                case 19:
                    canvas.keyPressed(21);
                    return true;
                case 20:
                    canvas.keyPressed(1);
                    return true;
                case 21:
                    canvas.keyPressed(19);
                    return true;
                case 22:
                    canvas.keyPressed(20);
                    return true;
                case 23:
                    canvas.keyPressed(2);
                    return true;
                default:
                    return false;
            }
        }
        return false;
    }

    @Override // android.view.View, android.view.KeyEvent.Callback
    public boolean onKeyUp(int keyCode, KeyEvent e) {
        j2meCanvas canvas = (j2meCanvas) Display.screen;
        if (canvas != null) {
            switch (e.getKeyCode()) {
                case 19:
                    canvas.keyReleased(21);
                    return true;
                case 20:
                    canvas.keyReleased(1);
                    return true;
                case 21:
                    canvas.keyReleased(19);
                    return true;
                case 22:
                    canvas.keyReleased(20);
                    return true;
                case 23:
                    canvas.keyReleased(2);
                    return true;
                default:
                    return false;
            }
        }
        return false;
    }
}
