package javax.microedition.midlet;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.opengl.GLSurfaceView;
import android.opengl.GLUtils;
import com.safetest.shark.R;
import com.slg.j2me.lib.sys.Application;
import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;
import javax.microedition.khronos.opengles.GL11;
import javax.microedition.khronos.opengles.GL11Ext;
import javax.microedition.lcdui.glGraphics;
/* loaded from: classes.dex */
public class GLQueryRenderer implements GLSurfaceView.Renderer {
    private Bitmap bitmap;
    protected Context mContext;
    protected GLQueryView mQueryView;
    private int viewHeight;
    private int viewWidth;
    private int textureID = -1;
    private int[] mTextureNameWorkspace = new int[1];
    private int[] uv_params = new int[4];
    private boolean haveSetFinishedLoading = false;
    private int framecount = 0;

    public GLQueryRenderer(Context context, GLQueryView queryview) {
        this.mContext = context;
        this.mQueryView = queryview;
    }

    public int[] getConfigSpec() {
        int[] configSpec = {12325, 0, 12344};
        return configSpec;
    }

    @Override // android.opengl.GLSurfaceView.Renderer
    public void onSurfaceChanged(GL10 gl, int width, int height) {
        gl.glViewport(0, 0, width, height);
        this.viewWidth = width;
        this.viewHeight = height;
        gl.glMatrixMode(5889);
        gl.glLoadIdentity();
        gl.glOrthof(0.0f, width, 0.0f, height, 0.0f, 1.0f);
        gl.glShadeModel(7424);
        gl.glEnable(3042);
        gl.glBlendFunc(770, 771);
        gl.glColor4x(65536, 65536, 65536, 65536);
        gl.glEnable(3553);
    }

    @Override // android.opengl.GLSurfaceView.Renderer
    public void onSurfaceCreated(GL10 gl, EGLConfig config) {
        gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
        gl.glShadeModel(7424);
        gl.glDisable(2929);
        gl.glDisable(3024);
        gl.glDisable(2896);
        gl.glClear(16640);
        String extensions = gl.glGetString(7939);
        if (extensions.indexOf("GL_ATI_texture_compression_atitc") != -1) {
            Application.GFX_EXTENSION = Application.GFX_ATI_EXTENSION;
            Application.isATI = true;
        } else {
            Application.GFX_EXTENSION = "_16b";
        }
        Bitmap origImg = BitmapFactory.decodeResource(Application.instance.getResources(), R.drawable.splash);
        this.bitmap = Bitmap.createBitmap(glGraphics.cMaxLines, glGraphics.cMaxLines, Bitmap.Config.RGB_565);
        Canvas canvas = new Canvas(this.bitmap);
        canvas.drawBitmap(origImg, 0.0f, 0.0f, (Paint) null);
        if (this.bitmap != null) {
            gl.glGenTextures(1, this.mTextureNameWorkspace, 0);
            this.textureID = this.mTextureNameWorkspace[0];
            gl.glBindTexture(3553, this.textureID);
            gl.glTexParameterf(3553, 10241, 9728.0f);
            gl.glTexParameterf(3553, 10240, 9728.0f);
            gl.glTexParameterf(3553, 10242, 33071.0f);
            gl.glTexParameterf(3553, 10243, 33071.0f);
            GLUtils.texImage2D(3553, 0, this.bitmap, 0);
        }
        this.bitmap = null;
    }

    @Override // android.opengl.GLSurfaceView.Renderer
    public void onDrawFrame(GL10 gl) {
        int i = this.framecount + 1;
        this.framecount = i;
        if (i > 5 && !this.haveSetFinishedLoading) {
            Application.doFinishedLoading = true;
            this.haveSetFinishedLoading = true;
        }
        gl.glClear(16640);
        float alpha = this.framecount / 25.0f;
        float additive = 0.0f;
        if (alpha < 0.0f) {
            alpha = 0.0f;
        }
        if (alpha > 1.0f) {
            additive = alpha - 1.0f;
            if (additive > 1.0f && additive < 2.0f) {
                additive = 2.0f - additive;
            }
            if (additive > 1.0f) {
                additive = 0.0f;
            }
            alpha = 1.0f;
        }
        gl.glBlendFunc(770, 771);
        gl.glEnable(3553);
        gl.glColor4f(1.0f, 1.0f, 1.0f, alpha);
        gl.glTexEnvf(8960, 8704, 8448.0f);
        gl.glBindTexture(3553, this.textureID);
        this.uv_params[0] = 0;
        this.uv_params[1] = 320;
        this.uv_params[2] = 480;
        this.uv_params[3] = -320;
        ((GL11) gl).glTexParameteriv(3553, 35741, this.uv_params, 0);
        ((GL11Ext) gl).glDrawTexfOES((this.viewWidth - 480) / 2, (this.viewHeight - 320) / 2, 0.0f, 480.0f, 320.0f);
        if (additive > 0.0f) {
            gl.glBlendFunc(770, 1);
            gl.glColor4f(1.0f, 1.0f, 1.0f, 0.5f * additive);
            ((GL11Ext) gl).glDrawTexfOES((this.viewWidth - 480) / 2, (this.viewHeight - 320) / 2, 0.0f, 480.0f, 320.0f);
            ((GL11Ext) gl).glDrawTexfOES((this.viewWidth - 480) / 2, (this.viewHeight - 320) / 2, 0.0f, 480.0f, 320.0f);
        }
    }

    public void shutdown(GL10 gl) {
        if (this.textureID != -1) {
            this.mTextureNameWorkspace[0] = this.textureID;
            gl.glDeleteTextures(1, this.mTextureNameWorkspace, 0);
            this.textureID = -1;
        }
    }
}
