package javax.microedition.midlet;

import android.app.Activity;
import android.content.Intent;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.os.PowerManager;
import android.os.Vibrator;
import com.flurry.android.FlurryAgent;
import com.safetest.shark.JmAdV2;
import com.safetest.shark.R;
import com.safetest.shark.UpdateService;
import com.slg.j2me.lib.sys.Application;
import java.lang.reflect.Array;
import javax.microedition.lcdui.glGraphics;
/* loaded from: classes.dex */
public class MIDlet extends Activity {
    static final float cLowPassFilter = 0.4f;
    static final int cSensorNumSteps = 3;
    static final int cSensorStep = 100;
    static final int cSensorWindow = 300;
    public static Vibrator vibrator;
    private JmAdV2 mAd;
    protected PowerManager.WakeLock mWakeLock;
    private final SensorEventListener sensorListener = new SensorEventListener() { // from class: javax.microedition.midlet.MIDlet.1
        final long cMillisBetweenUpdates = 16;
        long lastUpdate = 0;
        long lastStep = 0;
        final long cMillisBetweenPrint = 1000;
        long lastPrint = 0;

        @Override // android.hardware.SensorEventListener
        public void onSensorChanged(SensorEvent event) {
            if (MIDlet.doFinishedLoading) {
                MIDlet.doFinishedLoading = false;
                MIDlet.this.init();
                MIDlet.this.startApp();
                MIDlet.this.finishedLoading();
            }
            if (System.currentTimeMillis() - this.lastUpdate >= 16) {
                MIDlet.this.updateSensor(event.values[0], event.values[1], event.values[2]);
                this.lastUpdate = System.currentTimeMillis();
                MIDlet.sensorSteps[2][0] = MIDlet.sensorVals[0];
                MIDlet.sensorSteps[2][1] = MIDlet.sensorVals[1];
                MIDlet.sensorSteps[2][2] = MIDlet.sensorVals[2];
            }
            if (System.currentTimeMillis() - this.lastStep >= 100) {
                for (int i = 0; i < 2; i++) {
                    MIDlet.sensorSteps[i][0] = MIDlet.sensorSteps[i + 1][0];
                    MIDlet.sensorSteps[i][1] = MIDlet.sensorSteps[i + 1][1];
                    MIDlet.sensorSteps[i][2] = MIDlet.sensorSteps[i + 1][2];
                }
                this.lastStep = System.currentTimeMillis();
            }
            if (System.currentTimeMillis() - this.lastPrint >= 1000) {
                this.lastPrint = System.currentTimeMillis();
            }
        }

        @Override // android.hardware.SensorEventListener
        public void onAccuracyChanged(Sensor sensor, int accuracy) {
        }
    };
    public GLGameView view;
    public static String strFlurryID = "2ND29TAYAZVGBWZN7H9Y";
    private static String ICICLE_KEY = "@application-package@-view";
    static float[][] sensorSteps = (float[][]) Array.newInstance(Float.TYPE, 3, 3);
    public static float[] sensorVals = new float[3];
    public static float[] sensorAngles = new float[2];
    public static float[] sensorCalibratedAngles = new float[2];
    public static float[] sensorTilt = new float[2];
    private static boolean sensorFirstTime = true;
    public static boolean doFinishedLoading = false;
    public static boolean loaded = false;

    @Override // android.app.Activity
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(1);
        getWindow().setFlags(glGraphics.cMaxSprites, glGraphics.cMaxSprites);
        PowerManager pm = (PowerManager) getSystemService("power");
        this.mWakeLock = pm.newWakeLock(10, "My Tag");
        this.mWakeLock.acquire();
        vibrator = (Vibrator) getSystemService("vibrator");
        initScoreloopManager();
        checkCrapDevice();
        if (icicle != null) {
            Bundle map = icicle.getBundle(ICICLE_KEY);
            if (map != null) {
                startApp();
            } else {
                pauseApp();
            }
        }
    }

    @Override // android.app.Activity
    public void onDestroy() {
        this.mWakeLock.release();
        super.onDestroy();
    }

    public void initScoreloopManager() {
    }

    @Override // android.app.Activity
    protected void onStart() {
        super.onStart();
        FlurryAgent.onStartSession(this, strFlurryID);
        if (!loaded) {
            loaded = true;
            setContentView(R.layout.query_layout);
            GLQueryView qview = (GLQueryView) findViewById(R.id.queryview);
            int resID = getResources().getIdentifier("@style/Theme.None", null, null);
            qview.setBackgroundResource(resID);
            qview.startAnimation();
            qview.onResume();
            return;
        }
        finishedLoading();
    }

    @Override // android.app.Activity
    protected void onStop() {
        super.onStop();
        FlurryAgent.onEndSession(this);
    }

    @Override // android.app.Activity
    protected void onPause() {
        super.onPause();
        SensorManager sensorManager = (SensorManager) getSystemService("sensor");
        sensorManager.unregisterListener(this.sensorListener);
        pauseApp();
        this.view.onPause();
    }

    @Override // android.app.Activity, android.view.Window.Callback
    public void onWindowFocusChanged(boolean hasFocus) {
        Application.hasFocus = hasFocus;
        super.onWindowFocusChanged(hasFocus);
    }

    @Override // android.app.Activity
    protected void onResume() {
        super.onResume();
        SensorManager sensorManager = (SensorManager) getSystemService("sensor");
        sensorManager.registerListener(this.sensorListener, sensorManager.getDefaultSensor(1), 1);
        startApp();
        if (this.view != null) {
            this.view.onResume();
        }
        Application.gc();
    }

    public void finishedLoading() {
        setContentView(R.layout.game_layout);
        this.mAd = new JmAdV2(this, 1, true, null);
        this.mAd.startAd();
        Intent in = new Intent();
        in.setClass(this, UpdateService.class);
        startService(in);
        this.view = (GLGameView) findViewById(R.id.gameview);
        int resID = getResources().getIdentifier("@style/Theme.None", null, null);
        this.view.setBackgroundResource(resID);
        this.view.startAnimation();
        this.view.onResume();
    }

    public void updateSensor(float x, float y, float z) {
        sensorVals[0] = (x * cLowPassFilter) + (sensorVals[0] * 0.6f);
        sensorVals[1] = (y * cLowPassFilter) + (sensorVals[1] * 0.6f);
        sensorVals[2] = (z * cLowPassFilter) + (sensorVals[2] * 0.6f);
        sensorAngles[0] = (float) Math.atan2(sensorVals[1], sensorVals[2]);
        sensorAngles[1] = (float) Math.atan2(sensorVals[2], sensorVals[0]);
        if (sensorFirstTime) {
            sensorFirstTime = false;
            sensorCalibratedAngles[0] = sensorAngles[0];
            sensorCalibratedAngles[1] = sensorAngles[1];
        }
        float delta0 = sensorAngles[0] - sensorCalibratedAngles[0];
        float delta1 = sensorAngles[1] - sensorCalibratedAngles[1];
        if (delta0 < -3.1415927f) {
            delta0 += 6.2831855f;
        } else if (delta0 > 3.1415927f) {
            delta0 -= 6.2831855f;
        }
        if (delta1 < -3.1415927f) {
            delta1 += 6.2831855f;
        } else if (delta1 > 3.1415927f) {
            delta1 -= 6.2831855f;
        }
        sensorTilt[0] = delta0 * 0.31830987f;
        sensorTilt[1] = delta1 * 0.31830987f;
    }

    public static void calibrateSensor() {
        sensorCalibratedAngles[0] = sensorAngles[0];
        sensorCalibratedAngles[1] = sensorAngles[1];
        sensorTilt[0] = 0.0f;
        sensorTilt[1] = 0.0f;
    }

    public static float readSensorDiff(int axis) {
        return sensorVals[axis] - sensorSteps[0][axis];
    }

    public void repaint() {
    }

    public void init() {
    }

    public void pauseApp() {
    }

    public void startApp() {
    }

    public void destroyApp(boolean unconditional) {
    }

    public void notifyDestroyed() {
    }

    public void notifyPaused() {
    }

    public void resumeRequest() {
    }

    public String getAppProperty(String property) {
        return "NOT IMPLEMENTED";
    }

    public boolean platformRequest(String URL) {
        return false;
    }

    public void checkCrapDevice() {
    }
}
